<?php

class myUser extends sfBasicSecurityUser
{
  public function __construct(sfEventDispatcher $dispatcher, sfStorage $storage, $options = array())
  {
    parent::initialize($dispatcher, $storage, $options);
    
    $this->setUserTimezone();  
    
    $this->setDefaultConfiguration();   
  }
  
  public function setUserTimezone()
  {
    if($this->hasAttribute('timezone'))
    {
      date_default_timezone_set($this->getAttribute('timezone'));
    }
  }
  
  public function setDefaultConfiguration()
  {        
    $configuration_list = ConfigurationPeer::doSelect(new Criteria());
    foreach($configuration_list as $configuration)
    {      
      sfConfig::add(array($configuration->getKey()=>$configuration->getValue()));
    }
  }
}
