<?php

/**
 * extraFields actions.
 *
 * @package    sf_sandbox
 * @subpackage extraFields
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class attachmentsActions extends sfActions
{
  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($attachments = AttachmentsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object extra_fields does not exist (%s).', $request->getParameter('id')));

    $file_path = sfConfig::get('sf_upload_dir') . '/attachments/' . $attachments->getFile();
    
    if(is_file($file_path))
    {
      unlink($file_path);
    }

    $attachments->delete();

    exit();
  }
  
  public function executeView(sfWebRequest $request)
  {
    $this->forward404Unless($attachments = AttachmentsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object extra_fields does not exist (%s).', $request->getParameter('id')));
    
    $file_path = sfConfig::get('sf_upload_dir') . '/attachments/' . $attachments->getFile();
    
    if(!is_file($file_path))
    {
      echo 'File "' . $attachments->getFile() . '" not found';
    }
    
    if($size = getimagesize($file_path))
    {
      header("Content-type: {$size['mime']}");
      
      readfile($file_path);
    }
    else
    {
       $this->redirect('attachments/download?id=' . $attachments->getId());
    }
  
    exit();
  }
  
  public function executeDownload(sfWebRequest $request)
  {
    $this->forward404Unless($attachments = AttachmentsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object extra_fields does not exist (%s).', $request->getParameter('id')));
    
    $file_path = sfConfig::get('sf_upload_dir') . '/attachments/' . $attachments->getFile();
    
    if(is_file($file_path))
    {
      header("Expires: Mon, 26 Nov 1962 00:00:00 GMT");
      header("Last-Modified: " . gmdate("D,d M Y H:i:s") . " GMT");
      header("Cache-Control: no-cache, must-revalidate");
      header("Pragma: no-cache");
      header("Content-Type: Application/octet-stream");
      header("Content-disposition: attachment; filename=" . substr(str_replace(' ','_',$attachments->getFile()),7));
  
      readfile($file_path);
    }
    else
    {
      echo 'File "' . $attachments->getFile() . '" not found';
    }
  
    exit();
  }  
}
