<div class="infoBlock"><h1><?php echo __('General Configuration') ?></h1></div>
<br>
<b><?php echo __('Root Administrator'); ?></b>

<table class="formTable">
  <tr>
    <th><label for="cfg_app_administrator_email"><?php echo __('Administrator Email'); ?></label></th>
    <td><?php echo input_tag('cfg[app_administrator_email]', sfConfig::get('app_administrator_email'),'size="40"'); ?></td>
  </tr>
  <tr>
    <th><label for="cfg_app_administrator_password"><?php echo __('Administrator Password'); ?></label></th>
    <td><?php echo input_tag('cfg[app_administrator_password]', sfConfig::get('app_administrator_password'),'size="40"'); ?></td>
  </tr>
</table>
<i>&nbsp;&nbsp;<?php echo __('Root administrator is internal user who can just manage users and configuration and can’t create tasks or projects');?></i>  
<br><br>
<b><?php echo __('Application'); ?></b>
<table class="formTable">
  <tr>
    <th><label for="cfg_app_app_name"><?php echo __('Name of application'); ?></label></th>
    <td><?php echo input_tag('cfg[app_app_name]', sfConfig::get('app_app_name'),'size="40"'); ?></td>
  </tr>
  <tr>
    <th><label for="cfg_app_app_short_name"><?php echo __('Short name of application'); ?></label></th>
    <td><?php echo input_tag('cfg[app_app_short_name]', sfConfig::get('app_app_short_name'),'size="40"'); ?></td>
  </tr>
  <tr>
    <th><label for="cfg_app_email_label"><?php echo __('Email Subject Label'); ?></label></th>
    <td><?php echo input_tag('cfg[app_email_label]', sfConfig::get('app_email_label'),'size="40"'); ?></td>
  </tr>
</table> 
<br>

<?php

  $skins_list = array();
  
  $skins_list['Default'] = 'Default';
  
  $skinsDir = sfConfig::get('sf_web_dir') . '/css/skins/';
  
  if ($handle = opendir($skinsDir)) 
  {             
    while (false !== ($file = readdir($handle))) 
    {
      if ($file != "." && $file != ".." && is_dir($skinsDir . $file)) 
      {                     
        $skins_list[$file] = $file;
      }  
    }  
  }


  $timezone_list = array();
  $timezone_identifiers = DateTimeZone::listIdentifiers();
  for ($i=0; $i < sizeof($timezone_identifiers); $i++) 
  {    
      $timezone_list[$timezone_identifiers[$i]] = $timezone_identifiers[$i];
  }
  
  $cultures = sfYaml::load(sfConfig::get('sf_app_config_dir') . '/cultures.yml');
  asort($cultures);
  
?>

<b><?php echo __('Defaults'); ?></b>
<table class="formTable">
  <tr>
    <th><label for="cfg_app_default_skin"><?php echo __('Default Skin'); ?></label></th>
    <td><?php echo select_tag('cfg[app_default_skin]', options_for_select($skins_list,sfConfig::get('app_default_skin'))); ?></td>
  </tr>
  <tr>
    <th><label for="cfg_sf_default_timezone"><?php echo __('Default Timezone'); ?></label></th>
    <td><?php echo select_tag('cfg[sf_default_timezone]', options_for_select($timezone_list,sfConfig::get('sf_default_timezone'))); ?></td>
  </tr>
  <tr>
    <th><label for="cfg_sf_default_culture"><?php echo __('Default Culture'); ?></label></th>
    <td><?php echo select_tag('cfg[sf_default_culture]', options_for_select($cultures,sfConfig::get('sf_default_culture'))); ?></td>
  </tr>
  <tr>
    <th><label for="cfg_app_rows_per_page"><?php echo __('Default Rows Per Page'); ?></label></th>
    <td><?php echo input_tag('cfg[app_rows_per_page]', sfConfig::get('app_rows_per_page'),'size="5"'); ?><br><i><?php echo __('Javascript pager')?></i></td>
  </tr>
  <tr>
    <th><label for="cfg_app_rows_per_page_group"><?php echo __('Rows Per Page Group'); ?></label></th>
    <td><?php echo input_tag('cfg[app_rows_per_page_group]', sfConfig::get('app_rows_per_page_group'),'size="5"'); ?><br><i><?php echo __('Number of records constituting a "page" in standard PHP pager')?></i></td>
  </tr>
  <tr>
    <th><label for="cfg_app_custom_short_date_format"><?php echo __('Default Date Format'); ?></label></th>
    <td><?php echo input_tag('cfg[app_custom_short_date_format]', sfConfig::get('app_custom_short_date_format'),'size="5"'); ?></td>
  </tr>
  <tr>
    <th><label for="cfg_app_custom_logn_date_format"><?php echo __('Default Comments Date Format'); ?></label></th>
    <td><?php echo input_tag('cfg[app_custom_logn_date_format]', sfConfig::get('app_custom_logn_date_format'),'size="5"'); ?></td>
  </tr>
</table> 
<i>&nbsp;&nbsp;<?php echo __('more about date format see') . ' ' .  link_to('format a local time/date','http://php.net/manual/en/function.date.php',array('target'=>'_blanck'));?></i>   
<br><br>


<b><?php echo __('Other'); ?></b>
<table class="formTable">
  <tr>
    <th><label for="cfg_app_allow_adit_tasks_comments_date"><?php echo __('Allow edit tasks comments date'); ?></label></th>
    <td><?php echo select_tag('cfg[app_allow_adit_tasks_comments_date]',options_for_select($default_selector, sfConfig::get('app_allow_adit_tasks_comments_date'))); ?></td>
  </tr>    
  <tr>
    <th><label for="cfg_app_show_footer_links"><?php echo __('Show footer links'); ?></label></th>
    <td><?php echo select_tag('cfg[app_show_footer_links]',options_for_select($default_selector, sfConfig::get('app_show_footer_links'))); ?></td>
  </tr>
</table>     
