<?php

/**
 * departments actions.
 *
 * @package    sf_sandbox
 * @subpackage departments
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class departmentsActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $c= new Criteria();
    $c->addAscendingOrderByColumn(DepartmentsPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(DepartmentsPeer::NAME);
    $this->departments_list = DepartmentsPeer::doSelect($c);
    
    $this->getResponse()->setTitle(sfConfig::get('app_app_short_name') . ' | ' . I18NText::__('Configuration') . ' | ' . I18NText::__('Tickets Types'));
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new DepartmentsForm();
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new DepartmentsForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($departments = DepartmentsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object departments does not exist (%s).', $request->getParameter('id')));
    $this->form = new DepartmentsForm($departments);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($departments = DepartmentsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object departments does not exist (%s).', $request->getParameter('id')));
    $this->form = new DepartmentsForm($departments);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($departments = DepartmentsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object departments does not exist (%s).', $request->getParameter('id')));
    $departments->delete();

    $this->redirect('departments/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {    
      $departments = $form->save();

      $this->redirect('departments/index');
    }
  }
}
