<?php include_component('projects', 'shortInfo', array('projectId' => $projectId)) ?>

<div id="projectsMenuContainer"><?php include_partial('projects/projectsMenu', array('projectId' => $projectId)); ?></div>
    
<?php

$yuiTableOptions = array();
$yuiTableOptions['module'] = 'discussions';

$yuiTableOptions['urlParams'] = 'projectId=' . $projectId;

$yuiTableOptions['allowSortItems'] = false;

$yuiTableOptions['buttonInsertTitle'] = __('Add Discussion');

$yuiTableOptions['isUrlColumn'] = true;

if($sf_user->hasCredential('allow_manage_discussions_viewonly'))
{  
  $yuiTableOptions['allowEdit']   = false;
  $yuiTableOptions['allowDelete'] = false;
  $yuiTableOptions['allowInsert'] = false;  
}


$yuiTable = array();

$yuiTable['key'][] = array('id' => 'name', 'label'=>__('Name'),'formatter'=>'formatUrl');
$yuiTable['key'][] = array('id' => 'discussionsStatusId', 'label'=>__('Status'));
$yuiTable['key'][] = array('id' => 'createdBy', 'label'=>__('Created By'));

$commentsTipsTextsList = '';

$yuiTable['data'] = array();
foreach ($discussions_list as $discussions)
{

  $nameLastCommented = DiscussionsCommentsPeer::getNameLastCommented($discussions->getId());
  
  if(strlen($nameLastCommented)>0)
  {
    $commentsTipsTextId = 'commentTip_' . rand(111111111,999999999); 
    $commentsTipsTextsList .= input_hidden_tag($commentsTipsTextId,DiscussionsCommentsPeer::getTextLastCommented($discussions->getId()));
    $nameLastCommented = '&nbsp;<sup><div class="commentName"  onmouseover="doTip(\'' . $commentsTipsTextId . '\')" onmouseout="UnTip()">' . image_tag('icons/comment.png') . $nameLastCommented . '</div></sup>';
  }

  $yuiTable['data'][$discussions->getId()] =  array('name'    => $discussions->getName() . $nameLastCommented,
                                                    'url' => url_for('discussionsComments/index?projectId=' . $projectId . '&discussionId=' . $discussions->getId()), 
                                                    'discussionsStatusId' => ($discussions->getDiscussionsStatus() ? $discussions->getDiscussionsStatus()->getName() : ''),
                                                    'createdBy'    => $discussions->getUsers()->getName(),
                                                    );
}

include_partial('global/yuiBasicDataTable',array('yuiTable' => $yuiTable, 'yuiTableOptions' => $yuiTableOptions));

echo $commentsTipsTextsList;

include_partial('global/pager', array('url_params'=>'projectId=' . $sf_request->getParameter('projectId'),'request_page'=>'page','module' => $sf_context->getModuleName(), 'action'=>$sf_context->getActionName(),'pager'=>$pager));
