<?php

/**
 * discussionsComments actions.
 *
 * @package    sf_sandbox
 * @subpackage discussionsComments
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class discussionsCommentsActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $this->projectId = $request->getParameter('projectId');
    $this->discussionId = $request->getParameter('discussionId');

    $c = new Criteria();
    $c->add(DiscussionsCommentsPeer::DISCUSSIONS_ID,$this->discussionId);
    $c->addDescendingOrderByColumn(DiscussionsCommentsPeer::CREATED_AT);
    $this->discussions_comments_list = DiscussionsCommentsPeer::doSelectJoinAll($c);
    
    $response = $this->getResponse();
    $response->setTitle(sfConfig::get('app_app_short_name') . ' | ' . DiscussionsPeer::retrieveByPk($this->discussionId)->getName());
    
    
    $c = new Criteria();
    $c->add(DiscussionsPeer::ID,$this->discussionId);
    $discussions_list = DiscussionsPeer::doSelectJoinAll($c);
    $this->discussions = current($discussions_list);
    
    
    $c = new Criteria();
    $c->add(UsersPeer::ACTIVE,1);
    $c->add(UsersPeer::ID,explode(',',$this->discussions->getAssignedTo()), Criteria::IN);
    $this->assignet_to_list = UsersPeer::doSelect($c);            
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new DiscussionsCommentsForm();
    $this->form->setDefault('discussions_id', $request->getParameter('discussionId'));
    $this->form->setDefault('users_id', $this->getUser()->getAttribute('userId'));
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new DiscussionsCommentsForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($discussions_comments = DiscussionsCommentsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object discussions_comments does not exist (%s).', $request->getParameter('id')));
    $this->form = new DiscussionsCommentsForm($discussions_comments);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($discussions_comments = DiscussionsCommentsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object discussions_comments does not exist (%s).', $request->getParameter('id')));
    $this->form = new DiscussionsCommentsForm($discussions_comments);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($discussions_comments = DiscussionsCommentsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object discussions_comments does not exist (%s).', $request->getParameter('id')));
    
    AttachmentsPeer::deleteAttachments('discussionsComments', $discussions_comments->getId());

    $discussions_comments->delete();

    $this->redirect('discussionsComments/index?projectId=' . $request->getParameter('projectId') . '&discussionId=' . $request->getParameter('discussionId'));
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    //insert attachments
    $attachments_files = array();
    $files = $request->getFiles();

    foreach($files['attachments'] as $key=>$file)
    {
      if(strlen($file['name'])>0)
      {
        $filename = rand(111111,999999)  . '-' . $file['name'];
        move_uploaded_file($file['tmp_name'], sfConfig::get('sf_upload_dir') . '/attachments/'  . $filename);
        $attachments_files[] = $filename;
      }
      else
      {
        $attachments_files[] = '';
      }
    }
  
    $sendNofification = false;
    
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      if($form->getObject()->isNew())
      {
        $sendNofification = true;
      }
      
      $discussions_comments = $form->save();
      
      AttachmentsPeer::insertAttachments($request->getParameter('attachments_id'), $request->getParameter('attachments_info'),$attachments_files,$discussions_comments->getId(),'discussionsComments');

      $projects = ProjectsPeer::retrieveByPk($request->getParameter('projectId'));

       //send notification
      if($sendNofification==true && strlen($projects->getTeam())>0)
      {
        $sendTo = array();
        $sendFrom = array();

        $c = new Criteria();
        $c->add(UsersPeer::ACTIVE,1);
        $c->add(UsersPeer::ID,explode(',',$discussions_comments->getDiscussions()->getAssignedTo()), Criteria::IN);
        $users_list = UsersPeer::doSelect($c);

        foreach($users_list as $users)
        {
          $sendTo[$users->getEmail()] = $users->getName();
        }
        
        if(isset($sendTo[$this->getUser()->getAttribute('userEmail')]))
        {
          unset($sendTo[$this->getUser()->getAttribute('userEmail')]);
        }

        $c = new Criteria();
        $c->add(UsersPeer::ID,$discussions_comments->getUsersId());
        $user = UsersPeer::doSelectOne($c);

        $sendFrom[$user->getEmail()] = $user->getName();

        if(sizeof($sendTo)>0)
        {
          require_once sfConfig::get('sf_lib_dir').'/vendor/swift_init.php';
  
          $subject = 'New Discussion Comment: ' . $discussions_comments->getDiscussions()->getName() . ' [' . $projects->getName()  . ']';
          $body = $this->getComponent('discussionsComments','emailNewDiscussionComment', array('discussionId'=>$discussions_comments->getDiscussions()->getId()));
  
          UsersPeer::sendEmail($sendTo,$subject,$body, $sendFrom,$this->getUser());
        }
      }
      
      $this->redirect('discussionsComments/index?projectId=' . $request->getParameter('projectId') . '&discussionId=' . $discussions_comments->getDiscussionsId());
    }
  }
}
