<?php

/**
 * discussionsReports actions.
 *
 * @package    sf_sandbox
 * @subpackage discussionsReports
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class discussionsReportsActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $c = new Criteria();
    $c->add(DiscussionsReportsPeer::USERS_ID,$this->getUser()->getAttribute('userId'));
    $c->addAscendingOrderByColumn(DiscussionsReportsPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(DiscussionsReportsPeer::NAME);
    $this->discussions_reports_list = DiscussionsReportsPeer::doSelect($c);
  }
  
  public function executeView(sfWebRequest $request)
  {    
    $this->reportParams = DiscussionsReportsPeer::retrieveByPk($request->getParameter('id'));    
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new DiscussionsReportsForm(null, array('user'=>$this->getUser()));
    $this->form->setDefault('users_id', $this->getUser()->getAttribute('userId'));
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new DiscussionsReportsForm(null, array('user'=>$this->getUser()));

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($discussions_reports = DiscussionsReportsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object discussions_reports does not exist (%s).', $request->getParameter('id')));
    $this->form = new DiscussionsReportsForm($discussions_reports, array('user'=>$this->getUser()));
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($discussions_reports = DiscussionsReportsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object discussions_reports does not exist (%s).', $request->getParameter('id')));
    $this->form = new DiscussionsReportsForm($discussions_reports, array('user'=>$this->getUser()));

    $this->processForm($request, $this->form);

    $this->redirect('discussionsReports/index');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($discussions_reports = DiscussionsReportsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object discussions_reports does not exist (%s).', $request->getParameter('id')));
    $discussions_reports->delete();

    $this->redirect('discussionsReports/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      $form->setFieldValue('projects_id',implode(',',$form['projects_id']->getValue()));
      $form->setFieldValue('projects_type_id',implode(',',$form['projects_type_id']->getValue()));
      $form->setFieldValue('projects_status_id',implode(',',$form['projects_status_id']->getValue()));      
      $form->setFieldValue('discussions_status_id',implode(',',$form['discussions_status_id']->getValue()));      
      
      $discussions_reports = $form->save();
      
      if($request->hasParameter('redirectTo'))
      {
        $this->redirect('discussionsReports/view?id=' . $discussions_reports->getId());
      }

      $this->redirect('discussionsReports/index');
    }
  }
}
