<?php

class discussionsReportsComponents extends sfComponents
{
  public function executeViewReport()
  {
    $c = new Criteria();
    
    if(strlen($this->reportParams->getProjectsId())>0)
    {
      $c->add(DiscussionsPeer::PROJECTS_ID, explode(',',$this->reportParams->getProjectsId()), Criteria::IN);
    }
    else
    {
      if(!$this->getUser()->hasCredential('allow_view_all'))
      {
        $c->add('','(' . ProjectsPeer::CREATED_BY . '=' . $this->getUser()->getAttribute('userId') . " or FIND_IN_SET(" . $this->getUser()->getAttribute('userId') . "," . ProjectsPeer::TEAM . "))", Criteria::CUSTOM);
      }

    }
        
    if(strlen($this->reportParams->getProjectsTypeId())>0)
    {
      $c->add(ProjectsPeer::PROJECTS_TYPES_ID, explode(',',$this->reportParams->getProjectsTypeId()), Criteria::IN);
    }
        
    if(strlen($this->reportParams->getProjectsStatusId())>0)
    {
      $c->add(ProjectsPeer::PROJECTS_STATUS_ID, explode(',',$this->reportParams->getProjectsStatusId()), Criteria::IN);
    }              
        
    if(strlen($this->reportParams->getDiscussionsStatusId())>0)
    {
      $c->add(DiscussionsPeer::DISCUSSIONS_STATUS_ID, explode(',',$this->reportParams->getDiscussionsStatusId()), Criteria::IN);
    }
    
    $c->add('  ',"FIND_IN_SET(" . $this->getUser()->getAttribute('userId') . "," . DiscussionsPeer::ASSIGNED_TO . ")", Criteria::CUSTOM);
    
    $c->addAscendingOrderByColumn(DiscussionsPeer::DISCUSSIONS_STATUS_ID);
    $c->addAscendingOrderByColumn(DiscussionsPeer::NAME);
    
    $pager = new sfPropelPager('Discussions', sfConfig::get('app_rows_per_page_group'));
    $pager->setPeerMethod('doSelectJoinAll');
    $pager->setPeerCountMethod('doCountJoinAll');
    $pager->setCriteria($c);
    $pager->setPage($this->getRequestParameter('page', 1));
    $pager->init();
    $this->pager = $pager;
                       
    $this->discussions_list = DiscussionsPeer::doSelectJoinAll($c);
  }
}
?>