<?php

/**
 * discussionsStatus actions.
 *
 * @package    sf_sandbox
 * @subpackage discussionsStatus
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class discussionsStatusActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $c= new Criteria();
    $c->addAscendingOrderByColumn(DiscussionsStatusPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(DiscussionsStatusPeer::NAME);
    $this->discussions_status_list = DiscussionsStatusPeer::doSelect($c);
    
    $this->getResponse()->setTitle(sfConfig::get('app_app_short_name') . ' | ' . I18NText::__('Configuration') . ' | ' . I18NText::__('Discussions Status'));
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new DiscussionsStatusForm();
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new DiscussionsStatusForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($discussions_status = DiscussionsStatusPeer::retrieveByPk($request->getParameter('id')), sprintf('Object discussions_status does not exist (%s).', $request->getParameter('id')));
    $this->form = new DiscussionsStatusForm($discussions_status);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($discussions_status = DiscussionsStatusPeer::retrieveByPk($request->getParameter('id')), sprintf('Object discussions_status does not exist (%s).', $request->getParameter('id')));
    $this->form = new DiscussionsStatusForm($discussions_status);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($discussions_status = DiscussionsStatusPeer::retrieveByPk($request->getParameter('id')), sprintf('Object discussions_status does not exist (%s).', $request->getParameter('id')));
    $discussions_status->delete();

    $this->redirect('discussionsStatus/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      if($form['default_value']->getValue()==1)
      {
        DiscussionsStatusPeer::resetDefaultValues();
      }
    
      $discussions_status = $form->save();

      $this->redirect('discussionsStatus/index');
    }
  }
}
