<?php

/**
 * extraFields actions.
 *
 * @package    sf_sandbox
 * @subpackage extraFields
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class extraFieldsActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $this->bindType = $request->getParameter('bindType');
           
    $c= new Criteria();
    $c->add(ExtraFieldsPeer::BIND_TYPE,$this->bindType);
    $c->addAscendingOrderByColumn(ExtraFieldsPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(ExtraFieldsPeer::NAME);
    $this->extra_fields_list = ExtraFieldsPeer::doSelect($c);
    
    $this->bindTypeTitle = '';
    
    switch($this->bindType)
    {
      case 'projects': $this->bindTypeTitle = I18NText::__('Projects Extra Fields');
        break;
      case 'tasks': $this->bindTypeTitle = I18NText::__('Tasks Extra Fields');
        break;
      case 'users': $this->bindTypeTitle = I18NText::__('Users Extra Fields');
        break;
      case 'tickets': $this->bindTypeTitle = I18NText::__('Extra Fields');
        break;      
    }
    
    $response = $this->getResponse();
    $response->setTitle(sfConfig::get('app_app_short_name') . ' | ' . I18NText::__('Configuration') . ' | ' . $this->bindTypeTitle);        
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new ExtraFieldsForm();
    
    $bindType = $request->getParameter('bindType');
    
    $this->form->setFieldDefaultValue('bind_type',$bindType);
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new ExtraFieldsForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($extra_fields = ExtraFieldsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object extra_fields does not exist (%s).', $request->getParameter('id')));
    $this->form = new ExtraFieldsForm($extra_fields);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($extra_fields = ExtraFieldsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object extra_fields does not exist (%s).', $request->getParameter('id')));
    $this->form = new ExtraFieldsForm($extra_fields);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($extra_fields = ExtraFieldsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object extra_fields does not exist (%s).', $request->getParameter('id')));
    $extra_fields->delete();

    $this->redirect('extraFields/index?bindType=' . $request->getParameter('bindType'));
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      $extra_fields = $form->save();

      $this->redirect('extraFields/index?bindType=' . $form['bind_type']->getValue());
    }
  }
}
