<?php

/**
 * ganttCharts actions.
 *
 * @package    sf_sandbox
 * @subpackage ganttCharts
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12479 2008-10-31 10:54:40Z fabien $
 */
class ganttChartsActions extends sfActions
{
 /**
  * Executes index action
  *
  * @param sfRequest $request A request object
  */
  public function executeIndex(sfWebRequest $request)
  {
  
    if(!$this->getUser()->hasCredential('allow_manage_tasks') or ($this->getUser()->hasCredential('allow_manage_tasks') and $this->getUser()->hasCredential('allow_manage_tasks_viewonly')))
    {
      $this->getUser()->setFlash('userNotices', I18NText::__('You don\'t have permissions to this page'));      
      $this->redirect('projects/index');
      exit();
    }
  
    $this->projectId = $request->getParameter('projectId');
            
    /**
     *set default project filter by status
     */
    if(!$this->getUser()->hasAttribute('filterTasksByStatusGroupId'))
    {
      $this->getUser()->setAttribute('filterTasksByStatusGroupId', 'open');
    }
    
    /**
     *save projects filters in session
     */
    if($request->hasParameter('filterTasksByStatusGroupId'))
    {
      $this->getUser()->setAttribute('filterTasksByStatusGroupId', $request->getParameter('filterTasksByStatusGroupId'));
    }
     
    if($request->hasParameter('filterTasksByStatusId'))
    {
      $this->getUser()->setAttribute('filterTasksByStatusId', $request->getParameter('filterTasksByStatusId'));
      $this->getUser()->setAttribute('filterTasksByStatusGroupId', '');
    }
    
    if($request->hasParameter('filterTasksByGroupsId'))
    {
      $this->getUser()->setAttribute('filterTasksByGroupsId', $request->getParameter('filterTasksByGroupsId'));
    }
    
    if($request->hasParameter('filterTasksByPhasesId'))
    {
      $this->getUser()->setAttribute('filterTasksByPhasesId', $request->getParameter('filterTasksByPhasesId'));
    }
    
    if($request->hasParameter('filterTasksByVersionsId'))
    {
      $this->getUser()->setAttribute('filterTasksByVersionsId', $request->getParameter('filterTasksByVersionsId'));
    }
    
    if($request->hasParameter('filterTasksByAssignedId'))
    {
      $this->getUser()->setAttribute('filterTasksByAssignedId', $request->getParameter('filterTasksByAssignedId'));
    }
    
    
    $c = new Criteria();
    

    if($this->getUser()->getAttribute('filterTasksByStatusId')>0)
    {
      $c->add(TasksPeer::TASKS_STATUS_ID, $this->getUser()->getAttribute('filterTasksByStatusId'));
    }
    else
    {
      if(strlen($this->getUser()->getAttribute('filterTasksByStatusGroupId'))>1)
      {
        $c->add(TasksPeer::TASKS_STATUS_ID, TasksStatusPeer::getStatusIdByGroupID($this->getUser()->getAttribute('filterTasksByStatusGroupId')), Criteria::IN);
      }
    }
    
    if($this->getUser()->getAttribute('filterTasksByGroupsId')>0)
    {
      $c->add(TasksPeer::TASKS_GROUPS_ID, $this->getUser()->getAttribute('filterTasksByGroupsId'));
    }
    
    if($this->getUser()->getAttribute('filterTasksByPhasesId')>0)
    {
      $c->add(TasksPeer::PROJECTS_PHASES_ID, $this->getUser()->getAttribute('filterTasksByPhasesId'));
    }
    
    if($this->getUser()->getAttribute('filterTasksByVersionsId')>0)
    {
      $c->add(TasksPeer::VERSIONS_ID, $this->getUser()->getAttribute('filterTasksByVersionsId'));
    }
    
    if($this->getUser()->getAttribute('filterTasksByAssignedId')>0)
    {
      $c->add('',"FIND_IN_SET(" . $this->getUser()->getAttribute('filterTasksByAssignedId') . "," . TasksPeer::ASSIGNED_TO . ")",CRITERIA::CUSTOM);
    }
    
    $c->add(TasksPeer::PROJECTS_ID,$this->projectId);
    
    $c->add(TasksPeer::START_DATE,null,Criteria::ISNOTNULL);
    $c->add(TasksPeer::DUE_DATE,null,Criteria::ISNOTNULL);
    
    $c->addAscendingOrderByColumn(TasksPeer::START_DATE);
    $c->addAscendingOrderByColumn(TasksPeer::TASKS_STATUS_ID);
    $c->addAscendingOrderByColumn(TasksPeer::NAME);
    
    $this->tasks_list = TasksPeer::doSelectJoinAll($c);
              
    
    $response = $this->getResponse();
    $response->setTitle(sfConfig::get('app_app_short_name') . ' | ' . ProjectsPeer::retrieveByPk($this->projectId)->getName());
                   
  }
  

  
  public function executeOverallTasks(sfWebRequest $request)
  {      
  
    if(!$this->getUser()->hasCredential('allow_manage_tasks') or ($this->getUser()->hasCredential('allow_manage_tasks') and $this->getUser()->hasCredential('allow_manage_tasks_viewonly')))
    {
      $this->getUser()->setFlash('userNotices', I18NText::__('You don\'t have permissions to this page'));      
      $this->redirect('projects/index');
      exit();
    }
    
    /**
     *set default project filter by status
     */
    if(!$this->getUser()->hasAttribute('filterTasksListByStatusGroupId'))
    {
      $this->getUser()->setAttribute('filterTasksListByStatusGroupId', 'open');
    }
    
    if(!$this->getUser()->hasAttribute('filterTasksListByProjectsStatusId'))
    {
      $this->getUser()->setAttribute('filterTasksListByProjectsStatusId', ProjectsStatusPeer::getDafaultStatusId());
    }
    
    /**
     *save projects filters in session
     */
    if($request->hasParameter('filterTasksListByStatusGroupId'))
    {
      $this->getUser()->setAttribute('filterTasksListByStatusGroupId', $request->getParameter('filterTasksListByStatusGroupId'));
    }
     
    if($request->hasParameter('filterTasksListByStatusId'))
    {
      $this->getUser()->setAttribute('filterTasksListByStatusId', $request->getParameter('filterTasksListByStatusId'));
      $this->getUser()->setAttribute('filterTasksListByStatusGroupId', '');
    }
    
    
    if($request->hasParameter('filterTasksListByProjectsStatusId'))
    {
      $this->getUser()->setAttribute('filterTasksListByProjectsStatusId', $request->getParameter('filterTasksListByProjectsStatusId'));
    }

    if($request->hasParameter('filterTasksListByProjectsTypeId'))
    {
      $this->getUser()->setAttribute('filterTasksListByProjectsTypeId', $request->getParameter('filterTasksListByProjectsTypeId'));
    }
    
    if($request->hasParameter('filterTasksListByProjectsId'))
    {
      $this->getUser()->setAttribute('filterTasksListByProjectsId', $request->getParameter('filterTasksListByProjectsId'));
    }
    
    if($request->hasParameter('filterTasksListByUsersId'))
    {
      $this->getUser()->setAttribute('filterTasksListByUsersId', $request->getParameter('filterTasksListByUsersId'));
    } 
    
    if($request->hasParameter('setFilterTasksListByRelatedTickets'))
    {
      $this->getUser()->setAttribute('filterTasksListByRelatedTickets', $request->getParameter('filterTasksListByRelatedTickets'));
    }
    
    $c = new Criteria();
    
    if($this->getUser()->getAttribute('filterTasksListByStatusId')>0)
    {
      $c->add(TasksPeer::TASKS_STATUS_ID, $this->getUser()->getAttribute('filterTasksListByStatusId'));
    }
    else
    {
      if(strlen($this->getUser()->getAttribute('filterTasksListByStatusGroupId'))>1)
      {
        $c->add(TasksPeer::TASKS_STATUS_ID, TasksStatusPeer::getStatusIdByGroupID($this->getUser()->getAttribute('filterTasksListByStatusGroupId')), Criteria::IN);
      }
    }
    
    if($this->getUser()->getAttribute('filterTasksListByProjectsStatusId')>0)
    {
      $c->add(ProjectsPeer::PROJECTS_STATUS_ID, $this->getUser()->getAttribute('filterTasksListByProjectsStatusId'));
    }
    
    if($this->getUser()->getAttribute('filterTasksListByProjectsTypeId')>0)
    {
      $c->add(ProjectsPeer::PROJECTS_TYPES_ID, $this->getUser()->getAttribute('filterTasksListByProjectsTypeId'));
    }
    
    if(!$this->getUser()->hasCredential('allow_view_all'))
    {
      $c->add('','(' . ProjectsPeer::CREATED_BY . '=' . $this->getUser()->getAttribute('userId') . " or FIND_IN_SET(" . $this->getUser()->getAttribute('userId') . "," . ProjectsPeer::TEAM . "))", Criteria::CUSTOM);
    }
    
    if($this->getUser()->getAttribute('filterTasksListByProjectsId')>0)
    {
      $c->add(TasksPeer::PROJECTS_ID, $this->getUser()->getAttribute('filterTasksListByProjectsId'));
    }
    
    if($this->getUser()->getAttribute('filterTasksListByUsersId')>0)
    {      
      $c->add('',"FIND_IN_SET(" . $this->getUser()->getAttribute('filterTasksListByUsersId') . "," . TasksPeer::ASSIGNED_TO . ")",CRITERIA::CUSTOM);
    }
    
    if($this->getUser()->getAttribute('filterTasksListByRelatedTickets')>0)
    {
      $c->add(TasksPeer::TICKETS_ID,null,CRITERIA::ISNOTNULL);
    }
    
    $c->add(TasksPeer::START_DATE,null,Criteria::ISNOTNULL);
    $c->add(TasksPeer::DUE_DATE,null,Criteria::ISNOTNULL);
    
    $c->addAscendingOrderByColumn(ProjectsPeer::ID);
    $c->addAscendingOrderByColumn(TasksPeer::START_DATE);
    $c->addAscendingOrderByColumn(TasksPeer::TASKS_STATUS_ID);
    $c->addAscendingOrderByColumn(TasksPeer::NAME);
    $this->tasks_list = TasksPeer::doSelectJoinAll($c); 
  
  }
  

  
   function getShortDateFormat()
   {
     if(strlen(sfConfig::get('app_custom_short_date_format'))>0)
     {
       return sfConfig::get('app_custom_short_date_format');
     }
     else
     {
       return 'm/d/Y';
     }
   }
   
   function getLongDateFormat()
   {
     if(strlen(sfConfig::get('app_custom_logn_date_format'))>0)
     {
       return sfConfig::get('app_custom_logn_date_format'); 
     }
     else
     {
       return 'm/d/Y H:i:s';
     }
   }
  
   function getDateTimestamp($date)
   {
     if(strlen($date)>0)
     {
       $v = date_parse($date);
       
       return mktime(0, 0, 0, $v['month'], $v['day'], $v['year']);
     }
     else
     {
       return '""';
     }
   }
   
    function shortDateFormat($date)
   {
     if(strlen($date)>0)
     {
       $v = date_parse($date);
       
       return date('m/d/Y',mktime($v['hour'], $v['minute'], $v['second'], $v['month'], $v['day'], $v['year']));
     }
     else
     {
       return '';
     }
   }
}
