<?php include_component('projects', 'shortInfo', array('projectId' => $projectId)) ?>

<div id="projectsMenuContainer"><?php include_partial('projects/projectsMenu', array('projectId' => $projectId)); ?></div>

<?php include_component('tasks', 'filter', array('projectId' => $projectId, 'form_action'=>'ganttCharts')) ?>

<br>

<?  
  echo javascript_include_tag('/js/jsgantt/jsgantt.js');
  echo stylesheet_tag('/js/jsgantt/jsgantt.css');     
?>

<div id="page_width"></div>
<div class="gantt" id="GanttChartDIV"></div>



<script type="text/javascript">

function resize_gantt_bar()
{
   new_width = $('page_width').offsetWidth-685;
   $('rightside').style.width = new_width+'px';
   $('theTable').style.display='block'; 
}

var g = new JSGantt.GanttChart('g',document.getElementById('GanttChartDIV'), 'day');

g.setShowRes(1); // Show/Hide Responsible (0/1)
g.setShowDur(1); // Show/Hide Duration (0/1)
g.setShowComp(1); // Show/Hide % Complete(0/1)
g.setCaptionType('Complete');  // Set to Show Caption (None,Caption,Resource,Duration,Complete)
g.setShowStartDate(1); // Show/Hide Start Date(0/1)
g.setShowEndDate(1); // Show/Hide End Date(0/1)
g.setDateInputFormat('mm/dd/yyyy')  // Set format of input dates ('mm/dd/yyyy', 'dd/mm/yyyy', 'yyyy-mm-dd')
g.setDateDisplayFormat('mm/dd/yyyy') // Set format to display dates ('mm/dd/yyyy', 'dd/mm/yyyy', 'yyyy-mm-dd')
g.setFormatArr("day","week","month","quarter") // Set format options (up to 4 : "minute","hour","day","week","month","quarter")

<?php  
    $counter = 1;
    foreach($tasks_list as $tasks)
    {
    
      $estimated_time = $tasks->getEstimatedTime();
      
      if($estimated_time>0)
      {
        $estimated_title = $estimated_time . ' ' . I18NText::__('hours');
      }
      else
      {
        $estimated_title= '';
      }
      
            
      if($start_date = $tasks->getStartDate())
      {
        $estimated_days = round((getDateTimestamp($tasks->getDueDate())-getDateTimestamp($start_date))/(60*60*24));        
      }
      else
      {
        $estimated_days_title = '';
        $start_date = $tasks->getDueDate();
      }
                   
      $start_date = ganttShortDateFormat($start_date);
      $end_date = ganttShortDateFormat($tasks->getDueDate());                              
            
      echo "g.AddTaskItem(new JSGantt.TaskItem(" . $counter . ", '" . addslashes($tasks->getName()) . "','" . $start_date . "','" . $end_date . "','ffe763', '" . url_for('tasksComments/index?tasksId=' . $tasks->getId(). '&projectId=' . $tasks->getProjectsId()). "','','" . ($tasks->getTasksStatus() ? $tasks->getTasksStatus()->getName() : '') . "','" . $tasks->getProgress() . "')); \n";
                
      $counter++; 
    } 

?>

g.Draw();	
g.DrawDependencies();

resize_gantt_bar();
Event.observe(window, 'resize', function() {   resize_gantt_bar(); }); 
Event.observe(window, 'load', function() {   $('theTable').style.display='block'; });

</script>

<ul>
  <li><?php echo __('Note: only tasks with Start/Due Date can be used for Gantt Chart'); ?></li>  
</ul>