<?php

/**
 * home actions.
 *
 * @package    sf_sandbox
 * @subpackage home
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12479 2008-10-31 10:54:40Z fabien $
 */
class homeActions extends sfActions
{
 /**
  * Executes index action
  *
  * @param sfRequest $request A request object
  */
  public function executeKeepSession()
  {
    exit();
  }
  
  public function executeIndex(sfWebRequest $request)
  {  
    if(!$this->getUser()->hasCredential('allow_manage_tasks'))      
    {
      $this->redirect('projects/index');
    }
    
    UsersPeer::clearUsersFilters($this->getUser());
        
    $c = new Criteria();
    $c->add(UserReportsPeer::USERS_ID,$this->getUser()->getAttribute('userId'));
    $c->add(UserReportsPeer::DISPLAY_ON_HOME,1);
    $c->addAscendingOrderByColumn(UserReportsPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(UserReportsPeer::NAME);
    $this->user_reports_list = UserReportsPeer::doSelect($c);
    
    
    $c = new Criteria();
    $c->add(TicketsReportsPeer::USERS_ID,$this->getUser()->getAttribute('userId'));
    $c->add(TicketsReportsPeer::DISPLAY_ON_HOME,1);
    $c->addAscendingOrderByColumn(TicketsReportsPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(TicketsReportsPeer::NAME);
    $this->tickets_reports_list = TicketsReportsPeer::doSelect($c);
    
    $c = new Criteria();
    $c->add(DiscussionsReportsPeer::USERS_ID,$this->getUser()->getAttribute('userId'));
    $c->add(DiscussionsReportsPeer::DISPLAY_ON_HOME,1);
    $c->addAscendingOrderByColumn(DiscussionsReportsPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(DiscussionsReportsPeer::NAME);
    $this->discussions_reports_list = DiscussionsReportsPeer::doSelect($c);
    
    $c = new Criteria();
    $c->add(ProjectsReportsPeer::DISPLAY_ON_HOME,1);
    $c->add(ProjectsReportsPeer::USERS_ID,$this->getUser()->getAttribute('userId'));
    $c->addAscendingOrderByColumn(ProjectsReportsPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(ProjectsReportsPeer::NAME);
    $this->projects_reports_list = ProjectsReportsPeer::doSelect($c);
    
    $response = $this->getResponse();
    $response->setTitle(sfConfig::get('app_app_short_name') . ' | ' . I18NText::__('Home'));
  }
  
  public function executeLogin(sfWebRequest $request)
  {        
    $this->form = new LoginForm();
    
    if ($request->isMethod('post'))
    {
      $this->form->bind($request->getParameter($this->form->getName()));
      if ($this->form->isValid())
      {
        if($this->form['email']->getValue()==sfConfig::get('app_administrator_email') && $this->form['password']->getValue()==sfConfig::get('app_administrator_password'))
        {
          $this->getUser()->setAttribute('userId', 0);
          $this->getUser()->setAttribute('userEmail', sfConfig::get('app_administrator_email'));
          $this->getUser()->setAuthenticated(true);
          $this->getUser()->addCredentials('allow_manage_users', 'allow_manage_configuration');
          $this->redirect('users/index');
        }
        else
        {
          $c = new Criteria();
          $c->add(UsersPeer::EMAIL,$this->form['email']->getValue());
          $c->add(UsersPeer::PASSWORD,md5($this->form['password']->getValue()));
          $c->add(UsersPeer::ACTIVE,1);
          if($user = UsersPeer::doSelectOne($c))
          {
            $this->getUser()->setAttribute('userId', $user->getId());            
            $this->getUser()->setAttribute('userEmail', $user->getEmail());
            
            if(strlen($user->getSkin())>0)
            {
              $this->getUser()->setAttribute('userSkin', $user->getSkin());
            }
            
            $this->getUser()->setAuthenticated(true);
            
            
            $this->getUser()->setCulture($user->getCulture());
            
            $usersGroup = UsersGroupsPeer::retrieveByPk($user->getUsersGroupId());
            
            if($usersGroup->getAllowViewAll()==1)
            {
              $this->getUser()->addCredential('allow_view_all');
            }
            
            if($usersGroup->getAllowManageProjects()==1)
            {
              $this->getUser()->addCredential('allow_manage_projects');
            }
            
            if($usersGroup->getAllowManageTasks()==1)
            {              
              $this->getUser()->addCredentials('allow_manage_tasks', 'allow_view_reports','allow_search');
            }
            
            if($usersGroup->getAllowManageTasksViewOnly()==1)
            {              
              $this->getUser()->addCredentials('allow_manage_tasks_viewonly');
            }
            
            if($usersGroup->getAllowManageDiscussions()==1)
            {              
              $this->getUser()->addCredentials('allow_manage_discussions');
            }
            
            if($usersGroup->getAllowManageDiscussionsViewOnly()==1)
            {              
              $this->getUser()->addCredentials('allow_manage_discussions_viewonly');
            }
            
            if($usersGroup->getAllowManageTickets()==1)
            {
              $this->getUser()->addCredential('allow_manage_tickets');
            }
            
            if($usersGroup->getAllowManageUsers()==1)
            {
              $this->getUser()->addCredential('allow_manage_users');
              $this->getUser()->addCredential('allow_use_plugins');
            }
            
            if($usersGroup->getAllowManageConfiguration()==1)
            {
              $this->getUser()->addCredential('allow_manage_configuration');
            }
                        
            
            $this->getUser()->addCredential('allow_view_projects', 'allow_view_home');
                                    
            
            if(strlen($request->getParameter('http_referer'))>0)
            {
              $this->redirect($request->getParameter('http_referer'));
            }
                                    
            if($this->getUser()->hasCredential('allow_manage_tasks'))
            {
              $this->redirect('home/index');
            }
            else
            {
              $this->redirect('projects/index');
            }
                          
          }
        }
      }
    }
    
    $response = $this->getResponse();
    $response->setTitle(sfConfig::get('app_app_short_name') . ' | ' . I18NText::__('Login'));

  }
  
  public function executeLogoff()
  {
    $this->getUser()->setAuthenticated(false);
    $this->getUser()->getAttributeHolder()->clear();
    $this->getUser()->clearCredentials();
    $this->redirect('home/login');
  }
  
  public function executeRestorePassword(sfWebRequest $request)
  {
    $this->form = new RestorePasswordForm();
    
    if ($request->isMethod('post'))
    {
      $this->form->bind($request->getParameter($this->form->getName()));
      if ($this->form->isValid())
      {
        $c = new Criteria();
        $c->add(UsersPeer::EMAIL,$this->form['email']->getValue());
        if($user = UsersPeer::doSelectOne($c))
        {
          $newRandomPassword = UsersPeer::getRandomPassword();

          $user->setPassword(md5($newRandomPassword));
          $user->save();

          require_once sfConfig::get('sf_lib_dir').'/vendor/swift_init.php';                                  
          
          $body = 'A new password was requested from ' . $user->getEmail() . '.' . "<br><br>" . 'Your new password to "' . sfConfig::get('app_app_name') . '" is: ' . $newRandomPassword;
          
          UsersPeer::sendEmail(array($user->getEmail()=>$user->getName()),I18NText::__('New Password'),$body, array(sfConfig::get('app_administrator_email')=>sfConfig::get('app_app_name')),$this->getUser());

          $this->getUser()->setFlash('userNotices', I18NText::__('A new password has been sent to your e-mail address'));

          $this->redirect('home/login');
        }
      }
    }
  }
  
  public function executeMyAccount(sfWebRequest $request)
  {
    $this->forward404Unless($users = UsersPeer::retrieveByPk($this->getUser()->getAttribute('userId')), sprintf('Object users does not exist (%s).', $this->getUser()->getAttribute('userId')));
    $this->form = new UsersAccountForm($users);
    
    if ($request->isMethod('post') || $request->isMethod('put'))
    {
      $files = $request->getFiles();
      $userPhoto = $files['users']['photo']['name'];
        
      $this->form->bind($request->getParameter($this->form->getName()), $request->getFiles($this->form->getName()));
      if ($this->form->isValid())
      {
        if(strlen($request->getParameter('new_password'))>0)
        {
          $this->form->setFieldValue('password', md5($request->getParameter('new_password')));
        }
        

        if(strlen($userPhoto)>0)
        {
          $userPhoto =  rand(111111,999999) . '-' . $userPhoto;
          move_uploaded_file($files['users']['photo']['tmp_name'], sfConfig::get('sf_upload_dir') . '/users/' . $userPhoto);
          $this->form->setFieldValue('photo', $userPhoto);
        }
        else
        {
          $this->form->setFieldValue('photo', $request->getParameter('preview_photo'));
        }

        if($request->getParameter('remove_photo')==1 && strlen($request->getParameter('preview_photo'))>0)
        {
          unlink(sfConfig::get('sf_upload_dir') . '/users/' . $request->getParameter('preview_photo'));
          $this->form->setFieldValue('photo','');
        }
        
        $this->getUser()->setCulture($this->form['culture']->getValue());
        
        $users = $this->form->save();
        
        if($request->hasParameter('extra_fields'))
        {
          ExtraFieldsListPeer::insertFieldsValues($request->getParameter('extra_fields'),$users->getId(),'users');
        }

        $this->getUser()->setFlash('userNotices', I18NText::__('Your account has been successfully updated'));
        $this->redirect('home/myAccount');
      }
    }
  }
  
  public function executeSortItems(sfWebRequest $request)
  {
    $this->peer = $request->getParameter('peer');
    $this->sortModule= $request->getParameter('sortModule');
    $this->bindType = $request->getParameter('bindType');
    
    $sortableItems = $request->getParameter('order');
    
    if ($sortableItems)
    {
      //echo "<pre>";
      //print_r($sortableItems);

      foreach($sortableItems as $sortOrder=>$id)
      {
        eval('$item = ' . $this->peer . '::retrieveByPk(' . $id . ');');
        $item->setSortOrder($sortOrder);
        $item->save();
      }
      exit();
    }
    else
    {
      $c= new Criteria();
      
      if(strlen($this->bindType)>0)
      {
        eval('$c->add(' . $this->peer . '::BIND_TYPE,"' . $this->bindType . '");');
      }
      
      if($request->hasParameter('userId'))
      {
        eval('$c->add(' . $this->peer . '::USERS_ID,"' . $request->getParameter('userId') . '");');
      }
      
      eval('$c->addAscendingOrderByColumn(' . $this->peer . '::SORT_ORDER);');
      eval('$c->addAscendingOrderByColumn(' . $this->peer . '::NAME);');
      eval('$this->sort_items_list = ' . $this->peer . '::doSelect($c);');
      
    }

  }
  
  public function getFormErrorStr($form, $request)
  {
    $errorsStr = '';
     
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
     
    if (!$form->isValid())
    {
      $errorsStr = I18NText::__("Please make the following corrections") . ":\n";

      foreach ($form->getErrorSchema() as $field => $error) {
            $errors[$field] = $error->getMessage();
      }                  

      foreach($errors as $field=>$message)
      {
        $errorsStr .= "\n * " . strip_tags($form[$field]->renderLabel()) . ': ' . $message;
      }
      
    }
    
    return $errorsStr;
  }
  
  public function executeValidateForm(sfWebRequest $request)
  {

    $formOptions = array();
    if($request->hasParameter('formOptions'))
    {
      foreach($request->getParameter('formOptions') as $name=>$value)
      {
        $formOptions[$name] = $value;
      }
    }
    
    $formOptions['user'] = $this->getUser();
            
    eval('$form = new ' . $request->getParameter('formName') . '(null,$formOptions);');
    
    header('Content-type: text/html; charset=utf-8');
    
    echo  $this->getFormErrorStr($form, $request);
    
    exit();
  }
  

  public function executeValidateLoginForm(sfWebRequest $request)
  {

    $errorsStr = '';
    
    $form = new LoginForm();

    $errorsStr = $this->getFormErrorStr($form, $request);
    if (strlen($errorsStr)==0)
    {
        $c = new Criteria();
        $c->add(UsersPeer::EMAIL,$form['email']->getValue());
        $c->add(UsersPeer::PASSWORD,md5($form['password']->getValue()));
        $c->add(UsersPeer::ACTIVE,1);
        if(!UsersPeer::doSelectOne($c))
        {
          $errorsStr = I18NText::__("No match for Email and/or Password");
        }
        
        if($form['email']->getValue()==sfConfig::get('app_administrator_email') && $form['password']->getValue()==sfConfig::get('app_administrator_password'))
        {
          $errorsStr = '';
        }
    }
    
    header('Content-type: text/html; charset=utf-8');
    
    echo $errorsStr;

    exit();

  }
  
  public function executeValidateRestorePasswordForm(sfWebRequest $request)
  {

    $errorsStr = '';

    $form = new RestorePasswordForm();

    $errorsStr = $this->getFormErrorStr($form, $request);
    if (strlen($errorsStr)==0)
    {
        $c = new Criteria();
        $c->add(UsersPeer::EMAIL,$form['email']->getValue());
        if(!UsersPeer::doSelectOne($c))
        {
          $errorsStr = I18NText::__("No match for Email");
        }
    }

    header('Content-type: text/html; charset=utf-8');

    echo $errorsStr;

    exit();
  }
  
  public function executeValidateUsersForm(sfWebRequest $request)
  {
    $errorsStr = '';

    eval('$form = new ' . $request->getParameter('formName') . '();');

    $errorsStr = $this->getFormErrorStr($form, $request);
    
    if (strlen($errorsStr)==0)
    {
        $c = new Criteria();
        $c->add(UsersPeer::EMAIL,$form['email']->getValue());
        $c->add(UsersPeer::ID,$form['id']->getValue(),Criteria::NOT_EQUAL);
        if(UsersPeer::doSelectOne($c) or $form['email']->getValue()==sfConfig::get('app_administrator_email'))
        {
          $errorsStr = I18NText::__("Email already used");
        }
    }

    header('Content-type: text/html; charset=utf-8');
    
    echo $errorsStr;

    exit();
  }
}
