<?php

/**
 * phases actions.
 *
 * @package    sf_sandbox
 * @subpackage phases
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class phasesActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $c= new Criteria();
    $c->addAscendingOrderByColumn(PhasesPeer::NAME);
    $this->phases_list = PhasesPeer::doSelect($c);
    
    $response = $this->getResponse();
    $response->setTitle(sfConfig::get('app_app_short_name') . ' | ' . I18NText::__('Configuration') . ' | ' . I18NText::__('Phases'));
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new PhasesForm();
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new PhasesForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($phases = PhasesPeer::retrieveByPk($request->getParameter('id')), sprintf('Object phases does not exist (%s).', $request->getParameter('id')));
    $this->form = new PhasesForm($phases);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($phases = PhasesPeer::retrieveByPk($request->getParameter('id')), sprintf('Object phases does not exist (%s).', $request->getParameter('id')));
    $this->form = new PhasesForm($phases);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($phases = PhasesPeer::retrieveByPk($request->getParameter('id')), sprintf('Object phases does not exist (%s).', $request->getParameter('id')));
    $phases->delete();

    $this->redirect('phases/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      $phases = $form->save();

      $this->redirect('phases/index');
    }
  }
}
