<?php

/**
 * phasesStatus actions.
 *
 * @package    sf_sandbox
 * @subpackage phasesStatus
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class phasesStatusActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $c= new Criteria();
    $c->addAscendingOrderByColumn(PhasesStatusPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(PhasesStatusPeer::NAME);
    $this->phases_status_list = PhasesStatusPeer::doSelect($c);
    
    $this->getResponse()->setTitle(sfConfig::get('app_app_short_name') . ' | ' . I18NText::__('Configuration') . ' | ' . I18NText::__('Phases Status'));
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new PhasesStatusForm();
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new PhasesStatusForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($phases_status = PhasesStatusPeer::retrieveByPk($request->getParameter('id')), sprintf('Object phases_status does not exist (%s).', $request->getParameter('id')));
    $this->form = new PhasesStatusForm($phases_status);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($phases_status = PhasesStatusPeer::retrieveByPk($request->getParameter('id')), sprintf('Object phases_status does not exist (%s).', $request->getParameter('id')));
    $this->form = new PhasesStatusForm($phases_status);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($phases_status = PhasesStatusPeer::retrieveByPk($request->getParameter('id')), sprintf('Object phases_status does not exist (%s).', $request->getParameter('id')));
    $phases_status->delete();

    $this->redirect('phasesStatus/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      if($form['default_value']->getValue()==1)
      {
        PhasesStatusPeer::resetDefaultValues();
      }
      
      $phases_status = $form->save();

      $this->redirect('phasesStatus/index');
    }
  }
}
