<?php

class projectsComponents extends sfComponents
{
  public function executeFilter()
  {

    $c = new Criteria();
    $c->add(BaseProjectsStatusPeer::ACTIVE, 1);
    $this->countProjectsStatus = BaseProjectsStatusPeer::doCount($c);
    
    $c = new Criteria();
    $c->add(BaseProjectsTypesPeer::ACTIVE,1);
    $this->countProjectsTypes = BaseProjectsTypesPeer::doCount($c);
    
    $c= new Criteria();
    $c->add(ProjectsTypesPeer::ACTIVE, 1);
    $c->addAscendingOrderByColumn(ProjectsTypesPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(ProjectsTypesPeer::NAME);
    $projectsTypesList = ProjectsTypesPeer::doSelect($c);
    
    $this->projects_types_list = array();
    $this->projects_types_list[] = 'All';
    foreach($projectsTypesList as $projectsTypes)
    {
      $countProjectsByTypeId = ProjectsPeer::countProjectsByTypeId($projectsTypes->getId(), $this->getUser());

      $countProjectsByTypeIdStr = '';

      if($countProjectsByTypeId>0)
      {
        $countProjectsByTypeIdStr = ' (' . $countProjectsByTypeId . ')';
      }
      
      $this->projects_types_list[$projectsTypes->getId()] = $projectsTypes->getName() . $countProjectsByTypeIdStr;
    }
    
    
    $c= new Criteria();
    $c->add(ProjectsStatusPeer::ACTIVE, 1);
    $c->addAscendingOrderByColumn(ProjectsStatusPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(ProjectsStatusPeer::NAME);
    $projectsStatusList = ProjectsStatusPeer::doSelect($c);

    $this->projects_status_list = array();
    $this->projects_status_list[] = 'All';
    foreach($projectsStatusList as $projectsStauts)
    {
      $countProjectsByStatusId = ProjectsPeer::countProjectsByStatusId($projectsStauts->getId(), $this->getUser());

      $countProjectsByStatusIdStr = '';
      
      if($countProjectsByStatusId>0)
      {
        $countProjectsByStatusIdStr = ' (' . $countProjectsByStatusId . ')';
      }
      
      $this->projects_status_list[$projectsStauts->getId()] = $projectsStauts->getName() . $countProjectsByStatusIdStr;
    }
    
    
    $c= new Criteria();
    $c->add(UsersPeer::ACTIVE,1);
    $this->count_active_users = UsersPeer::doCount($c);
    
    $c= new Criteria();
    $c->add(UsersPeer::ACTIVE,1);
    $users_list = UsersPeer::doSelect($c);
    
    $this->users_list = array();
    $this->users_list[] = 'All';
    foreach($users_list as $user)
    {
      $this->users_list[$user->getId()] = $user->getName() . ' (' . UsersPeer::countProjectsByUserId($user->getId()). ')';
    }
    
  }
  
  public function executeShortInfo()
  {
    $c = new Criteria();
    $c->add(ProjectsPeer::ID, $this->projectId);
    $projects_list = ProjectsPeer::doSelectJoinAll($c);
    $this->project = current($projects_list);
    
    $team = explode(',',$this->project->getTeam());
    $c = new Criteria();
    $c->add(UsersPeer::ID,$team,Criteria::IN);
    $c->addAscendingOrderByColumn(UsersPeer::NAME);
    $this->users_list = UsersPeer::doSelect($c);
  }
  
  public function executeDetails()
  {
    $c = new Criteria();
    $c->add(ProjectsPeer::ID, $this->projectId);
    $projects_list = ProjectsPeer::doSelectJoinAll($c);
    $this->project = current($projects_list);
    
    $team = explode(',',$this->project->getTeam());
    $c = new Criteria();
    $c->add(UsersPeer::ID,$team,Criteria::IN);
    $c->addAscendingOrderByColumn(UsersPeer::NAME);
    $this->users_list = UsersPeer::doSelect($c);
    
    if(!isset($this->allowEdit))
    {
      $this->allowEdit = true;
    }
    
    
    if(!isset($this->setEmailStyle))
    {
      $this->setEmailStyle = false;
    }

    $this->divStyle = '';
    $this->tableStyle = '';
    $this->tdStyle = '';
    $this->thStyle = '';

    if($this->setEmailStyle==true)
    {
      $this->divStyle = ' style="padding: 5px; margin-top: 5px; border: 1px dashed LightGray;" ';
      $this->tableStyle = ' style="width: 100%;" ';
      $this->tdStyle = ' style="padding: 2px; border-bottom: 1px solid white; background: #eaf0f3; font-family:  Arial; font-size: 13px; color: #000;" ';
      $this->thStyle = ' style="padding: 2px; border-bottom: 1px solid white; background: #3d7291; color: white; font-family:  Arial; font-size: 13px; text-align: left;" ';
    }
    
  }
  
  public function executeEmailNewProject()
  {
    $c = new Criteria();
    $c->add(ProjectsPeer::ID, $this->projectId);
    $projects_list = ProjectsPeer::doSelectJoinAll($c);
    $this->project = current($projects_list);

    $this->urlParams = '?projectId=' . $this->projectId;
  }
  
}
?>