<?php include_stylesheets_for_form($form) ?>
<?php include_javascripts_for_form($form) ?>
<?php
  $countProjectsTypes = ProjectsTypesPeer::doCountActive();
  $countProjectsStatus = ProjectsStatusPeer::doCountActive();
  $countExtraFields = ExtraFieldsPeer::countByBindType('projects');
?>

<form name="ProjectsForm" id="ProjectsForm" onSubmit="return validateForm(this.id, '<?php echo url_for('home/validateForm',true); ?>')" action="<?php echo url_for('projects/'.($form->getObject()->isNew() ? 'create' : 'update').(!$form->getObject()->isNew() ? '?id='.$form->getObject()->getId() : ''),true) ?>" method="post" <?php echo 'enctype="multipart/form-data" ' ?>>
<input type="hidden" name="formName" value="ProjectsForm" />
<?php if (!$form->getObject()->isNew()): ?>
<input type="hidden" name="sf_method" value="put" />
<?php endif; ?>

<?php

if($form->getObject()->isNew())
{
  echo input_hidden_tag('redirectTo','tasks');
}
elseif($sf_request->hasParameter('redirectTo'))
{
  echo input_hidden_tag('redirectTo', $sf_request->getParameter('redirectTo'));
}

?>
  <table class="formTable" width="700">
    <tfoot>
      <tr>
        <td colspan="2">
          <?php echo $form->renderHiddenFields() ?>
          <table>
            <tr>
              <td><input type="submit" value="<?php echo __('Save') ?>" /></td>
              <td><div id="formLoadingContainer"></div></td>
            </tr>
          </table>
        </td>
      </tr>
    </tfoot>
    <tbody>
      <?php echo $form->renderGlobalErrors() ?>
     <tr>
      <td>

      <div id="yuiProjectTabMenu" class="yui-navset" style="display: none;">
          <ul class="yui-nav">
              <li class="selected"><a href="#projectInfo"><em><?php echo __('Info') ?></em></a></li>

              <?php if($countProjectsStatus>0 || $countProjectsTypes>0 || $countExtraFields>0):?>
              <li><a href="#projectGeneral"><em><?php echo __('General') ?></em></a></li>
              <?php endif ?>
              
              <li><a href="#projectTeam"><em><?php echo __('Team') ?></em></a></li>
              <li><a href="#projectAttachment"><em><?php echo __('Attachments') ?></em></a></li>
          </ul>
          <div class="yui-content">
              <div id="projectInfo">

                <table>
                  <tr>
                    <th><?php echo $form['name']->renderLabel() ?></th>
                    <td>
                      <?php echo $form['name']->renderError() ?>
                      <?php echo $form['name'] ?>
                    </td>
                  </tr>
                  <tr>
                    <th><?php echo $form['description']->renderLabel() ?></th>
                    <td>
                      <?php echo $form['description']->renderError() ?>
                      <?php echo $form['description'] ?>
                    </td>
                  </tr>
                </table>
                
              </div>
              
              <?php if($countProjectsStatus>0 || $countProjectsTypes>0 || $countExtraFields>0):?>
              <div id="projectGeneral">
              
                <table>
                  <?php if($countProjectsStatus>0):?>
                  <tr>
                    <th><?php echo $form['projects_status_id']->renderLabel() ?></th>
                    <td>
                      <?php echo $form['projects_status_id']->renderError() ?>
                      <?php echo $form['projects_status_id'] ?>
                    </td>
                  </tr>
                  <?php endif ?>
                  <?php if($countProjectsTypes>0):?>
                  <tr>
                    <th><?php echo $form['projects_types_id']->renderLabel() ?></th>
                    <td>
                      <?php echo $form['projects_types_id']->renderError() ?>
                      <?php echo $form['projects_types_id'] ?>
                    </td>
                  </tr>
                  <?php endif ?>

                  <?php
                  if($countExtraFields>0)
                  {
                    include_component('extraFields','extraFieldsList', array('bindType'=>'projects', 'bindId'=>(!$form->getObject()->isNew() ? $form->getObject()->getId() : '')));
                  }
                  ?>
                </table>

              </div>
              <?php endif ?>
              
              <div id="projectTeam"><?php echo renderGroupedUsersList(UsersPeer::getGroupedUserList(), explode(',', $form['team']->getValue())); ?></div>
              <div id="projectAttachment">
                <?php  include_component('attachments','attachmentsList', array('bindType'=>'projects', 'bindId'=>(!$form->getObject()->isNew() ? $form->getObject()->getId() : ''))); ?>
              </div>
          </div>
      </div>
<script type="text/javascript">
YAHOO.util.Event.onContentReady("yuiProjectTabMenu", function() {

    var tabView = new YAHOO.widget.TabView('yuiProjectTabMenu');
    yuiTabViewShowTabs('yuiProjectTabMenu');

});
</script>
      
      
       </td>
      </tr>
    </tbody>
  </table>
</form>



