<?php 

include_component('projects', 'filter'); 

$total_values = array();

$yuiTableOptions = array();
$yuiTableOptions['module'] = 'projects';
$yuiTableOptions['allowSortItems'] = false;
$yuiTableOptions['buttonInsertTitle'] = __('Add Project');
$yuiTableOptions['allowMultipleSelect'] = true;
$yuiTableOptions['allowMultipleExport'] = true;

if($countProjectsStatus>0 || $countProjectsTypes>0)
{
  $yuiTableOptions['allowMultipleEdit'] = true;                                                  
}

if(!$sf_user->hasCredential('allow_manage_projects'))
{
  $yuiTableOptions['allowEdit']   = false;
  $yuiTableOptions['allowDelete'] = false;
  $yuiTableOptions['allowInsert'] = false;  
  $yuiTableOptions['allowMultipleEdit'] = false;  
}

$yuiTableOptions['isUrlColumn'] = true;

$yuiTable = array();
$yuiTable['key'][] = array('id' => 'name', 'label'=>__('Name'),'formatter'=>'formatUrl');

if($sf_user->hasCredential('allow_manage_tasks'))
{
$yuiTable['key'][] = array('id' => 'openTasks', 'label'=>__('Open Tasks'),'parser'=>'number');
$yuiTable['key'][] = array('id' => 'overdueTasks', 'label'=>__('Overdue'),'parser'=>'number');
}

if($sf_user->hasCredential('allow_manage_tickets'))
{
  $yuiTable['key'][] = array('id' => 'openTickets', 'label'=>__('Open Tickets'),'parser'=>'number');
}

if($countProjectsStatus>0)
{
  $yuiTable['key'][] = array('id' => 'projectsStatusId', 'label'=>__('Status'));
}

if($countProjectsTypes>0)
{
  $yuiTable['key'][] = array('id' => 'projectsTypesId', 'label'=>__('Type'));
}

$yuiTable['key'][] = array('id' => 'createdBy', 'label'=>__('Created By'));
$yuiTable['key'][] = array('id' => 'createdAt', 'label'=>__('Created At'),'formatter'=>'formatDate');

$yuiTable = ExtraFieldsListPeer::setYuiTableKeys($yuiTable, 'projects');
$extra_fields_list = ExtraFieldsListPeer::getExtraFieldsListByType('projects');

$yuiTable['data'] = array();
foreach ($projects_list as $projects)
{
  $yuiTable['data'][$projects->getId()] =  array('name'              => $projects->getName(),
                                                 'url'               => ($sf_user->hasCredential('allow_manage_tasks') ? url_for('tasks/index?projectId=' . $projects->getId()) : url_for('tickets/index?projectId=' . $projects->getId())),
                                                 'openTasks'         => ProjectsPeer::countProjectTasksByStatusGroup($projects->getId(), 'open'),
                                                 'overdueTasks'      => ProjectsPeer::countProjectTasksByStatusGroup($projects->getId(), 'open', true),
                                                 'openTickets'         => TicketsPeer::countTicketsByStatusGroup($projects->getId(),'open'),
                                                 'projectsStatusId'  => ($projects->getProjectsStatusId()>0 ? $projects->getProjectsStatus()->getName() : ''),
                                                 'projectsTypesId'   => ($projects->getProjectsTypesId()>0 ? $projects->getProjectsTypes()->getName() : ''),
                                                 'createdBy'         => $projects->getUsers()->getName(),
                                                 'createdAt'         => getDateTimestamp($projects->getCreatedAt()));


  $yuiTable = ExtraFieldsListPeer::setYuiTableData($yuiTable, $extra_fields_list,$projects->getId());
                                                 
  $total_values = ExtraFieldsListPeer::getTotalNumericFieldsValues($total_values, 'projects', $projects->getId());
}

include_partial('global/yuiBasicDataTable',array('yuiTable' => $yuiTable, 'yuiTableOptions' => $yuiTableOptions));

include_partial('global/totalValues', array('total_values' => $total_values));

include_partial('global/pager', array('url_params'=>'','request_page'=>'page','module' => $sf_context->getModuleName(), 'action'=>$sf_context->getActionName(),'pager'=>$pager));
