<?php

/**
 * projectsComments actions.
 *
 * @package    sf_sandbox
 * @subpackage projectsComments
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class projectsCommentsActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $this->projectId = $request->getParameter('projectId');

    $c = new Criteria();
    $c->add(ProjectsCommentsPeer::PROJECTS_ID,$this->projectId);
    $c->addDescendingOrderByColumn(ProjectsCommentsPeer::CREATED_AT);
    $this->projects_comments_list = ProjectsCommentsPeer::doSelectJoinAll($c);


    $c = new Criteria();
    $c->add(ProjectsPeer::ID,$this->projectId);
    $projects_list = ProjectsPeer::doSelectJoinAll($c);
    $this->project = current($projects_list);
    
    $response = $this->getResponse();
    $response->setTitle(sfConfig::get('app_app_short_name') . ' | ' . $this->project->getName());
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new ProjectsCommentsForm(null,array('userId'=>$this->getUser()->getAttribute('userId')));
    $this->form->setDefault('projects_id', $request->getParameter('projectId'));
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new ProjectsCommentsForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($projects_comments = ProjectsCommentsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object projects_comments does not exist (%s).', $request->getParameter('id')));
    $this->form = new ProjectsCommentsForm($projects_comments);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($projects_comments = ProjectsCommentsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object projects_comments does not exist (%s).', $request->getParameter('id')));
    $this->form = new ProjectsCommentsForm($projects_comments);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($projects_comments = ProjectsCommentsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object projects_comments does not exist (%s).', $request->getParameter('id')));
    
    $projectId = $projects_comments->getProjectsId();
    
    $projects_comments->delete();

    $this->redirect('projectsComments/index?projectId=' . $projectId);
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      $projects_comments = $form->save();

      $this->redirect('projectsComments/index?projectId=' . $projects_comments->getProjectsId());
    }
  }
}
