<?php

/**
 * projectsPhases actions.
 *
 * @package    sf_sandbox
 * @subpackage projectsPhases
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class projectsPhasesActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $this->projectId = $request->getParameter('projectId');
    
    if($request->getParameter('setDefaultPhases')>0)
    {
      $c= new Criteria();
      $c->add(PhasesPeer::ID,$request->getParameter('setDefaultPhases'));
      $phase = PhasesPeer::doSelectOne($c);
      
      $phases_list = explode("\n",$phase->getDefaultValues());
      
      foreach($phases_list as $phase_name)
      {
        $projectsPhases = new ProjectsPhases();
        $projectsPhases->setProjectsId($this->projectId);
        $projectsPhases->setName($phase_name);
        $projectsPhases->save();
      }
      
      $this->redirect('projectsPhases/index?projectId=' . $this->projectId);
    }
    

    $c = new Criteria();
    $c->add(ProjectsPhasesPeer::PROJECTS_ID,$this->projectId);
    $this->projects_phases_list = ProjectsPhasesPeer::doSelectJoinAll($c);
    
    $response = $this->getResponse();
    $response->setTitle(sfConfig::get('app_app_short_name') . ' | ' . I18NText::__('Phases'));
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new ProjectsPhasesForm();
    
    $this->form->setDefault('projects_id', $request->getParameter('projectId'));
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new ProjectsPhasesForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($projects_phases = ProjectsPhasesPeer::retrieveByPk($request->getParameter('id')), sprintf('Object projects_phases does not exist (%s).', $request->getParameter('id')));
    $this->form = new ProjectsPhasesForm($projects_phases);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($projects_phases = ProjectsPhasesPeer::retrieveByPk($request->getParameter('id')), sprintf('Object projects_phases does not exist (%s).', $request->getParameter('id')));
    $this->form = new ProjectsPhasesForm($projects_phases);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($projects_phases = ProjectsPhasesPeer::retrieveByPk($request->getParameter('id')), sprintf('Object projects_phases does not exist (%s).', $request->getParameter('id')));

    $projectId = $projects_phases->getProjectsId();

    $projects_phases->delete();

    $this->redirect('projectsPhases/index?projectId=' . $projectId);
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      $projects_phases = $form->save();

      $this->redirect('projectsPhases/index?projectId=' . $projects_phases->getProjectsId());
    }
  }
}
