<?php

/**
 * projectsReports actions.
 *
 * @package    sf_sandbox
 * @subpackage projectsReports
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class projectsReportsActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    UsersPeer::clearUsersFilters($this->getUser());
    
    $c = new Criteria();
    $c->add(ProjectsReportsPeer::USERS_ID,$this->getUser()->getAttribute('userId'));
    $c->addAscendingOrderByColumn(ProjectsReportsPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(ProjectsReportsPeer::NAME);
    $this->projects_reports_list = ProjectsReportsPeer::doSelect($c);
  }
  
  public function executeSetVisibleOnHome(sfWebRequest $request)
  {
    $report = ProjectsReportsPeer::retrieveByPk($request->getParameter('id'));
    $report->setVisibleOnHome($request->getParameter('visibleOnHome'));
    $report->save();
    exit();
  }
  
  public function executeView(sfWebRequest $request)
  {    
    $this->forward404Unless($projects_reports = ProjectsReportsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object projects_reports does not exist (%s).', $request->getParameter('id')));
    $this->reportParams = ProjectsReportsPeer::retrieveByPk($request->getParameter('id'));    
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new ProjectsReportsForm(null, array('user'=>$this->getUser()));
    $this->form->setDefault('users_id', $this->getUser()->getAttribute('userId'));
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new ProjectsReportsForm(null, array('user'=>$this->getUser()));

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($projects_reports = ProjectsReportsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object projects_reports does not exist (%s).', $request->getParameter('id')));
    $this->form = new ProjectsReportsForm($projects_reports, array('user'=>$this->getUser()));
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($projects_reports = ProjectsReportsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object projects_reports does not exist (%s).', $request->getParameter('id')));
    $this->form = new ProjectsReportsForm($projects_reports, array('user'=>$this->getUser()));

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($projects_reports = ProjectsReportsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object projects_reports does not exist (%s).', $request->getParameter('id')));
    $projects_reports->delete();

    $this->redirect('projectsReports/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      if(is_array($form['projects_id']->getValue()))
        $form->setFieldValue('projects_id',implode(',',$form['projects_id']->getValue()));
      
      if(is_array($form['projects_type_id']->getValue()))
        $form->setFieldValue('projects_type_id',implode(',',$form['projects_type_id']->getValue()));
      
      if(is_array($form['projects_status_id']->getValue()))
        $form->setFieldValue('projects_status_id',implode(',',$form['projects_status_id']->getValue()));
                 
      $projects_reports = $form->save();
      
      if($request->hasParameter('redirectTo'))
      {
        $this->redirect('projectsReports/view?id=' . $projects_reports->getId());
      }

      $this->redirect('projectsReports/index');
    }
  }
}
