<?php

$total_values = array();

$yuiTableOptions = array();
$yuiTableOptions['module'] = 'projects';
$yuiTableOptions['allowSortItems'] = false;
$yuiTableOptions['buttonInsertTitle'] = __('Add Project');
$yuiTableOptions['allowMultipleSelect'] = false;
$yuiTableOptions['allowMultipleExport'] = false;

$yuiTableOptions['allowEdit']   = false;
$yuiTableOptions['allowDelete'] = false;
$yuiTableOptions['allowInsert'] = false;  
$yuiTableOptions['allowMultipleEdit'] = false;  


$yuiTableOptions['isUrlColumn'] = true;

$yuiTable = array();


$yuiTable['key'][] = array('id' => 'name', 'label'=>__('Name'),'formatter'=>'formatUrl');



if($countProjectsStatus>0)
{
  $yuiTable['key'][] = array('id' => 'status', 'label'=>__('Status'));
}

if($countProjectsTypes>0)
{
  $yuiTable['key'][] = array('id' => 'type', 'label'=>__('Type'));
}



$yuiTable['key'][] = array('id' => 'createdBy', 'label'=>__('Created By'));
$yuiTable['key'][] = array('id' => 'createdAt', 'label'=>__('Created At'),'formatter'=>'formatDate');

$yuiTable = ExtraFieldsListPeer::setYuiTableKeys($yuiTable, 'projects',$sf_user);
$extra_fields_list = ExtraFieldsListPeer::getExtraFieldsListByType('projects');

$yuiTable['data'] = array();
foreach ($projects_list as $projects)
{
  $yuiTable['data'][$projects->getId()] =  array('name'              => $projects->getName(),
                                                 'url'               => ($sf_user->hasCredential('allow_manage_tasks') ? url_for('tasks/index?projectId=' . $projects->getId()) : url_for('tickets/index?projectId=' . $projects->getId())),                                                 
                                                 
                                                 'status'  => ($projects->getProjectsStatusId()>0 ? $projects->getProjectsStatus()->getName() : ''),
                                                 'type'   => ($projects->getProjectsTypesId()>0 ? $projects->getProjectsTypes()->getName() : ''),                                                 
                                                 'createdBy'         => ($projects->getUsers() ? $projects->getUsers()->getName():''),
                                                 'createdAt'         => getDateTimestamp($projects->getCreatedAt()));


  $yuiTable = ExtraFieldsListPeer::setYuiTableData($yuiTable, $extra_fields_list,$projects->getId());
                                                 
  $total_values = ExtraFieldsListPeer::getTotalNumericFieldsValues($total_values, 'projects', $projects->getId(),$sf_user);
}

include_partial('global/yuiBasicDataTable',array('yuiTable' => $yuiTable, 'yuiTableOptions' => $yuiTableOptions));

include_partial('global/totalValues', array('total_values' => $total_values));