<?php

/**
 * projectsStatus actions.
 *
 * @package    sf_sandbox
 * @subpackage projectsStatus
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class projectsStatusActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $c= new Criteria();
    $c->addAscendingOrderByColumn(ProjectsStatusPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(ProjectsStatusPeer::NAME);
    $this->projects_status_list = ProjectsStatusPeer::doSelect($c);
    
    $response = $this->getResponse();
    $response->setTitle(sfConfig::get('app_app_short_name') . ' | ' . I18NText::__('Configuration') . ' | ' . I18NText::__('Projects Status'));
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new ProjectsStatusForm();
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new ProjectsStatusForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($projects_status = ProjectsStatusPeer::retrieveByPk($request->getParameter('id')), sprintf('Object projects_status does not exist (%s).', $request->getParameter('id')));
    $this->form = new ProjectsStatusForm($projects_status);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($projects_status = ProjectsStatusPeer::retrieveByPk($request->getParameter('id')), sprintf('Object projects_status does not exist (%s).', $request->getParameter('id')));
    $this->form = new ProjectsStatusForm($projects_status);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($projects_status = ProjectsStatusPeer::retrieveByPk($request->getParameter('id')), sprintf('Object projects_status does not exist (%s).', $request->getParameter('id')));
    $projects_status->delete();

    $this->redirect('projectsStatus/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
        
      $projects_status = $form->save();
                  
      if($form['default_value']->getValue()==1)
      {        
        ProjectsStatusPeer::resetDefaultValues($projects_status->getId());
      }

      $this->redirect('projectsStatus/index');
    }
  }
}
