<?php

/**
 * projectsTypes actions.
 *
 * @package    sf_sandbox
 * @subpackage projectsTypes
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class projectsTypesActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $c= new Criteria();
    $c->addAscendingOrderByColumn(ProjectsTypesPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(ProjectsTypesPeer::NAME);
    $this->projects_types_list = ProjectsTypesPeer::doSelect($c);
    
    $response = $this->getResponse();
    $response->setTitle(sfConfig::get('app_app_short_name') . ' | ' . I18NText::__('Configuration') . ' | ' . I18NText::__('Projects Types'));
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new ProjectsTypesForm();
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new ProjectsTypesForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($projects_types = ProjectsTypesPeer::retrieveByPk($request->getParameter('id')), sprintf('Object projects_types does not exist (%s).', $request->getParameter('id')));
    $this->form = new ProjectsTypesForm($projects_types);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($projects_types = ProjectsTypesPeer::retrieveByPk($request->getParameter('id')), sprintf('Object projects_types does not exist (%s).', $request->getParameter('id')));
    $this->form = new ProjectsTypesForm($projects_types);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($projects_types = ProjectsTypesPeer::retrieveByPk($request->getParameter('id')), sprintf('Object projects_types does not exist (%s).', $request->getParameter('id')));
    $projects_types->delete();

    $this->redirect('projectsTypes/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      $projects_types = $form->save();

      $this->redirect('projectsTypes/index');
    }
  }
}
