<?php

/**
 * search actions.
 *
 * @package    sf_sandbox
 * @subpackage search
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12479 2008-10-31 10:54:40Z fabien $
 */
class searchActions extends sfActions
{
 /**
  * Executes index action
  *
  * @param sfRequest $request A request object
  */
  public function executeIndex(sfWebRequest $request)
  {
    $this->form = new SearchForm(null,array('user'=>$this->getUser()));
    
    if ($request->isMethod('post'))
    {
      $this->form->bind($request->getParameter($this->form->getName()));
      $this->keywords = $this->form['keywords']->getValue();
      $this->search_in = $this->form['search_in']->getValue();
      $search_in_description = $this->form['search_in_description']->getValue();
      $search_in_comments = $this->form['search_in_comments']->getValue();
      
      $search_in_project_id = $request->getParameter('search_in_project_id');
      
      $allowed_projects = array();
      
      if(!$this->getUser()->hasCredential('allow_view_all'))
      {
        $c = new Criteria();
        $c->add('','(' . ProjectsPeer::CREATED_BY . '=' . $this->getUser()->getAttribute('userId') . " or FIND_IN_SET(" . $this->getUser()->getAttribute('userId') . "," . ProjectsPeer::TEAM . "))", Criteria::CUSTOM);
        $projects_list = ProjectsPeer::doSelect($c);
        
        foreach($projects_list as $proejcts)
        {
          $allowed_projects[] = $proejcts->getId();
        }
      }

      //search in projects
      if(in_array('projects',$this->search_in))
      {
        $c = new Criteria();
                
        $query_sql = $this->parse_search_keywords(ProjectsPeer::NAME, $this->keywords);

        if($search_in_description == true)
        {          
          $query_sql .= " OR " . $this->parse_search_keywords(ProjectsPeer::DESCRIPTION, $this->keywords);
        }
        
        if($search_in_comments == true)
        {
          $query_sql .= " OR (SELECT count(*) FROM " . ProjectsCommentsPeer::TABLE_NAME . " where " . $this->parse_search_keywords(ProjectsCommentsPeer::DESCRIPTION, $this->keywords) . "  AND " . ProjectsCommentsPeer::PROJECTS_ID . "=" . ProjectsPeer::ID. ")>0";
        }
        
        $c->add('',"(" . $query_sql . ")",Criteria::CUSTOM);
        
        if(!$this->getUser()->hasCredential('allow_view_all'))
        {
          $c->add(ProjectsPeer::ID,$allowed_projects,Criteria::IN);
        }
        
        $c->addAscendingOrderByColumn(ProjectsPeer::NAME);
        $this->projects_list = ProjectsPeer::doSelectJoinAll($c);
        
        $this->countProjectsTypes = BaseProjectsTypesPeer::doCount(new Criteria());
        $this->countProjectsStatus = BaseProjectsStatusPeer::doCount(new Criteria());

      }
      
      //search in tasks
      if(in_array('tasks',$this->search_in))
      {
        $c = new Criteria();

        $query_sql = $this->parse_search_keywords(TasksPeer::NAME, $this->keywords);
        
        $query_sql .= " OR " . TasksPeer::ID . " = '" . $this->keywords . "'";
        
        
        if($search_in_description == true)
        {
          $query_sql .= " OR " . $this->parse_search_keywords(TasksPeer::DESCRIPTION, $this->keywords);
        }

        if($search_in_comments == true)
        {
          $query_sql .= " OR (SELECT count(*) FROM " . TasksCommentsPeer::TABLE_NAME . " where " . $this->parse_search_keywords(TasksCommentsPeer::DESCRIPTION, $this->keywords) . " AND " . TasksCommentsPeer::TASKS_ID . "=" . TasksPeer::ID. ")>0";
                    
        }
        
        $query_sql = "(" . $query_sql . ")";


        $c->add('',"(" . $query_sql . ")",Criteria::CUSTOM);
        
        if($search_in_project_id>0)
        {
          $c->add(TasksPeer::PROJECTS_ID,$search_in_project_id);
        }
        elseif(!$this->getUser()->hasCredential('allow_view_all'))
        {
          $c->add(TasksPeer::PROJECTS_ID,$allowed_projects,Criteria::IN);
        }
        
        
        
        $c->addAscendingOrderByColumn(TasksPeer::TASKS_STATUS_ID);
        $c->addAscendingOrderByColumn(TasksPeer::NAME);
        $this->tasks_list = TasksPeer::doSelectJoinAll($c);
      }
      
      //search in tickets
      if(in_array('tickets',$this->search_in))
      {
        $c = new Criteria();
        
        $query_sql = $this->parse_search_keywords(TicketsPeer::NAME, $this->keywords);
        
        $query_sql .= " OR " . TicketsPeer::ID . " = '" . $this->keywords . "'";

        if($search_in_description == true)
        {          
          $query_sql .= " OR " . $this->parse_search_keywords(TicketsPeer::DESCRIPTION, $this->keywords);
        }

        if($search_in_comments == true)
        {
          $query_sql .= " OR (SELECT count(*) FROM " . TicketsCommentsPeer::TABLE_NAME . " where " . $this->parse_search_keywords(TicketsCommentsPeer::DESCRIPTION, $this->keywords) . " AND " . TicketsCommentsPeer::TICKETS_ID . "=" . TicketsPeer::ID. ")>0";
        }

        $c->add('',"(" . $query_sql . ")",Criteria::CUSTOM);
        
        if($search_in_project_id>0)
        {
          $c->add(TicketsPeer::PROJECTS_ID,$search_in_project_id);
        }
        elseif(!$this->getUser()->hasCredential('allow_view_all'))
        {
          $c->add(TicketsPeer::PROJECTS_ID,$allowed_projects,Criteria::IN);
        }
        

        
        $c->addAscendingOrderByColumn(TicketsPeer::TICKETS_STATUS_ID);
        $c->addAscendingOrderByColumn(TicketsPeer::NAME);
        $this->tickets_list = TicketsPeer::doSelectJoinAll($c);
      }
      
      //search in discussions
      if(in_array('discussions',$this->search_in))
      {
        $c = new Criteria();
        
        $query_sql = $this->parse_search_keywords(DiscussionsPeer::NAME, $this->keywords);
        
        if($search_in_description == true)
        {          
          $query_sql .= " OR " . $this->parse_search_keywords(DiscussionsPeer::DESCRIPTION, $this->keywords);
        }

        if($search_in_comments == true)
        {
          $query_sql .= " OR (SELECT count(*) FROM " . DiscussionsCommentsPeer::TABLE_NAME . " where " . $this->parse_search_keywords(DiscussionsCommentsPeer::DESCRIPTION, $this->keywords)  . " AND " . DiscussionsCommentsPeer::DISCUSSIONS_ID . "=" . DiscussionsPeer::ID. ")>0";
        }
        
        $query_sql = "(" . $query_sql . ")";
        
        if($this->getUser()->hasCredential('discussions_access_view_own_only'))
        {
          $query_sql .= " AND FIND_IN_SET(" . $this->getUser()->getAttribute('userId') . "," . DiscussionsPeer::ASSIGNED_TO . ")";
        }

        $c->add('',"(" . $query_sql . ")",Criteria::CUSTOM);
        
        
        if($search_in_project_id>0)
        {
          $c->add(DiscussionsPeer::PROJECTS_ID,$search_in_project_id);
        }
        
                        
        $c->addAscendingOrderByColumn(DiscussionsPeer::NAME);
        $this->discussions_list = DiscussionsPeer::doSelectJoinAll($c);
      }
    }
    
    $this->getResponse()->setTitle(sfConfig::get('app_app_short_name') . ' | ' . I18NText::__('Search'));
  }
  
  public function parse_search_keywords($field_name, $keywords)
  {
     $keywords_array = explode(' ', $keywords);
     
     if(sizeof($keywords_array)>1)
     {
       $sql = "(";
       
       for($i=0; $i<sizeof($keywords_array); $i++)
       {
         $sql .= $field_name . " LIKE '%" . $keywords_array[$i] . "%'";
         
         if(isset($keywords_array[$i+1]))
         {
           $sql .= " AND ";
         }         
       }
       
       $sql .= ")";
       
       return $sql;
       
     }
     else
     {
       return $field_name . " LIKE '%" . $keywords . "%'";
     }
     
  }
  
  public function executeNew(sfWebRequest $request)
  {
    $this->form = new SearchForm(null,array('user'=>$this->getUser()));
  }
}
