<?php

/**
 * tasks actions.
 *
 * @package    sf_sandbox
 * @subpackage tasks
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class tasksActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $this->projectId = $request->getParameter('projectId');
    $projects = ProjectsPeer::retrieveByPk($this->projectId);
    
    
    if($request->hasParameter('clearFilters'))
    {
      UsersPeer::clearUsersFilters($this->getUser());    
    }
    
    /**
     *set default project filter by status
     */
    if(!$this->getUser()->hasAttribute('filterTasksByStatusGroupId'))
    {
      $this->getUser()->setAttribute('filterTasksByStatusGroupId', 'open');
    }
    
    if(!$this->getUser()->hasAttribute('orderTasksBy'))
    {
      if($v = $projects->getOrderTasksBy())
      {
        $this->getUser()->setAttribute('orderTasksBy', $v);
      }
      else
      {
        $this->getUser()->setAttribute('orderTasksBy', 'status');
      }
    }    
    
    /**
     *save projects filters in session
     */
    if($request->hasParameter('filterTasksByStatusGroupId'))
    {
      $this->getUser()->setAttribute('filterTasksByStatusGroupId', $request->getParameter('filterTasksByStatusGroupId'));
      $this->getUser()->setAttribute('filterTasksByStatusId', '');
    }
     
    if($request->hasParameter('filterTasksByStatusId'))
    {
      $this->getUser()->setAttribute('filterTasksByStatusId', $request->getParameter('filterTasksByStatusId'));
      $this->getUser()->setAttribute('filterTasksByStatusGroupId', '');
    }
    
    if($request->hasParameter('filterTasksByGroupsId'))
    {
      $this->getUser()->setAttribute('filterTasksByGroupsId', $request->getParameter('filterTasksByGroupsId'));
    }
    
    if($request->hasParameter('filterTasksByPhasesId'))
    {
      $this->getUser()->setAttribute('filterTasksByPhasesId', $request->getParameter('filterTasksByPhasesId'));
    }
    
    if($request->hasParameter('filterTasksByVersionsId'))
    {
      $this->getUser()->setAttribute('filterTasksByVersionsId', $request->getParameter('filterTasksByVersionsId'));
    }
    
    if($request->hasParameter('filterTasksByAssignedId'))
    {
      $this->getUser()->setAttribute('filterTasksByAssignedId', $request->getParameter('filterTasksByAssignedId'));
    }
    
    if($request->hasParameter('orderTasksBy'))
    {
      $this->getUser()->setAttribute('orderTasksBy', $request->getParameter('orderTasksBy'));
      
      $projects->setOrderTasksBy($request->getParameter('orderTasksBy'));
      $projects->save();            
    }
    
    
    

    $c = new Criteria();
    

    if($this->getUser()->getAttribute('filterTasksByStatusId')>0)
    {
      $c->add(TasksPeer::TASKS_STATUS_ID, $this->getUser()->getAttribute('filterTasksByStatusId'));
    }
    else
    {
      if(strlen($this->getUser()->getAttribute('filterTasksByStatusGroupId'))>1)
      {
        $c->add(TasksPeer::TASKS_STATUS_ID, TasksStatusPeer::getStatusIdByGroupID($this->getUser()->getAttribute('filterTasksByStatusGroupId')), Criteria::IN);
      }
    }
    
    if($this->getUser()->getAttribute('filterTasksByGroupsId')>0)
    {
      $c->add(TasksPeer::TASKS_GROUPS_ID, $this->getUser()->getAttribute('filterTasksByGroupsId'));
    }
    
    if($this->getUser()->getAttribute('filterTasksByPhasesId')>0)
    {
      $c->add(TasksPeer::PROJECTS_PHASES_ID, $this->getUser()->getAttribute('filterTasksByPhasesId'));
    }
    
    if($this->getUser()->getAttribute('filterTasksByVersionsId')>0)
    {
      $c->add(TasksPeer::VERSIONS_ID, $this->getUser()->getAttribute('filterTasksByVersionsId'));
    }
    
    if($this->getUser()->getAttribute('filterTasksByAssignedId')>0)
    {
      $c->add('',"FIND_IN_SET(" . $this->getUser()->getAttribute('filterTasksByAssignedId') . "," . TasksPeer::ASSIGNED_TO . ")",CRITERIA::CUSTOM);
    }
    
    $c->add(TasksPeer::PROJECTS_ID,$this->projectId);
    
    switch($this->getUser()->getAttribute('orderTasksBy'))
    {
      case 'status':
          $c->addAscendingOrderByColumn(TasksPeer::TASKS_STATUS_ID);
          $c->addAscendingOrderByColumn(TasksPeer::NAME);
        break;
      case 'name':          
          $c->addAscendingOrderByColumn(TasksPeer::NAME);
        break;
      case 'label':
          $c->addAscendingOrderByColumn(TasksPeer::TASKS_LABEL_ID);
          $c->addAscendingOrderByColumn(TasksPeer::TASKS_STATUS_ID);
          $c->addAscendingOrderByColumn(TasksPeer::NAME);
        break;
      case 'priority':
          $c->addAscendingOrderByColumn(TasksPeer::TASKS_PRIORITY_ID);
          $c->addAscendingOrderByColumn(TasksPeer::TASKS_STATUS_ID);
          $c->addAscendingOrderByColumn(TasksPeer::NAME);
        break;
      case 'tasks_groups':
          $c->addAscendingOrderByColumn(TasksPeer::TASKS_GROUPS_ID);
          $c->addAscendingOrderByColumn(TasksPeer::TASKS_STATUS_ID);
          $c->addAscendingOrderByColumn(TasksPeer::NAME);
        break;
      case 'phases':
          $c->addAscendingOrderByColumn(TasksPeer::PROJECTS_PHASES_ID);
          $c->addAscendingOrderByColumn(TasksPeer::TASKS_STATUS_ID);
          $c->addAscendingOrderByColumn(TasksPeer::NAME);
        break;
      case 'versions':
          $c->addAscendingOrderByColumn(TasksPeer::VERSIONS_ID);
          $c->addAscendingOrderByColumn(TasksPeer::TASKS_STATUS_ID);
          $c->addAscendingOrderByColumn(TasksPeer::NAME);
        break;            
    }
    
    $pager = new sfPropelPager('Tasks', sfConfig::get('app_rows_per_page_group'));
    $pager->setPeerMethod('doSelectJoinAll');
    $pager->setPeerCountMethod('doCountJoinAll');
    $pager->setCriteria($c);
    $pager->setPage($this->getRequestParameter('page', 1));
    $pager->init();
    $this->pager = $pager;
            
    $this->tasks_list = TasksPeer::doSelectJoinAll($c);
    
    $response = $this->getResponse();
    $response->setTitle(sfConfig::get('app_app_short_name') . ' | ' . ProjectsPeer::retrieveByPk($this->projectId)->getName());
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new TasksForm(null, array('projectId' => $request->getParameter('projectId'), 'userId'=>$this->getUser()->getAttribute('userId')));
    
    $this->form->setDefault('projects_id', $request->getParameter('projectId'));
    
    if($this->getUser()->getAttribute('filterTasksByStatusId')>0)
    {
      $this->form->setDefault('tasks_status_id', $this->getUser()->getAttribute('filterTasksByStatusId'));
    }
    
    if($this->getUser()->getAttribute('filterTasksByGroupsId')>0)
    {
      $this->form->setDefault('tasks_groups_id', $this->getUser()->getAttribute('filterTasksByGroupsId'));
    }

    if($this->getUser()->getAttribute('filterTasksByPhasesId')>0)
    {
      $this->form->setDefault('projects_phases_id', $this->getUser()->getAttribute('filterTasksByPhasesId'));
    }

    if($this->getUser()->getAttribute('filterTasksByVersionsId')>0)
    {
      $this->form->setDefault('versions_id', $this->getUser()->getAttribute('filterTasksByVersionsId'));
    }
    
    if($request->hasParameter('ticketId'))
    {
      $this->form->setDefault('tickets_id',$request->getParameter('ticketId'));
    }
    
    if($request->hasParameter('discussionId'))
    {
      $this->form->setDefault('discussion_id',$request->getParameter('discussionId'));
    }
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new TasksForm(null,array('projectId' => $request->getParameter('projectId'), 'userId'=>$this->getUser()->getAttribute('userId')));


    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($tasks = TasksPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tasks does not exist (%s).', $request->getParameter('id')));
    $this->form = new TasksForm($tasks, array('projectId' => $request->getParameter('projectId'), 'userId'=>$this->getUser()->getAttribute('userId')));
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($tasks = TasksPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tasks does not exist (%s).', $request->getParameter('id')));
    $this->form = new TasksForm($tasks, array('projectId' => $request->getParameter('projectId'), 'userId'=>$this->getUser()->getAttribute('userId')));

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($tasks = TasksPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tasks does not exist (%s).', $request->getParameter('id')));

    $projectId = $tasks->getProjectsId();
    
    ExtraFields::deleteByBindId($tasks->getId(),'tasks');
    AttachmentsPeer::deleteAttachments('tasks', $tasks->getId());
    
    $tasks->delete();

    $this->redirect('tasks/index?projectId=' . $projectId);
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
  
    //insert attachments
    $attachments_files = array();
    $files = $request->getFiles();

    foreach($files['attachments'] as $key=>$file)
    {
      if(strlen($file['name'])>0)
      {
        $filename = rand(111111,999999)  . '-' . $file['name'];
        move_uploaded_file($file['tmp_name'], sfConfig::get('sf_upload_dir') . '/attachments/'  . $filename);
        $attachments_files[] = $filename;
      }
      else
      {
        $attachments_files[] = '';
      }
    }
  
    $sendNofification = false;
  
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
    
      $project = ProjectsPeer::retrieveByPk($request->getParameter('projectId'));
      
      $form->setFieldValue('assigned_to',implode(',',$form['assigned_to']->getValue()));
    
      if($form->getObject()->isNew())
      {
        $sendNofification = true;
      }
      else
      {
      
        if($form->getObject()->getAssignedTo()!=$form->getValue('assigned_to') && $form->getValue('assigned_to')>0)
        {
          $sendNofification = true;
        }
      
      
        $updateClosedDateType = TasksPeer::getUpdateClosedDateType($form->getObject(), $form->getValue('tasks_status_id'));  
        
        if($updateClosedDateType == 'updateClosedDate')
        {
          $form->setFieldValue('closed_date',date('Y-m-d'));
        }
        elseif($updateClosedDateType == 'clearClosedDate')
        {
          $form->setFieldValue('closed_date',NULL);
        }
        
        //insert new comment
        if($form->getObject()->getTasksStatusId()!=$form->getValue('tasks_status_id'))
        {                
          $tasks_comments = new TasksComments;
          $tasks_comments->setTasksId($form->getObject()->getId());
          $tasks_comments->setCreatedBy($this->getUser()->getAttribute('userId'));
          $tasks_comments->setTasksStatusId($form->getValue('tasks_status_id'));
          $tasks_comments->save();
                              
          //send notification        
          $v = TasksCommentsPeer::getSendToSendFrom($tasks_comments->getTasksId(), $tasks_comments->getCreatedBy());
          $sendTo = $v['sendTo'];
          $sendFrom = $v['sendFrom'];
                    
          if(sfConfig::get('app_notify_all_project_team')=='on')
          {
            $c = new Criteria();
            $c->add(UsersPeer::ACTIVE,1);
            $c->add(UsersPeer::ID,explode(',',$project->getTeam()), Criteria::IN);
            $users_list = UsersPeer::doSelect($c);
            
            foreach($users_list as $users)
            {
              $sendTo[$users->getEmail()] = $users->getName();
            }
          }
          
          if(sizeof($sendTo)>0)
          {
            require_once sfConfig::get('sf_lib_dir').'/vendor/swift_init.php';
                                                    
            $subject = I18NText::__('Status Updated') . ': ';                      
            $subject .= $project->getName() . ' - ' . $form->getValue('name') . ($tasks_comments->getTasksStatusId()>0 ? ' [' . $tasks_comments->getTasksStatus()->getName() . ']' : '');
            
            $body = $this->getComponent('tasksComments','emailNewComment', array('projectId'=>$request->getParameter('projectId'), 'taskId' => $tasks_comments->getTasksId()));
    
            UsersPeer::sendEmail($sendTo,$subject,$body, $sendFrom,$this->getUser());
          }
          
        } 
        
      }
      
      
      
      $tasks = $form->save();

      //insert extra fields values
      if($request->hasParameter('extra_fields'))
      {
        ExtraFieldsListPeer::insertFieldsValues($request->getParameter('extra_fields'),$tasks->getId(),'tasks');
      }

      //insert attachments

      AttachmentsPeer::insertAttachments($request->getParameter('attachments_id'), $request->getParameter('attachments_info'),$attachments_files,$tasks->getId(),'tasks');
      
      //send notification
      if($sendNofification==true && $tasks->getAssignedTo()>0)
      {
        $sendTo = array();
        $sendFrom = array();

        $c = new Criteria();
        $c->add(UsersPeer::ID,explode(',',$tasks->getAssignedTo()),CRITERIA::IN);
        $usersList = UsersPeer::doSelect($c);

        foreach($usersList as $user)
        {
          $sendTo[$user->getEmail()] = $user->getName();
        }
                      
        if(sfConfig::get('app_notify_all_project_team')=='on')
        {
          $c = new Criteria();
          $c->add(UsersPeer::ACTIVE,1);
          $c->add(UsersPeer::ID,explode(',',$project->getTeam()), Criteria::IN);                    
          $users_list = UsersPeer::doSelect($c);
          
          foreach($users_list as $users)
          {
            $sendTo[$users->getEmail()] = $users->getName();                        
          }
        }    
        
        $c = new Criteria();
        $c->add(UsersPeer::ID,$tasks->getCreatedBy());
        $user = UsersPeer::doSelectOne($c);

        $sendFrom[$user->getEmail()] = $user->getName();
        
        
        if(!sfConfig::get('app_notify_all_project_team'))
        {
          unset($sendTo[$user->getEmail()]);
        }

        if(sizeof($sendTo)>0)
        {
          require_once sfConfig::get('sf_lib_dir').'/vendor/swift_init.php';

          $subject = I18NText::__('New Task') . ': ' . $project->getName() . ' - ' . $tasks->getName() . ($tasks->getTasksLabelId()>0 ? ' [' . $tasks->getTasksLabels()->getName(). ']':'');
          $body = $this->getComponent('tasks','emailNewTask', array('projectId'=>$tasks->getProjectsId(), 'taskId' => $tasks->getId()));

          UsersPeer::sendEmail($sendTo,$subject,$body, $sendFrom,$this->getUser());
        }
      }
      
                  
      switch($request->getParameter('redirectTo'))
      {
        case 'discussionsComments':
            $this->redirect('discussionsComments/index?discussionId=' . $tasks->getDiscussionId() . '&projectId=' . $tasks->getProjectsId());
          break;
        case 'ticketsComments':
           $this->redirect('ticketsComments/index?ticketId=' . $tasks->getTicketsId() . '&projectId=' . $tasks->getProjectsId());
         break;
        case 'tasksComments':
           $this->redirect('tasksComments/index?tasksId=' . $tasks->getId() . '&projectId=' . $tasks->getProjectsId());
         break;
        default:
          $this->redirect('tasks/index?projectId=' . $tasks->getProjectsId()); 
      }
                      
    }
    
  }
  
  function executeExport(sfWebRequest $request)
  {
    //build header    
    $sheet1Header = array(I18NText::__('Project'),I18NText::__('Priority'),I18NText::__('Label'),I18NText::__('Tasks'),I18NText::__('Status'),I18NText::__('Assigned To'),I18NText::__('Created By'),I18NText::__('Est. Time'),I18NText::__('Start Date'),I18NText::__('Due Date'),I18NText::__('Progress'),I18NText::__('Type'),I18NText::__('Group'),I18NText::__('Phase'),I18NText::__('Version'));

    //include extra fields names in header
    $c= new Criteria();
    $c->add(ExtraFieldsPeer::BIND_TYPE,'tasks');
    $c->addAscendingOrderByColumn(ExtraFieldsPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(ExtraFieldsPeer::NAME);
    $extra_fields_list = ExtraFieldsPeer::doSelect($c);
    
    foreach($extra_fields_list as $extra_fields)
    {
      $sheet1Header = array_merge($sheet1Header,array($extra_fields->getName()));
    }
    
    $sheet1Header = array_merge($sheet1Header,array('Task Url'));
    
    $countSheetColumns = sizeof($sheet1Header);

    $sheet1 =  array(
      $sheet1Header,
    );
    
    
    //build data
    
    $export_items_list = explode('_',$request->getParameter('export_items'));
    
    $taskUrl = $request->getParameter('taskUrl');
    
    $tasksProject = '';
    $tasksProjectId = '';
    
    $projectTimeTotal = 0;
    $overallTimeTotal = 0;
    
    $projectExtraFieldsTotal = array();
    $overallExtraFieldsTotal = array();
    
    $countProjects = 0;
    
    foreach($export_items_list as $itemId)
    {
      $c = new Criteria();
      $c->add(TasksPeer::ID,$itemId);
      $tasks_list = TasksPeer::doSelectJoinAll($c);
      $tasks = current($tasks_list);
      
      if($tasksProjectId=='' or $tasksProjectId!=$tasks->getProjects()->getId())
      {
        if($projectTimeTotal>0)
        {
          $sheet1[][7] = 'Total: ' . $projectTimeTotal;
        }

        //set $projectExtraFieldsTotal;
        if(sizeof($projectExtraFieldsTotal)>0)
        {
          foreach($projectExtraFieldsTotal as $text=>$total)
          {
            $count_key = 0;
            foreach($sheet1Header as $value)
            {
              if($text==$value)
              {
                $sheet1[sizeof($sheet1)-1][$count_key] = 'Total: ' . $total;
              }
              $count_key++;
            }
          }
        }
        
        $tasksProject = $tasks->getProjects()->getName();
        $tasksProjectId = $tasks->getProjects()->getId();
        $sheet1[] = array();
        $sheet1[] = array($tasksProject);
        
        $projectTimeTotal = 0;
        
        $projectExtraFieldsTotal = array();
        
        $countProjects++;
      }
      
      
      $sheet1Item = array(
        '',
        ($tasks->getTasksPriorityId()>0 ? $tasks->getTasksPriority()->getName() :' '),
        ($tasks->getTasksLabelId()>0 ? $tasks->getTasksLabels()->getName() : ' '),
        $tasks->getName(),
        ($tasks->getTasksStatus() ? $tasks->getTasksStatus()->getName() : ''),
        UsersPeer::getUserNameById($tasks->getAssignedTo()),
        UsersPeer::getUserNameById($tasks->getCreatedBy()),
        $tasks->getEstimatedTime(),
        $tasks->getStartDate(),
        $tasks->getDueDate(),
        $tasks->getProgress() . '%',
        ($tasks->getTasksTypeId()>0 ? $tasks->getTasksTypes()->getName():''),
        ($tasks->getTasksGroupsId()>0 ? $tasks->getTasksGroups()->getName():''),
        ($tasks->getProjectsPhasesId()>0 ? $tasks->getProjectsPhases()->getName():''),
        ($tasks->getVersionsId()>0 ? $tasks->getVersions()->getName():''),
      );
      
      //include extra fields in data
      $c= new Criteria();
      $c->add(ExtraFieldsPeer::BIND_TYPE,'tasks');
      $c->addAscendingOrderByColumn(ExtraFieldsPeer::SORT_ORDER);
      $c->addAscendingOrderByColumn(ExtraFieldsPeer::NAME);
      $extra_fields_list = ExtraFieldsPeer::doSelect($c);

      foreach($extra_fields_list as $extra_fields)
      {
        $value = ExtraFieldsListPeer::getValueByBindId($itemId, $extra_fields->getId());
        $sheet1Item = array_merge($sheet1Item,array($value));
        
        if($value>0 && $extra_fields->getType()=='number')
        {
          //$projectExtraFieldsTotal
          if(!isset($projectExtraFieldsTotal[$extra_fields->getName()]))
          {
            $projectExtraFieldsTotal[$extra_fields->getName()] = $value;
          }
          else
          {
            $projectExtraFieldsTotal[$extra_fields->getName()] += $value;
          }
          
          //get $overallExtraFieldsTotal
          if(!isset($overallExtraFieldsTotal[$extra_fields->getName()]))
          {
            $overallExtraFieldsTotal[$extra_fields->getName()] = $value;
          }
          else
          {
            $overallExtraFieldsTotal[$extra_fields->getName()] += $value;
          }
        }
      }
      
      $sheet1Item = array_merge($sheet1Item,array($taskUrl . '?tasksId=' .$tasks->getId() . '&projectId=' . $tasks->getProjectsId()));
      
      //calculating time total
      $projectTimeTotal += $tasks->getEstimatedTime();
      $overallTimeTotal += $tasks->getEstimatedTime();
      
      $sheet1[] = $sheet1Item;
    }
    
    if($projectTimeTotal>0)
    {
      $sheet1[][7] = 'Total: ' . $projectTimeTotal;
    }

    //echo 'size=' . sizeof($sheet1);
    //set $projectExtraFieldsTotal
    if(sizeof($projectExtraFieldsTotal)>0)
    {
      foreach($projectExtraFieldsTotal as $text=>$total)
      {
        $count_key = 0;
        foreach($sheet1Header as $value)
        {
          if($text==$value)
          {
            $sheet1[sizeof($sheet1)-1][$count_key] = 'Total: ' . $total;
          }
          $count_key++;
        }
      }
    }
    
    //set $overallExtraFieldsTotal
    if($overallTimeTotal>0 && $countProjects>1)
    {
      $sheet1[] = array();
      $sheet1[][7] = 'Overall Total: ' . $overallTimeTotal;
    }
    
    //set $overallExtraFieldsTotal
    if(sizeof($overallExtraFieldsTotal)>0)
    {
      foreach($overallExtraFieldsTotal as $text=>$total)
      {
        $count_key = 0;
        foreach($sheet1Header as $value)
        {
          if($text==$value)
          {
            $sheet1[sizeof($sheet1)-1][$count_key] = 'Overall Total: ' . $total;
          }
          $count_key++;
        }
      }
    }
    
    //echo "<pre>";
    //print_r($sheet1);    
    //exit();
    
    chdir(sfConfig::get('sf_lib_dir') . '/phpxls');
    require_once 'Writer.php';
    chdir('..');

    $workbook = new Spreadsheet_Excel_Writer();
    
    $workbook->setVersion(8);

    $workbook->setCustomColor(24, 240, 240, 240);

    $format_und =& $workbook->addFormat();
    $format_und->setBottom(2);//thick
    $format_und->setBold();
    $format_und->setColor('black');
    $format_und->setFontFamily('Arial');
    $format_und->setSize(10);
    $format_und->setFgColor(24);

    $format_reg =& $workbook->addFormat();
    $format_reg->setColor('black');
    $format_reg->setFontFamily('Arial');
    $format_reg->setSize(10);
    
    $format_title =& $workbook->addFormat();
    $format_title->setBold();
    $format_title->setColor('black');
    $format_title->setFontFamily('Arial');
    $format_title->setSize(10);

    $arr = array(
          'Tasks'=>$sheet1,
          );

    //var_dump(iconv_get_encoding('all'));

    foreach($arr as $wbname=>$rows)
    {
        $rowcount = count($rows);
        $colcount = count($rows[0]);

        $worksheet =& $workbook->addWorksheet("\xD0\x9B\xD0\xB8\xD1\x81\xD1\x82");
        
        $worksheet->setInputEncoding('UTF-8');

        $worksheet->setColumn(0,0, 30);
        $worksheet->setColumn(1,2, 10);//setColumn(startcol,endcol,float)
        $worksheet->setColumn(3,3,50);
        $worksheet->setColumn(4,4,10);
        $worksheet->setColumn(5,$countSheetColumns-2,20);
        $worksheet->setColumn($countSheetColumns-1,$countSheetColumns-1, 80);

        for( $j=0; $j<$rowcount; $j++ )
        {
            for($i=0; $i<$colcount;$i++)
            {
                $fmt  =& $format_reg;
                if ($j==0)
                    $fmt =& $format_und;



                if (isset($rows[$j][$i]))
                {
                  if(isset($rows[$j][0]))
                  if(strlen($rows[$j][0])>0 and !isset($rows[$j][3]))
                  {
                    $fmt =& $format_title;
                  }
                
                    $data=$rows[$j][$i];
                                        
                    $worksheet->writeString($j, $i, $data, $fmt);
                }
            }
        }
    }
        
    $workbook->send('TasksExport.xls');
    $workbook->close();
    exit();
  }
  
  public function executeMultipleEdit(sfWebRequest $request)
  {
    if ($request->isMethod('post'))
    {
      require_once sfConfig::get('sf_lib_dir').'/vendor/swift_init.php';
      
      $selected_items = explode('_',$request->getParameter('selected_items'));
      $redirectToProject = $request->getParameter('projectId');
      
      foreach($selected_items as $itemId)
      {
        $sendNotification = false;
        $sendNewTaskNotification = false;
        
        $c = new Criteria();
        $c->add(TasksPeer::ID,$itemId);
        $tasks = TasksPeer::doSelectOne($c);
        
        $tasks_fields = $request->getParameter('tasks_fields');
        
        foreach($tasks_fields as $key=>$value)
        {
          if($value>0)
          {
            $functionName = '';
            for($i=0; $i<strlen($key);$i++)
            {
               if($i==0)
               {
                 $functionName .= strtoupper($key[$i]);
               }
               elseif($key[$i]=='_')
               {
                  $i++;
                 $functionName .= strtoupper($key[$i]);
               }
               else
               {
                 $functionName .= $key[$i];
               }
            }
            
            
            //update closed date
            if($functionName=='TasksStatusId')
            {
              $updateClosedDateType = TasksPeer::getUpdateClosedDateType($tasks, $value);  
        
              if($updateClosedDateType == 'updateClosedDate')
              {
                $tasks->setClosedDate(date('Y-m-d'));
              }
              elseif($updateClosedDateType == 'clearClosedDate')
              {
                $tasks->setClosedDate(NULL);
              }   
              
              //insert new comment
              if($tasks->getTasksStatusId()!=$value)
              {                
                $tasks_comments = new TasksComments;
                $tasks_comments->setTasksId($itemId);
                $tasks_comments->setCreatedBy($this->getUser()->getAttribute('userId'));
                $tasks_comments->setTasksStatusId($value);
                $tasks_comments->save();
                
                
                $sendNotification = true;                                
              }         
            }
            
            //notify user when tasks move to other user
            if($functionName=='AssignedTo' and $value>0)
            {
              if($tasks->getAssignedTo()!=$value)
              {
                $sendNewTaskNotification = true;
              }
            }

            $eval_str = '$tasks->set' . $functionName . '("' . $value . '");';
            
            eval($eval_str);
                                    
          }
        }
        
        $tasks->save();
        
        $project = ProjectsPeer::retrieveByPk($tasks->getProjectsId());
        
        if($sendNewTaskNotification)
        {
          $sendTo = array();
          $sendFrom = array();
  
          $c = new Criteria();
          $c->add(UsersPeer::ID,$tasks->getAssignedTo());
          $user = UsersPeer::doSelectOne($c);
  
          $sendTo[$user->getEmail()] = $user->getName();
          
          if(sfConfig::get('app_notify_all_project_team')=='on')
          {
            $c = new Criteria();
            $c->add(UsersPeer::ACTIVE,1);
            $c->add(UsersPeer::ID,explode(',',$project->getTeam()), Criteria::IN);                      
            $users_list = UsersPeer::doSelect($c);                    
            foreach($users_list as $users)
            {
              $sendTo[$users->getEmail()] = $users->getName();
            }
          }
  
          $c = new Criteria();
          $c->add(UsersPeer::ID,$tasks->getCreatedBy());
          $user = UsersPeer::doSelectOne($c);
  
          $sendFrom[$user->getEmail()] = $user->getName();
          
          if(!sfConfig::get('app_notify_all_project_team'))
          {
            unset($sendTo[$user->getEmail()]);
          }
  
          if(sizeof($sendTo)>0)
          {
            require_once sfConfig::get('sf_lib_dir').'/vendor/swift_init.php';
  
            $subject = I18NText::__('New Task') . ': ' . $project->getName() . ' - ' . $tasks->getName() . ($tasks->getTasksLabelId()>0 ? ' [' . $tasks->getTasksLabels()->getName(). ']':'');
            $body = $this->getComponent('tasks','emailNewTask', array('projectId'=>$tasks->getProjectsId(), 'taskId' => $tasks->getId()));
  
            UsersPeer::sendEmail($sendTo,$subject,$body, $sendFrom,$this->getUser());
          }        
        }
        elseif($sendNotification)
        {
          $v = TasksCommentsPeer::getSendToSendFrom($tasks->getId(), $tasks_comments->getCreatedBy());
          $sendTo = $v['sendTo'];
          $sendFrom = $v['sendFrom']; 
          
          if(sfConfig::get('app_notify_all_project_team')=='on')
          {
            $c = new Criteria();
            $c->add(UsersPeer::ACTIVE,1);
            $c->add(UsersPeer::ID,explode(',',$project->getTeam()), Criteria::IN);            
            $users_list = UsersPeer::doSelect($c);
            
            foreach($users_list as $users)
            {
              $sendTo[$users->getEmail()] = $users->getName();
            }
          }
          
          if(sizeof($sendTo)>0)
          {                          
                                    
            $subject = I18NText::__('Status Updated') . ': ';                        
            $subject .= $project->getName() . ' - ' . $tasks->getName() . ($tasks_comments->getTasksStatusId()>0 ? ' [' . $tasks_comments->getTasksStatus()->getName() . ']' : '');
            
            $body = $this->getComponent('tasksComments','emailNewComment', array('projectId'=>$tasks->getProjectsId(), 'taskId' => $tasks_comments->getTasksId()));
    
            UsersPeer::sendEmail($sendTo,$subject,$body, $sendFrom,$this->getUser());
          }
        }
        
        if($key=='projects_id' && $value>0)
        {
          $redirectToProject = $value;
        }

      }

       $this->redirect('tasks/index?projectId=' . $redirectToProject);
    }
  
    $this->form = new TasksMultipleEditForm(null,array('projectId' => $request->getParameter('projectId'), 'user'=>$this->getUser()));
  }
  
  public function executeRemoveRelation(sfWebRequest $request)
  {    
    if($tasks = TasksPeer::retrieveByPk($request->getParameter('tasksId')))
    {
      $tasks->setTicketsId(NULL);
      $tasks->save();
    }
      
    if($request->hasParameter('ticketId'))
    {
      $this->redirect('ticketsComments/index?ticketId=' . $request->getParameter('ticketId') . '&projectId=' . $request->getParameter('projectId'));
    }
    else
    {
      $this->redirect('tasksComments/index?tasksId=' . $request->getParameter('tasksId') . '&projectId=' . $request->getParameter('projectId'));
    }
  
  }
  
  public function executeRemoveDiscussionRelation(sfWebRequest $request)
  {    
    if($tasks = TasksPeer::retrieveByPk($request->getParameter('tasksId')))
    {
      $tasks->setDiscussionId(NULL);
      $tasks->save();
    }
      
    if($request->hasParameter('discussionId'))
    {
      $this->redirect('discussionsComments/index?discussionId=' . $request->getParameter('discussionId') . '&projectId=' . $request->getParameter('projectId'));
    }
    else
    {
      $this->redirect('tasksComments/index?tasksId=' . $request->getParameter('tasksId') . '&projectId=' . $request->getParameter('projectId'));
    }
  
  }  
}
