<?php

class tasksComponents extends sfComponents
{
  public function executeFilter()
  {
    $this->tasks_status_group_list = array();
    $this->tasks_status_group_list[] = 'All';
    $this->tasks_status_group_list = array_merge($this->tasks_status_group_list, TasksStatusPeer::getTasksStatusGroupsList());

    //get tasks status
    $c = new Criteria();
    $c->add(BaseTasksStatusPeer::ACTIVE, 1);
    $this->countTasksStatus = TasksStatusPeer::doCount($c);

    $c= new Criteria();
    $c->add(TasksStatusPeer::ACTIVE, 1);
    $c->addAscendingOrderByColumn(TasksStatusPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(TasksStatusPeer::NAME);
    $tasksStatusList = TasksStatusPeer::doSelect($c);

    $this->tasks_status_list = array();
    $this->tasks_status_list[] = 'All';
    foreach($tasksStatusList as $tasksStauts)
    {
      $countTasksByStatusId = TasksPeer::countTasksByStatusId($tasksStauts->getId(), $this->projectId);
      
      $countTasksByStatusIdStr = '';
      if($countTasksByStatusId>0)
      {
        $countTasksByStatusIdStr = ' (' . $countTasksByStatusId . ')';
      }
    
      $this->tasks_status_list[$tasksStauts->getGroup()][$tasksStauts->getId()] = '&nbsp;&nbsp;&nbsp;' . $tasksStauts->getName() . $countTasksByStatusIdStr;
    }
    
    //print_r($this->tasks_status_list);
    
    //get tasks groups
    $c = new Criteria();
    $c->add(TasksGroupsPeer::PROJECTS_ID, $this->projectId);
    $this->countTasksGroups = TasksGroupsPeer::doCount($c);
    
    $c= new Criteria();
    $c->add(TasksGroupsPeer::PROJECTS_ID, $this->projectId);
    $c->addAscendingOrderByColumn(TasksGroupsPeer::NAME);
    $tasksGroupsList = TasksGroupsPeer::doSelect($c);

    $this->tasks_groups_list = array();
    $this->tasks_groups_list[] = 'All';
    foreach($tasksGroupsList as $tasksGroups)
    {
    
      $countTasksByGroupId = TasksPeer::countTasksByGroupId($tasksGroups->getId(), $this->projectId);

      $countTasksByGroupIdStr = '';
      if($countTasksByGroupId>0)
      {
        $countTasksByGroupIdStr = ' (' . $countTasksByGroupId . ')';
      }
      
      $this->tasks_groups_list[$tasksGroups->getId()] =  $tasksGroups->getName() . $countTasksByGroupIdStr;
    }
    
    //get tasks phases
    $c = new Criteria();
    $c->add(ProjectsPhasesPeer::PROJECTS_ID, $this->projectId);
    $this->countProjectsPhases = ProjectsPhasesPeer::doCount($c);
    
    $c= new Criteria();
    $c->add(ProjectsPhasesPeer::PROJECTS_ID, $this->projectId);
    $c->addAscendingOrderByColumn(ProjectsPhasesPeer::NAME);
    $projectsPhasesList = ProjectsPhasesPeer::doSelect($c);

    $this->projects_phases_list = array();
    $this->projects_phases_list[] = 'All';
    foreach($projectsPhasesList as $projectsPhases)
    {
      $countTasksByPhaseId = TasksPeer::countTasksByPhaseId($projectsPhases->getId(), $this->projectId);

      $countTasksByPhaseIdStr = '';
      if($countTasksByPhaseId>0)
      {
        $countTasksByPhaseIdStr = ' (' . $countTasksByPhaseId . ')';
      }
      
      $this->projects_phases_list[$projectsPhases->getId()] =  $projectsPhases->getName() . $countTasksByPhaseIdStr;
    }
    
    //get tasks phases
    $c = new Criteria();
    $c->add(VersionsPeer::PROJECTS_ID, $this->projectId);
    $this->countVersions = VersionsPeer::doCount($c);

    $c= new Criteria();
    $c->add(VersionsPeer::PROJECTS_ID, $this->projectId);
    $c->addAscendingOrderByColumn(VersionsPeer::NAME);
    $versionsList = VersionsPeer::doSelect($c);

    $this->versions_list = array();
    $this->versions_list[] = 'All';
    foreach($versionsList as $versions)
    {
      $countTasksByVersionId = TasksPeer::countTasksByVersionId($versions->getId(), $this->projectId);

      $countTasksByVersionIdStr = '';
      if($countTasksByVersionId>0)
      {
        $countTasksByVersionIdStr = ' (' . $countTasksByVersionId . ')';
      }
      
      $this->versions_list[$versions->getId()] =  $versions->getName() . $countTasksByVersionIdStr;
    }
    
    $c = new Criteria();
    $c->add(ProjectsPeer::ID, $this->projectId);
    $this->project = ProjectsPeer::doSelectOne($c);
    
    if(strlen($this->project->getTeam())>0)
    {
      $c= new Criteria();
      $c->add(UsersPeer::ACTIVE,1);
      $c->add(UsersPeer::ID,explode(',',$this->project->getTeam()),CRITERIA::IN);
      $users_list = UsersPeer::doSelect($c);
      
      $this->users_list = array();
      $this->users_list[] = 'All';
      foreach($users_list as $user)
      {
        $this->users_list[$user->getId()] = $user->getName();
      }
    }
    
    if(!isset($this->form_action))
    {
      $this->form_action = 'tasks';
    }
    
    $this->orderTasksValuesList = array();
    $this->orderTasksValuesList['status'] = I18NText::__('Status');
    $this->orderTasksValuesList['name'] = I18NText::__('Name');
    $this->orderTasksValuesList['label'] = I18NText::__('Label');
    $this->orderTasksValuesList['priority'] = I18NText::__('Priority');
    
    if($this->countTasksGroups>0)
    {
      $this->orderTasksValuesList['tasks_groups'] = I18NText::__('Tasks Groups');
    }
    
    if($this->countProjectsPhases>0)
    {
      $this->orderTasksValuesList['phases'] = I18NText::__('Phases');
    }
    
    if($this->countVersions>0)
    {
      $this->orderTasksValuesList['versions'] = I18NText::__('Versions');
    }
    
  }
  
  public function executeDetails()
  {
    $c = new Criteria();
    $c->add(TasksPeer::ID,$this->tasksId);
    $this->tasks_list = TasksPeer::doSelectJoinAll($c);
    $this->task = current($this->tasks_list);
    
    $c = new Criteria();
    $c->add(TasksGroupsPeer::ID, $this->task->getTasksGroupsId());
    $this->tasksGroups = TasksGroupsPeer::doSelectOne($c);
    
    $c = new Criteria();
    $c->add(ProjectsPhasesPeer::ID, $this->task->getProjectsPhasesId());
    $this->tasksPhases = ProjectsPhasesPeer::doSelectOne($c);
    
    $c = new Criteria();
    $c->add(VersionsPeer::ID, $this->task->getVersionsId());
    $this->versions = VersionsPeer::doSelectOne($c);

    $c = new Criteria();
    $c->add(UsersPeer::ID, explode(',',$this->task->getAssignedTo()),CRITERIA::IN);
    $this->assignedTo = UsersPeer::doSelect($c);
    
    if(!isset($this->allowEdit))
    {
      $this->allowEdit = true;
    }
    
    if(!isset($this->setEmailStyle))
    {
      $this->setEmailStyle = false;
    }

    $this->divStyle = '';
    $this->tableStyle = '';
    $this->tdStyle = '';
    $this->thStyle = '';

    if($this->setEmailStyle==true)
    {
      $this->divStyle = ' style="padding: 5px; margin-top: 5px; border: 1px dashed LightGray;" ';
      $this->tableStyle = ' style="width: 100%;" ';
      $this->tdStyle = ' style="padding: 2px; border-bottom: 1px solid white; background: #eaf0f3; font-family:  Arial; font-size: 13px; color: #000;" ';
      $this->thStyle = ' style="padding: 2px; border-bottom: 1px solid white; background: #3d7291; color: white; font-family:  Arial; font-size: 13px; text-align: left;" ';
    }
    
  }
  
  public function executeEmailNewTask()
  {
    $c = new Criteria();
    $c->add(TasksPeer::ID,$this->taskId);
    $this->tasks_list = TasksPeer::doSelectJoinAll($c);
    $this->task = current($this->tasks_list);
    
    $c = new Criteria();
    $c->add(ProjectsPeer::ID, $this->task->getProjectsId());
    $projects_list = ProjectsPeer::doSelectJoinAll($c);
    $this->project = current($projects_list);
  }
  
  public function executeGoToTask()
  {
    if(!$this->getUser()->hasAttribute('filterTasksByStatusGroupId'))
    {
      $this->getUser()->setAttribute('filterTasksByStatusGroupId', 'open');
    }
    
    $c = new Criteria();
        
    if($this->getUser()->getAttribute('filterTasksByStatusId')>0)
    {
      $c->add(TasksPeer::TASKS_STATUS_ID, $this->getUser()->getAttribute('filterTasksByStatusId'));
    }
    else
    {
      if(strlen($this->getUser()->getAttribute('filterTasksByStatusGroupId'))>1)
      {
        $c->add(TasksPeer::TASKS_STATUS_ID, TasksStatusPeer::getStatusIdByGroupID($this->getUser()->getAttribute('filterTasksByStatusGroupId')), Criteria::IN);
      }
    }

    if($this->getUser()->getAttribute('filterTasksByGroupsId')>0)
    {
      $c->add(TasksPeer::TASKS_GROUPS_ID, $this->getUser()->getAttribute('filterTasksByGroupsId'));
    }

    if($this->getUser()->getAttribute('filterTasksByPhasesId')>0)
    {
      $c->add(TasksPeer::PROJECTS_PHASES_ID, $this->getUser()->getAttribute('filterTasksByPhasesId'));
    }

    if($this->getUser()->getAttribute('filterTasksByVersionsId')>0)
    {
      $c->add(TasksPeer::VERSIONS_ID, $this->getUser()->getAttribute('filterTasksByVersionsId'));
    }
    
    if($this->getUser()->getAttribute('filterTasksByAssignedId')>0)
    {
      $c->add('',"FIND_IN_SET(" . $this->getUser()->getAttribute('filterTasksByAssignedId') . "," . TasksPeer::ASSIGNED_TO . ")",CRITERIA::CUSTOM);
    }

    $c->add(TasksPeer::PROJECTS_ID,$this->projectId);
    
    
    switch($this->getUser()->getAttribute('orderTasksBy'))
    {
      case 'status':
          $c->addAscendingOrderByColumn(TasksPeer::TASKS_STATUS_ID);
          $c->addAscendingOrderByColumn(TasksPeer::NAME);
        break;
      case 'name':          
          $c->addAscendingOrderByColumn(TasksPeer::NAME);
        break;
      case 'label':
          $c->addAscendingOrderByColumn(TasksPeer::TASKS_LABEL_ID);
          $c->addAscendingOrderByColumn(TasksPeer::TASKS_STATUS_ID);
          $c->addAscendingOrderByColumn(TasksPeer::NAME);
        break;
      case 'priority':
          $c->addAscendingOrderByColumn(TasksPeer::TASKS_PRIORITY_ID);
          $c->addAscendingOrderByColumn(TasksPeer::TASKS_STATUS_ID);
          $c->addAscendingOrderByColumn(TasksPeer::NAME);
        break;
      case 'tasks_groups':
          $c->addAscendingOrderByColumn(TasksPeer::TASKS_GROUPS_ID);
          $c->addAscendingOrderByColumn(TasksPeer::TASKS_STATUS_ID);
          $c->addAscendingOrderByColumn(TasksPeer::NAME);
        break;
      case 'phases':
          $c->addAscendingOrderByColumn(TasksPeer::PROJECTS_PHASES_ID);
          $c->addAscendingOrderByColumn(TasksPeer::TASKS_STATUS_ID);
          $c->addAscendingOrderByColumn(TasksPeer::NAME);
        break;
      case 'versions':
          $c->addAscendingOrderByColumn(TasksPeer::VERSIONS_ID);
          $c->addAscendingOrderByColumn(TasksPeer::TASKS_STATUS_ID);
          $c->addAscendingOrderByColumn(TasksPeer::NAME);
        break;            
    }
    
    $tasks_list = TasksPeer::doSelectJoinAll($c);
    
    $this->options_for_select = array();
    
    foreach($tasks_list as $tasks)
    {
      $status_name_str = '';
      if($tasks->getTasksStatusId()>0)
      {
        $status_name_str = ' (' . $tasks->getTasksStatus()->getName() . ')';
      }
      
      $type_name_str = '';
      if($tasks->getTasksLabelId()>0)
      {
        $type_name_str = $tasks->getTasksLabels()->getName() . ': ';
      }
      
      $this->options_for_select[$tasks->getId()] = $type_name_str . $tasks->getName() . $status_name_str;
    }

  }
  
  public function executeRelatedTicket()
  {
     $c= new Criteria();
     $c->add(TicketsPeer::ID,$this->ticketId);
     $this->ticket = TicketsPeer::doSelectOne($c);
  }
  
  public function executeRelatedDiscussion()
  {
     $c= new Criteria();
     $c->add(DiscussionsPeer::ID,$this->discussionId);
     $this->discussion = DiscussionsPeer::doSelectOne($c);
  }
}
?>