<?php include_stylesheets_for_form($form) ?>
<?php include_javascripts_for_form($form) ?>
<?php $form->setDefault('assigned_to',explode(',', $form['assigned_to']->getValue())); ?>

<?php
  $countTasksStatus = TasksStatusPeer::doCountActive();
  $countTasksTypes = TasksTypesPeer::doCountActive();
  $countTasksPriority = TasksPriorityPeer::doCountActive();
  $countTasksLabels = TasksLabelsPeer::doCountActive();
?>

<form name="TasksForm" id="TasksForm" onSubmit="return validateForm(this.id, '<?php echo url_for('home/validateForm',true); ?>')" action="<?php echo url_for('tasks/'.($form->getObject()->isNew() ? 'create' : 'update').(!$form->getObject()->isNew() ? '?id='.$form->getObject()->getId() : ''),true) ?>" method="post" <?php echo 'enctype="multipart/form-data" ' ?>>
<input type="hidden" name="formName" value="TasksForm" />
<input type="hidden" name="formOptions[projectId]" value="<?php echo $sf_request->getParameter('projectId'); ?>" />
<?php if (!$form->getObject()->isNew()): ?>
<input type="hidden" name="sf_method" value="put" />
<?php endif; ?>

<?php


if($sf_request->hasParameter('redirectTo'))
{
  echo input_hidden_tag('redirectTo', $sf_request->getParameter('redirectTo'));
}
elseif($form->getObject()->isNew())
{
  echo input_hidden_tag('redirectTo','tasks');
}

?>

  <table class="formTable" width="700">
    <tfoot>
      <tr>
        <td colspan="2">
          <?php echo $form->renderHiddenFields() . input_hidden_tag('projectId', $sf_request->getParameter('projectId')) ?>
          <table>
            <tr>
              <td><input type="submit" value="<?php echo __('Save') ?>" /></td>
              <td><div id="formLoadingContainer"></div></td>
            </tr>
          </table>
        </td>
      </tr>
    </tfoot>
    <tbody>
      <?php echo $form->renderGlobalErrors() ?>
    <tr>
      <td>

      <div id="yuiTaskTabMenu" class="yui-navset" style="display: none;">
          <ul class="yui-nav">
              <li class="selected"><a href="#taskInfo"><em><?php echo __('General') ?></em></a></li>
              <li><a href="#taskGeneral"><em><?php echo __('Time') ?></em></a></li>
              <li><a href="#taskAttachment"><em><?php echo __('Attachments') ?></em></a></li>
          </ul>
          <div class="yui-content">
              <div id="taskInfo">
              
                <table>
                  <?php if($countTasksLabels>0):?>
                  <tr>
                    <th><?php echo $form['tasks_label_id']->renderLabel() ?></th>
                    <td>
                      <?php echo $form['tasks_label_id']->renderError() ?>
                      <?php echo $form['tasks_label_id'] ?>
                    </td>
                  </tr>
                  <?php endif ?>
                  
                  <tr>
                    <th><?php echo $form['name']->renderLabel() ?></th>
                    <td>
                      <?php echo $form['name']->renderError() ?>
                      <?php echo $form['name'] ?>
                    </td>
                  </tr>
                  
                  <?php if($countTasksStatus>0):?>
                  <tr>
                    <th><?php echo $form['tasks_status_id']->renderLabel() ?></th>
                    <td>
                      <?php echo $form['tasks_status_id']->renderError() ?>
                      <?php echo $form['tasks_status_id'] ?>
                    </td>
                  </tr>
                  <?php endif ?>
                  
                  <?php if($countTasksPriority>0):?>
                  <tr>
                    <th><?php echo $form['tasks_priority_id']->renderLabel() ?></th>
                    <td>
                      <?php echo $form['tasks_priority_id']->renderError() ?>
                      <?php echo $form['tasks_priority_id'] ?>
                    </td>
                  </tr>
                  <?php endif ?>
                  
                  <?php if($countTasksTypes>0):?>
                  <tr>
                    <th><?php echo $form['tasks_type_id']->renderLabel() ?></th>
                    <td>
                      <?php echo $form['tasks_type_id']->renderError() ?>
                      <?php echo $form['tasks_type_id'] ?>
                    </td>
                  </tr>
                  <?php endif ?> 
                  
                  <?php if($form->getOption('countTasksGroups')>0): ?>
                  <tr>
                    <th><?php echo $form['tasks_groups_id']->renderLabel() ?></th>
                    <td>
                      <?php echo $form['tasks_groups_id']->renderError() ?>
                      <?php echo $form['tasks_groups_id'] ?>
                    </td>
                  </tr>
                  <?php endif; ?>
                  
                  <?php if($form->getOption('countProjectsPhases')>0): ?>
                  <tr>
                    <th><?php echo $form['projects_phases_id']->renderLabel() ?></th>
                    <td>
                      <?php echo $form['projects_phases_id']->renderError() ?>
                      <?php echo $form['projects_phases_id'] ?>
                    </td>
                  </tr>
                  <?php endif; ?>
                  
                  <?php if($form->getOption('countVersions')>0): ?>
                  <tr>
                    <th><?php echo $form['versions_id']->renderLabel() ?></th>
                    <td>
                      <?php echo $form['versions_id']->renderError() ?>
                      <?php echo $form['versions_id'] ?>
                    </td>
                  </tr>
                  <?php endif; ?>
                  
                  <tr>
                    <th><?php echo $form['assigned_to']->renderLabel() ?></th>
                    <td>
                      <?php echo $form['assigned_to']->renderError() ?>
                      
                      <table><tr>
                      <td><?php echo $form['assigned_to'] ?></td>
                      <td style="vertical-align: top; padding-top: 5px;"><?php echo image_tag('icons/plus_large.png',array('onClick'=>'expandAssignedTo()','id'=>'assigned_to_expand_icon','class'=>'assigned_to_expand_icon'));?></td>
                      </tr></table>                                            
                    </td>                    
                  </tr>
                  
                  <?php  include_component('extraFields','extraFieldsList', array('bindType'=>'tasks', 'bindId'=>(!$form->getObject()->isNew() ? $form->getObject()->getId() : ''))); ?>
                  
                  <tr>
                    <th><?php echo $form['description']->renderLabel() ?></th>
                    <td>
                      <?php echo $form['description']->renderError() ?>
                      <?php echo $form['description'] ?>
                    </td>
                  </tr>
                  
                  <tr>
                    <th><?php echo $form['created_by']->renderLabel() ?></th>
                    <td>
                      <?php echo $form['created_by']->renderError() ?>
                      <?php echo $form['created_by'] ?>                      
                    </td>
                  </tr>

                </table>
      
              </div>
              <div id="taskGeneral">

                <table>
                                                                   
                  <tr>
                    <th><?php echo $form['progress']->renderLabel() ?></th>
                    <td>
                      <?php echo $form['progress']->renderError() ?>
                      <?php echo $form['progress'] ?>
                    </td>
                  </tr>                  
                  <tr>
                    <th><?php echo $form['estimated_time']->renderLabel() ?></th>
                    <td>
                      <?php echo $form['estimated_time']->renderError() ?>
                      <?php echo $form['estimated_time'] ?>
                    </td>
                  </tr>                  
                  <tr>
                    <th><?php echo $form['start_date']->renderLabel() ?></th>
                    <td>
                      <?php echo $form['start_date']->renderError() ?>
                      <?php echo $form['start_date'] ?>
                    </td>
                  </tr>
                  <tr>
                    <th><?php echo $form['due_date']->renderLabel() ?></th>
                    <td>
                      <?php echo $form['due_date']->renderError() ?>
                      <?php echo $form['due_date'] ?>
                    </td>
                  </tr>
                                     
                </table>                 
              </div>
              <div id="taskAttachment">
                <?php  include_component('attachments','attachmentsList', array('bindType'=>'tasks', 'bindId'=>(!$form->getObject()->isNew() ? $form->getObject()->getId() : ''))); ?>
              </div>
          </div>
      </div>
      
<script type="text/javascript">
YAHOO.util.Event.onContentReady("yuiTaskTabMenu", function() {

    var tabView = new YAHOO.widget.TabView('yuiTaskTabMenu');
    yuiTabViewShowTabs('yuiTaskTabMenu');
    
    <?php echo 'assigned_to_size = '. sizeof($form['assigned_to']->getValue()); ?>
    
    if(assigned_to_size>1)
    {
      $('tasks_assigned_to').size = 5;      
      $('tasks_assigned_to').multiple = "multiple";
    
      icon_src = $('assigned_to_expand_icon').src;
      $('assigned_to_expand_icon').src = icon_src.replace('plus_large','minus_large');
    }
    else
    {
      $('tasks_assigned_to').multiple = "";
    }
        

});
</script>
       </td>
      </tr>
    </tbody>
  </table>
</form>


