


<?php include_component('projects', 'shortInfo', array('projectId' => $projectId)) ?>

<div id="projectsMenuContainer"><?php include_partial('projects/projectsMenu', array('projectId' => $projectId)); ?></div>

<?php include_component('tasks', 'filter', array('projectId' => $projectId)) ?>

<?php

$total_values = array();


$yuiTableOptions = array();
$yuiTableOptions['module'] = 'tasks';

$yuiTableOptions['urlParams'] = 'projectId=' . $projectId;

$yuiTableOptions['allowMultipleSelect'] = true;
$yuiTableOptions['allowMultipleEdit'] = true;
$yuiTableOptions['allowMultipleExport'] = true;
$yuiTableOptions['allowSortItems'] = false;
$yuiTableOptions['buttonInsertTitle'] = __('Add Task');

$yuiTableOptions['isUrlColumn'] = true;

if($sf_user->hasCredential('allow_manage_tasks_viewonly'))
{
  
  $yuiTableOptions['allowMultipleEdit'] = false;  
  $yuiTableOptions['allowEdit']   = false;
  $yuiTableOptions['allowDelete'] = false;
  $yuiTableOptions['allowInsert'] = false;  
}


$yuiTable = array();


if(VersionsPeer::countVersions($projectId))
{
  $yuiTable['key'][] = array('id' => 'tasks_version', 'label'=>__('Version'));
}

if(ProjectsPhasesPeer::countProjectPhases($projectId))
{
  $yuiTable['key'][] = array('id' => 'tasks_phase', 'label'=>__('Phase'));
}

if(TasksGroupsPeer::countTasksGroups($projectId))
{
  $yuiTable['key'][] = array('id' => 'tasks_group', 'label'=>__('Group'));
}

if(TasksPriorityPeer::doCountActive()>0)
{
  $yuiTable['key'][] = array('id' => 'priority', 'label'=>'P','parser'=>'number','formatter'=>'formatTasksPriority');
}
$yuiTable['key'][] = array('id' => 'label', 'label'=>__('Label'));
$yuiTable['key'][] = array('id' => 'id', 'label'=>__('ID'),'parser'=>'number');
$yuiTable['key'][] = array('id' => 'name', 'label'=>__('Name'),'formatter'=>'formatUrl');

if(TasksStatusPeer::doCountActive()>0)
{
  $yuiTable['key'][] = array('id' => 'status', 'label'=>__('Status'));
}
$yuiTable['key'][] = array('id' => 'type', 'label'=>__('Type'));
$yuiTable['key'][] = array('id' => 'assigned_to', 'label'=>__('Assigned To'));
$yuiTable['key'][] = array('id' => 'created_by', 'label'=>__('Created By'));
$yuiTable['key'][] = array('id' => 'estimated_time', 'label'=>__('Est. Time'),'parser'=>'number');
$yuiTable['key'][] = array('id' => 'start_date', 'label'=>__('Start Date'),'formatter'=>'formatDate');
$yuiTable['key'][] = array('id' => 'due_date', 'label'=>__('Due Date'),'formatter'=>'formatDate');
$yuiTable['key'][] = array('id' => 'progress', 'label'=>__('Progress'),'formatter'=>'formatProgress');
$yuiTable['key'][] = array('id' => 'created_at', 'label'=>__('Created At'),'formatter'=>'formatDate');


$yuiTable = set_default_key_list($yuiTable);

$yuiTable = ExtraFieldsListPeer::setYuiTableKeys($yuiTable, 'tasks');
$extra_fields_list = ExtraFieldsListPeer::getExtraFieldsListByType('tasks');

$commentsTipsTextsList = '';

$yuiTable['data'] = array();
foreach ($tasks_list as $tasks)
{
  $nameLastCommented = TasksCommentsPeer::getNameLastCommented($tasks->getId());
  
  if(strlen($nameLastCommented)>0)
  {
    $commentsTipsTextId = 'commentTip_' . rand(111111111,999999999); 
    $commentsTipsTextsList .= input_hidden_tag($commentsTipsTextId,TasksCommentsPeer::getTextLastCommented($tasks->getId()));
    $nameLastCommented = '&nbsp;<sup><div class="commentName"  onmouseover="doTip(\'' . $commentsTipsTextId . '\')" onmouseout="UnTip()">' . image_tag('icons/comment.png') . $nameLastCommented . '</div></sup>';
  }
  
  $assignedToList = ''; 
  foreach(explode(',',$tasks->getAssignedTo()) as $v)
  {
    $assignedToList .= UsersPeer::getUserNameById($v) . '<br>';
  }
  
  $yuiTable['data'][$tasks->getId()] =  array('status'         => ($tasks->getTasksStatus() ? $tasks->getTasksStatus()->getName() : ''),
                                              'label'          => ($tasks->getTasksLabelId()>0 ? $tasks->getTasksLabels()->getName() : ''),
                                              'priority'       => ($tasks->getTasksPriorityId()>0 ? $tasks->getTasksPriority()->getSortOrder() . '.' .  $tasks->getTasksPriorityId(): ''),
                                              'id'             =>  $tasks->getId(),                                                                                            
                                              'name'           =>  $tasks->getName()  . $nameLastCommented,
                                              'url'            => url_for('tasksComments/index?tasksId=' . $tasks->getId() . '&projectId=' . $projectId),
                                              'type'          => ($tasks->getTasksTypeId()>0 ? $tasks->getTasksTypes()->getName() : ''),
                                              'assigned_to'    => $assignedToList,
                                              'created_by'     => ($tasks->getUsers() ? $tasks->getUsers()->getName():''),
                                              'estimated_time' => $tasks->getEstimatedTime(),
                                              'start_date'     => getDateTimestamp($tasks->getStartDate()),
                                              'due_date'       => getDateTimestamp($tasks->getDueDate()),
                                              'created_at'     => getDateTimestamp($tasks->getCreatedAt()),
                                              'progress'       => $tasks->getProgress(),
                                              'tasks_group'    => ($tasks->getTasksGroups() ? $tasks->getTasksGroups()->getName() : ''),
                                              'tasks_phase'    => ($tasks->getProjectsPhases() ? $tasks->getProjectsPhases()->getName() : ''),
                                              'tasks_version'  => ($tasks->getVersions() ? $tasks->getVersions()->getName() : ''),
                                              );
                                              
  $yuiTable = ExtraFieldsListPeer::setYuiTableData($yuiTable, $extra_fields_list,$tasks->getId());
                                              
  if(!isset($total_values['Est. Time']) && $tasks->getEstimatedTime()>0)
  {
    $total_values['Est. Time'] = $tasks->getEstimatedTime();
  }
  elseif($tasks->getEstimatedTime()>0)
  {
    $total_values['Est. Time'] += $tasks->getEstimatedTime();
  }
  
  $total_values = ExtraFieldsListPeer::getTotalNumericFieldsValues($total_values, 'tasks', $tasks->getId());
}

include_partial('global/yuiBasicDataTable',array('yuiTable' => $yuiTable, 'yuiTableOptions' => $yuiTableOptions));

include_partial('global/totalValues', array('total_values' => $total_values));

echo $commentsTipsTextsList;

include_partial('global/pager', array('url_params'=>'projectId=' . $sf_request->getParameter('projectId'),'request_page'=>'page','module' => $sf_context->getModuleName(), 'action'=>$sf_context->getActionName(),'pager'=>$pager));

?>
