<?php include_component('projects', 'shortInfo', array('projectId' => $projectId)) ?>

<div id="projectsMenuContainer"><?php include_partial('projects/projectsMenu', array('projectId' => $projectId)); ?></div>

<?php include_component('tasks', 'goToTask', array('projectId' => $projectId, 'tasksId' => $tasksId)) ?>

<table width="100%">
  <tr>
    <td style="vertical-align: top; padding-top: 15px;">
<h1><?php echo ($task->getTasksLabelId()>0 ? $task->getTasksLabels()->getName(). ': ':'') . $task->getName() . ($task->getTasksStatusId()>0 ? ' [' . $task->getTasksStatus()->getName() . ']' : ''); ?></h1>

<?php if(!$sf_user->hasCredential('allow_manage_tasks_viewonly')): ?>
<div class="itemAction">
  <table>
    <tr>
      <td>&nbsp;&nbsp;&nbsp;<?php echo link_to_function(image_tag('icons/comment_small.png') . ' ' . __('add comment'),'yuiShowPanel(\'New\',\'' . url_for('tasksComments/new?tasksId='. $task->getId() . '&projectId=' . $task->getProjectsId(),true) . '\')',array('style'=>'text-decoration:none;')); ?></td>      
      <td>&nbsp;&nbsp;&nbsp;<?php echo link_to_function(image_tag('icons/edit_small.png') . ' ' . __('edit details'),'yuiShowPanel(\'Edit\',\'' . url_for('tasks/edit?id='. $task->getId() . '&projectId=' . $task->getProjectsId() . '&redirectTo=tasksComments',true) . '\')',array('style'=>'text-decoration:none;')); ?></td>
      <td>&nbsp;&nbsp;&nbsp;<?php echo image_tag('icons/icon_delete_small.png') . ' ' . '<a href="' . url_for('tasks/delete?id=' . $task->getId() . '&projectId=' . $task->getProjectsId()). '" onClick="return confirm(\'' . __('Are you sure?') . '\');" style="text-decoration:none;">' . __('Remove') . '</a>'; ?></td>            
    </tr>
  </table>
</div>
<?php endif; ?>

<div class="itemDescription"><?php echo replaceTextToLinks($task->getDescription()); ?></div>

<?php  include_component('attachments','attachmentsValuesList', array('bindType'=>'tasks', 'bindId'=>$tasksId)); ?>

<?php

$yuiTableOptions = array();
$yuiTableOptions['module'] = 'tasksComments';

$yuiTableOptions['urlParams'] = 'projectId=' . $projectId . '&tasksId=' . $tasksId;

$yuiTableOptions['allowSortItems'] = false;

$yuiTableOptions['buttonInsertTitle'] = __('Add Comment');

$yuiTable = array();

$yuiTable['key'][] = array('id' => 'description', 'label'=>__('Comments'));
$yuiTable['key'][] = array('id' => 'createdBy',   'label'=>__('Created By'));

$yuiTable['data'] = array();
foreach ($tasks_comments_list as $tasks_comments)
{

  $comments_details = '<ul class="listInfoBlock">';
  
  if($tasks_comments->getTasksStatusId()>0)
  {
    $comments_details .= '<li>' . __('Task Status') . ': ' . $tasks_comments->getTasksStatus()->getName() . '</li>';
  }
  
  if($tasks_comments->getTasksPriorityId()>0)
  {
    $comments_details .= '<li>' . __('Task Priority') . ': ' . $tasks_comments->getTasksPriority()->getName() . '</li>';
  }
  
  if(strlen($tasks_comments->getDueDate())>0)
  {
    $comments_details .= '<li>' . __('Due Date') . ': ' . shortDateFormat($tasks_comments->getDueDate()) . '</li>';
  }
  
  if($tasks_comments->getWorkedHours()>0)
  {
    $comments_details .= '<li>' . __('Worked Hours') . ': ' . $tasks_comments->getWorkedHours() . '</li>';
  }
  
  if($tasks_comments->getProgress()>0)
  {
    $comments_details .= '<li>' . __('Progress') . ': ' . showProgressValue($tasks_comments->getProgress()) . '</li>';
  }
  
  
  $comments_details .= '</div>';
  
  $yuiTable['data'][$tasks_comments->getId()] =  array('description' => replaceTextToLinks($tasks_comments->getDescription()) . get_component('attachments','attachmentsValuesList', array('bindType'=>'comments', 'bindId'=>$tasks_comments->getId())) . $comments_details . '<br><br>',
                                                       'createdBy'   => longDateFormat($tasks_comments->getCreatedAt()) . '<br>' . $tasks_comments->getUsers()->getName() . '<br>' . $tasks_comments->getUsers()->getEmail() . '<br>' . (strlen($tasks_comments->getUsers()->getPhoto())>0 ? image_tag(public_path('uploads/users/' . $tasks_comments->getUsers()->getPhoto()), array('width'=>64, 'class'=>'usersPhoto')) : image_tag(public_path('images/no_photo.png'), array('width'=>64, 'class'=>'usersPhoto'))),
                                                      );
}

include_partial('global/yuiBasicDataTable',array('yuiTable' => $yuiTable, 'yuiTableOptions' => $yuiTableOptions));

?>

    </td>
    <td width="26%" style="padding-left: 5px; vertical-align: top;">
      <?php if($task->getTicketsId()>0 && $sf_user->hasCredential('allow_manage_tickets')) include_component('tasks', 'relatedTicket', array('ticketId' => $task->getTicketsId(),'projectId' => $projectId,'tasksId' => $tasksId)); ?>
      <?php if($task->getDiscussionId()>0) include_component('tasks', 'relatedDiscussion', array('discussionId' => $task->getDiscussionId(),'projectId' => $projectId,'tasksId' => $tasksId)); ?>
      <?php include_component('tasks', 'details', array('tasksId' => $tasksId,'setEmailStyle'=>false)) ?>
      
    </td>
  </tr>
</table>