<?php

/**
 * tasksGroups actions.
 *
 * @package    sf_sandbox
 * @subpackage tasksGroups
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class tasksGroupsActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $this->projectId = $request->getParameter('projectId');
    
    $c = new Criteria();
    $c->add(TasksGroupsPeer::PROJECTS_ID,$this->projectId);
    $this->tasks_groups_list = TasksGroupsPeer::doSelect($c);
    
    $response = $this->getResponse();
    $response->setTitle(sfConfig::get('app_app_short_name') . ' | ' . I18NText::__('Tasks Groups'));
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new TasksGroupsForm();
    
    $this->form->setDefault('projects_id', $request->getParameter('projectId'));
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new TasksGroupsForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($tasks_groups = TasksGroupsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tasks_groups does not exist (%s).', $request->getParameter('id')));
    $this->form = new TasksGroupsForm($tasks_groups);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($tasks_groups = TasksGroupsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tasks_groups does not exist (%s).', $request->getParameter('id')));
    $this->form = new TasksGroupsForm($tasks_groups);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($tasks_groups = TasksGroupsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tasks_groups does not exist (%s).', $request->getParameter('id')));

    $projectId = $tasks_groups->getProjectsId();

    $tasks_groups->delete();

    $this->redirect('tasksGroups/index?projectId=' . $projectId);
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      $tasks_groups = $form->save();

      $this->redirect('tasksGroups/index?projectId=' . $tasks_groups->getProjectsId());
    }
  }
}
