<?php

/**
 * tasksLabels actions.
 *
 * @package    sf_sandbox
 * @subpackage tasksLabels
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class tasksLabelsActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $c= new Criteria();
    $c->addAscendingOrderByColumn(TasksLabelsPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(TasksLabelsPeer::NAME);
    $this->tasks_labels_list = TasksLabelsPeer::doSelect($c);
    
    $this->getResponse()->setTitle(sfConfig::get('app_app_short_name') . ' | ' . I18NText::__('Configuration') . ' | ' . I18NText::__('Tasks Labels'));
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new TasksLabelsForm();
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new TasksLabelsForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($tasks_labels = TasksLabelsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tasks_labels does not exist (%s).', $request->getParameter('id')));
    $this->form = new TasksLabelsForm($tasks_labels);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($tasks_labels = TasksLabelsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tasks_labels does not exist (%s).', $request->getParameter('id')));
    $this->form = new TasksLabelsForm($tasks_labels);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($tasks_labels = TasksLabelsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tasks_labels does not exist (%s).', $request->getParameter('id')));
    $tasks_labels->delete();

    $this->redirect('tasksLabels/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {            
      $tasks_labels = $form->save();
      
      if($form['default_value']->getValue()==1)
      {
        TasksLabelsPeer::resetDefaultValues($tasks_labels->getId());
      }
      
      $this->redirect('tasksLabels/index');
    }
  }
}
