<?php

/**
 * tasksList actions.
 *
 * @package    sf_sandbox
 * @subpackage tasksList
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12479 2008-10-31 10:54:40Z fabien $
 */
class tasksListActions extends sfActions
{
 /**
  * Executes index action
  *
  * @param sfRequest $request A request object
  */
  public function executeIndex(sfWebRequest $request)
  {
    
    /**
     *set default project filter by status
     */
    if(!$this->getUser()->hasAttribute('filterTasksListByStatusGroupId'))
    {
      $this->getUser()->setAttribute('filterTasksListByStatusGroupId', 'open');
    }
    
    if(!$this->getUser()->hasAttribute('filterTasksListByProjectsStatusId'))
    {
      $this->getUser()->setAttribute('filterTasksListByProjectsStatusId', ProjectsStatusPeer::getDafaultStatusId());
    }
    
    /**
     *save projects filters in session
     */
    if($request->hasParameter('filterTasksListByStatusGroupId'))
    {
      $this->getUser()->setAttribute('filterTasksListByStatusGroupId', $request->getParameter('filterTasksListByStatusGroupId'));
       $this->getUser()->setAttribute('filterTasksListByStatusId', '');     
    }
     
    if($request->hasParameter('filterTasksListByStatusId'))
    {
      $this->getUser()->setAttribute('filterTasksListByStatusId', $request->getParameter('filterTasksListByStatusId'));
      $this->getUser()->setAttribute('filterTasksListByStatusGroupId', '');
    }
    
    
    if($request->hasParameter('filterTasksListByProjectsStatusId'))
    {
      $this->getUser()->setAttribute('filterTasksListByProjectsStatusId', $request->getParameter('filterTasksListByProjectsStatusId'));
    }

    if($request->hasParameter('filterTasksListByProjectsTypeId'))
    {
      $this->getUser()->setAttribute('filterTasksListByProjectsTypeId', $request->getParameter('filterTasksListByProjectsTypeId'));
    }
    
    if($request->hasParameter('filterTasksListByProjectsId'))
    {
      $this->getUser()->setAttribute('filterTasksListByProjectsId', $request->getParameter('filterTasksListByProjectsId'));
    }
    
    if($request->hasParameter('filterTasksListByUsersId'))
    {
      $this->getUser()->setAttribute('filterTasksListByUsersId', $request->getParameter('filterTasksListByUsersId'));
    }
    
    if($request->hasParameter('setFilterTasksListByRelatedTickets'))
    {
      $this->getUser()->setAttribute('filterTasksListByRelatedTickets', $request->getParameter('filterTasksListByRelatedTickets'));
    }
    
    
    $c = new Criteria();
        
    if($this->getUser()->getAttribute('filterTasksListByStatusId')>0)
    {
      $c->add(TasksPeer::TASKS_STATUS_ID, $this->getUser()->getAttribute('filterTasksListByStatusId'));
    }
    else
    {
      if(strlen($this->getUser()->getAttribute('filterTasksListByStatusGroupId'))>1)
      {
        $c->add(TasksPeer::TASKS_STATUS_ID, TasksStatusPeer::getStatusIdByGroupID($this->getUser()->getAttribute('filterTasksListByStatusGroupId')), Criteria::IN);
      }
    }
    
    if($this->getUser()->getAttribute('filterTasksListByProjectsStatusId')>0)
    {
      $c->add(ProjectsPeer::PROJECTS_STATUS_ID, $this->getUser()->getAttribute('filterTasksListByProjectsStatusId'));
    }
    
    if($this->getUser()->getAttribute('filterTasksListByProjectsTypeId')>0)
    {
      $c->add(ProjectsPeer::PROJECTS_TYPES_ID, $this->getUser()->getAttribute('filterTasksListByProjectsTypeId'));
    }
    
    if(!$this->getUser()->hasCredential('allow_view_all'))
    {
      $c->add('','(' . ProjectsPeer::CREATED_BY . '=' . $this->getUser()->getAttribute('userId') . " or FIND_IN_SET(" . $this->getUser()->getAttribute('userId') . "," . ProjectsPeer::TEAM . "))", Criteria::CUSTOM);
    }
    
    if($this->getUser()->getAttribute('filterTasksListByProjectsId')>0)
    {
      $c->add(TasksPeer::PROJECTS_ID, $this->getUser()->getAttribute('filterTasksListByProjectsId'));
    }
    
    if($this->getUser()->getAttribute('filterTasksListByUsersId')>0)
    {      
      $c->add('',"FIND_IN_SET(" . $this->getUser()->getAttribute('filterTasksListByUsersId') . "," . TasksPeer::ASSIGNED_TO . ")",CRITERIA::CUSTOM);
    }
    
    if($this->getUser()->getAttribute('filterTasksListByRelatedTickets')>0)
    {
      $c->add(TasksPeer::TICKETS_ID,null,CRITERIA::ISNOTNULL);
    }
            
    $c->addAscendingOrderByColumn(ProjectsPeer::ID);
    $c->addAscendingOrderByColumn(TasksPeer::TASKS_STATUS_ID);
    $c->addAscendingOrderByColumn(TasksPeer::NAME);
    
    $pager = new sfPropelPager('Tasks', sfConfig::get('app_rows_per_page_group'));
    $pager->setPeerMethod('doSelectJoinAll');
    $pager->setPeerCountMethod('doCountJoinAll');
    $pager->setCriteria($c);
    $pager->setPage($this->getRequestParameter('page', 1));
    $pager->init();
    $this->pager = $pager;
    
    $this->tasks_list = TasksPeer::doSelectJoinAll($c);    
                        
  }
}
