<?php

class tasksListComponents extends sfComponents
{
  public function executeFilter()
  {
    $this->tasks_status_group_list = array();
    $this->tasks_status_group_list[] = 'All';
    $this->tasks_status_group_list = array_merge($this->tasks_status_group_list, TasksStatusPeer::getTasksStatusGroupsList());

    //get tasks status
    $c = new Criteria();
    $c->add(BaseTasksStatusPeer::ACTIVE, 1);
    $this->countTasksStatus = TasksStatusPeer::doCount($c);

    $c= new Criteria();
    $c->add(TasksStatusPeer::ACTIVE, 1);
    $c->addAscendingOrderByColumn(TasksStatusPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(TasksStatusPeer::NAME);
    $tasksStatusList = TasksStatusPeer::doSelect($c);

    $this->tasks_status_list = array();
    $this->tasks_status_list[] = 'All';
    foreach($tasksStatusList as $tasksStauts)
    {
      $countTasksByStatusId = TasksPeer::countTasksByStatusId($tasksStauts->getId(), $this->projectId);
      
      $countTasksByStatusIdStr = '';
      if($countTasksByStatusId>0)
      {
        $countTasksByStatusIdStr = ' (' . $countTasksByStatusId . ')';
      }
    
      $this->tasks_status_list[$tasksStauts->getGroup()][$tasksStauts->getId()] = '&nbsp;&nbsp;&nbsp;' . $tasksStauts->getName() . $countTasksByStatusIdStr;
    } 
    
    $c = new Criteria();
    $c->add(BaseProjectsStatusPeer::ACTIVE, 1);
    $this->countProjectsStatus = BaseProjectsStatusPeer::doCount($c);
    
    $c = new Criteria();
    $c->add(BaseProjectsTypesPeer::ACTIVE,1);
    $this->countProjectsTypes = BaseProjectsTypesPeer::doCount($c);
    
    $c= new Criteria();
    $c->add(ProjectsTypesPeer::ACTIVE, 1);
    $c->addAscendingOrderByColumn(ProjectsTypesPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(ProjectsTypesPeer::NAME);
    $projectsTypesList = ProjectsTypesPeer::doSelect($c);
    
    $this->projects_types_list = array();
    $this->projects_types_list[] = 'All';
    foreach($projectsTypesList as $projectsTypes)
    {
      $countProjectsByTypeId = ProjectsPeer::countProjectsByTypeId($projectsTypes->getId(), $this->getUser());

      $countProjectsByTypeIdStr = '';

      if($countProjectsByTypeId>0)
      {
        $countProjectsByTypeIdStr = ' (' . $countProjectsByTypeId . ')';
      }
      
      $this->projects_types_list[$projectsTypes->getId()] = $projectsTypes->getName() . $countProjectsByTypeIdStr;
    }
    
    
    $c= new Criteria();
    $c->add(ProjectsStatusPeer::ACTIVE, 1);
    $c->addAscendingOrderByColumn(ProjectsStatusPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(ProjectsStatusPeer::NAME);
    $projectsStatusList = ProjectsStatusPeer::doSelect($c);

    $this->projects_status_list = array();
    $this->projects_status_list[] = 'All';
    foreach($projectsStatusList as $projectsStauts)
    {
      $countProjectsByStatusId = ProjectsPeer::countProjectsByStatusId($projectsStauts->getId(), $this->getUser());

      $countProjectsByStatusIdStr = '';
      
      if($countProjectsByStatusId>0)
      {
        $countProjectsByStatusIdStr = ' (' . $countProjectsByStatusId . ')';
      }
      
      $this->projects_status_list[$projectsStauts->getId()] = $projectsStauts->getName() . $countProjectsByStatusIdStr;
    }     
  
  
    $c= new Criteria();
    
    if($this->getUser()->getAttribute('filterTasksListByProjectsStatusId')>0)
    {
      $c->add(ProjectsPeer::PROJECTS_STATUS_ID, $this->getUser()->getAttribute('filterTasksListByProjectsStatusId'));
    }
    
    if($this->getUser()->getAttribute('filterTasksListByProjectsTypeId')>0)
    {
      $c->add(ProjectsPeer::PROJECTS_TYPES_ID, $this->getUser()->getAttribute('filterTasksListByProjectsTypeId'));
    }
    
    if(!$this->getUser()->hasCredential('allow_view_all'))
    {
      $c->add('','(' . ProjectsPeer::CREATED_BY . '=' . $this->getUser()->getAttribute('userId') . " or FIND_IN_SET(" . $this->getUser()->getAttribute('userId') . "," . ProjectsPeer::TEAM . "))", Criteria::CUSTOM);
    }
                   
    $c->addAscendingOrderByColumn(ProjectsPeer::NAME);
    $projects_list = ProjectsPeer::doSelectJoinAll($c);
    
    $this->projects_list = array();
    $this->projects_list[] = 'All';
    foreach($projects_list as $projects)
    {
      $this->projects_list[$projects->getId()] = $projects->getName();
    }
  
  
    if(!isset($this->form_action))
    {
      $this->form_action = 'tasksList/index';
    }
    
  }
}  
