<?php

/**
 * tasksStatus actions.
 *
 * @package    sf_sandbox
 * @subpackage tasksStatus
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class tasksStatusActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $c= new Criteria();
    $c->addAscendingOrderByColumn(TasksStatusPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(TasksStatusPeer::NAME);
    $this->tasks_status_list = TasksStatusPeer::doSelect($c);
    
    $this->getResponse()->setTitle(sfConfig::get('app_app_short_name') . ' | ' . I18NText::__('Configuration') . ' | ' . I18NText::__('Tasks Status'));
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new TasksStatusForm();
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new TasksStatusForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($tasks_status = TasksStatusPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tasks_status does not exist (%s).', $request->getParameter('id')));
    $this->form = new TasksStatusForm($tasks_status);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($tasks_status = TasksStatusPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tasks_status does not exist (%s).', $request->getParameter('id')));
    $this->form = new TasksStatusForm($tasks_status);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($tasks_status = TasksStatusPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tasks_status does not exist (%s).', $request->getParameter('id')));
    $tasks_status->delete();

    $this->redirect('tasksStatus/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      
      $tasks_status = $form->save();
      
      if($form['default_value']->getValue()==1)
      {
        TasksStatusPeer::resetDefaultValues($tasks_status->getId());
      }

      $this->redirect('tasksStatus/index');
    }
  }

}
