<?php

/**
 * tasksTypes actions.
 *
 * @package    sf_sandbox
 * @subpackage tasksTypes
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class tasksTypesActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $c= new Criteria();
    $c->addAscendingOrderByColumn(TasksTypesPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(TasksTypesPeer::NAME);
    $this->tasks_types_list = TasksTypesPeer::doSelect($c);
    
    $this->getResponse()->setTitle(sfConfig::get('app_app_short_name') . ' | ' . I18NText::__('Configuration') . ' | ' . I18NText::__('Tasks Types'));
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new TasksTypesForm();
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new TasksTypesForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($tasks_types = TasksTypesPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tasks_types does not exist (%s).', $request->getParameter('id')));
    $this->form = new TasksTypesForm($tasks_types);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($tasks_types = TasksTypesPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tasks_types does not exist (%s).', $request->getParameter('id')));
    $this->form = new TasksTypesForm($tasks_types);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($tasks_types = TasksTypesPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tasks_types does not exist (%s).', $request->getParameter('id')));
    $tasks_types->delete();

    $this->redirect('tasksTypes/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {        
      $tasks_types = $form->save();
      
      if($form['default_value']->getValue()==1)
      {
        TasksTypesPeer::resetDefaultValues($tasks_types->getId());
      }

      $this->redirect('tasksTypes/index');
    }
  }
}
