<?php

/**
 * tickets actions.
 *
 * @package    sf_sandbox
 * @subpackage tickets
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class ticketsActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $this->projectId = $request->getParameter('projectId');
    
    
    /**
     *set default project filter by status
     */
    if(!$this->getUser()->hasAttribute('filterTicketsByStatusGroupId'))
    {
      $this->getUser()->setAttribute('filterTicketsByStatusGroupId', 'open');
    }
      
    /**
     *save projects filters in session
     */
    if($request->hasParameter('filterTicketsByStatusGroupId'))
    {
      $this->getUser()->setAttribute('filterTicketsByStatusGroupId', $request->getParameter('filterTicketsByStatusGroupId'));
      $this->getUser()->setAttribute('filterTicketsByStatusId','');
    }
     
    if($request->hasParameter('filterTicketsByStatusId'))
    {
      $this->getUser()->setAttribute('filterTicketsByStatusId', $request->getParameter('filterTicketsByStatusId'));
      $this->getUser()->setAttribute('filterTicketsByStatusGroupId','');
    }
    
    
    if($request->hasParameter('filterTicketsByTypeId'))
    {
      $this->getUser()->setAttribute('filterTicketsByTypeId', $request->getParameter('filterTicketsByTypeId'));
    }
    
    if($request->hasParameter('filterTicketsByDepartmentId'))
    {
      $this->getUser()->setAttribute('filterTicketsByDepartmentId', $request->getParameter('filterTicketsByDepartmentId'));
    }
    /*
    else
    {
      $c = new Criteria;
      $c->add(DepartmentsPeer::USERS_ID, $this->getUser()->getAttribute('userId'));
      if($department = DepartmentsPeer::doSelectOne($c))
      {
         $this->getUser()->setAttribute('filterTicketsByDepartmentId',$department->getId());
      }
    }
    */
    
    $c= new Criteria();
    
    
    if($this->getUser()->getAttribute('filterTicketsByStatusId')>0)
    {
      $c->add(TicketsPeer::TICKETS_STATUS_ID, $this->getUser()->getAttribute('filterTicketsByStatusId'));
    }
    else
    {
      if(strlen($this->getUser()->getAttribute('filterTicketsByStatusGroupId'))>1)
      {
        $c->add(TicketsPeer::TICKETS_STATUS_ID, TicketsStatusPeer::getStatusIdByGroupID($this->getUser()->getAttribute('filterTicketsByStatusGroupId')), Criteria::IN);
      }
    }
    
    if($this->getUser()->getAttribute('filterTicketsByTypeId')>0)
    {
      $c->add(TicketsPeer::TICKETS_TYPES_ID, $this->getUser()->getAttribute('filterTicketsByTypeId'));
    }
    
    if($this->getUser()->getAttribute('filterTicketsByDepartmentId')>0)
    {
      $c->add(TicketsPeer::DEPARTMENTS_ID, $this->getUser()->getAttribute('filterTicketsByDepartmentId'));
    }
    
    
    if($this->projectId>0)
    {
      $c->add(TicketsPeer::PROJECTS_ID, $this->projectId);
    }
    
    if(!$this->getUser()->hasCredential('allow_view_all'))
    {
      $c->add('','(' . ProjectsPeer::CREATED_BY . '=' . $this->getUser()->getAttribute('userId') . " or FIND_IN_SET(" . $this->getUser()->getAttribute('userId') . "," . ProjectsPeer::TEAM . "))", Criteria::CUSTOM);
    }
            
    $c->addDescendingOrderByColumn(TicketsPeer::CREATED_AT);
    
    $pager = new sfPropelPager('Tickets',  sfConfig::get('app_rows_per_page_group'));
    $pager->setPeerMethod('doSelectJoinAll');
    $pager->setPeerCountMethod('doCountJoinAll');
    $pager->setCriteria($c);
    $pager->setPage($this->getRequestParameter('page', 1));
    $pager->init();
    $this->pager = $pager;
    
    $this->tickets_list = TicketsPeer::doSelectJoinAll($c);
  }

  public function executeNew(sfWebRequest $request)  
  {        
    $this->form = new TicketsForm(null, array('projectId' => $request->getParameter('projectId'), 'user'=>$this->getUser()));
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new TicketsForm(null, array('projectId' => $request->getParameter('projectId'), 'user'=>$this->getUser()));

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($tickets = TicketsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tickets does not exist (%s).', $request->getParameter('id')));
    $this->form = new TicketsForm($tickets, array('projectId' => $request->getParameter('projectId'), 'user'=>$this->getUser()));
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($tickets = TicketsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tickets does not exist (%s).', $request->getParameter('id')));
    $this->form = new TicketsForm($tickets, array('projectId' => $request->getParameter('projectId'), 'user'=>$this->getUser()));

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($tickets = TicketsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tickets does not exist (%s).', $request->getParameter('id')));
    
    ExtraFields::deleteByBindId($tickets->getId(),'tickets');
    AttachmentsPeer::deleteAttachments('tickets', $tickets->getId());
    
    $tickets->delete();
    
    $urlParams = '';
      
    if($request->getParameter('projectId')>0)
    {
      $urlParams = '?projectId=' . $request->getParameter('projectId'); 
    }

    $this->redirect('tickets/index' . $urlParams);
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {  
    //insert attachments
    $attachments_files = array();
    $files = $request->getFiles();

    foreach($files['attachments'] as $key=>$file)
    {
      if(strlen($file['name'])>0)
      {
        $filename = rand(111111,999999)  . '-' . $file['name'];
        move_uploaded_file($file['tmp_name'], sfConfig::get('sf_upload_dir') . '/attachments/'  . $filename);
        $attachments_files[] = $filename;
      }
      else
      {
        $attachments_files[] = '';
      }
    }
    
    $isStatusUpdated = false;
    
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      if($form->getObject()->isNew())
      {
        $sendNofification = true;
      }
      else
      {
        $sendNofification = false;
        
        //insert new comment
        if($form->getObject()->getTicketsStatusId()!=$form->getValue('tickets_status_id'))
        {                
          $tickets_comments = new TicketsComments;
          $tickets_comments->setTicketsId($form->getObject()->getId());
          $tickets_comments->setUsersId($this->getUser()->getAttribute('userId'));
          $tickets_comments->setTicketsStatusId($form->getValue('tickets_status_id'));
          $tickets_comments->save();
          
          $isStatusUpdated = true;
                              
        } 
      }
    
      $tickets = $form->save();
      
      //insert extra fields values
      if($request->hasParameter('extra_fields'))
      {
        ExtraFieldsListPeer::insertFieldsValues($request->getParameter('extra_fields'),$tickets->getId(),'tickets');
      }
      
      if($isStatusUpdated)
      {
          //send notification            
          $v = TicketsCommentsPeer::getSendToSendFrom($request->getParameter('projectId'), $tickets_comments->getTicketsId(),  $tickets_comments->getUsersId());
          $sendTo = $v['sendTo'];
          $sendFrom = $v['sendFrom'];
          
          if(sizeof($sendTo)>0)
          {
            require_once sfConfig::get('sf_lib_dir').'/vendor/swift_init.php';
                
            $project = ProjectsPeer::retrieveByPk($request->getParameter('projectId'));    
                
            $subject = I18NText::__('Ticket Status Updated') . ': ';                         
            $subject .= $tickets->getProjects()->getName() . ' - ' . $tickets->getName() . ($tickets->getTicketsStatusId()>0 ?  ' [' . $tickets->getTicketsStatus()->getName() . ']':'');
            $body = $this->getComponent('ticketsComments','emailNewComment', array('projectId'=>$request->getParameter('projectId'), 'ticketId' => $tickets_comments->getTicketsId()));
    
            UsersPeer::sendEmail($sendTo,$subject,$body, $sendFrom,$this->getUser());
          }
      }
      
      //save attachemts
      AttachmentsPeer::insertAttachments($request->getParameter('attachments_id'), $request->getParameter('attachments_info'),$attachments_files,$tickets->getId(),'tickets');
      
      
      //send notification
      if($sendNofification==true && $tickets->getDepartmentsId()>0)
      {
        $sendTo = array();
        $sendFrom = array();

        $c = new Criteria();
        $c->add(UsersPeer::ID,$tickets->getDepartments()->getUsersId());
        $user = UsersPeer::doSelectOne($c);

        $sendTo[$user->getEmail()] = $user->getName();

        $c = new Criteria();
        $c->add(UsersPeer::ID,$tickets->getUsersId());
        $user = UsersPeer::doSelectOne($c);

        $sendFrom[$user->getEmail()] = $user->getName();

        if(key($sendTo)!=key($sendFrom))
        {
          require_once sfConfig::get('sf_lib_dir').'/vendor/swift_init.php';

          $subject = I18NText::__('New Ticket') . ': ' . $tickets->getProjects()->getName()  . ' - ' . $tickets->getName() . ($tickets->getTicketsTypesId()>0 ? ' [' . $tickets->getTicketsTypes()->getName() . ']':'');
          $body = $this->getComponent('tickets','emailNewTicket', array('projectId'=>$tickets->getProjectsId(), 'ticketId' => $tickets->getId()));

          UsersPeer::sendEmail($sendTo,$subject,$body, $sendFrom,$this->getUser());
        }
      }

      $urlParams = '';
      
      if($request->hasParameter('redirectTo'))
      {
        if($request->getParameter('redirectTo')=='allTickets')
        {
          $this->redirect('tickets/index');
        }
        else
        {
          $this->redirect($request->getParameter('redirectTo') . '/index?ticketId=' . $tickets->getId() . '&projectId=' . $tickets->getProjectsId());
        }
      }
      else
      {      
        if($request->getParameter('projectId')>0)
        {
          $urlParams = '?projectId=' . $request->getParameter('projectId'); 
        }
        
        $this->redirect('tickets/index' . $urlParams);
      }
    }
  }
}
