<?php

class ticketsComponents extends sfComponents
{
  public function executeFilter()
  {
    $this->extra_url_param = '';
    if($this->projectId>0)
    {
      $this->extra_url_param = '?projectId=' . $this->projectId;
    }
    
    $this->tickets_status_group_list = array();
    $this->tickets_status_group_list[] = 'All';
    $this->tickets_status_group_list = array_merge($this->tickets_status_group_list, TicketsStatusPeer::getTicketsStatusGroupsList());

    //get tickets status
    $c = new Criteria();
    $c->add(BaseTicketsStatusPeer::ACTIVE, 1);
    $this->countTicketsStatus = TicketsStatusPeer::doCount($c);

    $c= new Criteria();
    $c->add(TicketsStatusPeer::ACTIVE, 1);
    $c->addAscendingOrderByColumn(TicketsStatusPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(TicketsStatusPeer::NAME);
    $ticketsStatusList = TicketsStatusPeer::doSelect($c);

    $this->tickets_status_list = array();
    $this->tickets_status_list[] = 'All';
    foreach($ticketsStatusList as $ticketsStauts)
    {

    
      $this->tickets_status_list[$ticketsStauts->getGroup()][$ticketsStauts->getId()] = '&nbsp;&nbsp;&nbsp;' . $ticketsStauts->getName();
    }
    
    //print_r($this->tickets_status_list);
    
    //get tickets types
    $c = new Criteria();    
    $this->countTicketsTypes = TicketsTypesPeer::doCount($c);
    
    $c= new Criteria();
    $c->add(TicketsTypesPeer::ACTIVE, 1);
    $c->addAscendingOrderByColumn(TicketsTypesPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(TicketsTypesPeer::NAME);    
    $ticketsTypesList = TicketsTypesPeer::doSelect($c);

    $this->tickets_types_list = array();
    $this->tickets_types_list[] = 'All';
    foreach($ticketsTypesList as $ticketsTypes)
    {
    

      
      $this->tickets_types_list[$ticketsTypes->getId()] =  $ticketsTypes->getName();
    }
    
    
    //get tickets types
    $c = new Criteria();    
    $this->countDepartments = DepartmentsPeer::doCount($c);
    
    $c= new Criteria();
    $c->add(DepartmentsPeer::ACTIVE, 1);
    $c->addAscendingOrderByColumn(DepartmentsPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(DepartmentsPeer::NAME);    
    $departmentsList = DepartmentsPeer::doSelect($c);

    $this->departments_list = array();
    $this->departments_list[] = 'All';
    foreach($departmentsList as $departments)
    {
    

      
      $this->departments_list[$departments->getId()] =  $departments->getName() ;
    }
    

  }
  
  public function executeDetails()
  {
    $c = new Criteria();
    $c->add(TicketsPeer::ID,$this->ticketId);
    $this->tickets_list = TicketsPeer::doSelectJoinAll($c);
    $this->ticket = current($this->tickets_list);
    
    if($this->ticket->getDepartmentsId()>0)
    {
      $c = new Criteria();
      $c->add(UsersPeer::ID, $this->ticket->getDepartments()->getUsersId());
      $this->assignedTo = UsersPeer::doSelectOne($c);
    }
    
    
    if(!isset($this->allowEdit))
    {
      $this->allowEdit = true;
    }
        
    if(!isset($this->setEmailStyle))
    {
      $this->setEmailStyle = false;
    }

    $this->divStyle = '';
    $this->tableStyle = '';
    $this->tdStyle = '';
    $this->thStyle = '';

    if($this->setEmailStyle==true)
    {
      $this->divStyle = ' style="padding: 5px; margin-top: 5px; border: 1px dashed LightGray;" ';
      $this->tableStyle = ' style="width: 100%;" ';
      $this->tdStyle = ' style="padding: 2px; border-bottom: 1px solid white; background: #eaf0f3; font-family:  Arial; font-size: 13px; color: #000;" ';
      $this->thStyle = ' style="padding: 2px; border-bottom: 1px solid white; background: #3d7291; color: white; font-family:  Arial; font-size: 13px; text-align: left;" ';
    }
    
  }
  
  public function executeEmailNewTicket()
  {
    $c = new Criteria();
    $c->add(TicketsPeer::ID,$this->ticketId);
    $this->tickets_list = TicketsPeer::doSelectJoinAll($c);
    $this->ticket = current($this->tickets_list);
    
    $c = new Criteria();
    $c->add(ProjectsPeer::ID, $this->ticket->getProjectsId());
    $projects_list = ProjectsPeer::doSelectJoinAll($c);
    $this->project = current($projects_list);
  }
  
  public function executeGoToTicket()
  {
    $c= new Criteria();
    
    
    if($this->getUser()->getAttribute('filterTicketsByStatusId')>0)
    {
      $c->add(TicketsPeer::TICKETS_STATUS_ID, $this->getUser()->getAttribute('filterTicketsByStatusId'));
    }
    else
    {
      if(strlen($this->getUser()->getAttribute('filterTicketsByStatusGroupId'))>1)
      {
        $c->add(TicketsPeer::TICKETS_STATUS_ID, TicketsStatusPeer::getStatusIdByGroupID($this->getUser()->getAttribute('filterTicketsByStatusGroupId')), Criteria::IN);
      }
    }
    
    if($this->getUser()->getAttribute('filterTicketsByTypeId')>0)
    {
      $c->add(TicketsPeer::TICKETS_TYPES_ID, $this->getUser()->getAttribute('filterTicketsByTypeId'));
    }
    
    if($this->getUser()->getAttribute('filterTicketsByDepartmentId')>0)
    {
      $c->add(TicketsPeer::DEPARTMENTS_ID, $this->getUser()->getAttribute('filterTicketsByDepartmentId'));
    }
    
    
    if($this->projectId>0)
    {
      $c->add(TicketsPeer::PROJECTS_ID, $this->projectId);
    }
    
    //$c->addDescendingOrderByColumn(TicketsPeer::PROJECTS_ID);
    //$c->addAscendingOrderByColumn(TicketsPeer::TICKETS_TYPES_ID);
    //$c->addAscendingOrderByColumn(TicketsPeer::TICKETS_STATUS_ID);
    $c->addDescendingOrderByColumn(TicketsPeer::CREATED_AT);
    $tickets_list = TicketsPeer::doSelect($c);
    
    $this->options_for_select = array();
    
    foreach($tickets_list as $tickets)
    {
      $status_name_str = '';
      if($tickets->getTicketsStatusId()>0)
      {
        $status_name_str = ' (' . $tickets->getTicketsStatus()->getName() . ')';
      }
      
      $this->options_for_select[$tickets->getId()] = $tickets->getName() . $status_name_str;
    }

  }
  
  
  public function executeRelatedTasks()
  {
    $c= new Criteria();
    $c->add(TasksPeer::PROJECTS_ID,$this->projectId);
    $c->add(TasksPeer::TICKETS_ID,$this->ticketId);
    $c->addAscendingOrderByColumn(TasksPeer::TASKS_STATUS_ID);
    $this->tasks_list = TasksPeer::doSelect($c);
    $c->addAscendingOrderByColumn(TasksPeer::NAME);
  }
}
?>