<?php 
  if($projectId>0):
  
  include_component('projects', 'shortInfo', array('projectId' => $projectId));
   
?>

<div id="projectsMenuContainer"><?php include_partial('projects/projectsMenu', array('projectId' => $projectId)); ?></div>

<?php endif; ?>
  
<?php include_component('tickets', 'filter', array('projectId' => $projectId)) ?>

<?php

$total_values = array();

$yuiTableOptions = array();
$yuiTableOptions['module'] = 'tickets';
$yuiTableOptions['peer'] = 'Tickets';
$yuiTableOptions['allowSortItems'] = false;
$yuiTableOptions['buttonInsertTitle'] = __('Add Ticket');


if($projectId>0)
{
  $yuiTableOptions['urlParams'] = 'projectId=' . $projectId;
}
else
{
  $yuiTableOptions['allowInsert'] = false;
  $yuiTableOptions['allowEdit'] = false;
  $yuiTableOptions['allowDelete'] = false;
  
}

$yuiTableOptions['isUrlColumn'] = true;
$yuiTableOptions['isProjectUrlColumn'] = true;


$yuiTable = array();
if(TicketsStatusPeer::doCountActive()>0) $yuiTable['key'][] = array('id' => 'status', 'label'=>__('Status'));
if(TicketsTypesPeer::doCountActive()>0) $yuiTable['key'][] = array('id' => 'type', 'label'=>__('Type'));
$yuiTable['key'][] = array('id' => 'name', 'label'=>__('Subject'),'formatter'=>'formatUrl');
$yuiTable['key'][] = array('id' => 'department', 'label'=>__('Department'));
$yuiTable['key'][] = array('id' => 'createdBy', 'label'=>__('Created By'));
$yuiTable['key'][] = array('id' => 'createdAt', 'label'=>__('Created At'),'formatter'=>'formatDate');

$yuiTable = ExtraFieldsListPeer::setYuiTableKeys($yuiTable, 'tickets');
$extra_fields_list = ExtraFieldsListPeer::getExtraFieldsListByType('tickets');

if($projectId==0)
{
  $yuiTable['key'][] = array('id' => 'project', 'label'=>__('Project'),'formatter'=>'formatProjectUrl');
}

$commentsTipsTextsList = '';

$yuiTable['data'] = array();
foreach ($tickets_list as $tickets)
{

  $nameLastCommented = TicketsCommentsPeer::getNameLastCommented($tickets->getId());
  
  if(strlen($nameLastCommented)>0)
  {    
    $commentsTipsTextId = 'commentTip_' . rand(111111111,999999999); 
    $commentsTipsTextsList .= input_hidden_tag($commentsTipsTextId,TicketsCommentsPeer::getTextLastCommented($tickets->getId()));
    $nameLastCommented = '&nbsp;<sup><div class="commentName"  onmouseover="doTip(\'' . $commentsTipsTextId . '\')" onmouseout="UnTip()">' . image_tag('icons/comment.png') . $nameLastCommented . '</div></sup>';
  }
  
  $yuiTable['data'][$tickets->getId()] = array( 'type' => ($tickets->getTicketsTypesId()>0 ? $tickets->getTicketsTypes()->getName() : ''),
                                                'name' =>  $tickets->getName()  . $nameLastCommented,
                                                'url'  => url_for('ticketsComments/index?ticketId=' . $tickets->getId() . '&projectId=' . $tickets->getProjectsId()),
                                                'project_url'  => url_for('tickets/index?projectId=' . $tickets->getProjectsId()),
                                                'status' => ($tickets->getTicketsStatusId() ? $tickets->getTicketsStatus()->getName() : ''),
                                                'department' => ($tickets->getDepartmentsId()>0 ? $tickets->getDepartments()->getName() : ''),
                                                'createdBy' => $tickets->getUsers()->getName(),
                                                'project' => $tickets->getProjects()->getName(),
                                                'createdAt' => getDateTimestamp($tickets->getCreatedAt()),
                                              );
                                              
  $yuiTable = ExtraFieldsListPeer::setYuiTableData($yuiTable, $extra_fields_list,$tickets->getId());
  
  $total_values = ExtraFieldsListPeer::getTotalNumericFieldsValues($total_values, 'tickets', $tickets->getId());                                              
}

include_partial('global/yuiBasicDataTable',array('yuiTable' => $yuiTable, 'yuiTableOptions' => $yuiTableOptions));

include_partial('global/totalValues', array('total_values' => $total_values));

echo $commentsTipsTextsList;

include_partial('global/pager', array('url_params'=>'','request_page'=>'page','module' => $sf_context->getModuleName(), 'action'=>$sf_context->getActionName(),'pager'=>$pager));
