<?php

/**
 * ticketsReports actions.
 *
 * @package    sf_sandbox
 * @subpackage ticketsReports
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class ticketsReportsActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    UsersPeer::clearUsersFilters($this->getUser());
  
    $c = new Criteria();
    $c->add(TicketsReportsPeer::USERS_ID,$this->getUser()->getAttribute('userId'));
    $c->addAscendingOrderByColumn(TicketsReportsPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(TicketsReportsPeer::NAME);
    $this->tickets_reports_list = TicketsReportsPeer::doSelect($c);
  }
  
  public function executeView(sfWebRequest $request)
  {    
    $this->reportParams = TicketsReportsPeer::retrieveByPk($request->getParameter('id'));    
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new TicketsReportsForm(null, array('user'=>$this->getUser()));
    $this->form->setDefault('users_id', $this->getUser()->getAttribute('userId'));
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new TicketsReportsForm(null, array('user'=>$this->getUser()));

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($tickets_reports = TicketsReportsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tickets_reports does not exist (%s).', $request->getParameter('id')));
    $this->form = new TicketsReportsForm($tickets_reports, array('user'=>$this->getUser()));
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($tickets_reports = TicketsReportsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tickets_reports does not exist (%s).', $request->getParameter('id')));
    $this->form = new TicketsReportsForm($tickets_reports, array('user'=>$this->getUser()));

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($tickets_reports = TicketsReportsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tickets_reports does not exist (%s).', $request->getParameter('id')));
    $tickets_reports->delete();

    $this->redirect('ticketsReports/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      $form->setFieldValue('projects_id',implode(',',$form['projects_id']->getValue()));
      $form->setFieldValue('projects_type_id',implode(',',$form['projects_type_id']->getValue()));
      $form->setFieldValue('projects_status_id',implode(',',$form['projects_status_id']->getValue()));
      $form->setFieldValue('departments_id',implode(',',$form['departments_id']->getValue()));
      $form->setFieldValue('tickets_status_id',implode(',',$form['tickets_status_id']->getValue()));
      $form->setFieldValue('tickets_types_id',implode(',',$form['tickets_types_id']->getValue()));
      
      $tickets_reports = $form->save();


      if($request->hasParameter('redirectTo'))
      {
        $this->redirect('ticketsReports/view?id=' . $tickets_reports->getId());
      }
      
      $this->redirect('ticketsReports/index');
    } 
  }
}
