<?php

class ticketsReportsComponents extends sfComponents
{
  public function executeViewReport()
  {
    $c = new Criteria();

    
    if(strlen($this->reportParams->getProjectsId())>0)
    {
      $c->add(TicketsPeer::PROJECTS_ID, explode(',',$this->reportParams->getProjectsId()), Criteria::IN);
    }
    else
    {
      if(!$this->getUser()->hasCredential('allow_view_all'))
      {
        $c->add('','(' . ProjectsPeer::CREATED_BY . '=' . $this->getUser()->getAttribute('userId') . " or FIND_IN_SET(" . $this->getUser()->getAttribute('userId') . "," . ProjectsPeer::TEAM . "))", Criteria::CUSTOM);
      }

    }
        
    if(strlen($this->reportParams->getProjectsTypeId())>0)
    {
      $c->add(ProjectsPeer::PROJECTS_TYPES_ID, explode(',',$this->reportParams->getProjectsTypeId()), Criteria::IN);
    }
        
    if(strlen($this->reportParams->getProjectsStatusId())>0)
    {
      $c->add(ProjectsPeer::PROJECTS_STATUS_ID, explode(',',$this->reportParams->getProjectsStatusId()), Criteria::IN);
    }
    
            
    if(strlen($this->reportParams->getDepartmentsId())>0)
    {
      $c->add(TicketsPeer::DEPARTMENTS_ID, explode(',',$this->reportParams->getDepartmentsId()), Criteria::IN);
    }
        
    if(strlen($this->reportParams->getTicketsStatusId())>0)
    {
      $c->add(TicketsPeer::TICKETS_STATUS_ID, explode(',',$this->reportParams->getTicketsStatusId()), Criteria::IN);
    }
    
    
    if(strlen($this->reportParams->getTicketsTypesId())>0)
    {
      $c->add(TicketsPeer::TICKETS_TYPES_ID, explode(',',$this->reportParams->getTicketsTypesId()), Criteria::IN);
    }
    
    
        
    //$c->addDescendingOrderByColumn(TicketsPeer::PROJECTS_ID);
    //$c->addAscendingOrderByColumn(TicketsPeer::TICKETS_TYPES_ID);
    //$c->addAscendingOrderByColumn(TicketsPeer::TICKETS_STATUS_ID);    
    $c->addDescendingOrderByColumn(TicketsPeer::CREATED_AT);
    
    
    $pager = new sfPropelPager('Tickets', sfConfig::get('app_rows_per_page_group'));
    $pager->setPeerMethod('doSelectJoinAll');
    $pager->setPeerCountMethod('doCountJoinAll');
    $pager->setCriteria($c);
    $pager->setPage($this->getRequestParameter('page', 1));
    $pager->init();
    $this->pager = $pager;
    
    $this->tickets_list = TicketsPeer::doSelectJoinAll($c);
  }
}
?>