<?php

/**
 * tasksStatus actions.
 *
 * @package    sf_sandbox
 * @subpackage ticketsStatus
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class ticketsStatusActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $c= new Criteria();
    $c->addAscendingOrderByColumn(TicketsStatusPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(TicketsStatusPeer::NAME);
    $this->tickets_status_list = TicketsStatusPeer::doSelect($c);
    
    $this->getResponse()->setTitle(sfConfig::get('app_app_short_name') . ' | ' . I18NText::__('Configuration') . ' | ' . I18NText::__('Tickets Status'));
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new TicketsStatusForm();
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new TicketsStatusForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($tickets_status = TicketsStatusPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tickets_status does not exist (%s).', $request->getParameter('id')));
    $this->form = new TicketsStatusForm($tickets_status);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($tickets_status = TicketsStatusPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tickets_status does not exist (%s).', $request->getParameter('id')));
    $this->form = new TicketsStatusForm($tickets_status);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($tickets_status = TicketsStatusPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tickets_status does not exist (%s).', $request->getParameter('id')));
    $tickets_status->delete();

    $this->redirect('ticketsStatus/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {      
      $tickets_status = $form->save();
      
      if($form['default_value']->getValue()==1)
      {
        TicketsStatusPeer::resetDefaultValues($tickets_status->getId());
      }

      $this->redirect('ticketsStatus/index');
    }
  }

}
