<?php

/**
 * ticketsTypes actions.
 *
 * @package    sf_sandbox
 * @subpackage ticketsTypes
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class ticketsTypesActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $c= new Criteria();
    $c->addAscendingOrderByColumn(TicketsTypesPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(TicketsTypesPeer::NAME);
    $this->tickets_types_list = TicketsTypesPeer::doSelect($c);
    
    $this->getResponse()->setTitle(sfConfig::get('app_app_short_name') . ' | ' . I18NText::__('Configuration') . ' | ' . I18NText::__('Tickets Types'));
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new TicketsTypesForm();
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new TicketsTypesForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($tickets_types = TicketsTypesPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tickets_types does not exist (%s).', $request->getParameter('id')));
    $this->form = new TicketsTypesForm($tickets_types);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($tickets_types = TicketsTypesPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tickets_types does not exist (%s).', $request->getParameter('id')));
    $this->form = new TicketsTypesForm($tickets_types);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($tickets_types = TicketsTypesPeer::retrieveByPk($request->getParameter('id')), sprintf('Object tickets_types does not exist (%s).', $request->getParameter('id')));
    $tickets_types->delete();

    $this->redirect('ticketsTypes/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {    
      $tickets_types = $form->save();

      $this->redirect('ticketsTypes/index');
    }
  }
}
