<?php

class timereportActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $this->form = new TimeReportFilterForm(null, array('filterByUserId'=>$request->getParameter('timereprotfilter[filterByUserId]')));
    
    $c = new Criteria;
    
    if($request->isMethod('post'))
    {
      $this->filterByDateAddedFrom = '';
  
      $this->form->bind($request->getParameter('timereprotfilter'));
      if ($this->form->isValid())
      {
        $v = $this->form->getValues();                
        
        if(strlen($v['filterByUserId'])>0)
        {
          $c->add(TasksCommentsPeer::CREATED_BY,$v['filterByUserId']);
        }                
        
        if(strlen($v['filterByDateAddedFrom'])>0 || strlen($v['filterByDateAddedTo'])>0)
        {
          $criteria_str = '';
          
          if(strlen($v['filterByDateAddedFrom'])>0)
          { 
            $criteria_str .= "date_format(" . TasksCommentsPeer::CREATED_AT . ",'%Y-%m-%d')>='" . $v['filterByDateAddedFrom'] . "'";
            $this->filterByDateAddedFrom = $v['filterByDateAddedFrom'];
          }
          
          if(strlen($v['filterByDateAddedTo'])>0)
          {
            if(strlen($v['filterByDateAddedFrom'])>0) $criteria_str .= ' and ';
            
            $criteria_str .= " date_format(" . TasksCommentsPeer::CREATED_AT . ",'%Y-%m-%d')<='" . $v['filterByDateAddedTo'] . "'";
          }
          
          $c->add('', $criteria_str , Criteria::CUSTOM);
        }
                
              
        if($v['filterByProjectId']>0)
        {
          $c->add(TasksPeer::PROJECTS_ID,$v['filterByProjectId']);
        }
        
        if($v['filterByTasksStatusId']>0)
        {
          $c->add(TasksPeer::TASKS_STATUS_ID,$v['filterByTasksStatusId']);
        }
      }

    }
    else
    {
      $c->add('', "date_format(" . TasksCommentsPeer::CREATED_AT . ",'%Y-%m-%d')>='" . date('Y-m-') . "01'", Criteria::CUSTOM);
      $this->filterByDateAddedFrom = date('Y-m-') . '01';      
    }
    
    $c->add(TasksCommentsPeer::WORKED_HOURS,0,Criteria::GREATER_THAN);
    $c->addAscendingOrderByColumn(TasksCommentsPeer::CREATED_AT);
    $this->tasks_comments_list = TasksCommentsPeer::doSelectJoinAll($c);
    
  }
  
  public function executeExport(sfWebRequest $request)
  {    
    $export_data = unserialize($request->getParameter('export_data'));
    
    
    chdir(sfConfig::get('sf_lib_dir') . '/phpxls');
    require_once 'Writer.php';
    chdir('..');

    $workbook = new Spreadsheet_Excel_Writer();
    
    $workbook->setVersion(8);

    $workbook->setCustomColor(24, 240, 240, 240);

    $format_und =& $workbook->addFormat();
    $format_und->setBottom(2);//thick
    $format_und->setBold();
    $format_und->setColor('black');
    $format_und->setFontFamily('Arial');
    $format_und->setSize(10);
    $format_und->setFgColor(24);

    $format_reg =& $workbook->addFormat();
    $format_reg->setColor('black');
    $format_reg->setFontFamily('Arial');
    $format_reg->setSize(10);
    
    $format_title =& $workbook->addFormat();
    $format_title->setBold();
    $format_title->setColor('black');
    $format_title->setFontFamily('Arial');
    $format_title->setSize(10);

    $arr = array(
          'items'=>$export_data,
          );

    foreach($arr as $wbname=>$rows)
    {
        $rowcount = count($rows);
        $colcount = count($rows[0]);

        $worksheet =& $workbook->addWorksheet("\xD0\x9B\xD0\xB8\xD1\x81\xD1\x82");
        
        $worksheet->setInputEncoding('UTF-8');

        $worksheet->setColumn(0,1, 30);        
        $worksheet->setColumn(2,2, 20);
        $worksheet->setColumn(3,3, 40);        
        $worksheet->setColumn(4,4, 15);
        $worksheet->setColumn(5,5, 40);


        for( $j=0; $j<$rowcount; $j++ )
        {
            for($i=0; $i<$colcount;$i++)
            {
                $fmt  =& $format_reg;
                if ($j==0)
                    $fmt =& $format_und;



                if (isset($rows[$j][$i]))
                {
                  if(isset($rows[$j][0]))
                  if(strlen($rows[$j][0])>0 and !isset($rows[$j][3]))
                  {
                    //$fmt =& $format_title;
                  }
                
                    $data=$rows[$j][$i];
                    $worksheet->writeString($j, $i, $data, $fmt);
                }
            }
        }
    }
    
    $filterByUserId = $request->getParameter('filterByUserId');

    $export_filename = 'Time_Report.xls';

    if($filterByUserId>0)
    {
      $user = UsersPeer::doSelectOne(new Criteria());
      
      $export_filename = str_replace(' ','_',$user->getName())  . '_' . $export_filename;
    }

    $workbook->send($export_filename);
    $workbook->close();
    exit();    
    
    exit();
  }
}  