<?php

/**
 * userReports actions.
 *
 * @package    sf_sandbox
 * @subpackage userReports
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class userReportsActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    UsersPeer::clearUsersFilters($this->getUser());
  
    $c = new Criteria();
    $c->add(UserReportsPeer::USERS_ID,$this->getUser()->getAttribute('userId'));
    $c->addAscendingOrderByColumn(UserReportsPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(UserReportsPeer::NAME);
    $this->user_reports_list = UserReportsPeer::doSelect($c);
    
    $response = $this->getResponse();
    $response->setTitle(sfConfig::get('app_app_short_name') . ' | ' . I18NText::__('Reports'));
  }
  
  public function executeView(sfWebRequest $request)
  {
    
    $user_reports = UserReportsPeer::retrieveByPk($request->getParameter('id'));

    $this->reportParams = UserReportsPeer::setReportParams($user_reports);
    
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new UserReportsForm(null, array('user'=>$this->getUser()));
    $this->form->setDefault('users_id', $this->getUser()->getAttribute('userId'));
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new UserReportsForm(null, array('user'=>$this->getUser()));

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($user_reports = UserReportsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object user_reports does not exist (%s).', $request->getParameter('id')));
    $this->form = new UserReportsForm($user_reports, array('user'=>$this->getUser()));
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($user_reports = UserReportsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object user_reports does not exist (%s).', $request->getParameter('id')));
    $this->form = new UserReportsForm($user_reports, array('user'=>$this->getUser()));

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($user_reports = UserReportsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object user_reports does not exist (%s).', $request->getParameter('id')));
    $user_reports->delete();

    $this->redirect('userReports/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      $form->setFieldValue('projects_id',implode(',',$form['projects_id']->getValue()));
      $form->setFieldValue('projects_type_id',implode(',',$form['projects_type_id']->getValue()));
      $form->setFieldValue('projects_status_id',implode(',',$form['projects_status_id']->getValue()));      
      $form->setFieldValue('tasks_status_id',implode(',',$form['tasks_status_id']->getValue()));
      $form->setFieldValue('tasks_type_id',implode(',',$form['tasks_type_id']->getValue()));
      $form->setFieldValue('tasks_label_id',implode(',',$form['tasks_label_id']->getValue()));
      
      $user_reports = $form->save();
      
      if($request->hasParameter('redirectTo'))
      {
        $this->redirect('userReports/view?id=' . $user_reports->getId());
      }

      $this->redirect('userReports/index');
    }
  }
  
  public function executeMultipleEdit(sfWebRequest $request)
  {
    if ($request->isMethod('post'))
    {
      require_once sfConfig::get('sf_lib_dir').'/vendor/swift_init.php';
      
      $selected_items = explode('_',$request->getParameter('selected_items'));      
      
      foreach($selected_items as $itemId)
      {
        $sendNotification = false;
        
        $c = new Criteria();
        $c->add(TasksPeer::ID,$itemId);
        $tasks = TasksPeer::doSelectOne($c);
        
        $tasks_fields = $request->getParameter('tasks_fields');
        
        foreach($tasks_fields as $key=>$value)
        {
          if($value>0)
          {
            $functionName = '';
            for($i=0; $i<strlen($key);$i++)
            {
               if($i==0)
               {
                 $functionName .= strtoupper($key[$i]);
               }
               elseif($key[$i]=='_')
               {
                  $i++;
                 $functionName .= strtoupper($key[$i]);
               }
               else
               {
                 $functionName .= $key[$i];
               }
            }
            
            
            //update closed date
            if($functionName=='TasksStatusId')
            {
              $updateClosedDateType = TasksPeer::getUpdateClosedDateType($tasks, $value);  
        
              if($updateClosedDateType == 'updateClosedDate')
              {
                $tasks->setClosedDate(date('Y-m-d'));
              }
              elseif($updateClosedDateType == 'clearClosedDate')
              {
                $tasks->setClosedDate(NULL);
              }   
              
              //insert new comment
              if($tasks->getTasksStatusId()!=$value)
              {                
                $tasks_comments = new TasksComments;
                $tasks_comments->setTasksId($itemId);
                $tasks_comments->setCreatedBy($this->getUser()->getAttribute('userId'));
                $tasks_comments->setTasksStatusId($value);
                $tasks_comments->save();
                
                
                $sendNotification = true;                                
              }         
            }

            $eval_str = '$tasks->set' . $functionName . '("' . $value . '");';
            
            eval($eval_str);
                                    
          }
        }
        
        $tasks->save();
        
        
        if($sendNotification)
        {
          $v = TasksCommentsPeer::getSendToSendFrom($tasks->getId(), $tasks_comments->getCreatedBy());
          $sendTo = $v['sendTo'];
          $sendFrom = $v['sendFrom'];
          
          if(sizeof($sendTo)>0)
          {              
            $project = ProjectsPeer::retrieveByPk($tasks->getProjectsId());
                                    
            $subject = I18NText::__('Status Updated') . ': ';                        
            $subject .= $project->getName() . ' - ' . $tasks->getName() . ($tasks_comments->getTasksStatusId()>0 ? ' [' . $tasks_comments->getTasksStatus()->getName() . ']' : '');
            
            $body = $this->getComponent('tasksComments','emailNewComment', array('projectId'=>$tasks->getProjectsId(), 'taskId' => $tasks_comments->getTasksId()));
    
            UsersPeer::sendEmail($sendTo,$subject,$body, $sendFrom,$this->getUser());
          }
        }      

      }

       if($request->getParameter('moduleName')=='tasksList')
       {
         $this->redirect('tasksList/index');       
       }
       elseif($request->getParameter('moduleName')=='home')
       {
         $this->redirect('home/index');
       }
       elseif($request->getParameter('reportId')>0)
       {
         $this->redirect('userReports/view?id=' . $request->getParameter('reportId'));
       }
       else
       {
         $this->redirect('userReports/index');       
       }

       
    }
  
    $this->form = new ReportsMultipleEditForm();
  }  
}
