<?php

class userReportsComponents extends sfComponents
{
  public function executeViewReport()
  {
    $c = new Criteria();

    if(isset($this->reportParams['projects_id']))
    if(strlen($this->reportParams['projects_id'])>0)
    {
      $c->add(TasksPeer::PROJECTS_ID, explode(',',$this->reportParams['projects_id']), Criteria::IN);
    }
    else
    {
      if(!$this->getUser()->hasCredential('allow_view_all'))
      {
        $c->add('','(' . ProjectsPeer::CREATED_BY . '=' . $this->getUser()->getAttribute('userId') . " or FIND_IN_SET(" . $this->getUser()->getAttribute('userId') . "," . ProjectsPeer::TEAM . "))", Criteria::CUSTOM);
      }

    }
    
    if(isset($this->reportParams['projects_type_id']))
    if(strlen($this->reportParams['projects_type_id'])>0)
    {
      $c->add(ProjectsPeer::PROJECTS_TYPES_ID, explode(',',$this->reportParams['projects_type_id']), Criteria::IN);
    }
    
    if(isset($this->reportParams['projects_status_id']))
    if(strlen($this->reportParams['projects_status_id'])>0)
    {
      $c->add(ProjectsPeer::PROJECTS_STATUS_ID, explode(',',$this->reportParams['projects_status_id']), Criteria::IN);
    }
    
    
    if(isset($this->reportParams['assigned_to']))
    if(strlen($this->reportParams['assigned_to'])>0)
    {      
      $c->add('  ',"FIND_IN_SET(" . (int)$this->reportParams['assigned_to'] . "," . TasksPeer::ASSIGNED_TO . ")",CRITERIA::CUSTOM);
    }
    
    if(isset($this->reportParams['tasks_status_id']))
    if(strlen($this->reportParams['tasks_status_id'])>0)
    {
      $c->add(TasksPeer::TASKS_STATUS_ID, explode(',',$this->reportParams['tasks_status_id']), Criteria::IN);
    }
    
    if(isset($this->reportParams['tasks_type_id']))
    if(strlen($this->reportParams['tasks_type_id'])>0)
    {
      $c->add(TasksPeer::TASKS_TYPE_ID, explode(',',$this->reportParams['tasks_type_id']), Criteria::IN);
    }
    
    if(isset($this->reportParams['tasks_label_id']))
    if(strlen($this->reportParams['tasks_label_id'])>0)
    {
      $c->add(TasksPeer::TASKS_LABEL_ID, explode(',',$this->reportParams['tasks_label_id']), Criteria::IN);
    }
    
    
    /**
     * Due Date
     */                 
    if(isset($this->reportParams['due_date_from']) && isset($this->reportParams['due_date_to']))
    {
      if(strlen($this->reportParams['due_date_from'])>0 && strlen($this->reportParams['due_date_to'])>0)
      {
        $c->add('   ',TasksPeer::DUE_DATE . " BETWEEN '" . $this->reportParams['due_date_from'] . "' AND '" . $this->reportParams['due_date_to'] . "'", Criteria::CUSTOM);
      }
    }
    else
    {    
      if(isset($this->reportParams['due_date_from']))
      if(strlen($this->reportParams['due_date_from'])>0)
      {
        $c->add(TasksPeer::DUE_DATE, $this->reportParams['due_date_from'], Criteria::GREATER_EQUAL);
      }
      
      if(isset($this->reportParams['due_date_to']))
      if(strlen($this->reportParams['due_date_to'])>0)
      {
        $c->add(TasksPeer::DUE_DATE, $this->reportParams['due_date_to'], Criteria::LESS_EQUAL);
      }
    }
    
    
    /**
     * Created At
     */               
    if(isset($this->reportParams['created_from']) && isset($this->reportParams['created_to']))
    {
      if(strlen($this->reportParams['created_from'])>0 && strlen($this->reportParams['created_to'])>0)
      {
        $c->add('    ',TasksPeer::CREATED_AT . " BETWEEN '" . $this->reportParams['created_from'] . "' AND '" . $this->reportParams['created_to'] . "'", Criteria::CUSTOM);
      }
    }
    else
    {
    
      if(isset($this->reportParams['created_from']))
      if(strlen($this->reportParams['created_from'])>0)
      {
        $c->add(TasksPeer::CREATED_AT, $this->reportParams['created_from'], Criteria::GREATER_EQUAL);
      }
  
      if(isset($this->reportParams['created_to']))
      if(strlen($this->reportParams['created_to'])>0)
      {
        $c->add(TasksPeer::CREATED_AT, $this->reportParams['created_to'], Criteria::LESS_EQUAL);
      }
    }
    
    /**
     *Closed Date
     */         
    if(isset($this->reportParams['closed_from']) && isset($this->reportParams['closed_to']))
    {
      if(strlen($this->reportParams['closed_from'])>0 && strlen($this->reportParams['closed_to'])>0)
      {
        $c->add('     ',TasksPeer::CLOSED_DATE . " BETWEEN '" . $this->reportParams['closed_from'] . "' AND '" . $this->reportParams['closed_to'] . "'", Criteria::CUSTOM);
      }
    }
    else
    {
      if(isset($this->reportParams['closed_from']))
      if(strlen($this->reportParams['closed_from'])>0)
      {
        $c->add(TasksPeer::CLOSED_DATE, $this->reportParams['closed_from'], Criteria::GREATER_EQUAL);      
      }
  
      if(isset($this->reportParams['closed_to']))
      if(strlen($this->reportParams['closed_to'])>0)
      {
        $c->add(TasksPeer::CLOSED_DATE, $this->reportParams['closed_to'], Criteria::LESS_EQUAL);
              
      }
    }
        
    $c->addAscendingOrderByColumn(ProjectsPeer::ID);
    $c->addAscendingOrderByColumn(TasksPeer::TASKS_STATUS_ID);
    $c->addAscendingOrderByColumn(TasksPeer::NAME);
    
    $pager = new sfPropelPager('Tasks', sfConfig::get('app_rows_per_page_group'));
    $pager->setPeerMethod('doSelectJoinAll');
    $pager->setPeerCountMethod('doCountJoinAll');
    $pager->setCriteria($c);
    $pager->setPage($this->getRequestParameter('page', 1));
    $pager->init();
    $this->pager = $pager;
    
    $this->tasks_list = TasksPeer::doSelectJoinAll($c);
  }
}
?>