<?php

/**
 * users actions.
 *
 * @package    sf_sandbox
 * @subpackage users
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class usersActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $c = new Criteria();
    $c->addAscendingOrderByColumn(UsersGroupsPeer::NAME);
    $c->addAscendingOrderByColumn(UsersPeer::NAME);
    $this->users_list = UsersPeer::doSelectJoinAll($c);
    
    $response = $this->getResponse();
    $response->setTitle(sfConfig::get('app_app_short_name') . ' | ' . I18NText::__('Users'));
    
    
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new UsersForm();
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new UsersForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($users = UsersPeer::retrieveByPk($request->getParameter('id')), sprintf('Object users does not exist (%s).', $request->getParameter('id')));
    $this->form = new UsersEditForm($users);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($users = UsersPeer::retrieveByPk($request->getParameter('id')), sprintf('Object users does not exist (%s).', $request->getParameter('id')));

    $this->form = new UsersEditForm($users);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($users = UsersPeer::retrieveByPk($request->getParameter('id')), sprintf('Object users does not exist (%s).', $request->getParameter('id')));
    
    if(UsersPeer::isAllowDelete($users->getId()))
    {
      $users->delete();    
    }
    else
    {
      $this->getUser()->setFlash('userNotices', I18NText::__('Deleting not allowed for this user. Use the status to disable the user.'));
    }
    
    $this->redirect('users/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $files = $request->getFiles();
    $userPhoto = $files['users']['photo']['name'];
  
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
    
      if(isset($form['password']))
      {
        $form->setFieldValue('password', md5($form['password']->getValue()));
      }
      
      if(strlen($request->getParameter('new_password'))>0)
      {
        $form->setFieldValue('password', md5($request->getParameter('new_password')));
      }

      if(strlen($userPhoto)>0)
      {
        $userPhoto =  rand(111111,999999) . '-' . $userPhoto;
        move_uploaded_file($files['users']['photo']['tmp_name'], sfConfig::get('sf_upload_dir') . '/users/' . $userPhoto);
        $form->setFieldValue('photo', $userPhoto);
      }
      else
      {
        $form->setFieldValue('photo', $request->getParameter('preview_photo'));
      }
      
      if($request->getParameter('remove_photo')==1 && strlen($request->getParameter('preview_photo'))>0)
      {
        unlink(sfConfig::get('sf_upload_dir') . '/users/' . $request->getParameter('preview_photo'));
        $form->setFieldValue('photo','');
      }

      $users = $form->save();

      if($request->hasParameter('extra_fields'))
      {
        ExtraFieldsListPeer::insertFieldsValues($request->getParameter('extra_fields'),$users->getId(),'users');
      }
      
      $this->redirect('users/index');
    }
  }
}
