<?php

/**
 * usersGroups actions.
 *
 * @package    sf_sandbox
 * @subpackage usersGroups
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class usersGroupsActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $c= new Criteria();
    $c->addAscendingOrderByColumn(UsersGroupsPeer::NAME);
    $this->users_groups_list = UsersGroupsPeer::doSelect($c);
    
    $response = $this->getResponse();
    $response->setTitle(sfConfig::get('app_app_short_name') . ' | ' . I18NText::__('Configuration') . ' | ' . I18NText::__('Users Groups'));
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new UsersGroupsForm();
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new UsersGroupsForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($users_groups = UsersGroupsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object users_groups does not exist (%s).', $request->getParameter('id')));
    $this->form = new UsersGroupsForm($users_groups);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($users_groups = UsersGroupsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object users_groups does not exist (%s).', $request->getParameter('id')));
    $this->form = new UsersGroupsForm($users_groups);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($users_groups = UsersGroupsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object users_groups does not exist (%s).', $request->getParameter('id')));
    $users_groups->delete();

    $this->redirect('usersGroups/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      $users_groups = $form->save();

      //$this->redirect('usersGroups/edit?id='.$users_groups->getId());
      $this->redirect('usersGroups/index');
    }
  }
}
