<?php

/**
 * versions actions.
 *
 * @package    sf_sandbox
 * @subpackage versions
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class versionsActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $this->projectId = $request->getParameter('projectId');

    $c = new Criteria();
    $c->add(VersionsPeer::PROJECTS_ID,$this->projectId);
    $this->versions_list = VersionsPeer::doSelectJoinAll($c);
    
    $response = $this->getResponse();
    $response->setTitle(sfConfig::get('app_app_short_name') . ' | ' . I18NText::__('Versions'));
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new VersionsForm();
    
    $this->form->setDefault('projects_id', $request->getParameter('projectId'));
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new VersionsForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($versions = VersionsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object versions does not exist (%s).', $request->getParameter('id')));
    $this->form = new VersionsForm($versions);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($versions = VersionsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object versions does not exist (%s).', $request->getParameter('id')));
    $this->form = new VersionsForm($versions);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($versions = VersionsPeer::retrieveByPk($request->getParameter('id')), sprintf('Object versions does not exist (%s).', $request->getParameter('id')));

    $projectId = $versions->getProjectsId();

    $versions->delete();

    $this->redirect('versions/index?projectId=' . $projectId);
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      $versions = $form->save();

      $this->redirect('versions/index?projectId=' . $versions->getProjectsId());
    }
  }
}
