<?php

/**
 * versionsStatus actions.
 *
 * @package    sf_sandbox
 * @subpackage versionsStatus
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class versionsStatusActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $c= new Criteria();
    $c->addAscendingOrderByColumn(VersionsStatusPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(VersionsStatusPeer::NAME);
    $this->versions_status_list = VersionsStatusPeer::doSelect($c);
    
    $this->getResponse()->setTitle(sfConfig::get('app_app_short_name') . ' | ' . I18NText::__('Configuration') . ' | ' . I18NText::__('Versions Status'));
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new VersionsStatusForm();
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new VersionsStatusForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($versions_status = VersionsStatusPeer::retrieveByPk($request->getParameter('id')), sprintf('Object versions_status does not exist (%s).', $request->getParameter('id')));
    $this->form = new VersionsStatusForm($versions_status);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($versions_status = VersionsStatusPeer::retrieveByPk($request->getParameter('id')), sprintf('Object versions_status does not exist (%s).', $request->getParameter('id')));
    $this->form = new VersionsStatusForm($versions_status);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($versions_status = VersionsStatusPeer::retrieveByPk($request->getParameter('id')), sprintf('Object versions_status does not exist (%s).', $request->getParameter('id')));
    $versions_status->delete();

    $this->redirect('versionsStatus/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      if($form['default_value']->getValue()==1)
      {
        VersionsStatusPeer::resetDefaultValues();
      }
      
      $versions_status = $form->save();

      $this->redirect('versionsStatus/index');
    }
  }
}
