<?php

class ReportsMultipleEditForm extends sfForm
{
  public function configure()
  {
    $projectId = $this->getOption('projectId');
    $user = $this->getOption('user');
    
    $this->widgetSchema['tasks_status_id'] =  new sfWidgetFormChoice(array('choices' => TasksStatusPeer::getGroupedStatusList(true)));
    
    $c= new Criteria();
    $c->add(TasksPriorityPeer::ACTIVE,1);
    $c->addAscendingOrderByColumn(TasksPriorityPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(TasksPriorityPeer::NAME);
    $this->widgetSchema['tasks_priority_id'] =  new sfWidgetFormPropelChoice(array('model' => 'TasksPriority', 'add_empty' => true,'criteria' => $c));
    
    $this->widgetSchema['due_date'] = new sfWidgetFormInputDateTag();
    
    $c= new Criteria();
    $c->add(TasksLabelsPeer::ACTIVE,1);
    $c->addAscendingOrderByColumn(TasksLabelsPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(TasksLabelsPeer::NAME);
    $this->widgetSchema['tasks_label_id'] =  new sfWidgetFormPropelChoice(array('model' => 'TasksLabels', 'add_empty' => true,'criteria' => $c));

    $c= new Criteria();
    $c->add(TasksTypesPeer::ACTIVE,1);
    $c->addAscendingOrderByColumn(TasksTypesPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(TasksTypesPeer::NAME);
    $this->widgetSchema['tasks_type_id'] =  new sfWidgetFormPropelChoice(array('model' => 'TasksTypes', 'add_empty' => true,'criteria' => $c));

    


    
    $this->widgetSchema->setNameFormat('tasks_fields[%s]');


    $this->widgetSchema->setLabels(array('tasks_status_id'    => 'Status',
                                         'tasks_priority_id'  => 'Priority',
                                         'tasks_type_id'      => 'Type',
                                         'tasks_label_id'     => 'Label',                                         
                                         ));

  }
}

?>
