<?php

/**
 * Tasks form.
 *
 * @package    sf_sandbox
 * @subpackage form
 * @author     Your name here
 * @version    SVN: $Id: sfPropelFormTemplate.php 10377 2008-07-21 07:10:32Z dwhittle $
 */
class TasksForm extends BaseTasksForm
{
  public function configure()
  {
    $projectId = $this->getOption('projectId');
    $userId = $this->getOption('userId');

    $c = new Criteria();
    $c->add(VersionsPeer::PROJECTS_ID, $projectId);
    $countVersions = VersionsPeer::doCount($c);
    $this->setOption('countVersions',$countVersions);
    
    $c = new Criteria();
    $c->add(TasksGroupsPeer::PROJECTS_ID, $projectId);
    $countTasksGroups = TasksGroupsPeer::doCount($c);
    $this->setOption('countTasksGroups',$countTasksGroups);
    
    $c = new Criteria();
    $c->add(ProjectsPhasesPeer::PROJECTS_ID, $projectId);
    $countProjectsPhases = ProjectsPhasesPeer::doCount($c);
    $this->setOption('countProjectsPhases',$countProjectsPhases);

    if($countTasksGroups>0)
    {
      $c = new Criteria();
      $c->add(TasksGroupsPeer::PROJECTS_ID,$projectId);
      $this->widgetSchema['tasks_groups_id'] = new sfWidgetFormPropelChoice(array('model' => 'TasksGroups', 'add_empty' => true,'criteria' => $c));
    }
    else
    {
      $this->widgetSchema['tasks_groups_id'] = new sfWidgetFormInputHidden();
    }
    
    if($countProjectsPhases>0)
    {
      $c = new Criteria();
      $c->add(ProjectsPhasesPeer::PROJECTS_ID,$projectId);
      $this->widgetSchema['projects_phases_id'] = new sfWidgetFormPropelChoice(array('model' => 'ProjectsPhases', 'add_empty' => true,'criteria' => $c));
    }
    else
    {
      $this->widgetSchema['projects_phases_id'] = new sfWidgetFormInputHidden();
    }
    
    if($countVersions>0)
    {
      $c = new Criteria();
      $c->add(VersionsPeer::PROJECTS_ID,$projectId);
      $this->widgetSchema['versions_id'] = new sfWidgetFormPropelChoice(array('model' => 'Versions', 'add_empty' => true,'criteria' => $c));
    }
    else
    {
      $this->widgetSchema['versions_id'] = new sfWidgetFormInputHidden();
    }
    
    $c = new Criteria();
    $c->add(ProjectsPeer::ID, $projectId);
    $projects = ProjectsPeer::doSelect($c);
    $project = current($projects);

    $c = new Criteria();
    $c->add(UsersPeer::ACTIVE,1);
    $c->add(UsersPeer::ID,explode(',',$project->getTeam()), Criteria::IN);
    $c->add(UsersGroupsPeer::ALLOW_MANAGE_TASKS,1);
    $c->addAscendingOrderByColumn(UsersPeer::NAME);
    $this->widgetSchema['assigned_to'] = new sfWidgetFormPropelChoice(array('model' => 'Users','peer_method'=>'doSelectJoinAll', 'multiple' => true, 'add_empty' => true,'criteria' => $c));
    
    $c = new Criteria();
    $c->add(UsersPeer::ACTIVE,1);
    $c->add(UsersPeer::ID,explode(',',$project->getTeam()), Criteria::IN);
    //$c->add(UsersGroupsPeer::ALLOW_MANAGE_TASKS,1);
    $c->addAscendingOrderByColumn(UsersPeer::NAME);
    $this->widgetSchema['created_by'] = new sfWidgetFormPropelChoice(array('model' => 'Users', 'peer_method'=>'doSelectJoinAll', 'add_empty' => false,'criteria' => $c));
  
    $this->widgetSchema['description'] = new sfWidgetFormTextareaFCKeditor();
    
    $this->widgetSchema['tasks_status_id'] =  new sfWidgetFormChoice(array('choices' => TasksStatusPeer::getGroupedStatusList()));
    
    $c= new Criteria();
    $c->add(TasksLabelsPeer::ACTIVE,1);
    $c->addAscendingOrderByColumn(TasksLabelsPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(TasksLabelsPeer::NAME);
    $this->widgetSchema['tasks_label_id'] =  new sfWidgetFormPropelChoice(array('model' => 'TasksLabels', 'add_empty' => false,'criteria' => $c));
    
    $c= new Criteria();
    $c->add(TasksTypesPeer::ACTIVE,1);
    $c->addAscendingOrderByColumn(TasksTypesPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(TasksTypesPeer::NAME);
    $this->widgetSchema['tasks_type_id'] =  new sfWidgetFormPropelChoice(array('model' => 'TasksTypes', 'add_empty' => true,'criteria' => $c));
    
    $c= new Criteria();
    $c->add(TasksPriorityPeer::ACTIVE,1);
    $c->addAscendingOrderByColumn(TasksPriorityPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(TasksPriorityPeer::NAME);
    $this->widgetSchema['tasks_priority_id'] =  new sfWidgetFormPropelChoice(array('model' => 'TasksPriority', 'add_empty' => true,'criteria' => $c));
    
    $this->widgetSchema['created_at'] = new sfWidgetFormInputHidden();
    $this->widgetSchema['projects_id'] = new sfWidgetFormInputHidden();
    $this->widgetSchema['tickets_id'] = new sfWidgetFormInputHidden();
    $this->widgetSchema['discussion_id'] = new sfWidgetFormInputHidden();    
    
    $this->widgetSchema['start_date'] = new sfWidgetFormInputDateTag();
    $this->widgetSchema['due_date'] = new sfWidgetFormInputDateTag();
    
    $this->widgetSchema['progress'] =  new sfWidgetFormChoice(array('choices' => TasksPeer::getProgressValuesList(true)));
    
    $this->widgetSchema['name']->setAttribute('size','60');
    
    $this->setDefault('created_by', $userId);
    $this->setDefault('tasks_type_id', TasksTypesPeer::getDafaultStatusId());
    $this->setDefault('tasks_label_id',TasksLabelsPeer::getDafaultStatusId());
    $this->setDefault('tasks_status_id',TasksLabelsPeer::getDafaultStatusId());

    $this->widgetSchema->setLabels(array('tasks_status_id'    => 'Status',
                                         'tasks_priority_id'  => 'Priority',
                                         'tasks_type_id'      => 'Type',
                                         'assigned_to'      => 'Assigned To',
                                         'estimated_time'      => 'Est. Time',
                                         'tasks_label_id'     => 'Label',
                                         'tasks_groups_id'    => 'Group',
                                         'projects_phases_id' => 'Phase',
                                         'start_date' => 'Start Date',
                                         'due_date' => 'Due Date',
                                         'created_by' => 'Created By',
                                         'versions_id'        => 'Version',));
  }
}
