<?php

/**
 * Tickets form.
 *
 * @package    sf_sandbox
 * @subpackage form
 * @author     Your name here
 * @version    SVN: $Id: sfPropelFormTemplate.php 10377 2008-07-21 07:10:32Z dwhittle $
 */
class TicketsForm extends BaseTicketsForm
{
  public function configure()
  {
    $projectId = $this->getOption('projectId');
        
    if(TicketsTypesPeer::doCountActive()>0)
    {
      $c = new Criteria;
      $c->addAscendingOrderByColumn(TicketsTypesPeer::SORT_ORDER);
      $c->addAscendingOrderByColumn(TicketsTypesPeer::NAME);
      $this->widgetSchema['tickets_types_id'] =  new sfWidgetFormPropelChoice(array('model' => 'TicketsTypes', 'add_empty' => false, 'expanded' => true,'criteria' => $c));
      $this->validatorSchema['tickets_types_id'] =  new sfValidatorPropelChoice(array('model' => 'TicketsTypes', 'column' => 'id', 'required' => true));
    }
    else
    {
      $this->widgetSchema['tickets_types_id'] = new sfWidgetFormInputHidden();
    }
    
    if(TicketsStatusPeer::doCountActive()>0)
    {
      $this->widgetSchema['tickets_status_id'] =  new sfWidgetFormChoice(array('choices' => TicketsStatusPeer::getGroupedStatusList()));
    }
    else
    {
      $this->widgetSchema['tickets_status_id'] = new sfWidgetFormInputHidden();
    }
    
    $this->widgetSchema['projects_id'] = new sfWidgetFormInputHidden();
    $this->setDefault('projects_id',$projectId);    
             
    $team_list = array();  
    if($project = ProjectsPeer::retrieveByPk($projectId))
    {
      $team_list = explode(',',$project->getTeam());
    }
    $departmentTeam_list = array();
    
    foreach($team_list as $uId)
    {
      $c = new Criteria;
      $c->add(DepartmentsPeer::USERS_ID,$uId);
      $c->addAscendingOrderByColumn(DepartmentsPeer::SORT_ORDER);
      $c->addAscendingOrderByColumn(DepartmentsPeer::NAME);
      $departments_list = DepartmentsPeer::doSelect($c);
      
      foreach($departments_list as $departments)
      {
        $departmentTeam_list[] = $departments->getId();
      }
    }        
    
    if(sizeof($departmentTeam_list)==1)
    {
      $this->widgetSchema['departments_id'] = new sfWidgetFormInputHidden();
      $this->setDefault('departments_id',$departmentTeam_list[0]); 
      
      $department = DepartmentsPeer::retrieveByPk($departmentTeam_list[0]);
      
      $this->setOption('departmentName',$department->getName());      
    }
    else
    {  
      $c = new Criteria();
      $c->add(DepartmentsPeer::ID,$departmentTeam_list,Criteria::IN);
      $c->addAscendingOrderByColumn(DepartmentsPeer::SORT_ORDER);
      $c->addAscendingOrderByColumn(DepartmentsPeer::NAME);
      $this->widgetSchema['departments_id'] =  new sfWidgetFormPropelChoice(array('model' => 'Departments', 'add_empty' => false,'criteria' => $c));
      
      $this->validatorSchema['departments_id'] =  new sfValidatorPropelChoice(array('model' => 'Departments', 'column' => 'id', 'required' => true));
    }
    
    $this->widgetSchema['users_id'] = new sfWidgetFormInputHidden();
    
    $this->setDefault('users_id', $this->getOption('user')->getAttribute('userId'));
    
    $this->widgetSchema['description'] = new sfWidgetFormTextareaFCKeditor();
    $this->widgetSchema['created_at'] = new sfWidgetFormInputHidden();
        
    $this->widgetSchema['name']->setAttribute('size','60');
    
    $this->widgetSchema->setLabels(array('departments_id'    => 'Department',
                                         'tickets_types_id'  => 'Type',
                                         'name'              => 'Subject',
                                         'tickets_status_id' => 'Status',
                                         'projects_id'       => 'Project'));
  }
}
