<?php

class TimeReportFilterForm extends sfForm
{
  public function configure()
  {
    $filterByUserId = $this->getOption('filterByUserId');
  
    $this->setWidgets(array(      
      'filterByDateAddedFrom'    => new sfWidgetFormInputDateTag(),
      'filterByDateAddedTo'    => new sfWidgetFormInputDateTag(),
      
    ));
            
    $this->widgetSchema->setNameFormat('timereprotfilter[%s]');
    
    $c = new Criteria();
    $c->add(UsersPeer::ACTIVE,1);    
    $c->addAscendingOrderByColumn(UsersPeer::NAME);
    $this->widgetSchema['filterByUserId'] = new sfWidgetFormPropelChoice(array('model' => 'Users', 'add_empty' => true,'criteria' => $c));
    
    $c= new Criteria();
    if($filterByUserId>0)
    {    
      $c->add('',"(FIND_IN_SET(" . $filterByUserId . "," . ProjectsPeer::TEAM . "))", Criteria::CUSTOM);          
    }                                         
    $c->addAscendingOrderByColumn(ProjectsPeer::NAME);    
    $this->widgetSchema['filterByProjectId']   = new sfWidgetFormPropelChoice(array('model' => 'Projects', 'add_empty' => true,'criteria' => $c));
    
    
    $this->widgetSchema['filterByTasksStatusId'] =  new sfWidgetFormChoice(array('choices' => TasksStatusPeer::getGroupedStatusList(true)));
    $this->widgetSchema['filterByDiscrepancy'] =  new sfWidgetFormChoice(array('choices' => array('all'=>I18NText::__('All'),'under'=>I18NText::__('Under'),'over'=>I18NText::__('Over'),'ok'=>I18NText::__('Ok'))));
    
    
    
    $this->setValidators(array(
      'filterByUserId'    => new sfValidatorNumber(array('required' => false)),
      'filterByProjectId'   => new sfValidatorNumber(array('required' => false)),
      'filterByTasksStatusId'   => new sfValidatorNumber(array('required' => false)),
      'filterByDateAddedFrom'   => new sfValidatorDate(array('required' => false)),
      'filterByDateAddedTo'   => new sfValidatorDate(array('required' => false)),      
      'filterByDiscrepancy'   => new sfValidatorString(array('required' => false)),
    ));
    
    $this->setDefault('filterByDateAddedFrom', date('Y-m-').'01');
        
    $this->widgetSchema->setLabels(array('filterByUserId'    => 'Select User',
                                         'filterByProjectId' => 'Project', 
                                         'filterByDiscrepancy'=>'Discrepancy',   
                                         'filterByTasksStatusId' => 'Tasks Status',
                                         'filterByDateAddedFrom'  => 'Date From',
                                         'filterByDateAddedTo'      => 'Date To',                                         
                                         ));
                                                                                  
    
    

  }
}