<?php

/**
 * UserReports form.
 *
 * @package    sf_sandbox
 * @subpackage form
 * @author     Your name here
 * @version    SVN: $Id: sfPropelFormTemplate.php 10377 2008-07-21 07:10:32Z dwhittle $
 */
class UserReportsForm extends BaseUserReportsForm
{
  public function configure()
  {
    $c= new Criteria();
    if(!$this->getOption('user')->hasCredential('allow_view_all'))
    {
    $c->add('','(' . ProjectsPeer::CREATED_BY . '=' . $this->getOption('user')->getAttribute('userId') . " or FIND_IN_SET(" . $this->getOption('user')->getAttribute('userId') . "," . ProjectsPeer::TEAM . "))", Criteria::CUSTOM);
    }
    $c->addAscendingOrderByColumn(ProjectsPeer::NAME);
    $this->widgetSchema['projects_id']   = new sfWidgetFormPropelChoice(array('multiple' => true, 'model' => 'Projects', 'add_empty' => true,'criteria' => $c), array('style'=>'height: 180px; width: 250px;'));
    
    
    $projectsTeam = array();
    $projects_list = ProjectsPeer::doSelect($c);
    foreach($projects_list as $projects)
    {
      $projectsTeam = array_merge($projectsTeam, explode(',',$projects->getTeam()));
    }
    
    $projectsTeam = array_unique($projectsTeam);

    
    $c= new Criteria();
    $c->add(UsersPeer::ID,$projectsTeam, Criteria::IN);
    $c->add(UsersGroupsPeer::ALLOW_MANAGE_TASKS,1);
    $c->addAscendingOrderByColumn(UsersPeer::NAME);
    $this->widgetSchema['assigned_to']   = new sfWidgetFormPropelChoice(array( 'model' => 'Users', 'peer_method'=>'doSelectJoinAll', 'add_empty' => true, 'criteria' => $c));

    $this->widgetSchema['projects_type_id'] =   new sfWidgetFormPropelChoice(array('multiple' => true, 'model' => 'ProjectsTypes', 'add_empty' => true), array('style'=>'height: 95px; width: 250px;'));
    $this->widgetSchema['projects_status_id'] =   new sfWidgetFormPropelChoice(array('multiple' => true, 'model' => 'ProjectsStatus', 'add_empty' => true), array('style'=>'height: 95px; width: 250px;'));
    
    $this->widgetSchema['tasks_status_id'] =  new sfWidgetFormChoice(array('multiple' => true, 'choices' => TasksStatusPeer::getGroupedStatusList(true)), array('style'=>'height: 180px; width: 250px;'));
    $this->widgetSchema['tasks_type_id']   = new sfWidgetFormPropelChoice(array('multiple' => true, 'model' => 'TasksTypes', 'add_empty' => true), array('style'=>'height: 95px; width: 250px;'));
    $this->widgetSchema['tasks_label_id']   = new sfWidgetFormPropelChoice(array('multiple' => true, 'model' => 'TasksLabels', 'add_empty' => true), array('style'=>'height: 95px; width: 250px;'));
    
    $this->widgetSchema['due_date_from'] = new sfWidgetFormInputDateTag();
    $this->widgetSchema['due_date_to'] = new sfWidgetFormInputDateTag();
    
    $this->widgetSchema['created_from'] = new sfWidgetFormInputDateTag();
    $this->widgetSchema['created_to'] = new sfWidgetFormInputDateTag();
    
    $this->widgetSchema['closed_from'] = new sfWidgetFormInputDateTag();
    $this->widgetSchema['closed_to'] = new sfWidgetFormInputDateTag();
    
    $this->widgetSchema['users_id'] = new sfWidgetFormInputHidden();
    $this->widgetSchema['sort_order'] = new sfWidgetFormInputHidden();
    $this->widgetSchema['display_on_home'] = new sfWidgetFormInputCheckbox(array(),array('value'=>1));

    $this->setDefault('display_on_home', null);
    $this->setDefault('tasks_status_id', '');
    
  }
}
