<?php

 function getShortDateFormat()
 {
   if(strlen(sfConfig::get('app_custom_short_date_format'))>0)
   {
     return sfConfig::get('app_custom_short_date_format');
   }
   else
   {
     return 'm/d/Y';
   }
 }
 
 function getLongDateFormat()
 {
   if(strlen(sfConfig::get('app_custom_logn_date_format'))>0)
   {
     return sfConfig::get('app_custom_logn_date_format'); 
   }
   else
   {
     return 'm/d/Y H:i:s';
   }
 }

 function getDateTimestamp($date)
 {
   if(strlen($date)>0)
   {
     $v = date_parse($date);
     
     return mktime($v['hour'], $v['minute'],$v['second'], $v['month'], $v['day'], $v['year']);
   }
   else
   {
     return '""';
   }
 }
 
  
 function dueDateFormat($date)
 {
       
   if(strlen($date)>0)
   {
     $v = date_parse($date);
                
     $date_sec = mktime($v['hour'], $v['minute'],$v['second'], $v['month'], $v['day'], $v['year']);
     $current_date_sec =  time();              
     
     if($current_date_sec>$date_sec)
     {
       return '<b>' . date(getShortDateFormat(),$date_sec) . '</b>';
       
     }
     else
     {
      return date(getShortDateFormat(),$date_sec);
     }
   } 
   else
   {
     return '""';
   }    
 }
 
 function ganttShortDateFormat($date)
 {
   if(strlen($date)>0)
   {
     $v = date_parse($date);
     
     return date('m/d/Y',mktime($v['hour'], $v['minute'], $v['second'], $v['month'], $v['day'], $v['year']));
   }
   else
   {
     return '';
   }
 }
 
 function shortDateFormat($date)
 {
   if(strlen($date)>0)
   {
     $v = date_parse($date);
     
     return date(getShortDateFormat(),mktime($v['hour'], $v['minute'], $v['second'], $v['month'], $v['day'], $v['year']));
   }
   else
   {
     return '';
   }
 }
 
 function longDateFormat($date)
 {
   if(strlen($date)>0)
   {
     $v = date_parse($date);
     
     return date(getLongDateFormat(),mktime($v['hour'], $v['minute'], $v['second'], $v['month'], $v['day'], $v['year']));
   }
   else
   {
     return '';
   }
 }
 
 function showProgressValue($v)
 {
   return $v . '%';
 }
 
  function renderTaskPriorityValuesJavaScriptList()
  {
    $html = 'var tasks_priority_values_list = new Array();' . "\n";
    
    $c= new Criteria();
    $c->addAscendingOrderByColumn(TasksPriorityPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(TasksPriorityPeer::NAME);
    $tasks_priority_list = TasksPriorityPeer::doSelect($c);
    
    foreach($tasks_priority_list as $tasks_priority)
    {
      $html .= 'tasks_priority_values_list[' . $tasks_priority->getId() . ']=\'' . (strlen($tasks_priority->getIcon())>0 ? '&nbsp;' . image_tag('icons/' . $tasks_priority->getIcon(), array('alt'=>addslashes($tasks_priority->getName()),'title'=>addslashes($tasks_priority->getName()))) : addslashes($tasks_priority->getName())). '\';' . "\n";
    }
    
    return $html;
  }
 
?>