<?php

  function set_default_key_list($yuiTable, $projectColumnList='')
  {
       
    foreach($yuiTable['key'] as $key=>$value)
    {
      if(strlen($projectColumnList)>0)
      {
        if(!in_array($value['id'], explode(',',$projectColumnList)))
        {
          unset($yuiTable['key'][$key]);
        }
      }
      else
      {
        if(sfConfig::get('app_tasks_fields_' . $value['id'])=='off')
        {
          unset($yuiTable['key'][$key]);
        }
      }
    }
    
    reset($yuiTable['key']);
  
    return $yuiTable;
  }
  
  function rendeYuiTableRows($yuiTable, $yuiTableOptions)
  {
    $rowStr = '';
    foreach($yuiTable['data'] as $id=>$row)
    {
      $rowStr .= '{';
      
      $rowStr .= rendeYuiTableActionRow($yuiTableOptions,$id);
      
      foreach($row as $key=>$value)
      {
        if($key=='start_date' or $key=='due_date' or $key=='created_at')
        {
          $rowStr .= $key . ':' . $value . ',';
        }
        else
        {
          $rowStr .= $key . ':"' .  addslashes(str_replace(array("\r\n", "\n", "\r"),'',$value)) . '",';
        }
      }
      
      $rowStr = substr($rowStr,0,-1);
      
      $rowStr .= '},' . "\n";
    }
    
    $rowStr = substr($rowStr,0,-2);
    
    return $rowStr;
  }
  
  function rendeYuiTableColumnDefs($yuiTable, $yuiTableOptions)
  {
    $rowStr = rendeYuiTableActionColumnDefs($yuiTableOptions);
    
    foreach($yuiTable['key'] as $value)
    {
      $extraOptions = '';
      
      if($value['id']=='description')
      {
        $extraOptions = ', className: "yui-dt-description-column"';
      }
      elseif($value['id']!='name')
      {
        $extraOptions = ', className: "yui-dt-short-column"';
      }
      
      $isSortable = 'true';
      
      if($value['id']=='description' || $value['id']=='createdBy')
      {
        $isSortable = 'false';
      }    
      
      if(!isset($value['formatter']))
      {
        $value['formatter'] = '"string"';
      }            
                  
      $rowStr .= '{key: "' . $value['id'] . '", label: "' . $value['label'] . '", formatter: ' . $value['formatter'] . ', sortable:' . $isSortable . ', resizeable:false ' . $extraOptions . '},';
    }
    
    $rowStr = substr($rowStr,0,-1);
    
    $rowStr .= "\n";
    
    return $rowStr;
  }
  
  
  function rendeYuiTableFields($yuiTable, $yuiTableOptions)
  {
    $rowStr = rendeYuiTableActionField($yuiTableOptions);
    
    
    foreach($yuiTable['key'] as $value)
    {                                              
      $rowStr .= '{key: "' . $value['id'] . '"' . (isset($value['parser']) ? ', parser:"' . $value['parser'] . '"':''). '},';
    }
            
    if($yuiTableOptions['isUrlColumn']==true)
    {
     $rowStr .= '{key: "url"},';
    }
    
    if($yuiTableOptions['isProjectUrlColumn']==true)
    {
     $rowStr .= '{key: "project_url"},';
    }  

    

    $rowStr = substr($rowStr,0,-1);
    
    $rowStr .= "\n";

    return $rowStr;
  }
  
  function rendeYuiTableActionRow($yuiTableOptions,$id)
  {
    $rowStr = '';
    
    if($yuiTableOptions['allowMultipleSelect'])
    {
      $rowStr .= 'multipleSelect:"' . addslashes(checkbox_tag('yuiDataTableItems[]',$id,false,array('class'=>'yuiDataTableItemCheckbox'))) . '",';
    }
    
    if($yuiTableOptions['allowEdit'] || $yuiTableOptions['allowDelete'])
    {
      $rowStr .= 'action:"';
      
      if($yuiTableOptions['allowDelete'])
      {
        $rowStr .= addslashes(link_to(image_tag('icons/icon_delete.png', array('border'=>'0')),$yuiTableOptions['module'] . '/delete?id='.$id . '&' . $yuiTableOptions['urlParams'],array('confirm' => __('Are you sure?')))) . '  ';
      }

      if($yuiTableOptions['allowEdit'])
      {
        $rowStr .= addslashes(image_tag('icons/icon_edit.png', array('onClick'=>'yuiShowPanel(\'' . __('Edit') . '\',"' . url_for($yuiTableOptions['module'] . '/edit?id='.$id . '&' . $yuiTableOptions['urlParams']) . '")')));
      }
      $rowStr .='", ';
    }
    
    return $rowStr;
  }
  
  function rendeYuiTableActionColumnDefs($yuiTableOptions)
  {
    $rowStr = '';
    
    if($yuiTableOptions['allowMultipleSelect'])
    {
      $rowStr .= '{key: "multipleSelect", label: "' . addslashes(checkbox_tag('select_all_' . $yuiTableOptions['containerId'],'',false,array("onClick"=>"selectAllDataTableItems('" . $yuiTableOptions['containerId'] . "')"))). '", sortable:false, resizeable:false, className: "yui-dt-short-column"},' . "\n";
    }
    
    if($yuiTableOptions['allowEdit'] || $yuiTableOptions['allowDelete'])
    {
      $rowStr .= '{key: "action", label: "' . __('Action') . '", sortable:false, resizeable:false, className: "yui-dt-short-column"},' . "\n";
    }
  
    return $rowStr;
  }
  
  function rendeYuiTableActionField($yuiTableOptions)
  {
    $rowStr = '';
    
    if($yuiTableOptions['allowMultipleSelect'])
    {
      $rowStr .= '"multipleSelect",';
    }
    
    if($yuiTableOptions['allowEdit'] || $yuiTableOptions['allowDelete'])
    {
      $rowStr .= '"action",';
    }
    return $rowStr;
  }
  
  function renderBooleanValueText($v)
  {
    if($v == true)
    {
      return __('Yes');
    }
    else
    {
      return '<span class="boleanValueTextNo">' . __('No') . '</span>';
    }
  }
  
  function replaceTextToLinks($text)
  {    
    $text = str_replace('<a href','<a target="_balnk" href',$text);    
  
    $text = auto_link_text($text,'urls',array('target'=>'_blank'));
                
    $text = str_replace('<script','&lt;script',$text);
    $text = str_replace('</script>','&lt/script&gt;',$text);
                    
    return $text;
  }
  
?>