<?php

class DiscussionsCommentsPeer extends BaseDiscussionsCommentsPeer
{
  public static function getNameLastCommented($discussionId)
  {
    $c = new Criteria();
    $c->add(DiscussionsCommentsPeer::DISCUSSIONS_ID, $discussionId);
    $c->addDescendingOrderByColumn(DiscussionsCommentsPeer::CREATED_AT);
    $c->setLimit(1);
    if($tasks_comments_list = DiscussionsCommentsPeer::doSelectJoinAll($c))
    {
      $tasks_comments = current($tasks_comments_list);

      return $tasks_comments->getUsers()->getName();
    }
    
    return '';
  }
  
  public static function getTextLastCommented($discussionId)
  {
    $c = new Criteria();
    $c->add(DiscussionsCommentsPeer::DISCUSSIONS_ID, $discussionId);
    $c->addDescendingOrderByColumn(DiscussionsCommentsPeer::CREATED_AT);
    $c->setLimit(1);
    if($discussions_comments_list = DiscussionsCommentsPeer::doSelectJoinAll($c))
    {
      $discussions_comments = current($discussions_comments_list);
            
      $comments_details =  replaceTextToLinks($discussions_comments->getDescription());
                  
      if(strlen(strip_tags($comments_details))==0) $comments_details = '';
      
      $comments_details .= get_component('attachments','attachmentsValuesList', array('bindType'=>'discussionsComments', 'bindId'=>$discussions_comments->getId()));
        
      return str_replace(array("\n","\r","\n\r"),'',$comments_details);
    }
    
    return '';
  }  
}
