<?php

class ExtraFieldsListPeer extends BaseExtraFieldsListPeer
{
  public static function insertFieldsValues($values, $bindId, $bindType)
  {
    foreach($values as $key=>$value)
    {
      if(key($value)>0)
      {
        $extraField = ExtraFieldsListPeer::retrieveByPk(key($value));
      }
      else
      {
        $extraField = new ExtraFieldsList();
      }
      
      $extraField->setExtraFieldsId($key);
      $extraField->setBindId($bindId);
      
      
      $field_value = current($value);
      
      if(ExtraFieldsListPeer::getTypeByExtraFieldsId($key)=='date' and strlen($field_value)>0)
      {
        $dt= new DateTime($field_value);
        $field_value = ($dt ? $dt->format('Y-m-d') : '');
      }
      
      $extraField->setValue($field_value);
      
      $extraField->save();
    }    
  }
  
  public static function getTypeByExtraFieldsId($id)
  {          
    if($extra_fields = ExtraFieldsPeer::retrieveByPk($id))
    {
      return $extra_fields->getType();
    }
    else
    {
      return '';
    }
  
  } 
  
  public static function getIdByBindId($bindId, $extraFieldsId)
  {
      $c= new Criteria();
      $c->add(ExtraFieldsListPeer::BIND_ID,$bindId);
      $c->add(ExtraFieldsListPeer::EXTRA_FIELDS_ID,$extraFieldsId);
      if($extraField = ExtraFieldsListPeer::doSelectOne($c))
      {
        return $extraField->getId();
      }
  }
  
  public static function getValueByBindId($bindId, $extraFieldsId)
  {
    $c= new Criteria();
    $c->add(ExtraFieldsListPeer::BIND_ID,$bindId);
    $c->add(ExtraFieldsListPeer::EXTRA_FIELDS_ID,$extraFieldsId);
    if($extraField = ExtraFieldsListPeer::doSelectOne($c))
    {
      return $extraField->getValue();
    }
  }
  
  public static function getTotalNumericFieldsValues($total_values, $bindType, $bindId)
  {
    $c= new Criteria();
    $c->add(ExtraFieldsPeer::BIND_TYPE,$bindType);
    $c->add(ExtraFieldsPeer::TYPE,'number');
    $c->addAscendingOrderByColumn(ExtraFieldsPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(ExtraFieldsPeer::NAME);
    $extra_fields_list = ExtraFieldsPeer::doSelect($c);
    
    foreach ($extra_fields_list as $extra_fields)
    {
      $value = ExtraFieldsListPeer::getValueByBindId($bindId, $extra_fields->getId());
      if($value>0)
      {
        if(!isset($total_values[$extra_fields->getName()]))
        {
          $total_values[$extra_fields->getName()] = $value;
        }
        else
        {
          $total_values[$extra_fields->getName()] += $value;
        }
      }
    }
    
    return $total_values;

  }
  
  public static function setYuiTableKeys($yuiTable, $bindType)
  {
    $c= new Criteria();
    $c->add(ExtraFieldsPeer::BIND_TYPE,$bindType);
    $c->add(ExtraFieldsPeer::DISPLAY_IN_LIST,1);
    $c->add(ExtraFieldsPeer::ACTIVE,1);
    $c->addAscendingOrderByColumn(ExtraFieldsPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(ExtraFieldsPeer::NAME);
    $extra_fields_list = ExtraFieldsPeer::doSelect($c);

    foreach ($extra_fields_list as $extra_fields)
    {
      $yuiTable['key'][] = array('id' => 'extra_fields_' . $extra_fields->getId(), 'label'=> $extra_fields->getName(),'formatter'=>($extra_fields->getType()=='date' ? 'formatDate':'"string"'),'parser'=>($extra_fields->getType()=='number' ? 'number':'string'));
    }
    
    return $yuiTable;
  }
  
  public static function getExtraFieldsListByType($bindType)
  {
    $c= new Criteria();
    $c->add(ExtraFieldsPeer::BIND_TYPE,$bindType);
    $c->add(ExtraFieldsPeer::DISPLAY_IN_LIST,1);
    $c->add(ExtraFieldsPeer::ACTIVE,1);
    $c->addAscendingOrderByColumn(ExtraFieldsPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(ExtraFieldsPeer::NAME);
    $extra_fields_list = ExtraFieldsPeer::doSelect($c);
    
    return $extra_fields_list;
  }
  
  public static function setYuiTableData($yuiTable, $extra_fields_list, $bindId)
  {


    $data = array();
    foreach ($extra_fields_list as $extra_fields)
    {
      $value = ExtraFieldsListPeer::getValueByBindId($bindId, $extra_fields->getId());
      
      if($extra_fields->getType()=='date' && strlen($value)>0)
      {
        $value = getDateTimestamp($value);
      }
      
      if($extra_fields->getType()=='url' && strlen($value)>0)
      {
        if(!stristr($value,'://')) $value = 'http://' . $value;
        $value = '<a href="' . $value. '" target="_blank" class="table-list-link">' . I18NText::__('View') . '</a>';
      }
      
      $data['extra_fields_' . $extra_fields->getId()] = $value;
    }

    $yuiTable['data'][$bindId] = array_merge($yuiTable['data'][$bindId], $data);

    return $yuiTable;
  }
  
}
