<?php

class ExtraFieldsPeer extends BaseExtraFieldsPeer
{
  public static function getExtraFieldsTypesList()
  {
    $list = array();
    $list['number'] = 'Number';
    $list['text'] = 'Text';
    $list['date'] = 'Date';
    $list['url']  = 'Url';

    return $list;
  }

  public static function getExtraFieldsTypeName($key)
  {
    $list = ExtraFieldsPeer::getExtraFieldsTypesList();

    if(strlen($key)>0 && isset($list[$key]))
    {
      return $list[$key];
    }
  }
  
  public static function countByBindType($bindType)
  {
    $c= new Criteria();
    $c->add(ExtraFieldsPeer::BIND_TYPE,$bindType);
    return ExtraFieldsPeer::doCount($c);
  }
  
  public static function getExtraFieldsList($bindType, $type='', $addEmpty = true)
  {
    $c= new Criteria();
    $c->add(ExtraFieldsPeer::BIND_TYPE,$bindType);
    if(strlen($type)>0)$c->add(ExtraFieldsPeer::TYPE,$type);
    $c->addAscendingOrderByColumn(ExtraFieldsPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(ExtraFieldsPeer::NAME);
    $extra_fields = ExtraFieldsPeer::doSelect($c);
    
    $extra_fields_list = array();
    
    if($addEmpty)
    {
      $extra_fields_list[] = '';
    }
    
    foreach($extra_fields as $v)
    {
      $extra_fields_list[$v->getId()] = $v->getName();
    }
    
    return $extra_fields_list;
  }
  
}
