<?php

class ProjectsPeer extends BaseProjectsPeer
{
  public static function countProjectsByStatusId($statusId, $users)
  {
    $c = new Criteria();
    $c->add(ProjectsPeer::PROJECTS_STATUS_ID,$statusId);
    
    if(!$users->hasCredential('allow_view_all'))
    {
      $c->add('','(' . ProjectsPeer::CREATED_BY . '=' . $users->getAttribute('userId') . " or FIND_IN_SET(" . $users->getAttribute('userId') . "," . ProjectsPeer::TEAM . "))", Criteria::CUSTOM);
    }
    
    return ProjectsPeer::doCountJoinProjectsStatus($c);
  }
  
  public static function countProjectsByTypeId($statusId, $users)
  {
    $c = new Criteria();
    $c->add(ProjectsPeer::PROJECTS_TYPES_ID,$statusId);
    
    if(!$users->hasCredential('allow_view_all'))
    {
      $c->add('','(' . ProjectsPeer::CREATED_BY . '=' . $users->getAttribute('userId') . " or FIND_IN_SET(" . $users->getAttribute('userId') . "," . ProjectsPeer::TEAM . "))", Criteria::CUSTOM);
    }
    
    return ProjectsPeer::doCountJoinProjectsTypes($c);
  }
  
  public static function countProjectTasksByStatusGroup($projectId, $group, $countOverdue = false)
  {
    $c = new Criteria();
    $c->add(TasksPeer::PROJECTS_ID,$projectId);
    $c->add(TasksPeer::TASKS_STATUS_ID,TasksStatusPeer::getStatusIdByGroupID($group),Criteria::IN);
    
    if($countOverdue)
    {
      $c->add(TasksPeer::DUE_DATE, date('Y-m-d'), Criteria::LESS_THAN);
    }
    
    return TasksPeer::doCount($c);
  }
  
  public static function check_users_have_proejcts_access($userId,$projectId)
  {
    $c = new Criteria();   
    $c->add(ProjectsPeer::ID, $projectId); 
    $c->add('','(' . ProjectsPeer::CREATED_BY . '=' . $userId . " or FIND_IN_SET(" . $userId . "," . ProjectsPeer::TEAM . "))", Criteria::CUSTOM);
    return ProjectsPeer::doCount($c);    
  }
}
