<?php

class ProjectsReportsPeer extends BaseProjectsReportsPeer
{
  public static function getReportsList($userId,$display_in_menu = false)
  {
    $c = new Criteria();
    
    $c->add(ProjectsReportsPeer::USERS_ID,$userId);
    
    if($display_in_menu)
    {
      $c->add(ProjectsReportsPeer::DISPLAY_IN_MENU,1);
    }
    
    $c->addAscendingOrderByColumn(ProjectsReportsPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(ProjectsReportsPeer::NAME);
    
    return ProjectsReportsPeer::doSelect($c);
  }
  
  public static function getReportDataList($reportParams, $userId, $orderBy = array('status','name'))
  {
  
    $user = UsersPeer::retrieveByPk($userId);
            
    $c = new Criteria();
    
    if(strlen($reportParams->getProjectsId())>0)
    {
      $c->add(ProjectsPeer::ID, explode(',',$reportParams->getProjectsId()), Criteria::IN);
    }
    else
    {
      //if($user->getUsersGroups()->getAllowViewAll()!=1)
      {
        $c->add('','(' . ProjectsPeer::CREATED_BY . '=' . $userId . " or FIND_IN_SET(" . $userId . "," . ProjectsPeer::TEAM . "))", Criteria::CUSTOM);
      }

    }
        
    if(strlen($reportParams->getProjectsTypeId())>0)
    {
      $c->add(ProjectsPeer::PROJECTS_TYPES_ID, explode(',',$reportParams->getProjectsTypeId()), Criteria::IN);
    }
        
    if(strlen($reportParams->getProjectsStatusId())>0)
    {
      $c->add(ProjectsPeer::PROJECTS_STATUS_ID, explode(',',$reportParams->getProjectsStatusId()), Criteria::IN);
    }
    

    
    if($reportParams->getInTeam()>0)
    {
      $c->add('  ',"FIND_IN_SET(" . $reportParams->getInTeam() . "," . ProjectsPeer::TEAM . ")", Criteria::CUSTOM);
    }
    
    
    
    if(in_array('status',$orderBy)) $c->addAscendingOrderByColumn(ProjectsPeer::PROJECTS_STATUS_ID);
    if(in_array('name',$orderBy)) $c->addAscendingOrderByColumn(ProjectsPeer::NAME);
    
    return ProjectsPeer::doSelectJoinAll($c);
  }
}
