<?php

class TasksPeer extends BaseTasksPeer
{
  public static function  getDateTimestamp($date)
   {
     if(strlen($date)>0)
     {
       $v = date_parse($date);
       
       return mktime(0, 0, 0, $v['month'], $v['day'], $v['year']);
     }
     else
     {
       return '""';
     }
   }
   
  public static function countTasksByStatusId($statusId, $projectId)
  {
    $c = new Criteria();
    $c->add(TasksPeer::TASKS_STATUS_ID, $statusId);
    $c->add(TasksPeer::PROJECTS_ID, $projectId);
    return TasksPeer::doCount($c);
  }
  
  public static function countTasksByGroupId($groupId, $projectId)
  {
    $c = new Criteria();
    $c->add(TasksPeer::TASKS_GROUPS_ID, $groupId);
    $c->add(TasksPeer::PROJECTS_ID, $projectId);
    return TasksPeer::doCount($c);
  }
  
  public static function countTasksByPhaseId($phaseId, $projectId)
  {
    $c = new Criteria();
    $c->add(TasksPeer::PROJECTS_PHASES_ID, $phaseId);
    $c->add(TasksPeer::PROJECTS_ID, $projectId);
    return TasksPeer::doCount($c);
  }
  
  public static function countTasksByVersionId($versionId, $projectId)
  {
    $c = new Criteria();
    $c->add(TasksPeer::VERSIONS_ID, $versionId);
    $c->add(TasksPeer::PROJECTS_ID, $projectId);
    return TasksPeer::doCount($c);
  }
  
  public static function getUpdateClosedDateType($tasks, $newStatusId)
  {
    $isStatusCahnged = true;
        
    if($tasks->getTasksStatusId()==$newStatusId)
    {
      $isStatusCahnged=false;
    }
    
    $closedIdList = TasksStatusPeer::getStatusIdByGroupID('closed');
        
    if($isStatusCahnged && in_array($newStatusId,$closedIdList))
    {
      return 'updateClosedDate';
    }
    elseif($isStatusCahnged && !in_array($newStatusId,$closedIdList))
    {
      return 'clearClosedDate';
    }
  }
  
  public static function getActualTime($taskId, $date_from='', $date_to='')
  {
    $total = 0;
    
    $c = new Criteria();
    $c->add(TasksCommentsPeer::TASKS_ID, $taskId);
    $c->add(TasksCommentsPeer::WORKED_HOURS, 0, Criteria::GREATER_THAN);
    
    
    if(strlen($date_from)>0 || strlen($date_to)>0)
    {
      $criteria_str = '';
      
      if(strlen($date_from)>0) $criteria_str .= "date_format(" . TasksCommentsPeer::CREATED_AT . ",'%Y-%m-%d')>='" . $date_from . "'";
      
      if(strlen($date_to)>0)
      {
        if(strlen($date_from)>0) $criteria_str .= ' and ';
        
        $criteria_str .= " date_format(" . TasksCommentsPeer::CREATED_AT . ",'%Y-%m-%d')<='" . $date_to . "'";
      }
      
      $c->add('', $criteria_str , Criteria::CUSTOM);
    }
    
    
    if($tasks_comments_list = TasksCommentsPeer::doSelect($c))
    {    
      foreach($tasks_comments_list as $tasks_comments)
      {
        $total+=$tasks_comments->getWorkedHours();
      }
    }
    
    return $total;
  }
  
  public static function getProgressValuesList($add_empty=false)
  {
    $list = array();
    
    if($add_empty)
    {
      $list[] = '';
    }
    
    for($i=5;$i<=100;$i+=5)
    {
      $list[$i]=$i . '%';
    }
    
    return $list;
  }
}
