<?php

class TasksStatusPeer extends BaseTasksStatusPeer
{
  public static function getTasksStatusGroupsList()
  {
    $list = array();
    $list['open'] = 'Open';
    $list['done'] = 'Done';
    $list['closed'] = 'Closed';
    
    return $list;
  }
  
  public static function getTasksStatusGroupsName($key)
  {
    $list = TasksStatusPeer::getTasksStatusGroupsList();

    if(strlen($key)>0 && isset($list[$key]))
    {
      return $list[$key];
    }
  }
  
  public static function getStatusIdByGroupID($id)
  {
    $c = new Criteria();
    $c->add(TasksStatusPeer::GROUP,$id);
    $status_list = TasksStatusPeer::doSelect($c);

    $status_id_list = array();
    foreach($status_list as $status)
    {
      $status_id_list[] = $status->getId();
    }
    
    return $status_id_list;
  }
  
  public static function resetDefaultValues($exclude_id)
  {
    $connection = Propel::getConnection();
    $query = 'UPDATE  %s  SET %s=null WHERE id!="%s"';
    $query = sprintf($query, TasksStatusPeer::TABLE_NAME, TasksStatusPeer::DEFAULT_VALUE,$exclude_id);
    $statement = $connection->prepare($query);
    $statement->execute();
  }
  
  public static function getGroupedStatusList($add_emplty = false)
  {
    $c= new Criteria();
    $c->add(TasksStatusPeer::ACTIVE, 1);
    $c->addAscendingOrderByColumn(TasksStatusPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(TasksStatusPeer::NAME);
    $tasksStatusList = TasksStatusPeer::doSelect($c);
    
    $tasks_status_list = array();
    
    if($add_emplty)
    {
      $tasks_status_list[''][''] = '';
    }
    
    foreach($tasksStatusList as $tasksStauts)
    {
      $tasks_status_list[$tasksStauts->getGroup()][$tasksStauts->getId()] = '&nbsp;&nbsp;&nbsp;' . $tasksStauts->getName();
    }
    
    return $tasks_status_list;
  }
  
  public static function doCountActive()
  {
    $c = new Criteria();
    $c->add(TasksStatusPeer::ACTIVE,1);
    return TasksStatusPeer::doCount($c);
  }
}
