<?php

class TicketsCommentsPeer extends BaseTicketsCommentsPeer
{
  public static function getNameLastCommented($ticket)
  {
    $c = new Criteria();
    $c->add(TicketsCommentsPeer::TICKETS_ID, $ticket);
    $c->addDescendingOrderByColumn(TicketsCommentsPeer::CREATED_AT);
    $c->setLimit(1);
    if($Tickets_comments_list = TicketsCommentsPeer::doSelectJoinAll($c))
    {
      $Tickets_comments = current($Tickets_comments_list);

      return $Tickets_comments->getUsers()->getName();
    }
    
    return '';
  }
  
  public static function getTextLastCommented($ticketsId)
  {
    $c = new Criteria();
    $c->add(TicketsCommentsPeer::TICKETS_ID, $ticketsId);
    $c->addDescendingOrderByColumn(TicketsCommentsPeer::CREATED_AT);
    $c->setLimit(1);
    if($tickets_comments_list = TicketsCommentsPeer::doSelectJoinAll($c))
    {
      $tickets_comments = current($tickets_comments_list);
            
      $comments_details =  replaceTextToLinks($tickets_comments->getDescription());
                  
      if(strlen(strip_tags($comments_details))==0) $comments_details = '';
      
      $comments_details .= get_component('attachments','attachmentsValuesList', array('bindType'=>'ticketsComments', 'bindId'=>$tickets_comments->getId()));
        
      return str_replace(array("\n","\r","\n\r"),'',$comments_details);
    }
    
    return '';
  }   
  
  public static function getSendToSendFrom($porjectId, $ticketId, $userId)
  {
    $c = new Criteria();
    $c->add(TicketsPeer::ID,$ticketId);
    $tickets = TicketsPeer::doSelectOne($c);
     

    $sendTo = array();
    $sendFrom = array();

    $c = new Criteria();
    $c->add(UsersPeer::ID,$userId);
    $user = UsersPeer::doSelectOne($c);

    $sendFrom[$user->getEmail()] = $user->getName();

    $c = new Criteria();
    $c->add(UsersPeer::ID,$tickets->getDepartments()->getUsersId());
    if($assignedTo = UsersPeer::doSelectOne($c))
    {
      if($assignedTo->getEmail() != $user->getEmail())
      {
        $sendTo[$assignedTo->getEmail()] = $assignedTo->getName();
      }
    }

    $c = new Criteria();
    $c->add(UsersPeer::ID,$tickets->getUsersId());
    if($createdBy = UsersPeer::doSelectOne($c))
    {
      if($createdBy->getEmail() != $user->getEmail())
      {
        $sendTo[$createdBy->getEmail()] = $createdBy->getName();
      }
    }
    
    return array('sendTo'=> $sendTo, 'sendFrom'=> $sendFrom);
  }
}
