<?php

class TicketsPeer extends BaseTicketsPeer
{
  public static function countTicketsByStatusId($statusId, $projectId)
  {
    $c = new Criteria();
    $c->add(TicketsPeer::TICKETS_STATUS_ID, $statusId);
    
    if($projectId>0)
    {
      $c->add(TicketsPeer::PROJECTS_ID, $projectId);
    } 
     
    return TicketsPeer::doCount($c);
  }
  
  public static function countTicketsByStatusGroup($projectId, $group)
  {
    $c = new Criteria();
    $c->add(TicketsPeer::PROJECTS_ID, $projectId);
    $c->add(TicketsPeer::TICKETS_STATUS_ID,TicketsStatusPeer::getStatusIdByGroupID($group),Criteria::IN);
              
    return TicketsPeer::doCount($c);
  }
  
  public static function countTicketsByTypeId($typeId, $projectId)
  {
    $c = new Criteria();
    $c->add(TicketsPeer::TICKETS_TYPES_ID, $typeId);
    
    if($projectId>0)
    {
      $c->add(TicketsPeer::PROJECTS_ID, $projectId);
    } 
     
    return TicketsPeer::doCount($c);
  }
  
  public static function countTicketsByDepartmentId($departmentId, $projectId)
  {
    $c = new Criteria();
    $c->add(TicketsPeer::DEPARTMENTS_ID, $departmentId);
    
    if($projectId>0)
    {
      $c->add(TicketsPeer::PROJECTS_ID, $projectId);
    } 
     
    return TicketsPeer::doCount($c);
  }
  
  public static function hasOpenRelatedTasks($ticketId, $projectId)
  {        
    $c= new Criteria();
    $c->add(TasksPeer::PROJECTS_ID,$projectId);
    $c->add(TasksPeer::TICKETS_ID,$ticketId);    
    $tasks_list = TasksPeer::doSelect($c);
    
    $closedIdList = TasksStatusPeer::getStatusIdByGroupID('closed');
    
    foreach($tasks_list as $tasks)
    {
      if(!in_array($tasks->getTasksStatusId(),$closedIdList))
      {
        return true;
      }
    }
    
    return false;
  }
  
  public static function isClosed($ticketId)
  {
    $c = new Criteria();
    $c->add(TicketsPeer::ID,$ticketId);
    $ticket = TicketsPeer::doSelectOne($c);
    
    $closedIdList = TicketsStatusPeer::getStatusIdByGroupID('closed');
    
    if(in_array($ticket->getTicketsStatusId(),$closedIdList))
    {
      return true;
    }
    else
    {
      return false;
    }
  }
}
