<?php

class TicketsStatusPeer extends BaseTicketsStatusPeer
{
  public static function getTicketsStatusGroupsList()
  {
    $list = array();
    $list['open'] = 'Open';    
    $list['closed'] = 'Closed';
    
    return $list;
  }
  
  public static function getTicketsStatusGroupsName($key)
  {
    $list = TicketsStatusPeer::getTicketsStatusGroupsList();

    if(strlen($key)>0 && isset($list[$key]))
    {
      return $list[$key];
    }
  }
  
  public static function getStatusIdByGroupID($id)
  {
    $c = new Criteria();
    $c->add(TicketsStatusPeer::GROUP,$id);
    $status_list = TicketsStatusPeer::doSelect($c);

    $status_id_list = array();
    foreach($status_list as $status)
    {
      $status_id_list[] = $status->getId();
    }
    
    return $status_id_list;
  }
  
  public static function resetDefaultValues($exclude_id)
  {
    $connection = Propel::getConnection();
    $query = 'UPDATE  %s  SET %s=null WHERE id!="%s"';
    $query = sprintf($query, TicketsStatusPeer::TABLE_NAME, TicketsStatusPeer::DEFAULT_VALUE,$exclude_id);
    $statement = $connection->prepare($query);
    $statement->execute();
  }
  
  public static function getGroupedStatusList($add_emplty = false)
  {
    $c= new Criteria();
    $c->add(TicketsTypesPeer::ACTIVE, 1);
    $c->addAscendingOrderByColumn(TicketsStatusPeer::SORT_ORDER);
    $c->addAscendingOrderByColumn(TicketsStatusPeer::NAME);
    $ticketsStatusList = TicketsStatusPeer::doSelect($c);
    
    $tickets_status_list = array();
    
    if($add_emplty)
    {
      $tickets_status_list[''][''] = '';
    }
    
    foreach($ticketsStatusList as $ticketsStauts)
    {
      $tickets_status_list[$ticketsStauts->getGroup()][$ticketsStauts->getId()] = '&nbsp;&nbsp;&nbsp;' . $ticketsStauts->getName();
    }
    
    return $tickets_status_list;
  }
  
  public static function doCountActive()
  {
    $c = new Criteria();
    $c->add(TicketsStatusPeer::ACTIVE,1);
    return TicketsStatusPeer::doCount($c);
  }

}
