<?php

/**
 * Base class that represents a row from the 'discussions' table.
 *
 * 
 *
 * This class was autogenerated by Propel 1.3.0-dev on:
 *
 * 10/01/11 13:54:40
 *
 * @package    lib.model.om
 */
abstract class BaseDiscussions extends BaseObject  implements Persistent {


  const PEER = 'DiscussionsPeer';

	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var        DiscussionsPeer
	 */
	protected static $peer;

	/**
	 * The value for the id field.
	 * @var        int
	 */
	protected $id;

	/**
	 * The value for the projects_id field.
	 * Note: this column has a database default value of: 0
	 * @var        int
	 */
	protected $projects_id;

	/**
	 * The value for the users_id field.
	 * @var        int
	 */
	protected $users_id;

	/**
	 * The value for the discussions_status_id field.
	 * @var        int
	 */
	protected $discussions_status_id;

	/**
	 * The value for the name field.
	 * Note: this column has a database default value of: ''
	 * @var        string
	 */
	protected $name;

	/**
	 * The value for the description field.
	 * @var        string
	 */
	protected $description;

	/**
	 * The value for the assigned_to field.
	 * Note: this column has a database default value of: ''
	 * @var        string
	 */
	protected $assigned_to;

	/**
	 * @var        Projects
	 */
	protected $aProjects;

	/**
	 * @var        Users
	 */
	protected $aUsers;

	/**
	 * @var        DiscussionsStatus
	 */
	protected $aDiscussionsStatus;

	/**
	 * @var        array DiscussionsComments[] Collection to store aggregation of DiscussionsComments objects.
	 */
	protected $collDiscussionsCommentss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collDiscussionsCommentss.
	 */
	private $lastDiscussionsCommentsCriteria = null;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInValidation = false;

	/**
	 * Initializes internal state of BaseDiscussions object.
	 * @see        applyDefaults()
	 */
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	/**
	 * Applies default values to this object.
	 * This method should be called from the object's constructor (or
	 * equivalent initialization method).
	 * @see        __construct()
	 */
	public function applyDefaultValues()
	{
		$this->projects_id = 0;
		$this->name = '';
		$this->assigned_to = '';
	}

	/**
	 * Get the [id] column value.
	 * 
	 * @return     int
	 */
	public function getId()
	{
		return $this->id;
	}

	/**
	 * Get the [projects_id] column value.
	 * 
	 * @return     int
	 */
	public function getProjectsId()
	{
		return $this->projects_id;
	}

	/**
	 * Get the [users_id] column value.
	 * 
	 * @return     int
	 */
	public function getUsersId()
	{
		return $this->users_id;
	}

	/**
	 * Get the [discussions_status_id] column value.
	 * 
	 * @return     int
	 */
	public function getDiscussionsStatusId()
	{
		return $this->discussions_status_id;
	}

	/**
	 * Get the [name] column value.
	 * 
	 * @return     string
	 */
	public function getName()
	{
		return $this->name;
	}

	/**
	 * Get the [description] column value.
	 * 
	 * @return     string
	 */
	public function getDescription()
	{
		return $this->description;
	}

	/**
	 * Get the [assigned_to] column value.
	 * 
	 * @return     string
	 */
	public function getAssignedTo()
	{
		return $this->assigned_to;
	}

	/**
	 * Set the value of [id] column.
	 * 
	 * @param      int $v new value
	 * @return     Discussions The current object (for fluent API support)
	 */
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = DiscussionsPeer::ID;
		}

		return $this;
	} // setId()

	/**
	 * Set the value of [projects_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Discussions The current object (for fluent API support)
	 */
	public function setProjectsId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->projects_id !== $v || $v === 0) {
			$this->projects_id = $v;
			$this->modifiedColumns[] = DiscussionsPeer::PROJECTS_ID;
		}

		if ($this->aProjects !== null && $this->aProjects->getId() !== $v) {
			$this->aProjects = null;
		}

		return $this;
	} // setProjectsId()

	/**
	 * Set the value of [users_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Discussions The current object (for fluent API support)
	 */
	public function setUsersId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->users_id !== $v) {
			$this->users_id = $v;
			$this->modifiedColumns[] = DiscussionsPeer::USERS_ID;
		}

		if ($this->aUsers !== null && $this->aUsers->getId() !== $v) {
			$this->aUsers = null;
		}

		return $this;
	} // setUsersId()

	/**
	 * Set the value of [discussions_status_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Discussions The current object (for fluent API support)
	 */
	public function setDiscussionsStatusId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->discussions_status_id !== $v) {
			$this->discussions_status_id = $v;
			$this->modifiedColumns[] = DiscussionsPeer::DISCUSSIONS_STATUS_ID;
		}

		if ($this->aDiscussionsStatus !== null && $this->aDiscussionsStatus->getId() !== $v) {
			$this->aDiscussionsStatus = null;
		}

		return $this;
	} // setDiscussionsStatusId()

	/**
	 * Set the value of [name] column.
	 * 
	 * @param      string $v new value
	 * @return     Discussions The current object (for fluent API support)
	 */
	public function setName($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->name !== $v || $v === '') {
			$this->name = $v;
			$this->modifiedColumns[] = DiscussionsPeer::NAME;
		}

		return $this;
	} // setName()

	/**
	 * Set the value of [description] column.
	 * 
	 * @param      string $v new value
	 * @return     Discussions The current object (for fluent API support)
	 */
	public function setDescription($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = DiscussionsPeer::DESCRIPTION;
		}

		return $this;
	} // setDescription()

	/**
	 * Set the value of [assigned_to] column.
	 * 
	 * @param      string $v new value
	 * @return     Discussions The current object (for fluent API support)
	 */
	public function setAssignedTo($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->assigned_to !== $v || $v === '') {
			$this->assigned_to = $v;
			$this->modifiedColumns[] = DiscussionsPeer::ASSIGNED_TO;
		}

		return $this;
	} // setAssignedTo()

	/**
	 * Indicates whether the columns in this object are only set to default values.
	 *
	 * This method can be used in conjunction with isModified() to indicate whether an object is both
	 * modified _and_ has some values set which are non-default.
	 *
	 * @return     boolean Whether the columns in this object are only been set with default values.
	 */
	public function hasOnlyDefaultValues()
	{
			// First, ensure that we don't have any columns that have been modified which aren't default columns.
			if (array_diff($this->modifiedColumns, array(DiscussionsPeer::PROJECTS_ID,DiscussionsPeer::NAME,DiscussionsPeer::ASSIGNED_TO))) {
				return false;
			}

			if ($this->projects_id !== 0) {
				return false;
			}

			if ($this->name !== '') {
				return false;
			}

			if ($this->assigned_to !== '') {
				return false;
			}

		// otherwise, everything was equal, so return TRUE
		return true;
	} // hasOnlyDefaultValues()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (0-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param      array $row The row returned by PDOStatement->fetch(PDO::FETCH_NUM)
	 * @param      int $startcol 0-based offset column which indicates which restultset column to start with.
	 * @param      boolean $rehydrate Whether this object is being re-hydrated from the database.
	 * @return     int next starting column
	 * @throws     PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->projects_id = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
			$this->users_id = ($row[$startcol + 2] !== null) ? (int) $row[$startcol + 2] : null;
			$this->discussions_status_id = ($row[$startcol + 3] !== null) ? (int) $row[$startcol + 3] : null;
			$this->name = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
			$this->description = ($row[$startcol + 5] !== null) ? (string) $row[$startcol + 5] : null;
			$this->assigned_to = ($row[$startcol + 6] !== null) ? (string) $row[$startcol + 6] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 7; // 7 = DiscussionsPeer::NUM_COLUMNS - DiscussionsPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating Discussions object", $e);
		}
	}

	/**
	 * Checks and repairs the internal consistency of the object.
	 *
	 * This method is executed after an already-instantiated object is re-hydrated
	 * from the database.  It exists to check any foreign keys to make sure that
	 * the objects related to the current object are correct based on foreign key.
	 *
	 * You can override this method in the stub class, but you should always invoke
	 * the base method from the overridden method (i.e. parent::ensureConsistency()),
	 * in case your model changes.
	 *
	 * @throws     PropelException
	 */
	public function ensureConsistency()
	{

		if ($this->aProjects !== null && $this->projects_id !== $this->aProjects->getId()) {
			$this->aProjects = null;
		}
		if ($this->aUsers !== null && $this->users_id !== $this->aUsers->getId()) {
			$this->aUsers = null;
		}
		if ($this->aDiscussionsStatus !== null && $this->discussions_status_id !== $this->aDiscussionsStatus->getId()) {
			$this->aDiscussionsStatus = null;
		}
	} // ensureConsistency

	/**
	 * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
	 *
	 * This will only work if the object has been saved and has a valid primary key set.
	 *
	 * @param      boolean $deep (optional) Whether to also de-associated any related objects.
	 * @param      PropelPDO $con (optional) The PropelPDO connection to use.
	 * @return     void
	 * @throws     PropelException - if this object is deleted, unsaved or doesn't have pk match in db
	 */
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(DiscussionsPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

		// We don't need to alter the object instance pool; we're just modifying this instance
		// already in the pool.

		$stmt = DiscussionsPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); // rehydrate

		if ($deep) {  // also de-associate any related objects?

			$this->aProjects = null;
			$this->aUsers = null;
			$this->aDiscussionsStatus = null;
			$this->collDiscussionsCommentss = null;
			$this->lastDiscussionsCommentsCriteria = null;

		} // if (deep)
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param      PropelPDO $con
	 * @return     void
	 * @throws     PropelException
	 * @see        BaseObject::setDeleted()
	 * @see        BaseObject::isDeleted()
	 */
	public function delete(PropelPDO $con = null)
	{

    foreach (sfMixer::getCallables('BaseDiscussions:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(DiscussionsPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			DiscussionsPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseDiscussions:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	/**
	 * Persists this object to the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All modified related objects will also be persisted in the doSave()
	 * method.  This method wraps all precipitate database operations in a
	 * single transaction.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        doSave()
	 */
	public function save(PropelPDO $con = null)
	{

    foreach (sfMixer::getCallables('BaseDiscussions:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(DiscussionsPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseDiscussions:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			DiscussionsPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	/**
	 * Performs the work of inserting or updating the row in the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        save()
	 */
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aProjects !== null) {
				if ($this->aProjects->isModified() || $this->aProjects->isNew()) {
					$affectedRows += $this->aProjects->save($con);
				}
				$this->setProjects($this->aProjects);
			}

			if ($this->aUsers !== null) {
				if ($this->aUsers->isModified() || $this->aUsers->isNew()) {
					$affectedRows += $this->aUsers->save($con);
				}
				$this->setUsers($this->aUsers);
			}

			if ($this->aDiscussionsStatus !== null) {
				if ($this->aDiscussionsStatus->isModified() || $this->aDiscussionsStatus->isNew()) {
					$affectedRows += $this->aDiscussionsStatus->save($con);
				}
				$this->setDiscussionsStatus($this->aDiscussionsStatus);
			}

			if ($this->isNew() ) {
				$this->modifiedColumns[] = DiscussionsPeer::ID;
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = DiscussionsPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which
										 // should always be true here (even though technically
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setId($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += DiscussionsPeer::doUpdate($this, $con);
				}

				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			if ($this->collDiscussionsCommentss !== null) {
				foreach ($this->collDiscussionsCommentss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var        array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return     array ValidationFailed[]
	 * @see        validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param      mixed $columns Column name or an array of column names.
	 * @return     boolean Whether all columns pass validation.
	 * @see        doValidate()
	 * @see        getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param      array $columns Array of column names to validate.
	 * @return     mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aProjects !== null) {
				if (!$this->aProjects->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aProjects->getValidationFailures());
				}
			}

			if ($this->aUsers !== null) {
				if (!$this->aUsers->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUsers->getValidationFailures());
				}
			}

			if ($this->aDiscussionsStatus !== null) {
				if (!$this->aDiscussionsStatus->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aDiscussionsStatus->getValidationFailures());
				}
			}


			if (($retval = DiscussionsPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collDiscussionsCommentss !== null) {
					foreach ($this->collDiscussionsCommentss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param      string $name name
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = DiscussionsPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @return     mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getProjectsId();
				break;
			case 2:
				return $this->getUsersId();
				break;
			case 3:
				return $this->getDiscussionsStatusId();
				break;
			case 4:
				return $this->getName();
				break;
			case 5:
				return $this->getDescription();
				break;
			case 6:
				return $this->getAssignedTo();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param      string $keyType (optional) One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                        BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM. Defaults to BasePeer::TYPE_PHPNAME.
	 * @param      boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns.  Defaults to TRUE.
	 * @return     an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = DiscussionsPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getProjectsId(),
			$keys[2] => $this->getUsersId(),
			$keys[3] => $this->getDiscussionsStatusId(),
			$keys[4] => $this->getName(),
			$keys[5] => $this->getDescription(),
			$keys[6] => $this->getAssignedTo(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param      string $name peer name
	 * @param      mixed $value field value
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = DiscussionsPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @param      mixed $value field value
	 * @return     void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setProjectsId($value);
				break;
			case 2:
				$this->setUsersId($value);
				break;
			case 3:
				$this->setDiscussionsStatusId($value);
				break;
			case 4:
				$this->setName($value);
				break;
			case 5:
				$this->setDescription($value);
				break;
			case 6:
				$this->setAssignedTo($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
	 * BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
	 * The default key type is the column's phpname (e.g. 'AuthorId')
	 *
	 * @param      array  $arr     An array to populate the object from.
	 * @param      string $keyType The type of keys the array uses.
	 * @return     void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = DiscussionsPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setProjectsId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setUsersId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setDiscussionsStatusId($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setName($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setDescription($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setAssignedTo($arr[$keys[6]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return     Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(DiscussionsPeer::DATABASE_NAME);

		if ($this->isColumnModified(DiscussionsPeer::ID)) $criteria->add(DiscussionsPeer::ID, $this->id);
		if ($this->isColumnModified(DiscussionsPeer::PROJECTS_ID)) $criteria->add(DiscussionsPeer::PROJECTS_ID, $this->projects_id);
		if ($this->isColumnModified(DiscussionsPeer::USERS_ID)) $criteria->add(DiscussionsPeer::USERS_ID, $this->users_id);
		if ($this->isColumnModified(DiscussionsPeer::DISCUSSIONS_STATUS_ID)) $criteria->add(DiscussionsPeer::DISCUSSIONS_STATUS_ID, $this->discussions_status_id);
		if ($this->isColumnModified(DiscussionsPeer::NAME)) $criteria->add(DiscussionsPeer::NAME, $this->name);
		if ($this->isColumnModified(DiscussionsPeer::DESCRIPTION)) $criteria->add(DiscussionsPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(DiscussionsPeer::ASSIGNED_TO)) $criteria->add(DiscussionsPeer::ASSIGNED_TO, $this->assigned_to);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return     Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(DiscussionsPeer::DATABASE_NAME);

		$criteria->add(DiscussionsPeer::ID, $this->id);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return     int
	 */
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	/**
	 * Generic method to set the primary key (id column).
	 *
	 * @param      int $key Primary key.
	 * @return     void
	 */
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      object $copyObj An object of Discussions (or compatible) type.
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws     PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setProjectsId($this->projects_id);

		$copyObj->setUsersId($this->users_id);

		$copyObj->setDiscussionsStatusId($this->discussions_status_id);

		$copyObj->setName($this->name);

		$copyObj->setDescription($this->description);

		$copyObj->setAssignedTo($this->assigned_to);


		if ($deepCopy) {
			// important: temporarily setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach ($this->getDiscussionsCommentss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addDiscussionsComments($relObj->copy($deepCopy));
				}
			}

		} // if ($deepCopy)


		$copyObj->setNew(true);

		$copyObj->setId(NULL); // this is a auto-increment column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return     Discussions Clone of current object.
	 * @throws     PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return     DiscussionsPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new DiscussionsPeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a Projects object.
	 *
	 * @param      Projects $v
	 * @return     Discussions The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setProjects(Projects $v = null)
	{
		if ($v === null) {
			$this->setProjectsId(0);
		} else {
			$this->setProjectsId($v->getId());
		}

		$this->aProjects = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the Projects object, it will not be re-added.
		if ($v !== null) {
			$v->addDiscussions($this);
		}

		return $this;
	}


	/**
	 * Get the associated Projects object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     Projects The associated Projects object.
	 * @throws     PropelException
	 */
	public function getProjects(PropelPDO $con = null)
	{
		if ($this->aProjects === null && ($this->projects_id !== null)) {
			$c = new Criteria(ProjectsPeer::DATABASE_NAME);
			$c->add(ProjectsPeer::ID, $this->projects_id);
			$this->aProjects = ProjectsPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aProjects->addDiscussionss($this);
			 */
		}
		return $this->aProjects;
	}

	/**
	 * Declares an association between this object and a Users object.
	 *
	 * @param      Users $v
	 * @return     Discussions The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setUsers(Users $v = null)
	{
		if ($v === null) {
			$this->setUsersId(NULL);
		} else {
			$this->setUsersId($v->getId());
		}

		$this->aUsers = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the Users object, it will not be re-added.
		if ($v !== null) {
			$v->addDiscussions($this);
		}

		return $this;
	}


	/**
	 * Get the associated Users object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     Users The associated Users object.
	 * @throws     PropelException
	 */
	public function getUsers(PropelPDO $con = null)
	{
		if ($this->aUsers === null && ($this->users_id !== null)) {
			$c = new Criteria(UsersPeer::DATABASE_NAME);
			$c->add(UsersPeer::ID, $this->users_id);
			$this->aUsers = UsersPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aUsers->addDiscussionss($this);
			 */
		}
		return $this->aUsers;
	}

	/**
	 * Declares an association between this object and a DiscussionsStatus object.
	 *
	 * @param      DiscussionsStatus $v
	 * @return     Discussions The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setDiscussionsStatus(DiscussionsStatus $v = null)
	{
		if ($v === null) {
			$this->setDiscussionsStatusId(NULL);
		} else {
			$this->setDiscussionsStatusId($v->getId());
		}

		$this->aDiscussionsStatus = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the DiscussionsStatus object, it will not be re-added.
		if ($v !== null) {
			$v->addDiscussions($this);
		}

		return $this;
	}


	/**
	 * Get the associated DiscussionsStatus object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     DiscussionsStatus The associated DiscussionsStatus object.
	 * @throws     PropelException
	 */
	public function getDiscussionsStatus(PropelPDO $con = null)
	{
		if ($this->aDiscussionsStatus === null && ($this->discussions_status_id !== null)) {
			$c = new Criteria(DiscussionsStatusPeer::DATABASE_NAME);
			$c->add(DiscussionsStatusPeer::ID, $this->discussions_status_id);
			$this->aDiscussionsStatus = DiscussionsStatusPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aDiscussionsStatus->addDiscussionss($this);
			 */
		}
		return $this->aDiscussionsStatus;
	}

	/**
	 * Clears out the collDiscussionsCommentss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addDiscussionsCommentss()
	 */
	public function clearDiscussionsCommentss()
	{
		$this->collDiscussionsCommentss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collDiscussionsCommentss collection (array).
	 *
	 * By default this just sets the collDiscussionsCommentss collection to an empty array (like clearcollDiscussionsCommentss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initDiscussionsCommentss()
	{
		$this->collDiscussionsCommentss = array();
	}

	/**
	 * Gets an array of DiscussionsComments objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Discussions has previously been saved, it will retrieve
	 * related DiscussionsCommentss from storage. If this Discussions is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array DiscussionsComments[]
	 * @throws     PropelException
	 */
	public function getDiscussionsCommentss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(DiscussionsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collDiscussionsCommentss === null) {
			if ($this->isNew()) {
			   $this->collDiscussionsCommentss = array();
			} else {

				$criteria->add(DiscussionsCommentsPeer::DISCUSSIONS_ID, $this->id);

				DiscussionsCommentsPeer::addSelectColumns($criteria);
				$this->collDiscussionsCommentss = DiscussionsCommentsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(DiscussionsCommentsPeer::DISCUSSIONS_ID, $this->id);

				DiscussionsCommentsPeer::addSelectColumns($criteria);
				if (!isset($this->lastDiscussionsCommentsCriteria) || !$this->lastDiscussionsCommentsCriteria->equals($criteria)) {
					$this->collDiscussionsCommentss = DiscussionsCommentsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastDiscussionsCommentsCriteria = $criteria;
		return $this->collDiscussionsCommentss;
	}

	/**
	 * Returns the number of related DiscussionsComments objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related DiscussionsComments objects.
	 * @throws     PropelException
	 */
	public function countDiscussionsCommentss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(DiscussionsPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collDiscussionsCommentss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(DiscussionsCommentsPeer::DISCUSSIONS_ID, $this->id);

				$count = DiscussionsCommentsPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(DiscussionsCommentsPeer::DISCUSSIONS_ID, $this->id);

				if (!isset($this->lastDiscussionsCommentsCriteria) || !$this->lastDiscussionsCommentsCriteria->equals($criteria)) {
					$count = DiscussionsCommentsPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collDiscussionsCommentss);
				}
			} else {
				$count = count($this->collDiscussionsCommentss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a DiscussionsComments object to this object
	 * through the DiscussionsComments foreign key attribute.
	 *
	 * @param      DiscussionsComments $l DiscussionsComments
	 * @return     void
	 * @throws     PropelException
	 */
	public function addDiscussionsComments(DiscussionsComments $l)
	{
		if ($this->collDiscussionsCommentss === null) {
			$this->initDiscussionsCommentss();
		}
		if (!in_array($l, $this->collDiscussionsCommentss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collDiscussionsCommentss, $l);
			$l->setDiscussions($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Discussions is new, it will return
	 * an empty collection; or if this Discussions has previously
	 * been saved, it will retrieve related DiscussionsCommentss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Discussions.
	 */
	public function getDiscussionsCommentssJoinUsers($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(DiscussionsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collDiscussionsCommentss === null) {
			if ($this->isNew()) {
				$this->collDiscussionsCommentss = array();
			} else {

				$criteria->add(DiscussionsCommentsPeer::DISCUSSIONS_ID, $this->id);

				$this->collDiscussionsCommentss = DiscussionsCommentsPeer::doSelectJoinUsers($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(DiscussionsCommentsPeer::DISCUSSIONS_ID, $this->id);

			if (!isset($this->lastDiscussionsCommentsCriteria) || !$this->lastDiscussionsCommentsCriteria->equals($criteria)) {
				$this->collDiscussionsCommentss = DiscussionsCommentsPeer::doSelectJoinUsers($criteria, $con, $join_behavior);
			}
		}
		$this->lastDiscussionsCommentsCriteria = $criteria;

		return $this->collDiscussionsCommentss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Discussions is new, it will return
	 * an empty collection; or if this Discussions has previously
	 * been saved, it will retrieve related DiscussionsCommentss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Discussions.
	 */
	public function getDiscussionsCommentssJoinDiscussionsStatus($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(DiscussionsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collDiscussionsCommentss === null) {
			if ($this->isNew()) {
				$this->collDiscussionsCommentss = array();
			} else {

				$criteria->add(DiscussionsCommentsPeer::DISCUSSIONS_ID, $this->id);

				$this->collDiscussionsCommentss = DiscussionsCommentsPeer::doSelectJoinDiscussionsStatus($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(DiscussionsCommentsPeer::DISCUSSIONS_ID, $this->id);

			if (!isset($this->lastDiscussionsCommentsCriteria) || !$this->lastDiscussionsCommentsCriteria->equals($criteria)) {
				$this->collDiscussionsCommentss = DiscussionsCommentsPeer::doSelectJoinDiscussionsStatus($criteria, $con, $join_behavior);
			}
		}
		$this->lastDiscussionsCommentsCriteria = $criteria;

		return $this->collDiscussionsCommentss;
	}

	/**
	 * Resets all collections of referencing foreign keys.
	 *
	 * This method is a user-space workaround for PHP's inability to garbage collect objects
	 * with circular references.  This is currently necessary when using Propel in certain
	 * daemon or large-volumne/high-memory operations.
	 *
	 * @param      boolean $deep Whether to also clear the references on all associated objects.
	 */
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collDiscussionsCommentss) {
				foreach ((array) $this->collDiscussionsCommentss as $o) {
					$o->clearAllReferences($deep);
				}
			}
		} // if ($deep)

		$this->collDiscussionsCommentss = null;
			$this->aProjects = null;
			$this->aUsers = null;
			$this->aDiscussionsStatus = null;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseDiscussions:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseDiscussions::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} // BaseDiscussions
