<?php

/**
 * Base class that represents a row from the 'projects' table.
 *
 * 
 *
 * This class was autogenerated by Propel 1.3.0-dev on:
 *
 * 10/01/11 13:54:40
 *
 * @package    lib.model.om
 */
abstract class BaseProjects extends BaseObject  implements Persistent {


  const PEER = 'ProjectsPeer';

	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var        ProjectsPeer
	 */
	protected static $peer;

	/**
	 * The value for the id field.
	 * @var        int
	 */
	protected $id;

	/**
	 * The value for the projects_status_id field.
	 * @var        int
	 */
	protected $projects_status_id;

	/**
	 * The value for the projects_types_id field.
	 * @var        int
	 */
	protected $projects_types_id;

	/**
	 * The value for the created_by field.
	 * @var        int
	 */
	protected $created_by;

	/**
	 * The value for the name field.
	 * Note: this column has a database default value of: ''
	 * @var        string
	 */
	protected $name;

	/**
	 * The value for the description field.
	 * @var        string
	 */
	protected $description;

	/**
	 * The value for the team field.
	 * @var        string
	 */
	protected $team;

	/**
	 * The value for the created_at field.
	 * @var        string
	 */
	protected $created_at;

	/**
	 * The value for the order_tasks_by field.
	 * @var        string
	 */
	protected $order_tasks_by;

	/**
	 * @var        ProjectsStatus
	 */
	protected $aProjectsStatus;

	/**
	 * @var        ProjectsTypes
	 */
	protected $aProjectsTypes;

	/**
	 * @var        Users
	 */
	protected $aUsers;

	/**
	 * @var        array Discussions[] Collection to store aggregation of Discussions objects.
	 */
	protected $collDiscussionss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collDiscussionss.
	 */
	private $lastDiscussionsCriteria = null;

	/**
	 * @var        array ProjectsComments[] Collection to store aggregation of ProjectsComments objects.
	 */
	protected $collProjectsCommentss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collProjectsCommentss.
	 */
	private $lastProjectsCommentsCriteria = null;

	/**
	 * @var        array ProjectsPhases[] Collection to store aggregation of ProjectsPhases objects.
	 */
	protected $collProjectsPhasess;

	/**
	 * @var        Criteria The criteria used to select the current contents of collProjectsPhasess.
	 */
	private $lastProjectsPhasesCriteria = null;

	/**
	 * @var        array Tasks[] Collection to store aggregation of Tasks objects.
	 */
	protected $collTaskss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collTaskss.
	 */
	private $lastTasksCriteria = null;

	/**
	 * @var        array TasksGroups[] Collection to store aggregation of TasksGroups objects.
	 */
	protected $collTasksGroupss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collTasksGroupss.
	 */
	private $lastTasksGroupsCriteria = null;

	/**
	 * @var        array Tickets[] Collection to store aggregation of Tickets objects.
	 */
	protected $collTicketss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collTicketss.
	 */
	private $lastTicketsCriteria = null;

	/**
	 * @var        array Versions[] Collection to store aggregation of Versions objects.
	 */
	protected $collVersionss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collVersionss.
	 */
	private $lastVersionsCriteria = null;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInValidation = false;

	/**
	 * Initializes internal state of BaseProjects object.
	 * @see        applyDefaults()
	 */
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	/**
	 * Applies default values to this object.
	 * This method should be called from the object's constructor (or
	 * equivalent initialization method).
	 * @see        __construct()
	 */
	public function applyDefaultValues()
	{
		$this->name = '';
	}

	/**
	 * Get the [id] column value.
	 * 
	 * @return     int
	 */
	public function getId()
	{
		return $this->id;
	}

	/**
	 * Get the [projects_status_id] column value.
	 * 
	 * @return     int
	 */
	public function getProjectsStatusId()
	{
		return $this->projects_status_id;
	}

	/**
	 * Get the [projects_types_id] column value.
	 * 
	 * @return     int
	 */
	public function getProjectsTypesId()
	{
		return $this->projects_types_id;
	}

	/**
	 * Get the [created_by] column value.
	 * 
	 * @return     int
	 */
	public function getCreatedBy()
	{
		return $this->created_by;
	}

	/**
	 * Get the [name] column value.
	 * 
	 * @return     string
	 */
	public function getName()
	{
		return $this->name;
	}

	/**
	 * Get the [description] column value.
	 * 
	 * @return     string
	 */
	public function getDescription()
	{
		return $this->description;
	}

	/**
	 * Get the [team] column value.
	 * 
	 * @return     string
	 */
	public function getTeam()
	{
		return $this->team;
	}

	/**
	 * Get the [optionally formatted] temporal [created_at] column value.
	 * 
	 *
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the raw DateTime object will be returned.
	 * @return     mixed Formatted date/time value as string or DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00 00:00:00
	 * @throws     PropelException - if unable to parse/validate the date/time value.
	 */
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->created_at === null) {
			return null;
		}


		if ($this->created_at === '0000-00-00 00:00:00') {
			// while technically this is not a default value of NULL,
			// this seems to be closest in meaning.
			return null;
		} else {
			try {
				$dt = new DateTime($this->created_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->created_at, true), $x);
			}
		}

		if ($format === null) {
			// Because propel.useDateTimeClass is TRUE, we return a DateTime object.
			return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	/**
	 * Get the [order_tasks_by] column value.
	 * 
	 * @return     string
	 */
	public function getOrderTasksBy()
	{
		return $this->order_tasks_by;
	}

	/**
	 * Set the value of [id] column.
	 * 
	 * @param      int $v new value
	 * @return     Projects The current object (for fluent API support)
	 */
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ProjectsPeer::ID;
		}

		return $this;
	} // setId()

	/**
	 * Set the value of [projects_status_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Projects The current object (for fluent API support)
	 */
	public function setProjectsStatusId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->projects_status_id !== $v) {
			$this->projects_status_id = $v;
			$this->modifiedColumns[] = ProjectsPeer::PROJECTS_STATUS_ID;
		}

		if ($this->aProjectsStatus !== null && $this->aProjectsStatus->getId() !== $v) {
			$this->aProjectsStatus = null;
		}

		return $this;
	} // setProjectsStatusId()

	/**
	 * Set the value of [projects_types_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Projects The current object (for fluent API support)
	 */
	public function setProjectsTypesId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->projects_types_id !== $v) {
			$this->projects_types_id = $v;
			$this->modifiedColumns[] = ProjectsPeer::PROJECTS_TYPES_ID;
		}

		if ($this->aProjectsTypes !== null && $this->aProjectsTypes->getId() !== $v) {
			$this->aProjectsTypes = null;
		}

		return $this;
	} // setProjectsTypesId()

	/**
	 * Set the value of [created_by] column.
	 * 
	 * @param      int $v new value
	 * @return     Projects The current object (for fluent API support)
	 */
	public function setCreatedBy($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->created_by !== $v) {
			$this->created_by = $v;
			$this->modifiedColumns[] = ProjectsPeer::CREATED_BY;
		}

		if ($this->aUsers !== null && $this->aUsers->getId() !== $v) {
			$this->aUsers = null;
		}

		return $this;
	} // setCreatedBy()

	/**
	 * Set the value of [name] column.
	 * 
	 * @param      string $v new value
	 * @return     Projects The current object (for fluent API support)
	 */
	public function setName($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->name !== $v || $v === '') {
			$this->name = $v;
			$this->modifiedColumns[] = ProjectsPeer::NAME;
		}

		return $this;
	} // setName()

	/**
	 * Set the value of [description] column.
	 * 
	 * @param      string $v new value
	 * @return     Projects The current object (for fluent API support)
	 */
	public function setDescription($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = ProjectsPeer::DESCRIPTION;
		}

		return $this;
	} // setDescription()

	/**
	 * Set the value of [team] column.
	 * 
	 * @param      string $v new value
	 * @return     Projects The current object (for fluent API support)
	 */
	public function setTeam($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->team !== $v) {
			$this->team = $v;
			$this->modifiedColumns[] = ProjectsPeer::TEAM;
		}

		return $this;
	} // setTeam()

	/**
	 * Sets the value of [created_at] column to a normalized version of the date/time value specified.
	 * 
	 * @param      mixed $v string, integer (timestamp), or DateTime value.  Empty string will
	 *						be treated as NULL for temporal objects.
	 * @return     Projects The current object (for fluent API support)
	 */
	public function setCreatedAt($v)
	{
		// we treat '' as NULL for temporal objects because DateTime('') == DateTime('now')
		// -- which is unexpected, to say the least.
		if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
			// some string/numeric value passed; we normalize that so that we can
			// validate it.
			try {
				if (is_numeric($v)) { // if it's a unix timestamp
					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
					// We have to explicitly specify and then change the time zone because of a
					// DateTime bug: http://bugs.php.net/bug.php?id=43003
					$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->created_at !== null || $dt !== null ) {
			// (nested ifs are a little easier to read in this case)

			$currNorm = ($this->created_at !== null && $tmpDt = new DateTime($this->created_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) // normalized values don't match 
					)
			{
				$this->created_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = ProjectsPeer::CREATED_AT;
			}
		} // if either are not null

		return $this;
	} // setCreatedAt()

	/**
	 * Set the value of [order_tasks_by] column.
	 * 
	 * @param      string $v new value
	 * @return     Projects The current object (for fluent API support)
	 */
	public function setOrderTasksBy($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->order_tasks_by !== $v) {
			$this->order_tasks_by = $v;
			$this->modifiedColumns[] = ProjectsPeer::ORDER_TASKS_BY;
		}

		return $this;
	} // setOrderTasksBy()

	/**
	 * Indicates whether the columns in this object are only set to default values.
	 *
	 * This method can be used in conjunction with isModified() to indicate whether an object is both
	 * modified _and_ has some values set which are non-default.
	 *
	 * @return     boolean Whether the columns in this object are only been set with default values.
	 */
	public function hasOnlyDefaultValues()
	{
			// First, ensure that we don't have any columns that have been modified which aren't default columns.
			if (array_diff($this->modifiedColumns, array(ProjectsPeer::NAME))) {
				return false;
			}

			if ($this->name !== '') {
				return false;
			}

		// otherwise, everything was equal, so return TRUE
		return true;
	} // hasOnlyDefaultValues()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (0-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param      array $row The row returned by PDOStatement->fetch(PDO::FETCH_NUM)
	 * @param      int $startcol 0-based offset column which indicates which restultset column to start with.
	 * @param      boolean $rehydrate Whether this object is being re-hydrated from the database.
	 * @return     int next starting column
	 * @throws     PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->projects_status_id = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
			$this->projects_types_id = ($row[$startcol + 2] !== null) ? (int) $row[$startcol + 2] : null;
			$this->created_by = ($row[$startcol + 3] !== null) ? (int) $row[$startcol + 3] : null;
			$this->name = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
			$this->description = ($row[$startcol + 5] !== null) ? (string) $row[$startcol + 5] : null;
			$this->team = ($row[$startcol + 6] !== null) ? (string) $row[$startcol + 6] : null;
			$this->created_at = ($row[$startcol + 7] !== null) ? (string) $row[$startcol + 7] : null;
			$this->order_tasks_by = ($row[$startcol + 8] !== null) ? (string) $row[$startcol + 8] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 9; // 9 = ProjectsPeer::NUM_COLUMNS - ProjectsPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating Projects object", $e);
		}
	}

	/**
	 * Checks and repairs the internal consistency of the object.
	 *
	 * This method is executed after an already-instantiated object is re-hydrated
	 * from the database.  It exists to check any foreign keys to make sure that
	 * the objects related to the current object are correct based on foreign key.
	 *
	 * You can override this method in the stub class, but you should always invoke
	 * the base method from the overridden method (i.e. parent::ensureConsistency()),
	 * in case your model changes.
	 *
	 * @throws     PropelException
	 */
	public function ensureConsistency()
	{

		if ($this->aProjectsStatus !== null && $this->projects_status_id !== $this->aProjectsStatus->getId()) {
			$this->aProjectsStatus = null;
		}
		if ($this->aProjectsTypes !== null && $this->projects_types_id !== $this->aProjectsTypes->getId()) {
			$this->aProjectsTypes = null;
		}
		if ($this->aUsers !== null && $this->created_by !== $this->aUsers->getId()) {
			$this->aUsers = null;
		}
	} // ensureConsistency

	/**
	 * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
	 *
	 * This will only work if the object has been saved and has a valid primary key set.
	 *
	 * @param      boolean $deep (optional) Whether to also de-associated any related objects.
	 * @param      PropelPDO $con (optional) The PropelPDO connection to use.
	 * @return     void
	 * @throws     PropelException - if this object is deleted, unsaved or doesn't have pk match in db
	 */
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ProjectsPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

		// We don't need to alter the object instance pool; we're just modifying this instance
		// already in the pool.

		$stmt = ProjectsPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); // rehydrate

		if ($deep) {  // also de-associate any related objects?

			$this->aProjectsStatus = null;
			$this->aProjectsTypes = null;
			$this->aUsers = null;
			$this->collDiscussionss = null;
			$this->lastDiscussionsCriteria = null;

			$this->collProjectsCommentss = null;
			$this->lastProjectsCommentsCriteria = null;

			$this->collProjectsPhasess = null;
			$this->lastProjectsPhasesCriteria = null;

			$this->collTaskss = null;
			$this->lastTasksCriteria = null;

			$this->collTasksGroupss = null;
			$this->lastTasksGroupsCriteria = null;

			$this->collTicketss = null;
			$this->lastTicketsCriteria = null;

			$this->collVersionss = null;
			$this->lastVersionsCriteria = null;

		} // if (deep)
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param      PropelPDO $con
	 * @return     void
	 * @throws     PropelException
	 * @see        BaseObject::setDeleted()
	 * @see        BaseObject::isDeleted()
	 */
	public function delete(PropelPDO $con = null)
	{

    foreach (sfMixer::getCallables('BaseProjects:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ProjectsPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			ProjectsPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseProjects:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	/**
	 * Persists this object to the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All modified related objects will also be persisted in the doSave()
	 * method.  This method wraps all precipitate database operations in a
	 * single transaction.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        doSave()
	 */
	public function save(PropelPDO $con = null)
	{

    foreach (sfMixer::getCallables('BaseProjects:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


    if ($this->isNew() && !$this->isColumnModified(ProjectsPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ProjectsPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseProjects:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			ProjectsPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	/**
	 * Performs the work of inserting or updating the row in the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        save()
	 */
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aProjectsStatus !== null) {
				if ($this->aProjectsStatus->isModified() || $this->aProjectsStatus->isNew()) {
					$affectedRows += $this->aProjectsStatus->save($con);
				}
				$this->setProjectsStatus($this->aProjectsStatus);
			}

			if ($this->aProjectsTypes !== null) {
				if ($this->aProjectsTypes->isModified() || $this->aProjectsTypes->isNew()) {
					$affectedRows += $this->aProjectsTypes->save($con);
				}
				$this->setProjectsTypes($this->aProjectsTypes);
			}

			if ($this->aUsers !== null) {
				if ($this->aUsers->isModified() || $this->aUsers->isNew()) {
					$affectedRows += $this->aUsers->save($con);
				}
				$this->setUsers($this->aUsers);
			}

			if ($this->isNew() ) {
				$this->modifiedColumns[] = ProjectsPeer::ID;
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ProjectsPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which
										 // should always be true here (even though technically
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setId($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += ProjectsPeer::doUpdate($this, $con);
				}

				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			if ($this->collDiscussionss !== null) {
				foreach ($this->collDiscussionss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collProjectsCommentss !== null) {
				foreach ($this->collProjectsCommentss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collProjectsPhasess !== null) {
				foreach ($this->collProjectsPhasess as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collTaskss !== null) {
				foreach ($this->collTaskss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collTasksGroupss !== null) {
				foreach ($this->collTasksGroupss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collTicketss !== null) {
				foreach ($this->collTicketss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collVersionss !== null) {
				foreach ($this->collVersionss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var        array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return     array ValidationFailed[]
	 * @see        validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param      mixed $columns Column name or an array of column names.
	 * @return     boolean Whether all columns pass validation.
	 * @see        doValidate()
	 * @see        getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param      array $columns Array of column names to validate.
	 * @return     mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aProjectsStatus !== null) {
				if (!$this->aProjectsStatus->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aProjectsStatus->getValidationFailures());
				}
			}

			if ($this->aProjectsTypes !== null) {
				if (!$this->aProjectsTypes->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aProjectsTypes->getValidationFailures());
				}
			}

			if ($this->aUsers !== null) {
				if (!$this->aUsers->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUsers->getValidationFailures());
				}
			}


			if (($retval = ProjectsPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collDiscussionss !== null) {
					foreach ($this->collDiscussionss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collProjectsCommentss !== null) {
					foreach ($this->collProjectsCommentss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collProjectsPhasess !== null) {
					foreach ($this->collProjectsPhasess as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collTaskss !== null) {
					foreach ($this->collTaskss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collTasksGroupss !== null) {
					foreach ($this->collTasksGroupss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collTicketss !== null) {
					foreach ($this->collTicketss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collVersionss !== null) {
					foreach ($this->collVersionss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param      string $name name
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ProjectsPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @return     mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getProjectsStatusId();
				break;
			case 2:
				return $this->getProjectsTypesId();
				break;
			case 3:
				return $this->getCreatedBy();
				break;
			case 4:
				return $this->getName();
				break;
			case 5:
				return $this->getDescription();
				break;
			case 6:
				return $this->getTeam();
				break;
			case 7:
				return $this->getCreatedAt();
				break;
			case 8:
				return $this->getOrderTasksBy();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param      string $keyType (optional) One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                        BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM. Defaults to BasePeer::TYPE_PHPNAME.
	 * @param      boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns.  Defaults to TRUE.
	 * @return     an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = ProjectsPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getProjectsStatusId(),
			$keys[2] => $this->getProjectsTypesId(),
			$keys[3] => $this->getCreatedBy(),
			$keys[4] => $this->getName(),
			$keys[5] => $this->getDescription(),
			$keys[6] => $this->getTeam(),
			$keys[7] => $this->getCreatedAt(),
			$keys[8] => $this->getOrderTasksBy(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param      string $name peer name
	 * @param      mixed $value field value
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ProjectsPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @param      mixed $value field value
	 * @return     void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setProjectsStatusId($value);
				break;
			case 2:
				$this->setProjectsTypesId($value);
				break;
			case 3:
				$this->setCreatedBy($value);
				break;
			case 4:
				$this->setName($value);
				break;
			case 5:
				$this->setDescription($value);
				break;
			case 6:
				$this->setTeam($value);
				break;
			case 7:
				$this->setCreatedAt($value);
				break;
			case 8:
				$this->setOrderTasksBy($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
	 * BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
	 * The default key type is the column's phpname (e.g. 'AuthorId')
	 *
	 * @param      array  $arr     An array to populate the object from.
	 * @param      string $keyType The type of keys the array uses.
	 * @return     void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ProjectsPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setProjectsStatusId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setProjectsTypesId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setCreatedBy($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setName($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setDescription($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setTeam($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setCreatedAt($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setOrderTasksBy($arr[$keys[8]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return     Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);

		if ($this->isColumnModified(ProjectsPeer::ID)) $criteria->add(ProjectsPeer::ID, $this->id);
		if ($this->isColumnModified(ProjectsPeer::PROJECTS_STATUS_ID)) $criteria->add(ProjectsPeer::PROJECTS_STATUS_ID, $this->projects_status_id);
		if ($this->isColumnModified(ProjectsPeer::PROJECTS_TYPES_ID)) $criteria->add(ProjectsPeer::PROJECTS_TYPES_ID, $this->projects_types_id);
		if ($this->isColumnModified(ProjectsPeer::CREATED_BY)) $criteria->add(ProjectsPeer::CREATED_BY, $this->created_by);
		if ($this->isColumnModified(ProjectsPeer::NAME)) $criteria->add(ProjectsPeer::NAME, $this->name);
		if ($this->isColumnModified(ProjectsPeer::DESCRIPTION)) $criteria->add(ProjectsPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(ProjectsPeer::TEAM)) $criteria->add(ProjectsPeer::TEAM, $this->team);
		if ($this->isColumnModified(ProjectsPeer::CREATED_AT)) $criteria->add(ProjectsPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(ProjectsPeer::ORDER_TASKS_BY)) $criteria->add(ProjectsPeer::ORDER_TASKS_BY, $this->order_tasks_by);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return     Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);

		$criteria->add(ProjectsPeer::ID, $this->id);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return     int
	 */
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	/**
	 * Generic method to set the primary key (id column).
	 *
	 * @param      int $key Primary key.
	 * @return     void
	 */
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      object $copyObj An object of Projects (or compatible) type.
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws     PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setProjectsStatusId($this->projects_status_id);

		$copyObj->setProjectsTypesId($this->projects_types_id);

		$copyObj->setCreatedBy($this->created_by);

		$copyObj->setName($this->name);

		$copyObj->setDescription($this->description);

		$copyObj->setTeam($this->team);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setOrderTasksBy($this->order_tasks_by);


		if ($deepCopy) {
			// important: temporarily setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach ($this->getDiscussionss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addDiscussions($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getProjectsCommentss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addProjectsComments($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getProjectsPhasess() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addProjectsPhases($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getTaskss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addTasks($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getTasksGroupss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addTasksGroups($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getTicketss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addTickets($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getVersionss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addVersions($relObj->copy($deepCopy));
				}
			}

		} // if ($deepCopy)


		$copyObj->setNew(true);

		$copyObj->setId(NULL); // this is a auto-increment column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return     Projects Clone of current object.
	 * @throws     PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return     ProjectsPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ProjectsPeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a ProjectsStatus object.
	 *
	 * @param      ProjectsStatus $v
	 * @return     Projects The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setProjectsStatus(ProjectsStatus $v = null)
	{
		if ($v === null) {
			$this->setProjectsStatusId(NULL);
		} else {
			$this->setProjectsStatusId($v->getId());
		}

		$this->aProjectsStatus = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the ProjectsStatus object, it will not be re-added.
		if ($v !== null) {
			$v->addProjects($this);
		}

		return $this;
	}


	/**
	 * Get the associated ProjectsStatus object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     ProjectsStatus The associated ProjectsStatus object.
	 * @throws     PropelException
	 */
	public function getProjectsStatus(PropelPDO $con = null)
	{
		if ($this->aProjectsStatus === null && ($this->projects_status_id !== null)) {
			$c = new Criteria(ProjectsStatusPeer::DATABASE_NAME);
			$c->add(ProjectsStatusPeer::ID, $this->projects_status_id);
			$this->aProjectsStatus = ProjectsStatusPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aProjectsStatus->addProjectss($this);
			 */
		}
		return $this->aProjectsStatus;
	}

	/**
	 * Declares an association between this object and a ProjectsTypes object.
	 *
	 * @param      ProjectsTypes $v
	 * @return     Projects The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setProjectsTypes(ProjectsTypes $v = null)
	{
		if ($v === null) {
			$this->setProjectsTypesId(NULL);
		} else {
			$this->setProjectsTypesId($v->getId());
		}

		$this->aProjectsTypes = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the ProjectsTypes object, it will not be re-added.
		if ($v !== null) {
			$v->addProjects($this);
		}

		return $this;
	}


	/**
	 * Get the associated ProjectsTypes object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     ProjectsTypes The associated ProjectsTypes object.
	 * @throws     PropelException
	 */
	public function getProjectsTypes(PropelPDO $con = null)
	{
		if ($this->aProjectsTypes === null && ($this->projects_types_id !== null)) {
			$c = new Criteria(ProjectsTypesPeer::DATABASE_NAME);
			$c->add(ProjectsTypesPeer::ID, $this->projects_types_id);
			$this->aProjectsTypes = ProjectsTypesPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aProjectsTypes->addProjectss($this);
			 */
		}
		return $this->aProjectsTypes;
	}

	/**
	 * Declares an association between this object and a Users object.
	 *
	 * @param      Users $v
	 * @return     Projects The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setUsers(Users $v = null)
	{
		if ($v === null) {
			$this->setCreatedBy(NULL);
		} else {
			$this->setCreatedBy($v->getId());
		}

		$this->aUsers = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the Users object, it will not be re-added.
		if ($v !== null) {
			$v->addProjects($this);
		}

		return $this;
	}


	/**
	 * Get the associated Users object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     Users The associated Users object.
	 * @throws     PropelException
	 */
	public function getUsers(PropelPDO $con = null)
	{
		if ($this->aUsers === null && ($this->created_by !== null)) {
			$c = new Criteria(UsersPeer::DATABASE_NAME);
			$c->add(UsersPeer::ID, $this->created_by);
			$this->aUsers = UsersPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aUsers->addProjectss($this);
			 */
		}
		return $this->aUsers;
	}

	/**
	 * Clears out the collDiscussionss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addDiscussionss()
	 */
	public function clearDiscussionss()
	{
		$this->collDiscussionss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collDiscussionss collection (array).
	 *
	 * By default this just sets the collDiscussionss collection to an empty array (like clearcollDiscussionss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initDiscussionss()
	{
		$this->collDiscussionss = array();
	}

	/**
	 * Gets an array of Discussions objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Projects has previously been saved, it will retrieve
	 * related Discussionss from storage. If this Projects is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Discussions[]
	 * @throws     PropelException
	 */
	public function getDiscussionss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collDiscussionss === null) {
			if ($this->isNew()) {
			   $this->collDiscussionss = array();
			} else {

				$criteria->add(DiscussionsPeer::PROJECTS_ID, $this->id);

				DiscussionsPeer::addSelectColumns($criteria);
				$this->collDiscussionss = DiscussionsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(DiscussionsPeer::PROJECTS_ID, $this->id);

				DiscussionsPeer::addSelectColumns($criteria);
				if (!isset($this->lastDiscussionsCriteria) || !$this->lastDiscussionsCriteria->equals($criteria)) {
					$this->collDiscussionss = DiscussionsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastDiscussionsCriteria = $criteria;
		return $this->collDiscussionss;
	}

	/**
	 * Returns the number of related Discussions objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Discussions objects.
	 * @throws     PropelException
	 */
	public function countDiscussionss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collDiscussionss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(DiscussionsPeer::PROJECTS_ID, $this->id);

				$count = DiscussionsPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(DiscussionsPeer::PROJECTS_ID, $this->id);

				if (!isset($this->lastDiscussionsCriteria) || !$this->lastDiscussionsCriteria->equals($criteria)) {
					$count = DiscussionsPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collDiscussionss);
				}
			} else {
				$count = count($this->collDiscussionss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a Discussions object to this object
	 * through the Discussions foreign key attribute.
	 *
	 * @param      Discussions $l Discussions
	 * @return     void
	 * @throws     PropelException
	 */
	public function addDiscussions(Discussions $l)
	{
		if ($this->collDiscussionss === null) {
			$this->initDiscussionss();
		}
		if (!in_array($l, $this->collDiscussionss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collDiscussionss, $l);
			$l->setProjects($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Projects is new, it will return
	 * an empty collection; or if this Projects has previously
	 * been saved, it will retrieve related Discussionss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Projects.
	 */
	public function getDiscussionssJoinUsers($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collDiscussionss === null) {
			if ($this->isNew()) {
				$this->collDiscussionss = array();
			} else {

				$criteria->add(DiscussionsPeer::PROJECTS_ID, $this->id);

				$this->collDiscussionss = DiscussionsPeer::doSelectJoinUsers($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(DiscussionsPeer::PROJECTS_ID, $this->id);

			if (!isset($this->lastDiscussionsCriteria) || !$this->lastDiscussionsCriteria->equals($criteria)) {
				$this->collDiscussionss = DiscussionsPeer::doSelectJoinUsers($criteria, $con, $join_behavior);
			}
		}
		$this->lastDiscussionsCriteria = $criteria;

		return $this->collDiscussionss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Projects is new, it will return
	 * an empty collection; or if this Projects has previously
	 * been saved, it will retrieve related Discussionss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Projects.
	 */
	public function getDiscussionssJoinDiscussionsStatus($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collDiscussionss === null) {
			if ($this->isNew()) {
				$this->collDiscussionss = array();
			} else {

				$criteria->add(DiscussionsPeer::PROJECTS_ID, $this->id);

				$this->collDiscussionss = DiscussionsPeer::doSelectJoinDiscussionsStatus($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(DiscussionsPeer::PROJECTS_ID, $this->id);

			if (!isset($this->lastDiscussionsCriteria) || !$this->lastDiscussionsCriteria->equals($criteria)) {
				$this->collDiscussionss = DiscussionsPeer::doSelectJoinDiscussionsStatus($criteria, $con, $join_behavior);
			}
		}
		$this->lastDiscussionsCriteria = $criteria;

		return $this->collDiscussionss;
	}

	/**
	 * Clears out the collProjectsCommentss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addProjectsCommentss()
	 */
	public function clearProjectsCommentss()
	{
		$this->collProjectsCommentss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collProjectsCommentss collection (array).
	 *
	 * By default this just sets the collProjectsCommentss collection to an empty array (like clearcollProjectsCommentss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initProjectsCommentss()
	{
		$this->collProjectsCommentss = array();
	}

	/**
	 * Gets an array of ProjectsComments objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Projects has previously been saved, it will retrieve
	 * related ProjectsCommentss from storage. If this Projects is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array ProjectsComments[]
	 * @throws     PropelException
	 */
	public function getProjectsCommentss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collProjectsCommentss === null) {
			if ($this->isNew()) {
			   $this->collProjectsCommentss = array();
			} else {

				$criteria->add(ProjectsCommentsPeer::PROJECTS_ID, $this->id);

				ProjectsCommentsPeer::addSelectColumns($criteria);
				$this->collProjectsCommentss = ProjectsCommentsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(ProjectsCommentsPeer::PROJECTS_ID, $this->id);

				ProjectsCommentsPeer::addSelectColumns($criteria);
				if (!isset($this->lastProjectsCommentsCriteria) || !$this->lastProjectsCommentsCriteria->equals($criteria)) {
					$this->collProjectsCommentss = ProjectsCommentsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastProjectsCommentsCriteria = $criteria;
		return $this->collProjectsCommentss;
	}

	/**
	 * Returns the number of related ProjectsComments objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related ProjectsComments objects.
	 * @throws     PropelException
	 */
	public function countProjectsCommentss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collProjectsCommentss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(ProjectsCommentsPeer::PROJECTS_ID, $this->id);

				$count = ProjectsCommentsPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(ProjectsCommentsPeer::PROJECTS_ID, $this->id);

				if (!isset($this->lastProjectsCommentsCriteria) || !$this->lastProjectsCommentsCriteria->equals($criteria)) {
					$count = ProjectsCommentsPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collProjectsCommentss);
				}
			} else {
				$count = count($this->collProjectsCommentss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a ProjectsComments object to this object
	 * through the ProjectsComments foreign key attribute.
	 *
	 * @param      ProjectsComments $l ProjectsComments
	 * @return     void
	 * @throws     PropelException
	 */
	public function addProjectsComments(ProjectsComments $l)
	{
		if ($this->collProjectsCommentss === null) {
			$this->initProjectsCommentss();
		}
		if (!in_array($l, $this->collProjectsCommentss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collProjectsCommentss, $l);
			$l->setProjects($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Projects is new, it will return
	 * an empty collection; or if this Projects has previously
	 * been saved, it will retrieve related ProjectsCommentss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Projects.
	 */
	public function getProjectsCommentssJoinUsers($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collProjectsCommentss === null) {
			if ($this->isNew()) {
				$this->collProjectsCommentss = array();
			} else {

				$criteria->add(ProjectsCommentsPeer::PROJECTS_ID, $this->id);

				$this->collProjectsCommentss = ProjectsCommentsPeer::doSelectJoinUsers($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(ProjectsCommentsPeer::PROJECTS_ID, $this->id);

			if (!isset($this->lastProjectsCommentsCriteria) || !$this->lastProjectsCommentsCriteria->equals($criteria)) {
				$this->collProjectsCommentss = ProjectsCommentsPeer::doSelectJoinUsers($criteria, $con, $join_behavior);
			}
		}
		$this->lastProjectsCommentsCriteria = $criteria;

		return $this->collProjectsCommentss;
	}

	/**
	 * Clears out the collProjectsPhasess collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addProjectsPhasess()
	 */
	public function clearProjectsPhasess()
	{
		$this->collProjectsPhasess = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collProjectsPhasess collection (array).
	 *
	 * By default this just sets the collProjectsPhasess collection to an empty array (like clearcollProjectsPhasess());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initProjectsPhasess()
	{
		$this->collProjectsPhasess = array();
	}

	/**
	 * Gets an array of ProjectsPhases objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Projects has previously been saved, it will retrieve
	 * related ProjectsPhasess from storage. If this Projects is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array ProjectsPhases[]
	 * @throws     PropelException
	 */
	public function getProjectsPhasess($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collProjectsPhasess === null) {
			if ($this->isNew()) {
			   $this->collProjectsPhasess = array();
			} else {

				$criteria->add(ProjectsPhasesPeer::PROJECTS_ID, $this->id);

				ProjectsPhasesPeer::addSelectColumns($criteria);
				$this->collProjectsPhasess = ProjectsPhasesPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(ProjectsPhasesPeer::PROJECTS_ID, $this->id);

				ProjectsPhasesPeer::addSelectColumns($criteria);
				if (!isset($this->lastProjectsPhasesCriteria) || !$this->lastProjectsPhasesCriteria->equals($criteria)) {
					$this->collProjectsPhasess = ProjectsPhasesPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastProjectsPhasesCriteria = $criteria;
		return $this->collProjectsPhasess;
	}

	/**
	 * Returns the number of related ProjectsPhases objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related ProjectsPhases objects.
	 * @throws     PropelException
	 */
	public function countProjectsPhasess(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collProjectsPhasess === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(ProjectsPhasesPeer::PROJECTS_ID, $this->id);

				$count = ProjectsPhasesPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(ProjectsPhasesPeer::PROJECTS_ID, $this->id);

				if (!isset($this->lastProjectsPhasesCriteria) || !$this->lastProjectsPhasesCriteria->equals($criteria)) {
					$count = ProjectsPhasesPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collProjectsPhasess);
				}
			} else {
				$count = count($this->collProjectsPhasess);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a ProjectsPhases object to this object
	 * through the ProjectsPhases foreign key attribute.
	 *
	 * @param      ProjectsPhases $l ProjectsPhases
	 * @return     void
	 * @throws     PropelException
	 */
	public function addProjectsPhases(ProjectsPhases $l)
	{
		if ($this->collProjectsPhasess === null) {
			$this->initProjectsPhasess();
		}
		if (!in_array($l, $this->collProjectsPhasess, true)) { // only add it if the **same** object is not already associated
			array_push($this->collProjectsPhasess, $l);
			$l->setProjects($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Projects is new, it will return
	 * an empty collection; or if this Projects has previously
	 * been saved, it will retrieve related ProjectsPhasess from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Projects.
	 */
	public function getProjectsPhasessJoinPhasesStatus($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collProjectsPhasess === null) {
			if ($this->isNew()) {
				$this->collProjectsPhasess = array();
			} else {

				$criteria->add(ProjectsPhasesPeer::PROJECTS_ID, $this->id);

				$this->collProjectsPhasess = ProjectsPhasesPeer::doSelectJoinPhasesStatus($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(ProjectsPhasesPeer::PROJECTS_ID, $this->id);

			if (!isset($this->lastProjectsPhasesCriteria) || !$this->lastProjectsPhasesCriteria->equals($criteria)) {
				$this->collProjectsPhasess = ProjectsPhasesPeer::doSelectJoinPhasesStatus($criteria, $con, $join_behavior);
			}
		}
		$this->lastProjectsPhasesCriteria = $criteria;

		return $this->collProjectsPhasess;
	}

	/**
	 * Clears out the collTaskss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addTaskss()
	 */
	public function clearTaskss()
	{
		$this->collTaskss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collTaskss collection (array).
	 *
	 * By default this just sets the collTaskss collection to an empty array (like clearcollTaskss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initTaskss()
	{
		$this->collTaskss = array();
	}

	/**
	 * Gets an array of Tasks objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Projects has previously been saved, it will retrieve
	 * related Taskss from storage. If this Projects is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Tasks[]
	 * @throws     PropelException
	 */
	public function getTaskss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
			   $this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::PROJECTS_ID, $this->id);

				TasksPeer::addSelectColumns($criteria);
				$this->collTaskss = TasksPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(TasksPeer::PROJECTS_ID, $this->id);

				TasksPeer::addSelectColumns($criteria);
				if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
					$this->collTaskss = TasksPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTasksCriteria = $criteria;
		return $this->collTaskss;
	}

	/**
	 * Returns the number of related Tasks objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Tasks objects.
	 * @throws     PropelException
	 */
	public function countTaskss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(TasksPeer::PROJECTS_ID, $this->id);

				$count = TasksPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(TasksPeer::PROJECTS_ID, $this->id);

				if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
					$count = TasksPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collTaskss);
				}
			} else {
				$count = count($this->collTaskss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a Tasks object to this object
	 * through the Tasks foreign key attribute.
	 *
	 * @param      Tasks $l Tasks
	 * @return     void
	 * @throws     PropelException
	 */
	public function addTasks(Tasks $l)
	{
		if ($this->collTaskss === null) {
			$this->initTaskss();
		}
		if (!in_array($l, $this->collTaskss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collTaskss, $l);
			$l->setProjects($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Projects is new, it will return
	 * an empty collection; or if this Projects has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Projects.
	 */
	public function getTaskssJoinTasksStatus($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::PROJECTS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinTasksStatus($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::PROJECTS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinTasksStatus($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Projects is new, it will return
	 * an empty collection; or if this Projects has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Projects.
	 */
	public function getTaskssJoinTasksPriority($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::PROJECTS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinTasksPriority($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::PROJECTS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinTasksPriority($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Projects is new, it will return
	 * an empty collection; or if this Projects has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Projects.
	 */
	public function getTaskssJoinTasksTypes($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::PROJECTS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinTasksTypes($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::PROJECTS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinTasksTypes($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Projects is new, it will return
	 * an empty collection; or if this Projects has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Projects.
	 */
	public function getTaskssJoinTasksLabels($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::PROJECTS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinTasksLabels($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::PROJECTS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinTasksLabels($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Projects is new, it will return
	 * an empty collection; or if this Projects has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Projects.
	 */
	public function getTaskssJoinTasksGroups($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::PROJECTS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinTasksGroups($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::PROJECTS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinTasksGroups($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Projects is new, it will return
	 * an empty collection; or if this Projects has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Projects.
	 */
	public function getTaskssJoinProjectsPhases($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::PROJECTS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinProjectsPhases($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::PROJECTS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinProjectsPhases($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Projects is new, it will return
	 * an empty collection; or if this Projects has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Projects.
	 */
	public function getTaskssJoinVersions($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::PROJECTS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinVersions($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::PROJECTS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinVersions($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Projects is new, it will return
	 * an empty collection; or if this Projects has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Projects.
	 */
	public function getTaskssJoinUsers($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::PROJECTS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinUsers($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::PROJECTS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinUsers($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Projects is new, it will return
	 * an empty collection; or if this Projects has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Projects.
	 */
	public function getTaskssJoinTickets($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::PROJECTS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinTickets($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::PROJECTS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinTickets($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}

	/**
	 * Clears out the collTasksGroupss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addTasksGroupss()
	 */
	public function clearTasksGroupss()
	{
		$this->collTasksGroupss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collTasksGroupss collection (array).
	 *
	 * By default this just sets the collTasksGroupss collection to an empty array (like clearcollTasksGroupss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initTasksGroupss()
	{
		$this->collTasksGroupss = array();
	}

	/**
	 * Gets an array of TasksGroups objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Projects has previously been saved, it will retrieve
	 * related TasksGroupss from storage. If this Projects is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array TasksGroups[]
	 * @throws     PropelException
	 */
	public function getTasksGroupss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTasksGroupss === null) {
			if ($this->isNew()) {
			   $this->collTasksGroupss = array();
			} else {

				$criteria->add(TasksGroupsPeer::PROJECTS_ID, $this->id);

				TasksGroupsPeer::addSelectColumns($criteria);
				$this->collTasksGroupss = TasksGroupsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(TasksGroupsPeer::PROJECTS_ID, $this->id);

				TasksGroupsPeer::addSelectColumns($criteria);
				if (!isset($this->lastTasksGroupsCriteria) || !$this->lastTasksGroupsCriteria->equals($criteria)) {
					$this->collTasksGroupss = TasksGroupsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTasksGroupsCriteria = $criteria;
		return $this->collTasksGroupss;
	}

	/**
	 * Returns the number of related TasksGroups objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related TasksGroups objects.
	 * @throws     PropelException
	 */
	public function countTasksGroupss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collTasksGroupss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(TasksGroupsPeer::PROJECTS_ID, $this->id);

				$count = TasksGroupsPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(TasksGroupsPeer::PROJECTS_ID, $this->id);

				if (!isset($this->lastTasksGroupsCriteria) || !$this->lastTasksGroupsCriteria->equals($criteria)) {
					$count = TasksGroupsPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collTasksGroupss);
				}
			} else {
				$count = count($this->collTasksGroupss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a TasksGroups object to this object
	 * through the TasksGroups foreign key attribute.
	 *
	 * @param      TasksGroups $l TasksGroups
	 * @return     void
	 * @throws     PropelException
	 */
	public function addTasksGroups(TasksGroups $l)
	{
		if ($this->collTasksGroupss === null) {
			$this->initTasksGroupss();
		}
		if (!in_array($l, $this->collTasksGroupss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collTasksGroupss, $l);
			$l->setProjects($this);
		}
	}

	/**
	 * Clears out the collTicketss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addTicketss()
	 */
	public function clearTicketss()
	{
		$this->collTicketss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collTicketss collection (array).
	 *
	 * By default this just sets the collTicketss collection to an empty array (like clearcollTicketss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initTicketss()
	{
		$this->collTicketss = array();
	}

	/**
	 * Gets an array of Tickets objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Projects has previously been saved, it will retrieve
	 * related Ticketss from storage. If this Projects is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Tickets[]
	 * @throws     PropelException
	 */
	public function getTicketss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTicketss === null) {
			if ($this->isNew()) {
			   $this->collTicketss = array();
			} else {

				$criteria->add(TicketsPeer::PROJECTS_ID, $this->id);

				TicketsPeer::addSelectColumns($criteria);
				$this->collTicketss = TicketsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(TicketsPeer::PROJECTS_ID, $this->id);

				TicketsPeer::addSelectColumns($criteria);
				if (!isset($this->lastTicketsCriteria) || !$this->lastTicketsCriteria->equals($criteria)) {
					$this->collTicketss = TicketsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTicketsCriteria = $criteria;
		return $this->collTicketss;
	}

	/**
	 * Returns the number of related Tickets objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Tickets objects.
	 * @throws     PropelException
	 */
	public function countTicketss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collTicketss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(TicketsPeer::PROJECTS_ID, $this->id);

				$count = TicketsPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(TicketsPeer::PROJECTS_ID, $this->id);

				if (!isset($this->lastTicketsCriteria) || !$this->lastTicketsCriteria->equals($criteria)) {
					$count = TicketsPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collTicketss);
				}
			} else {
				$count = count($this->collTicketss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a Tickets object to this object
	 * through the Tickets foreign key attribute.
	 *
	 * @param      Tickets $l Tickets
	 * @return     void
	 * @throws     PropelException
	 */
	public function addTickets(Tickets $l)
	{
		if ($this->collTicketss === null) {
			$this->initTicketss();
		}
		if (!in_array($l, $this->collTicketss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collTicketss, $l);
			$l->setProjects($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Projects is new, it will return
	 * an empty collection; or if this Projects has previously
	 * been saved, it will retrieve related Ticketss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Projects.
	 */
	public function getTicketssJoinDepartments($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTicketss === null) {
			if ($this->isNew()) {
				$this->collTicketss = array();
			} else {

				$criteria->add(TicketsPeer::PROJECTS_ID, $this->id);

				$this->collTicketss = TicketsPeer::doSelectJoinDepartments($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TicketsPeer::PROJECTS_ID, $this->id);

			if (!isset($this->lastTicketsCriteria) || !$this->lastTicketsCriteria->equals($criteria)) {
				$this->collTicketss = TicketsPeer::doSelectJoinDepartments($criteria, $con, $join_behavior);
			}
		}
		$this->lastTicketsCriteria = $criteria;

		return $this->collTicketss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Projects is new, it will return
	 * an empty collection; or if this Projects has previously
	 * been saved, it will retrieve related Ticketss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Projects.
	 */
	public function getTicketssJoinTicketsTypes($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTicketss === null) {
			if ($this->isNew()) {
				$this->collTicketss = array();
			} else {

				$criteria->add(TicketsPeer::PROJECTS_ID, $this->id);

				$this->collTicketss = TicketsPeer::doSelectJoinTicketsTypes($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TicketsPeer::PROJECTS_ID, $this->id);

			if (!isset($this->lastTicketsCriteria) || !$this->lastTicketsCriteria->equals($criteria)) {
				$this->collTicketss = TicketsPeer::doSelectJoinTicketsTypes($criteria, $con, $join_behavior);
			}
		}
		$this->lastTicketsCriteria = $criteria;

		return $this->collTicketss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Projects is new, it will return
	 * an empty collection; or if this Projects has previously
	 * been saved, it will retrieve related Ticketss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Projects.
	 */
	public function getTicketssJoinTicketsStatus($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTicketss === null) {
			if ($this->isNew()) {
				$this->collTicketss = array();
			} else {

				$criteria->add(TicketsPeer::PROJECTS_ID, $this->id);

				$this->collTicketss = TicketsPeer::doSelectJoinTicketsStatus($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TicketsPeer::PROJECTS_ID, $this->id);

			if (!isset($this->lastTicketsCriteria) || !$this->lastTicketsCriteria->equals($criteria)) {
				$this->collTicketss = TicketsPeer::doSelectJoinTicketsStatus($criteria, $con, $join_behavior);
			}
		}
		$this->lastTicketsCriteria = $criteria;

		return $this->collTicketss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Projects is new, it will return
	 * an empty collection; or if this Projects has previously
	 * been saved, it will retrieve related Ticketss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Projects.
	 */
	public function getTicketssJoinUsers($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTicketss === null) {
			if ($this->isNew()) {
				$this->collTicketss = array();
			} else {

				$criteria->add(TicketsPeer::PROJECTS_ID, $this->id);

				$this->collTicketss = TicketsPeer::doSelectJoinUsers($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TicketsPeer::PROJECTS_ID, $this->id);

			if (!isset($this->lastTicketsCriteria) || !$this->lastTicketsCriteria->equals($criteria)) {
				$this->collTicketss = TicketsPeer::doSelectJoinUsers($criteria, $con, $join_behavior);
			}
		}
		$this->lastTicketsCriteria = $criteria;

		return $this->collTicketss;
	}

	/**
	 * Clears out the collVersionss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addVersionss()
	 */
	public function clearVersionss()
	{
		$this->collVersionss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collVersionss collection (array).
	 *
	 * By default this just sets the collVersionss collection to an empty array (like clearcollVersionss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initVersionss()
	{
		$this->collVersionss = array();
	}

	/**
	 * Gets an array of Versions objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Projects has previously been saved, it will retrieve
	 * related Versionss from storage. If this Projects is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Versions[]
	 * @throws     PropelException
	 */
	public function getVersionss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collVersionss === null) {
			if ($this->isNew()) {
			   $this->collVersionss = array();
			} else {

				$criteria->add(VersionsPeer::PROJECTS_ID, $this->id);

				VersionsPeer::addSelectColumns($criteria);
				$this->collVersionss = VersionsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(VersionsPeer::PROJECTS_ID, $this->id);

				VersionsPeer::addSelectColumns($criteria);
				if (!isset($this->lastVersionsCriteria) || !$this->lastVersionsCriteria->equals($criteria)) {
					$this->collVersionss = VersionsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastVersionsCriteria = $criteria;
		return $this->collVersionss;
	}

	/**
	 * Returns the number of related Versions objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Versions objects.
	 * @throws     PropelException
	 */
	public function countVersionss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collVersionss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(VersionsPeer::PROJECTS_ID, $this->id);

				$count = VersionsPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(VersionsPeer::PROJECTS_ID, $this->id);

				if (!isset($this->lastVersionsCriteria) || !$this->lastVersionsCriteria->equals($criteria)) {
					$count = VersionsPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collVersionss);
				}
			} else {
				$count = count($this->collVersionss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a Versions object to this object
	 * through the Versions foreign key attribute.
	 *
	 * @param      Versions $l Versions
	 * @return     void
	 * @throws     PropelException
	 */
	public function addVersions(Versions $l)
	{
		if ($this->collVersionss === null) {
			$this->initVersionss();
		}
		if (!in_array($l, $this->collVersionss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collVersionss, $l);
			$l->setProjects($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Projects is new, it will return
	 * an empty collection; or if this Projects has previously
	 * been saved, it will retrieve related Versionss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Projects.
	 */
	public function getVersionssJoinVersionsStatus($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ProjectsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collVersionss === null) {
			if ($this->isNew()) {
				$this->collVersionss = array();
			} else {

				$criteria->add(VersionsPeer::PROJECTS_ID, $this->id);

				$this->collVersionss = VersionsPeer::doSelectJoinVersionsStatus($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(VersionsPeer::PROJECTS_ID, $this->id);

			if (!isset($this->lastVersionsCriteria) || !$this->lastVersionsCriteria->equals($criteria)) {
				$this->collVersionss = VersionsPeer::doSelectJoinVersionsStatus($criteria, $con, $join_behavior);
			}
		}
		$this->lastVersionsCriteria = $criteria;

		return $this->collVersionss;
	}

	/**
	 * Resets all collections of referencing foreign keys.
	 *
	 * This method is a user-space workaround for PHP's inability to garbage collect objects
	 * with circular references.  This is currently necessary when using Propel in certain
	 * daemon or large-volumne/high-memory operations.
	 *
	 * @param      boolean $deep Whether to also clear the references on all associated objects.
	 */
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collDiscussionss) {
				foreach ((array) $this->collDiscussionss as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collProjectsCommentss) {
				foreach ((array) $this->collProjectsCommentss as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collProjectsPhasess) {
				foreach ((array) $this->collProjectsPhasess as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collTaskss) {
				foreach ((array) $this->collTaskss as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collTasksGroupss) {
				foreach ((array) $this->collTasksGroupss as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collTicketss) {
				foreach ((array) $this->collTicketss as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collVersionss) {
				foreach ((array) $this->collVersionss as $o) {
					$o->clearAllReferences($deep);
				}
			}
		} // if ($deep)

		$this->collDiscussionss = null;
		$this->collProjectsCommentss = null;
		$this->collProjectsPhasess = null;
		$this->collTaskss = null;
		$this->collTasksGroupss = null;
		$this->collTicketss = null;
		$this->collVersionss = null;
			$this->aProjectsStatus = null;
			$this->aProjectsTypes = null;
			$this->aUsers = null;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseProjects:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseProjects::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} // BaseProjects
