<?php

/**
 * Base class that represents a row from the 'projects_reports' table.
 *
 * 
 *
 * This class was autogenerated by Propel 1.3.0-dev on:
 *
 * 10/01/11 13:54:40
 *
 * @package    lib.model.om
 */
abstract class BaseProjectsReports extends BaseObject  implements Persistent {


  const PEER = 'ProjectsReportsPeer';

	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var        ProjectsReportsPeer
	 */
	protected static $peer;

	/**
	 * The value for the id field.
	 * @var        int
	 */
	protected $id;

	/**
	 * The value for the users_id field.
	 * Note: this column has a database default value of: 0
	 * @var        int
	 */
	protected $users_id;

	/**
	 * The value for the name field.
	 * Note: this column has a database default value of: ''
	 * @var        string
	 */
	protected $name;

	/**
	 * The value for the display_on_home field.
	 * @var        int
	 */
	protected $display_on_home;

	/**
	 * The value for the projects_id field.
	 * @var        string
	 */
	protected $projects_id;

	/**
	 * The value for the projects_type_id field.
	 * @var        string
	 */
	protected $projects_type_id;

	/**
	 * The value for the projects_status_id field.
	 * @var        string
	 */
	protected $projects_status_id;

	/**
	 * The value for the in_team field.
	 * @var        int
	 */
	protected $in_team;

	/**
	 * The value for the sort_order field.
	 * @var        int
	 */
	protected $sort_order;

	/**
	 * The value for the display_in_menu field.
	 * @var        int
	 */
	protected $display_in_menu;

	/**
	 * The value for the visible_on_home field.
	 * @var        int
	 */
	protected $visible_on_home;

	/**
	 * @var        Users
	 */
	protected $aUsers;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInValidation = false;

	/**
	 * Initializes internal state of BaseProjectsReports object.
	 * @see        applyDefaults()
	 */
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	/**
	 * Applies default values to this object.
	 * This method should be called from the object's constructor (or
	 * equivalent initialization method).
	 * @see        __construct()
	 */
	public function applyDefaultValues()
	{
		$this->users_id = 0;
		$this->name = '';
	}

	/**
	 * Get the [id] column value.
	 * 
	 * @return     int
	 */
	public function getId()
	{
		return $this->id;
	}

	/**
	 * Get the [users_id] column value.
	 * 
	 * @return     int
	 */
	public function getUsersId()
	{
		return $this->users_id;
	}

	/**
	 * Get the [name] column value.
	 * 
	 * @return     string
	 */
	public function getName()
	{
		return $this->name;
	}

	/**
	 * Get the [display_on_home] column value.
	 * 
	 * @return     int
	 */
	public function getDisplayOnHome()
	{
		return $this->display_on_home;
	}

	/**
	 * Get the [projects_id] column value.
	 * 
	 * @return     string
	 */
	public function getProjectsId()
	{
		return $this->projects_id;
	}

	/**
	 * Get the [projects_type_id] column value.
	 * 
	 * @return     string
	 */
	public function getProjectsTypeId()
	{
		return $this->projects_type_id;
	}

	/**
	 * Get the [projects_status_id] column value.
	 * 
	 * @return     string
	 */
	public function getProjectsStatusId()
	{
		return $this->projects_status_id;
	}

	/**
	 * Get the [in_team] column value.
	 * 
	 * @return     int
	 */
	public function getInTeam()
	{
		return $this->in_team;
	}

	/**
	 * Get the [sort_order] column value.
	 * 
	 * @return     int
	 */
	public function getSortOrder()
	{
		return $this->sort_order;
	}

	/**
	 * Get the [display_in_menu] column value.
	 * 
	 * @return     int
	 */
	public function getDisplayInMenu()
	{
		return $this->display_in_menu;
	}

	/**
	 * Get the [visible_on_home] column value.
	 * 
	 * @return     int
	 */
	public function getVisibleOnHome()
	{
		return $this->visible_on_home;
	}

	/**
	 * Set the value of [id] column.
	 * 
	 * @param      int $v new value
	 * @return     ProjectsReports The current object (for fluent API support)
	 */
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ProjectsReportsPeer::ID;
		}

		return $this;
	} // setId()

	/**
	 * Set the value of [users_id] column.
	 * 
	 * @param      int $v new value
	 * @return     ProjectsReports The current object (for fluent API support)
	 */
	public function setUsersId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->users_id !== $v || $v === 0) {
			$this->users_id = $v;
			$this->modifiedColumns[] = ProjectsReportsPeer::USERS_ID;
		}

		if ($this->aUsers !== null && $this->aUsers->getId() !== $v) {
			$this->aUsers = null;
		}

		return $this;
	} // setUsersId()

	/**
	 * Set the value of [name] column.
	 * 
	 * @param      string $v new value
	 * @return     ProjectsReports The current object (for fluent API support)
	 */
	public function setName($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->name !== $v || $v === '') {
			$this->name = $v;
			$this->modifiedColumns[] = ProjectsReportsPeer::NAME;
		}

		return $this;
	} // setName()

	/**
	 * Set the value of [display_on_home] column.
	 * 
	 * @param      int $v new value
	 * @return     ProjectsReports The current object (for fluent API support)
	 */
	public function setDisplayOnHome($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->display_on_home !== $v) {
			$this->display_on_home = $v;
			$this->modifiedColumns[] = ProjectsReportsPeer::DISPLAY_ON_HOME;
		}

		return $this;
	} // setDisplayOnHome()

	/**
	 * Set the value of [projects_id] column.
	 * 
	 * @param      string $v new value
	 * @return     ProjectsReports The current object (for fluent API support)
	 */
	public function setProjectsId($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->projects_id !== $v) {
			$this->projects_id = $v;
			$this->modifiedColumns[] = ProjectsReportsPeer::PROJECTS_ID;
		}

		return $this;
	} // setProjectsId()

	/**
	 * Set the value of [projects_type_id] column.
	 * 
	 * @param      string $v new value
	 * @return     ProjectsReports The current object (for fluent API support)
	 */
	public function setProjectsTypeId($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->projects_type_id !== $v) {
			$this->projects_type_id = $v;
			$this->modifiedColumns[] = ProjectsReportsPeer::PROJECTS_TYPE_ID;
		}

		return $this;
	} // setProjectsTypeId()

	/**
	 * Set the value of [projects_status_id] column.
	 * 
	 * @param      string $v new value
	 * @return     ProjectsReports The current object (for fluent API support)
	 */
	public function setProjectsStatusId($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->projects_status_id !== $v) {
			$this->projects_status_id = $v;
			$this->modifiedColumns[] = ProjectsReportsPeer::PROJECTS_STATUS_ID;
		}

		return $this;
	} // setProjectsStatusId()

	/**
	 * Set the value of [in_team] column.
	 * 
	 * @param      int $v new value
	 * @return     ProjectsReports The current object (for fluent API support)
	 */
	public function setInTeam($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->in_team !== $v) {
			$this->in_team = $v;
			$this->modifiedColumns[] = ProjectsReportsPeer::IN_TEAM;
		}

		return $this;
	} // setInTeam()

	/**
	 * Set the value of [sort_order] column.
	 * 
	 * @param      int $v new value
	 * @return     ProjectsReports The current object (for fluent API support)
	 */
	public function setSortOrder($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->sort_order !== $v) {
			$this->sort_order = $v;
			$this->modifiedColumns[] = ProjectsReportsPeer::SORT_ORDER;
		}

		return $this;
	} // setSortOrder()

	/**
	 * Set the value of [display_in_menu] column.
	 * 
	 * @param      int $v new value
	 * @return     ProjectsReports The current object (for fluent API support)
	 */
	public function setDisplayInMenu($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->display_in_menu !== $v) {
			$this->display_in_menu = $v;
			$this->modifiedColumns[] = ProjectsReportsPeer::DISPLAY_IN_MENU;
		}

		return $this;
	} // setDisplayInMenu()

	/**
	 * Set the value of [visible_on_home] column.
	 * 
	 * @param      int $v new value
	 * @return     ProjectsReports The current object (for fluent API support)
	 */
	public function setVisibleOnHome($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->visible_on_home !== $v) {
			$this->visible_on_home = $v;
			$this->modifiedColumns[] = ProjectsReportsPeer::VISIBLE_ON_HOME;
		}

		return $this;
	} // setVisibleOnHome()

	/**
	 * Indicates whether the columns in this object are only set to default values.
	 *
	 * This method can be used in conjunction with isModified() to indicate whether an object is both
	 * modified _and_ has some values set which are non-default.
	 *
	 * @return     boolean Whether the columns in this object are only been set with default values.
	 */
	public function hasOnlyDefaultValues()
	{
			// First, ensure that we don't have any columns that have been modified which aren't default columns.
			if (array_diff($this->modifiedColumns, array(ProjectsReportsPeer::USERS_ID,ProjectsReportsPeer::NAME))) {
				return false;
			}

			if ($this->users_id !== 0) {
				return false;
			}

			if ($this->name !== '') {
				return false;
			}

		// otherwise, everything was equal, so return TRUE
		return true;
	} // hasOnlyDefaultValues()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (0-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param      array $row The row returned by PDOStatement->fetch(PDO::FETCH_NUM)
	 * @param      int $startcol 0-based offset column which indicates which restultset column to start with.
	 * @param      boolean $rehydrate Whether this object is being re-hydrated from the database.
	 * @return     int next starting column
	 * @throws     PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->users_id = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
			$this->name = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->display_on_home = ($row[$startcol + 3] !== null) ? (int) $row[$startcol + 3] : null;
			$this->projects_id = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
			$this->projects_type_id = ($row[$startcol + 5] !== null) ? (string) $row[$startcol + 5] : null;
			$this->projects_status_id = ($row[$startcol + 6] !== null) ? (string) $row[$startcol + 6] : null;
			$this->in_team = ($row[$startcol + 7] !== null) ? (int) $row[$startcol + 7] : null;
			$this->sort_order = ($row[$startcol + 8] !== null) ? (int) $row[$startcol + 8] : null;
			$this->display_in_menu = ($row[$startcol + 9] !== null) ? (int) $row[$startcol + 9] : null;
			$this->visible_on_home = ($row[$startcol + 10] !== null) ? (int) $row[$startcol + 10] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 11; // 11 = ProjectsReportsPeer::NUM_COLUMNS - ProjectsReportsPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating ProjectsReports object", $e);
		}
	}

	/**
	 * Checks and repairs the internal consistency of the object.
	 *
	 * This method is executed after an already-instantiated object is re-hydrated
	 * from the database.  It exists to check any foreign keys to make sure that
	 * the objects related to the current object are correct based on foreign key.
	 *
	 * You can override this method in the stub class, but you should always invoke
	 * the base method from the overridden method (i.e. parent::ensureConsistency()),
	 * in case your model changes.
	 *
	 * @throws     PropelException
	 */
	public function ensureConsistency()
	{

		if ($this->aUsers !== null && $this->users_id !== $this->aUsers->getId()) {
			$this->aUsers = null;
		}
	} // ensureConsistency

	/**
	 * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
	 *
	 * This will only work if the object has been saved and has a valid primary key set.
	 *
	 * @param      boolean $deep (optional) Whether to also de-associated any related objects.
	 * @param      PropelPDO $con (optional) The PropelPDO connection to use.
	 * @return     void
	 * @throws     PropelException - if this object is deleted, unsaved or doesn't have pk match in db
	 */
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ProjectsReportsPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

		// We don't need to alter the object instance pool; we're just modifying this instance
		// already in the pool.

		$stmt = ProjectsReportsPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); // rehydrate

		if ($deep) {  // also de-associate any related objects?

			$this->aUsers = null;
		} // if (deep)
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param      PropelPDO $con
	 * @return     void
	 * @throws     PropelException
	 * @see        BaseObject::setDeleted()
	 * @see        BaseObject::isDeleted()
	 */
	public function delete(PropelPDO $con = null)
	{

    foreach (sfMixer::getCallables('BaseProjectsReports:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ProjectsReportsPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			ProjectsReportsPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseProjectsReports:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	/**
	 * Persists this object to the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All modified related objects will also be persisted in the doSave()
	 * method.  This method wraps all precipitate database operations in a
	 * single transaction.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        doSave()
	 */
	public function save(PropelPDO $con = null)
	{

    foreach (sfMixer::getCallables('BaseProjectsReports:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ProjectsReportsPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseProjectsReports:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			ProjectsReportsPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	/**
	 * Performs the work of inserting or updating the row in the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        save()
	 */
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aUsers !== null) {
				if ($this->aUsers->isModified() || $this->aUsers->isNew()) {
					$affectedRows += $this->aUsers->save($con);
				}
				$this->setUsers($this->aUsers);
			}

			if ($this->isNew() ) {
				$this->modifiedColumns[] = ProjectsReportsPeer::ID;
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ProjectsReportsPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which
										 // should always be true here (even though technically
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setId($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += ProjectsReportsPeer::doUpdate($this, $con);
				}

				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var        array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return     array ValidationFailed[]
	 * @see        validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param      mixed $columns Column name or an array of column names.
	 * @return     boolean Whether all columns pass validation.
	 * @see        doValidate()
	 * @see        getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param      array $columns Array of column names to validate.
	 * @return     mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aUsers !== null) {
				if (!$this->aUsers->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUsers->getValidationFailures());
				}
			}


			if (($retval = ProjectsReportsPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param      string $name name
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ProjectsReportsPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @return     mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getUsersId();
				break;
			case 2:
				return $this->getName();
				break;
			case 3:
				return $this->getDisplayOnHome();
				break;
			case 4:
				return $this->getProjectsId();
				break;
			case 5:
				return $this->getProjectsTypeId();
				break;
			case 6:
				return $this->getProjectsStatusId();
				break;
			case 7:
				return $this->getInTeam();
				break;
			case 8:
				return $this->getSortOrder();
				break;
			case 9:
				return $this->getDisplayInMenu();
				break;
			case 10:
				return $this->getVisibleOnHome();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param      string $keyType (optional) One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                        BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM. Defaults to BasePeer::TYPE_PHPNAME.
	 * @param      boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns.  Defaults to TRUE.
	 * @return     an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = ProjectsReportsPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getUsersId(),
			$keys[2] => $this->getName(),
			$keys[3] => $this->getDisplayOnHome(),
			$keys[4] => $this->getProjectsId(),
			$keys[5] => $this->getProjectsTypeId(),
			$keys[6] => $this->getProjectsStatusId(),
			$keys[7] => $this->getInTeam(),
			$keys[8] => $this->getSortOrder(),
			$keys[9] => $this->getDisplayInMenu(),
			$keys[10] => $this->getVisibleOnHome(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param      string $name peer name
	 * @param      mixed $value field value
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ProjectsReportsPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @param      mixed $value field value
	 * @return     void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setUsersId($value);
				break;
			case 2:
				$this->setName($value);
				break;
			case 3:
				$this->setDisplayOnHome($value);
				break;
			case 4:
				$this->setProjectsId($value);
				break;
			case 5:
				$this->setProjectsTypeId($value);
				break;
			case 6:
				$this->setProjectsStatusId($value);
				break;
			case 7:
				$this->setInTeam($value);
				break;
			case 8:
				$this->setSortOrder($value);
				break;
			case 9:
				$this->setDisplayInMenu($value);
				break;
			case 10:
				$this->setVisibleOnHome($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
	 * BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
	 * The default key type is the column's phpname (e.g. 'AuthorId')
	 *
	 * @param      array  $arr     An array to populate the object from.
	 * @param      string $keyType The type of keys the array uses.
	 * @return     void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ProjectsReportsPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setUsersId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setName($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setDisplayOnHome($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setProjectsId($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setProjectsTypeId($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setProjectsStatusId($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setInTeam($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setSortOrder($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setDisplayInMenu($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setVisibleOnHome($arr[$keys[10]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return     Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(ProjectsReportsPeer::DATABASE_NAME);

		if ($this->isColumnModified(ProjectsReportsPeer::ID)) $criteria->add(ProjectsReportsPeer::ID, $this->id);
		if ($this->isColumnModified(ProjectsReportsPeer::USERS_ID)) $criteria->add(ProjectsReportsPeer::USERS_ID, $this->users_id);
		if ($this->isColumnModified(ProjectsReportsPeer::NAME)) $criteria->add(ProjectsReportsPeer::NAME, $this->name);
		if ($this->isColumnModified(ProjectsReportsPeer::DISPLAY_ON_HOME)) $criteria->add(ProjectsReportsPeer::DISPLAY_ON_HOME, $this->display_on_home);
		if ($this->isColumnModified(ProjectsReportsPeer::PROJECTS_ID)) $criteria->add(ProjectsReportsPeer::PROJECTS_ID, $this->projects_id);
		if ($this->isColumnModified(ProjectsReportsPeer::PROJECTS_TYPE_ID)) $criteria->add(ProjectsReportsPeer::PROJECTS_TYPE_ID, $this->projects_type_id);
		if ($this->isColumnModified(ProjectsReportsPeer::PROJECTS_STATUS_ID)) $criteria->add(ProjectsReportsPeer::PROJECTS_STATUS_ID, $this->projects_status_id);
		if ($this->isColumnModified(ProjectsReportsPeer::IN_TEAM)) $criteria->add(ProjectsReportsPeer::IN_TEAM, $this->in_team);
		if ($this->isColumnModified(ProjectsReportsPeer::SORT_ORDER)) $criteria->add(ProjectsReportsPeer::SORT_ORDER, $this->sort_order);
		if ($this->isColumnModified(ProjectsReportsPeer::DISPLAY_IN_MENU)) $criteria->add(ProjectsReportsPeer::DISPLAY_IN_MENU, $this->display_in_menu);
		if ($this->isColumnModified(ProjectsReportsPeer::VISIBLE_ON_HOME)) $criteria->add(ProjectsReportsPeer::VISIBLE_ON_HOME, $this->visible_on_home);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return     Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ProjectsReportsPeer::DATABASE_NAME);

		$criteria->add(ProjectsReportsPeer::ID, $this->id);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return     int
	 */
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	/**
	 * Generic method to set the primary key (id column).
	 *
	 * @param      int $key Primary key.
	 * @return     void
	 */
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      object $copyObj An object of ProjectsReports (or compatible) type.
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws     PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setUsersId($this->users_id);

		$copyObj->setName($this->name);

		$copyObj->setDisplayOnHome($this->display_on_home);

		$copyObj->setProjectsId($this->projects_id);

		$copyObj->setProjectsTypeId($this->projects_type_id);

		$copyObj->setProjectsStatusId($this->projects_status_id);

		$copyObj->setInTeam($this->in_team);

		$copyObj->setSortOrder($this->sort_order);

		$copyObj->setDisplayInMenu($this->display_in_menu);

		$copyObj->setVisibleOnHome($this->visible_on_home);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); // this is a auto-increment column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return     ProjectsReports Clone of current object.
	 * @throws     PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return     ProjectsReportsPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ProjectsReportsPeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a Users object.
	 *
	 * @param      Users $v
	 * @return     ProjectsReports The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setUsers(Users $v = null)
	{
		if ($v === null) {
			$this->setUsersId(0);
		} else {
			$this->setUsersId($v->getId());
		}

		$this->aUsers = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the Users object, it will not be re-added.
		if ($v !== null) {
			$v->addProjectsReports($this);
		}

		return $this;
	}


	/**
	 * Get the associated Users object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     Users The associated Users object.
	 * @throws     PropelException
	 */
	public function getUsers(PropelPDO $con = null)
	{
		if ($this->aUsers === null && ($this->users_id !== null)) {
			$c = new Criteria(UsersPeer::DATABASE_NAME);
			$c->add(UsersPeer::ID, $this->users_id);
			$this->aUsers = UsersPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aUsers->addProjectsReportss($this);
			 */
		}
		return $this->aUsers;
	}

	/**
	 * Resets all collections of referencing foreign keys.
	 *
	 * This method is a user-space workaround for PHP's inability to garbage collect objects
	 * with circular references.  This is currently necessary when using Propel in certain
	 * daemon or large-volumne/high-memory operations.
	 *
	 * @param      boolean $deep Whether to also clear the references on all associated objects.
	 */
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
		} // if ($deep)

			$this->aUsers = null;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseProjectsReports:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseProjectsReports::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} // BaseProjectsReports
