<?php

/**
 * Base class that represents a row from the 'tasks' table.
 *
 * 
 *
 * This class was autogenerated by Propel 1.3.0-dev on:
 *
 * 10/01/11 13:54:40
 *
 * @package    lib.model.om
 */
abstract class BaseTasks extends BaseObject  implements Persistent {


  const PEER = 'TasksPeer';

	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var        TasksPeer
	 */
	protected static $peer;

	/**
	 * The value for the id field.
	 * @var        int
	 */
	protected $id;

	/**
	 * The value for the projects_id field.
	 * Note: this column has a database default value of: 0
	 * @var        int
	 */
	protected $projects_id;

	/**
	 * The value for the tasks_status_id field.
	 * @var        int
	 */
	protected $tasks_status_id;

	/**
	 * The value for the tasks_priority_id field.
	 * @var        int
	 */
	protected $tasks_priority_id;

	/**
	 * The value for the tasks_type_id field.
	 * @var        int
	 */
	protected $tasks_type_id;

	/**
	 * The value for the tasks_label_id field.
	 * @var        int
	 */
	protected $tasks_label_id;

	/**
	 * The value for the tasks_groups_id field.
	 * @var        int
	 */
	protected $tasks_groups_id;

	/**
	 * The value for the projects_phases_id field.
	 * @var        int
	 */
	protected $projects_phases_id;

	/**
	 * The value for the versions_id field.
	 * @var        int
	 */
	protected $versions_id;

	/**
	 * The value for the created_by field.
	 * @var        int
	 */
	protected $created_by;

	/**
	 * The value for the name field.
	 * Note: this column has a database default value of: ''
	 * @var        string
	 */
	protected $name;

	/**
	 * The value for the description field.
	 * @var        string
	 */
	protected $description;

	/**
	 * The value for the assigned_to field.
	 * @var        string
	 */
	protected $assigned_to;

	/**
	 * The value for the estimated_time field.
	 * @var        double
	 */
	protected $estimated_time;

	/**
	 * The value for the due_date field.
	 * @var        string
	 */
	protected $due_date;

	/**
	 * The value for the created_at field.
	 * @var        string
	 */
	protected $created_at;

	/**
	 * The value for the tickets_id field.
	 * @var        int
	 */
	protected $tickets_id;

	/**
	 * The value for the closed_date field.
	 * @var        string
	 */
	protected $closed_date;

	/**
	 * The value for the discussion_id field.
	 * @var        int
	 */
	protected $discussion_id;

	/**
	 * The value for the start_date field.
	 * @var        string
	 */
	protected $start_date;

	/**
	 * The value for the progress field.
	 * @var        int
	 */
	protected $progress;

	/**
	 * @var        Projects
	 */
	protected $aProjects;

	/**
	 * @var        TasksStatus
	 */
	protected $aTasksStatus;

	/**
	 * @var        TasksPriority
	 */
	protected $aTasksPriority;

	/**
	 * @var        TasksTypes
	 */
	protected $aTasksTypes;

	/**
	 * @var        TasksLabels
	 */
	protected $aTasksLabels;

	/**
	 * @var        TasksGroups
	 */
	protected $aTasksGroups;

	/**
	 * @var        ProjectsPhases
	 */
	protected $aProjectsPhases;

	/**
	 * @var        Versions
	 */
	protected $aVersions;

	/**
	 * @var        Users
	 */
	protected $aUsers;

	/**
	 * @var        Tickets
	 */
	protected $aTickets;

	/**
	 * @var        array TasksComments[] Collection to store aggregation of TasksComments objects.
	 */
	protected $collTasksCommentss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collTasksCommentss.
	 */
	private $lastTasksCommentsCriteria = null;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInValidation = false;

	/**
	 * Initializes internal state of BaseTasks object.
	 * @see        applyDefaults()
	 */
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	/**
	 * Applies default values to this object.
	 * This method should be called from the object's constructor (or
	 * equivalent initialization method).
	 * @see        __construct()
	 */
	public function applyDefaultValues()
	{
		$this->projects_id = 0;
		$this->name = '';
	}

	/**
	 * Get the [id] column value.
	 * 
	 * @return     int
	 */
	public function getId()
	{
		return $this->id;
	}

	/**
	 * Get the [projects_id] column value.
	 * 
	 * @return     int
	 */
	public function getProjectsId()
	{
		return $this->projects_id;
	}

	/**
	 * Get the [tasks_status_id] column value.
	 * 
	 * @return     int
	 */
	public function getTasksStatusId()
	{
		return $this->tasks_status_id;
	}

	/**
	 * Get the [tasks_priority_id] column value.
	 * 
	 * @return     int
	 */
	public function getTasksPriorityId()
	{
		return $this->tasks_priority_id;
	}

	/**
	 * Get the [tasks_type_id] column value.
	 * 
	 * @return     int
	 */
	public function getTasksTypeId()
	{
		return $this->tasks_type_id;
	}

	/**
	 * Get the [tasks_label_id] column value.
	 * 
	 * @return     int
	 */
	public function getTasksLabelId()
	{
		return $this->tasks_label_id;
	}

	/**
	 * Get the [tasks_groups_id] column value.
	 * 
	 * @return     int
	 */
	public function getTasksGroupsId()
	{
		return $this->tasks_groups_id;
	}

	/**
	 * Get the [projects_phases_id] column value.
	 * 
	 * @return     int
	 */
	public function getProjectsPhasesId()
	{
		return $this->projects_phases_id;
	}

	/**
	 * Get the [versions_id] column value.
	 * 
	 * @return     int
	 */
	public function getVersionsId()
	{
		return $this->versions_id;
	}

	/**
	 * Get the [created_by] column value.
	 * 
	 * @return     int
	 */
	public function getCreatedBy()
	{
		return $this->created_by;
	}

	/**
	 * Get the [name] column value.
	 * 
	 * @return     string
	 */
	public function getName()
	{
		return $this->name;
	}

	/**
	 * Get the [description] column value.
	 * 
	 * @return     string
	 */
	public function getDescription()
	{
		return $this->description;
	}

	/**
	 * Get the [assigned_to] column value.
	 * 
	 * @return     string
	 */
	public function getAssignedTo()
	{
		return $this->assigned_to;
	}

	/**
	 * Get the [estimated_time] column value.
	 * 
	 * @return     double
	 */
	public function getEstimatedTime()
	{
		return $this->estimated_time;
	}

	/**
	 * Get the [optionally formatted] temporal [due_date] column value.
	 * 
	 *
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the raw DateTime object will be returned.
	 * @return     mixed Formatted date/time value as string or DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00
	 * @throws     PropelException - if unable to parse/validate the date/time value.
	 */
	public function getDueDate($format = 'Y-m-d')
	{
		if ($this->due_date === null) {
			return null;
		}


		if ($this->due_date === '0000-00-00') {
			// while technically this is not a default value of NULL,
			// this seems to be closest in meaning.
			return null;
		} else {
			try {
				$dt = new DateTime($this->due_date);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->due_date, true), $x);
			}
		}

		if ($format === null) {
			// Because propel.useDateTimeClass is TRUE, we return a DateTime object.
			return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	/**
	 * Get the [optionally formatted] temporal [created_at] column value.
	 * 
	 *
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the raw DateTime object will be returned.
	 * @return     mixed Formatted date/time value as string or DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00 00:00:00
	 * @throws     PropelException - if unable to parse/validate the date/time value.
	 */
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->created_at === null) {
			return null;
		}


		if ($this->created_at === '0000-00-00 00:00:00') {
			// while technically this is not a default value of NULL,
			// this seems to be closest in meaning.
			return null;
		} else {
			try {
				$dt = new DateTime($this->created_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->created_at, true), $x);
			}
		}

		if ($format === null) {
			// Because propel.useDateTimeClass is TRUE, we return a DateTime object.
			return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	/**
	 * Get the [tickets_id] column value.
	 * 
	 * @return     int
	 */
	public function getTicketsId()
	{
		return $this->tickets_id;
	}

	/**
	 * Get the [optionally formatted] temporal [closed_date] column value.
	 * 
	 *
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the raw DateTime object will be returned.
	 * @return     mixed Formatted date/time value as string or DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00
	 * @throws     PropelException - if unable to parse/validate the date/time value.
	 */
	public function getClosedDate($format = 'Y-m-d')
	{
		if ($this->closed_date === null) {
			return null;
		}


		if ($this->closed_date === '0000-00-00') {
			// while technically this is not a default value of NULL,
			// this seems to be closest in meaning.
			return null;
		} else {
			try {
				$dt = new DateTime($this->closed_date);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->closed_date, true), $x);
			}
		}

		if ($format === null) {
			// Because propel.useDateTimeClass is TRUE, we return a DateTime object.
			return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	/**
	 * Get the [discussion_id] column value.
	 * 
	 * @return     int
	 */
	public function getDiscussionId()
	{
		return $this->discussion_id;
	}

	/**
	 * Get the [optionally formatted] temporal [start_date] column value.
	 * 
	 *
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the raw DateTime object will be returned.
	 * @return     mixed Formatted date/time value as string or DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00
	 * @throws     PropelException - if unable to parse/validate the date/time value.
	 */
	public function getStartDate($format = 'Y-m-d')
	{
		if ($this->start_date === null) {
			return null;
		}


		if ($this->start_date === '0000-00-00') {
			// while technically this is not a default value of NULL,
			// this seems to be closest in meaning.
			return null;
		} else {
			try {
				$dt = new DateTime($this->start_date);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->start_date, true), $x);
			}
		}

		if ($format === null) {
			// Because propel.useDateTimeClass is TRUE, we return a DateTime object.
			return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	/**
	 * Get the [progress] column value.
	 * 
	 * @return     int
	 */
	public function getProgress()
	{
		return $this->progress;
	}

	/**
	 * Set the value of [id] column.
	 * 
	 * @param      int $v new value
	 * @return     Tasks The current object (for fluent API support)
	 */
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = TasksPeer::ID;
		}

		return $this;
	} // setId()

	/**
	 * Set the value of [projects_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Tasks The current object (for fluent API support)
	 */
	public function setProjectsId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->projects_id !== $v || $v === 0) {
			$this->projects_id = $v;
			$this->modifiedColumns[] = TasksPeer::PROJECTS_ID;
		}

		if ($this->aProjects !== null && $this->aProjects->getId() !== $v) {
			$this->aProjects = null;
		}

		return $this;
	} // setProjectsId()

	/**
	 * Set the value of [tasks_status_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Tasks The current object (for fluent API support)
	 */
	public function setTasksStatusId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->tasks_status_id !== $v) {
			$this->tasks_status_id = $v;
			$this->modifiedColumns[] = TasksPeer::TASKS_STATUS_ID;
		}

		if ($this->aTasksStatus !== null && $this->aTasksStatus->getId() !== $v) {
			$this->aTasksStatus = null;
		}

		return $this;
	} // setTasksStatusId()

	/**
	 * Set the value of [tasks_priority_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Tasks The current object (for fluent API support)
	 */
	public function setTasksPriorityId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->tasks_priority_id !== $v) {
			$this->tasks_priority_id = $v;
			$this->modifiedColumns[] = TasksPeer::TASKS_PRIORITY_ID;
		}

		if ($this->aTasksPriority !== null && $this->aTasksPriority->getId() !== $v) {
			$this->aTasksPriority = null;
		}

		return $this;
	} // setTasksPriorityId()

	/**
	 * Set the value of [tasks_type_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Tasks The current object (for fluent API support)
	 */
	public function setTasksTypeId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->tasks_type_id !== $v) {
			$this->tasks_type_id = $v;
			$this->modifiedColumns[] = TasksPeer::TASKS_TYPE_ID;
		}

		if ($this->aTasksTypes !== null && $this->aTasksTypes->getId() !== $v) {
			$this->aTasksTypes = null;
		}

		return $this;
	} // setTasksTypeId()

	/**
	 * Set the value of [tasks_label_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Tasks The current object (for fluent API support)
	 */
	public function setTasksLabelId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->tasks_label_id !== $v) {
			$this->tasks_label_id = $v;
			$this->modifiedColumns[] = TasksPeer::TASKS_LABEL_ID;
		}

		if ($this->aTasksLabels !== null && $this->aTasksLabels->getId() !== $v) {
			$this->aTasksLabels = null;
		}

		return $this;
	} // setTasksLabelId()

	/**
	 * Set the value of [tasks_groups_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Tasks The current object (for fluent API support)
	 */
	public function setTasksGroupsId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->tasks_groups_id !== $v) {
			$this->tasks_groups_id = $v;
			$this->modifiedColumns[] = TasksPeer::TASKS_GROUPS_ID;
		}

		if ($this->aTasksGroups !== null && $this->aTasksGroups->getId() !== $v) {
			$this->aTasksGroups = null;
		}

		return $this;
	} // setTasksGroupsId()

	/**
	 * Set the value of [projects_phases_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Tasks The current object (for fluent API support)
	 */
	public function setProjectsPhasesId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->projects_phases_id !== $v) {
			$this->projects_phases_id = $v;
			$this->modifiedColumns[] = TasksPeer::PROJECTS_PHASES_ID;
		}

		if ($this->aProjectsPhases !== null && $this->aProjectsPhases->getId() !== $v) {
			$this->aProjectsPhases = null;
		}

		return $this;
	} // setProjectsPhasesId()

	/**
	 * Set the value of [versions_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Tasks The current object (for fluent API support)
	 */
	public function setVersionsId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->versions_id !== $v) {
			$this->versions_id = $v;
			$this->modifiedColumns[] = TasksPeer::VERSIONS_ID;
		}

		if ($this->aVersions !== null && $this->aVersions->getId() !== $v) {
			$this->aVersions = null;
		}

		return $this;
	} // setVersionsId()

	/**
	 * Set the value of [created_by] column.
	 * 
	 * @param      int $v new value
	 * @return     Tasks The current object (for fluent API support)
	 */
	public function setCreatedBy($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->created_by !== $v) {
			$this->created_by = $v;
			$this->modifiedColumns[] = TasksPeer::CREATED_BY;
		}

		if ($this->aUsers !== null && $this->aUsers->getId() !== $v) {
			$this->aUsers = null;
		}

		return $this;
	} // setCreatedBy()

	/**
	 * Set the value of [name] column.
	 * 
	 * @param      string $v new value
	 * @return     Tasks The current object (for fluent API support)
	 */
	public function setName($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->name !== $v || $v === '') {
			$this->name = $v;
			$this->modifiedColumns[] = TasksPeer::NAME;
		}

		return $this;
	} // setName()

	/**
	 * Set the value of [description] column.
	 * 
	 * @param      string $v new value
	 * @return     Tasks The current object (for fluent API support)
	 */
	public function setDescription($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = TasksPeer::DESCRIPTION;
		}

		return $this;
	} // setDescription()

	/**
	 * Set the value of [assigned_to] column.
	 * 
	 * @param      string $v new value
	 * @return     Tasks The current object (for fluent API support)
	 */
	public function setAssignedTo($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->assigned_to !== $v) {
			$this->assigned_to = $v;
			$this->modifiedColumns[] = TasksPeer::ASSIGNED_TO;
		}

		return $this;
	} // setAssignedTo()

	/**
	 * Set the value of [estimated_time] column.
	 * 
	 * @param      double $v new value
	 * @return     Tasks The current object (for fluent API support)
	 */
	public function setEstimatedTime($v)
	{
		if ($v !== null) {
			$v = (double) $v;
		}

		if ($this->estimated_time !== $v) {
			$this->estimated_time = $v;
			$this->modifiedColumns[] = TasksPeer::ESTIMATED_TIME;
		}

		return $this;
	} // setEstimatedTime()

	/**
	 * Sets the value of [due_date] column to a normalized version of the date/time value specified.
	 * 
	 * @param      mixed $v string, integer (timestamp), or DateTime value.  Empty string will
	 *						be treated as NULL for temporal objects.
	 * @return     Tasks The current object (for fluent API support)
	 */
	public function setDueDate($v)
	{
		// we treat '' as NULL for temporal objects because DateTime('') == DateTime('now')
		// -- which is unexpected, to say the least.
		if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
			// some string/numeric value passed; we normalize that so that we can
			// validate it.
			try {
				if (is_numeric($v)) { // if it's a unix timestamp
					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
					// We have to explicitly specify and then change the time zone because of a
					// DateTime bug: http://bugs.php.net/bug.php?id=43003
					$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->due_date !== null || $dt !== null ) {
			// (nested ifs are a little easier to read in this case)

			$currNorm = ($this->due_date !== null && $tmpDt = new DateTime($this->due_date)) ? $tmpDt->format('Y-m-d') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d') : null;

			if ( ($currNorm !== $newNorm) // normalized values don't match 
					)
			{
				$this->due_date = ($dt ? $dt->format('Y-m-d') : null);
				$this->modifiedColumns[] = TasksPeer::DUE_DATE;
			}
		} // if either are not null

		return $this;
	} // setDueDate()

	/**
	 * Sets the value of [created_at] column to a normalized version of the date/time value specified.
	 * 
	 * @param      mixed $v string, integer (timestamp), or DateTime value.  Empty string will
	 *						be treated as NULL for temporal objects.
	 * @return     Tasks The current object (for fluent API support)
	 */
	public function setCreatedAt($v)
	{
		// we treat '' as NULL for temporal objects because DateTime('') == DateTime('now')
		// -- which is unexpected, to say the least.
		if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
			// some string/numeric value passed; we normalize that so that we can
			// validate it.
			try {
				if (is_numeric($v)) { // if it's a unix timestamp
					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
					// We have to explicitly specify and then change the time zone because of a
					// DateTime bug: http://bugs.php.net/bug.php?id=43003
					$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->created_at !== null || $dt !== null ) {
			// (nested ifs are a little easier to read in this case)

			$currNorm = ($this->created_at !== null && $tmpDt = new DateTime($this->created_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) // normalized values don't match 
					)
			{
				$this->created_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = TasksPeer::CREATED_AT;
			}
		} // if either are not null

		return $this;
	} // setCreatedAt()

	/**
	 * Set the value of [tickets_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Tasks The current object (for fluent API support)
	 */
	public function setTicketsId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->tickets_id !== $v) {
			$this->tickets_id = $v;
			$this->modifiedColumns[] = TasksPeer::TICKETS_ID;
		}

		if ($this->aTickets !== null && $this->aTickets->getId() !== $v) {
			$this->aTickets = null;
		}

		return $this;
	} // setTicketsId()

	/**
	 * Sets the value of [closed_date] column to a normalized version of the date/time value specified.
	 * 
	 * @param      mixed $v string, integer (timestamp), or DateTime value.  Empty string will
	 *						be treated as NULL for temporal objects.
	 * @return     Tasks The current object (for fluent API support)
	 */
	public function setClosedDate($v)
	{
		// we treat '' as NULL for temporal objects because DateTime('') == DateTime('now')
		// -- which is unexpected, to say the least.
		if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
			// some string/numeric value passed; we normalize that so that we can
			// validate it.
			try {
				if (is_numeric($v)) { // if it's a unix timestamp
					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
					// We have to explicitly specify and then change the time zone because of a
					// DateTime bug: http://bugs.php.net/bug.php?id=43003
					$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->closed_date !== null || $dt !== null ) {
			// (nested ifs are a little easier to read in this case)

			$currNorm = ($this->closed_date !== null && $tmpDt = new DateTime($this->closed_date)) ? $tmpDt->format('Y-m-d') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d') : null;

			if ( ($currNorm !== $newNorm) // normalized values don't match 
					)
			{
				$this->closed_date = ($dt ? $dt->format('Y-m-d') : null);
				$this->modifiedColumns[] = TasksPeer::CLOSED_DATE;
			}
		} // if either are not null

		return $this;
	} // setClosedDate()

	/**
	 * Set the value of [discussion_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Tasks The current object (for fluent API support)
	 */
	public function setDiscussionId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->discussion_id !== $v) {
			$this->discussion_id = $v;
			$this->modifiedColumns[] = TasksPeer::DISCUSSION_ID;
		}

		return $this;
	} // setDiscussionId()

	/**
	 * Sets the value of [start_date] column to a normalized version of the date/time value specified.
	 * 
	 * @param      mixed $v string, integer (timestamp), or DateTime value.  Empty string will
	 *						be treated as NULL for temporal objects.
	 * @return     Tasks The current object (for fluent API support)
	 */
	public function setStartDate($v)
	{
		// we treat '' as NULL for temporal objects because DateTime('') == DateTime('now')
		// -- which is unexpected, to say the least.
		if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
			// some string/numeric value passed; we normalize that so that we can
			// validate it.
			try {
				if (is_numeric($v)) { // if it's a unix timestamp
					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
					// We have to explicitly specify and then change the time zone because of a
					// DateTime bug: http://bugs.php.net/bug.php?id=43003
					$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->start_date !== null || $dt !== null ) {
			// (nested ifs are a little easier to read in this case)

			$currNorm = ($this->start_date !== null && $tmpDt = new DateTime($this->start_date)) ? $tmpDt->format('Y-m-d') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d') : null;

			if ( ($currNorm !== $newNorm) // normalized values don't match 
					)
			{
				$this->start_date = ($dt ? $dt->format('Y-m-d') : null);
				$this->modifiedColumns[] = TasksPeer::START_DATE;
			}
		} // if either are not null

		return $this;
	} // setStartDate()

	/**
	 * Set the value of [progress] column.
	 * 
	 * @param      int $v new value
	 * @return     Tasks The current object (for fluent API support)
	 */
	public function setProgress($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->progress !== $v) {
			$this->progress = $v;
			$this->modifiedColumns[] = TasksPeer::PROGRESS;
		}

		return $this;
	} // setProgress()

	/**
	 * Indicates whether the columns in this object are only set to default values.
	 *
	 * This method can be used in conjunction with isModified() to indicate whether an object is both
	 * modified _and_ has some values set which are non-default.
	 *
	 * @return     boolean Whether the columns in this object are only been set with default values.
	 */
	public function hasOnlyDefaultValues()
	{
			// First, ensure that we don't have any columns that have been modified which aren't default columns.
			if (array_diff($this->modifiedColumns, array(TasksPeer::PROJECTS_ID,TasksPeer::NAME))) {
				return false;
			}

			if ($this->projects_id !== 0) {
				return false;
			}

			if ($this->name !== '') {
				return false;
			}

		// otherwise, everything was equal, so return TRUE
		return true;
	} // hasOnlyDefaultValues()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (0-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param      array $row The row returned by PDOStatement->fetch(PDO::FETCH_NUM)
	 * @param      int $startcol 0-based offset column which indicates which restultset column to start with.
	 * @param      boolean $rehydrate Whether this object is being re-hydrated from the database.
	 * @return     int next starting column
	 * @throws     PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->projects_id = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
			$this->tasks_status_id = ($row[$startcol + 2] !== null) ? (int) $row[$startcol + 2] : null;
			$this->tasks_priority_id = ($row[$startcol + 3] !== null) ? (int) $row[$startcol + 3] : null;
			$this->tasks_type_id = ($row[$startcol + 4] !== null) ? (int) $row[$startcol + 4] : null;
			$this->tasks_label_id = ($row[$startcol + 5] !== null) ? (int) $row[$startcol + 5] : null;
			$this->tasks_groups_id = ($row[$startcol + 6] !== null) ? (int) $row[$startcol + 6] : null;
			$this->projects_phases_id = ($row[$startcol + 7] !== null) ? (int) $row[$startcol + 7] : null;
			$this->versions_id = ($row[$startcol + 8] !== null) ? (int) $row[$startcol + 8] : null;
			$this->created_by = ($row[$startcol + 9] !== null) ? (int) $row[$startcol + 9] : null;
			$this->name = ($row[$startcol + 10] !== null) ? (string) $row[$startcol + 10] : null;
			$this->description = ($row[$startcol + 11] !== null) ? (string) $row[$startcol + 11] : null;
			$this->assigned_to = ($row[$startcol + 12] !== null) ? (string) $row[$startcol + 12] : null;
			$this->estimated_time = ($row[$startcol + 13] !== null) ? (double) $row[$startcol + 13] : null;
			$this->due_date = ($row[$startcol + 14] !== null) ? (string) $row[$startcol + 14] : null;
			$this->created_at = ($row[$startcol + 15] !== null) ? (string) $row[$startcol + 15] : null;
			$this->tickets_id = ($row[$startcol + 16] !== null) ? (int) $row[$startcol + 16] : null;
			$this->closed_date = ($row[$startcol + 17] !== null) ? (string) $row[$startcol + 17] : null;
			$this->discussion_id = ($row[$startcol + 18] !== null) ? (int) $row[$startcol + 18] : null;
			$this->start_date = ($row[$startcol + 19] !== null) ? (string) $row[$startcol + 19] : null;
			$this->progress = ($row[$startcol + 20] !== null) ? (int) $row[$startcol + 20] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 21; // 21 = TasksPeer::NUM_COLUMNS - TasksPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating Tasks object", $e);
		}
	}

	/**
	 * Checks and repairs the internal consistency of the object.
	 *
	 * This method is executed after an already-instantiated object is re-hydrated
	 * from the database.  It exists to check any foreign keys to make sure that
	 * the objects related to the current object are correct based on foreign key.
	 *
	 * You can override this method in the stub class, but you should always invoke
	 * the base method from the overridden method (i.e. parent::ensureConsistency()),
	 * in case your model changes.
	 *
	 * @throws     PropelException
	 */
	public function ensureConsistency()
	{

		if ($this->aProjects !== null && $this->projects_id !== $this->aProjects->getId()) {
			$this->aProjects = null;
		}
		if ($this->aTasksStatus !== null && $this->tasks_status_id !== $this->aTasksStatus->getId()) {
			$this->aTasksStatus = null;
		}
		if ($this->aTasksPriority !== null && $this->tasks_priority_id !== $this->aTasksPriority->getId()) {
			$this->aTasksPriority = null;
		}
		if ($this->aTasksTypes !== null && $this->tasks_type_id !== $this->aTasksTypes->getId()) {
			$this->aTasksTypes = null;
		}
		if ($this->aTasksLabels !== null && $this->tasks_label_id !== $this->aTasksLabels->getId()) {
			$this->aTasksLabels = null;
		}
		if ($this->aTasksGroups !== null && $this->tasks_groups_id !== $this->aTasksGroups->getId()) {
			$this->aTasksGroups = null;
		}
		if ($this->aProjectsPhases !== null && $this->projects_phases_id !== $this->aProjectsPhases->getId()) {
			$this->aProjectsPhases = null;
		}
		if ($this->aVersions !== null && $this->versions_id !== $this->aVersions->getId()) {
			$this->aVersions = null;
		}
		if ($this->aUsers !== null && $this->created_by !== $this->aUsers->getId()) {
			$this->aUsers = null;
		}
		if ($this->aTickets !== null && $this->tickets_id !== $this->aTickets->getId()) {
			$this->aTickets = null;
		}
	} // ensureConsistency

	/**
	 * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
	 *
	 * This will only work if the object has been saved and has a valid primary key set.
	 *
	 * @param      boolean $deep (optional) Whether to also de-associated any related objects.
	 * @param      PropelPDO $con (optional) The PropelPDO connection to use.
	 * @return     void
	 * @throws     PropelException - if this object is deleted, unsaved or doesn't have pk match in db
	 */
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(TasksPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

		// We don't need to alter the object instance pool; we're just modifying this instance
		// already in the pool.

		$stmt = TasksPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); // rehydrate

		if ($deep) {  // also de-associate any related objects?

			$this->aProjects = null;
			$this->aTasksStatus = null;
			$this->aTasksPriority = null;
			$this->aTasksTypes = null;
			$this->aTasksLabels = null;
			$this->aTasksGroups = null;
			$this->aProjectsPhases = null;
			$this->aVersions = null;
			$this->aUsers = null;
			$this->aTickets = null;
			$this->collTasksCommentss = null;
			$this->lastTasksCommentsCriteria = null;

		} // if (deep)
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param      PropelPDO $con
	 * @return     void
	 * @throws     PropelException
	 * @see        BaseObject::setDeleted()
	 * @see        BaseObject::isDeleted()
	 */
	public function delete(PropelPDO $con = null)
	{

    foreach (sfMixer::getCallables('BaseTasks:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(TasksPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			TasksPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseTasks:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	/**
	 * Persists this object to the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All modified related objects will also be persisted in the doSave()
	 * method.  This method wraps all precipitate database operations in a
	 * single transaction.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        doSave()
	 */
	public function save(PropelPDO $con = null)
	{

    foreach (sfMixer::getCallables('BaseTasks:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


    if ($this->isNew() && !$this->isColumnModified(TasksPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(TasksPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseTasks:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			TasksPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	/**
	 * Performs the work of inserting or updating the row in the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        save()
	 */
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aProjects !== null) {
				if ($this->aProjects->isModified() || $this->aProjects->isNew()) {
					$affectedRows += $this->aProjects->save($con);
				}
				$this->setProjects($this->aProjects);
			}

			if ($this->aTasksStatus !== null) {
				if ($this->aTasksStatus->isModified() || $this->aTasksStatus->isNew()) {
					$affectedRows += $this->aTasksStatus->save($con);
				}
				$this->setTasksStatus($this->aTasksStatus);
			}

			if ($this->aTasksPriority !== null) {
				if ($this->aTasksPriority->isModified() || $this->aTasksPriority->isNew()) {
					$affectedRows += $this->aTasksPriority->save($con);
				}
				$this->setTasksPriority($this->aTasksPriority);
			}

			if ($this->aTasksTypes !== null) {
				if ($this->aTasksTypes->isModified() || $this->aTasksTypes->isNew()) {
					$affectedRows += $this->aTasksTypes->save($con);
				}
				$this->setTasksTypes($this->aTasksTypes);
			}

			if ($this->aTasksLabels !== null) {
				if ($this->aTasksLabels->isModified() || $this->aTasksLabels->isNew()) {
					$affectedRows += $this->aTasksLabels->save($con);
				}
				$this->setTasksLabels($this->aTasksLabels);
			}

			if ($this->aTasksGroups !== null) {
				if ($this->aTasksGroups->isModified() || $this->aTasksGroups->isNew()) {
					$affectedRows += $this->aTasksGroups->save($con);
				}
				$this->setTasksGroups($this->aTasksGroups);
			}

			if ($this->aProjectsPhases !== null) {
				if ($this->aProjectsPhases->isModified() || $this->aProjectsPhases->isNew()) {
					$affectedRows += $this->aProjectsPhases->save($con);
				}
				$this->setProjectsPhases($this->aProjectsPhases);
			}

			if ($this->aVersions !== null) {
				if ($this->aVersions->isModified() || $this->aVersions->isNew()) {
					$affectedRows += $this->aVersions->save($con);
				}
				$this->setVersions($this->aVersions);
			}

			if ($this->aUsers !== null) {
				if ($this->aUsers->isModified() || $this->aUsers->isNew()) {
					$affectedRows += $this->aUsers->save($con);
				}
				$this->setUsers($this->aUsers);
			}

			if ($this->aTickets !== null) {
				if ($this->aTickets->isModified() || $this->aTickets->isNew()) {
					$affectedRows += $this->aTickets->save($con);
				}
				$this->setTickets($this->aTickets);
			}

			if ($this->isNew() ) {
				$this->modifiedColumns[] = TasksPeer::ID;
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = TasksPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which
										 // should always be true here (even though technically
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setId($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += TasksPeer::doUpdate($this, $con);
				}

				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			if ($this->collTasksCommentss !== null) {
				foreach ($this->collTasksCommentss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var        array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return     array ValidationFailed[]
	 * @see        validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param      mixed $columns Column name or an array of column names.
	 * @return     boolean Whether all columns pass validation.
	 * @see        doValidate()
	 * @see        getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param      array $columns Array of column names to validate.
	 * @return     mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aProjects !== null) {
				if (!$this->aProjects->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aProjects->getValidationFailures());
				}
			}

			if ($this->aTasksStatus !== null) {
				if (!$this->aTasksStatus->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aTasksStatus->getValidationFailures());
				}
			}

			if ($this->aTasksPriority !== null) {
				if (!$this->aTasksPriority->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aTasksPriority->getValidationFailures());
				}
			}

			if ($this->aTasksTypes !== null) {
				if (!$this->aTasksTypes->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aTasksTypes->getValidationFailures());
				}
			}

			if ($this->aTasksLabels !== null) {
				if (!$this->aTasksLabels->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aTasksLabels->getValidationFailures());
				}
			}

			if ($this->aTasksGroups !== null) {
				if (!$this->aTasksGroups->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aTasksGroups->getValidationFailures());
				}
			}

			if ($this->aProjectsPhases !== null) {
				if (!$this->aProjectsPhases->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aProjectsPhases->getValidationFailures());
				}
			}

			if ($this->aVersions !== null) {
				if (!$this->aVersions->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aVersions->getValidationFailures());
				}
			}

			if ($this->aUsers !== null) {
				if (!$this->aUsers->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUsers->getValidationFailures());
				}
			}

			if ($this->aTickets !== null) {
				if (!$this->aTickets->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aTickets->getValidationFailures());
				}
			}


			if (($retval = TasksPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collTasksCommentss !== null) {
					foreach ($this->collTasksCommentss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param      string $name name
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = TasksPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @return     mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getProjectsId();
				break;
			case 2:
				return $this->getTasksStatusId();
				break;
			case 3:
				return $this->getTasksPriorityId();
				break;
			case 4:
				return $this->getTasksTypeId();
				break;
			case 5:
				return $this->getTasksLabelId();
				break;
			case 6:
				return $this->getTasksGroupsId();
				break;
			case 7:
				return $this->getProjectsPhasesId();
				break;
			case 8:
				return $this->getVersionsId();
				break;
			case 9:
				return $this->getCreatedBy();
				break;
			case 10:
				return $this->getName();
				break;
			case 11:
				return $this->getDescription();
				break;
			case 12:
				return $this->getAssignedTo();
				break;
			case 13:
				return $this->getEstimatedTime();
				break;
			case 14:
				return $this->getDueDate();
				break;
			case 15:
				return $this->getCreatedAt();
				break;
			case 16:
				return $this->getTicketsId();
				break;
			case 17:
				return $this->getClosedDate();
				break;
			case 18:
				return $this->getDiscussionId();
				break;
			case 19:
				return $this->getStartDate();
				break;
			case 20:
				return $this->getProgress();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param      string $keyType (optional) One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                        BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM. Defaults to BasePeer::TYPE_PHPNAME.
	 * @param      boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns.  Defaults to TRUE.
	 * @return     an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = TasksPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getProjectsId(),
			$keys[2] => $this->getTasksStatusId(),
			$keys[3] => $this->getTasksPriorityId(),
			$keys[4] => $this->getTasksTypeId(),
			$keys[5] => $this->getTasksLabelId(),
			$keys[6] => $this->getTasksGroupsId(),
			$keys[7] => $this->getProjectsPhasesId(),
			$keys[8] => $this->getVersionsId(),
			$keys[9] => $this->getCreatedBy(),
			$keys[10] => $this->getName(),
			$keys[11] => $this->getDescription(),
			$keys[12] => $this->getAssignedTo(),
			$keys[13] => $this->getEstimatedTime(),
			$keys[14] => $this->getDueDate(),
			$keys[15] => $this->getCreatedAt(),
			$keys[16] => $this->getTicketsId(),
			$keys[17] => $this->getClosedDate(),
			$keys[18] => $this->getDiscussionId(),
			$keys[19] => $this->getStartDate(),
			$keys[20] => $this->getProgress(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param      string $name peer name
	 * @param      mixed $value field value
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = TasksPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @param      mixed $value field value
	 * @return     void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setProjectsId($value);
				break;
			case 2:
				$this->setTasksStatusId($value);
				break;
			case 3:
				$this->setTasksPriorityId($value);
				break;
			case 4:
				$this->setTasksTypeId($value);
				break;
			case 5:
				$this->setTasksLabelId($value);
				break;
			case 6:
				$this->setTasksGroupsId($value);
				break;
			case 7:
				$this->setProjectsPhasesId($value);
				break;
			case 8:
				$this->setVersionsId($value);
				break;
			case 9:
				$this->setCreatedBy($value);
				break;
			case 10:
				$this->setName($value);
				break;
			case 11:
				$this->setDescription($value);
				break;
			case 12:
				$this->setAssignedTo($value);
				break;
			case 13:
				$this->setEstimatedTime($value);
				break;
			case 14:
				$this->setDueDate($value);
				break;
			case 15:
				$this->setCreatedAt($value);
				break;
			case 16:
				$this->setTicketsId($value);
				break;
			case 17:
				$this->setClosedDate($value);
				break;
			case 18:
				$this->setDiscussionId($value);
				break;
			case 19:
				$this->setStartDate($value);
				break;
			case 20:
				$this->setProgress($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
	 * BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
	 * The default key type is the column's phpname (e.g. 'AuthorId')
	 *
	 * @param      array  $arr     An array to populate the object from.
	 * @param      string $keyType The type of keys the array uses.
	 * @return     void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = TasksPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setProjectsId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setTasksStatusId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setTasksPriorityId($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setTasksTypeId($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setTasksLabelId($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setTasksGroupsId($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setProjectsPhasesId($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setVersionsId($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setCreatedBy($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setName($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setDescription($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setAssignedTo($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setEstimatedTime($arr[$keys[13]]);
		if (array_key_exists($keys[14], $arr)) $this->setDueDate($arr[$keys[14]]);
		if (array_key_exists($keys[15], $arr)) $this->setCreatedAt($arr[$keys[15]]);
		if (array_key_exists($keys[16], $arr)) $this->setTicketsId($arr[$keys[16]]);
		if (array_key_exists($keys[17], $arr)) $this->setClosedDate($arr[$keys[17]]);
		if (array_key_exists($keys[18], $arr)) $this->setDiscussionId($arr[$keys[18]]);
		if (array_key_exists($keys[19], $arr)) $this->setStartDate($arr[$keys[19]]);
		if (array_key_exists($keys[20], $arr)) $this->setProgress($arr[$keys[20]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return     Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(TasksPeer::DATABASE_NAME);

		if ($this->isColumnModified(TasksPeer::ID)) $criteria->add(TasksPeer::ID, $this->id);
		if ($this->isColumnModified(TasksPeer::PROJECTS_ID)) $criteria->add(TasksPeer::PROJECTS_ID, $this->projects_id);
		if ($this->isColumnModified(TasksPeer::TASKS_STATUS_ID)) $criteria->add(TasksPeer::TASKS_STATUS_ID, $this->tasks_status_id);
		if ($this->isColumnModified(TasksPeer::TASKS_PRIORITY_ID)) $criteria->add(TasksPeer::TASKS_PRIORITY_ID, $this->tasks_priority_id);
		if ($this->isColumnModified(TasksPeer::TASKS_TYPE_ID)) $criteria->add(TasksPeer::TASKS_TYPE_ID, $this->tasks_type_id);
		if ($this->isColumnModified(TasksPeer::TASKS_LABEL_ID)) $criteria->add(TasksPeer::TASKS_LABEL_ID, $this->tasks_label_id);
		if ($this->isColumnModified(TasksPeer::TASKS_GROUPS_ID)) $criteria->add(TasksPeer::TASKS_GROUPS_ID, $this->tasks_groups_id);
		if ($this->isColumnModified(TasksPeer::PROJECTS_PHASES_ID)) $criteria->add(TasksPeer::PROJECTS_PHASES_ID, $this->projects_phases_id);
		if ($this->isColumnModified(TasksPeer::VERSIONS_ID)) $criteria->add(TasksPeer::VERSIONS_ID, $this->versions_id);
		if ($this->isColumnModified(TasksPeer::CREATED_BY)) $criteria->add(TasksPeer::CREATED_BY, $this->created_by);
		if ($this->isColumnModified(TasksPeer::NAME)) $criteria->add(TasksPeer::NAME, $this->name);
		if ($this->isColumnModified(TasksPeer::DESCRIPTION)) $criteria->add(TasksPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(TasksPeer::ASSIGNED_TO)) $criteria->add(TasksPeer::ASSIGNED_TO, $this->assigned_to);
		if ($this->isColumnModified(TasksPeer::ESTIMATED_TIME)) $criteria->add(TasksPeer::ESTIMATED_TIME, $this->estimated_time);
		if ($this->isColumnModified(TasksPeer::DUE_DATE)) $criteria->add(TasksPeer::DUE_DATE, $this->due_date);
		if ($this->isColumnModified(TasksPeer::CREATED_AT)) $criteria->add(TasksPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(TasksPeer::TICKETS_ID)) $criteria->add(TasksPeer::TICKETS_ID, $this->tickets_id);
		if ($this->isColumnModified(TasksPeer::CLOSED_DATE)) $criteria->add(TasksPeer::CLOSED_DATE, $this->closed_date);
		if ($this->isColumnModified(TasksPeer::DISCUSSION_ID)) $criteria->add(TasksPeer::DISCUSSION_ID, $this->discussion_id);
		if ($this->isColumnModified(TasksPeer::START_DATE)) $criteria->add(TasksPeer::START_DATE, $this->start_date);
		if ($this->isColumnModified(TasksPeer::PROGRESS)) $criteria->add(TasksPeer::PROGRESS, $this->progress);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return     Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(TasksPeer::DATABASE_NAME);

		$criteria->add(TasksPeer::ID, $this->id);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return     int
	 */
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	/**
	 * Generic method to set the primary key (id column).
	 *
	 * @param      int $key Primary key.
	 * @return     void
	 */
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      object $copyObj An object of Tasks (or compatible) type.
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws     PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setProjectsId($this->projects_id);

		$copyObj->setTasksStatusId($this->tasks_status_id);

		$copyObj->setTasksPriorityId($this->tasks_priority_id);

		$copyObj->setTasksTypeId($this->tasks_type_id);

		$copyObj->setTasksLabelId($this->tasks_label_id);

		$copyObj->setTasksGroupsId($this->tasks_groups_id);

		$copyObj->setProjectsPhasesId($this->projects_phases_id);

		$copyObj->setVersionsId($this->versions_id);

		$copyObj->setCreatedBy($this->created_by);

		$copyObj->setName($this->name);

		$copyObj->setDescription($this->description);

		$copyObj->setAssignedTo($this->assigned_to);

		$copyObj->setEstimatedTime($this->estimated_time);

		$copyObj->setDueDate($this->due_date);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setTicketsId($this->tickets_id);

		$copyObj->setClosedDate($this->closed_date);

		$copyObj->setDiscussionId($this->discussion_id);

		$copyObj->setStartDate($this->start_date);

		$copyObj->setProgress($this->progress);


		if ($deepCopy) {
			// important: temporarily setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach ($this->getTasksCommentss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addTasksComments($relObj->copy($deepCopy));
				}
			}

		} // if ($deepCopy)


		$copyObj->setNew(true);

		$copyObj->setId(NULL); // this is a auto-increment column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return     Tasks Clone of current object.
	 * @throws     PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return     TasksPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new TasksPeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a Projects object.
	 *
	 * @param      Projects $v
	 * @return     Tasks The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setProjects(Projects $v = null)
	{
		if ($v === null) {
			$this->setProjectsId(0);
		} else {
			$this->setProjectsId($v->getId());
		}

		$this->aProjects = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the Projects object, it will not be re-added.
		if ($v !== null) {
			$v->addTasks($this);
		}

		return $this;
	}


	/**
	 * Get the associated Projects object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     Projects The associated Projects object.
	 * @throws     PropelException
	 */
	public function getProjects(PropelPDO $con = null)
	{
		if ($this->aProjects === null && ($this->projects_id !== null)) {
			$c = new Criteria(ProjectsPeer::DATABASE_NAME);
			$c->add(ProjectsPeer::ID, $this->projects_id);
			$this->aProjects = ProjectsPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aProjects->addTaskss($this);
			 */
		}
		return $this->aProjects;
	}

	/**
	 * Declares an association between this object and a TasksStatus object.
	 *
	 * @param      TasksStatus $v
	 * @return     Tasks The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setTasksStatus(TasksStatus $v = null)
	{
		if ($v === null) {
			$this->setTasksStatusId(NULL);
		} else {
			$this->setTasksStatusId($v->getId());
		}

		$this->aTasksStatus = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the TasksStatus object, it will not be re-added.
		if ($v !== null) {
			$v->addTasks($this);
		}

		return $this;
	}


	/**
	 * Get the associated TasksStatus object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     TasksStatus The associated TasksStatus object.
	 * @throws     PropelException
	 */
	public function getTasksStatus(PropelPDO $con = null)
	{
		if ($this->aTasksStatus === null && ($this->tasks_status_id !== null)) {
			$c = new Criteria(TasksStatusPeer::DATABASE_NAME);
			$c->add(TasksStatusPeer::ID, $this->tasks_status_id);
			$this->aTasksStatus = TasksStatusPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aTasksStatus->addTaskss($this);
			 */
		}
		return $this->aTasksStatus;
	}

	/**
	 * Declares an association between this object and a TasksPriority object.
	 *
	 * @param      TasksPriority $v
	 * @return     Tasks The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setTasksPriority(TasksPriority $v = null)
	{
		if ($v === null) {
			$this->setTasksPriorityId(NULL);
		} else {
			$this->setTasksPriorityId($v->getId());
		}

		$this->aTasksPriority = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the TasksPriority object, it will not be re-added.
		if ($v !== null) {
			$v->addTasks($this);
		}

		return $this;
	}


	/**
	 * Get the associated TasksPriority object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     TasksPriority The associated TasksPriority object.
	 * @throws     PropelException
	 */
	public function getTasksPriority(PropelPDO $con = null)
	{
		if ($this->aTasksPriority === null && ($this->tasks_priority_id !== null)) {
			$c = new Criteria(TasksPriorityPeer::DATABASE_NAME);
			$c->add(TasksPriorityPeer::ID, $this->tasks_priority_id);
			$this->aTasksPriority = TasksPriorityPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aTasksPriority->addTaskss($this);
			 */
		}
		return $this->aTasksPriority;
	}

	/**
	 * Declares an association between this object and a TasksTypes object.
	 *
	 * @param      TasksTypes $v
	 * @return     Tasks The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setTasksTypes(TasksTypes $v = null)
	{
		if ($v === null) {
			$this->setTasksTypeId(NULL);
		} else {
			$this->setTasksTypeId($v->getId());
		}

		$this->aTasksTypes = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the TasksTypes object, it will not be re-added.
		if ($v !== null) {
			$v->addTasks($this);
		}

		return $this;
	}


	/**
	 * Get the associated TasksTypes object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     TasksTypes The associated TasksTypes object.
	 * @throws     PropelException
	 */
	public function getTasksTypes(PropelPDO $con = null)
	{
		if ($this->aTasksTypes === null && ($this->tasks_type_id !== null)) {
			$c = new Criteria(TasksTypesPeer::DATABASE_NAME);
			$c->add(TasksTypesPeer::ID, $this->tasks_type_id);
			$this->aTasksTypes = TasksTypesPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aTasksTypes->addTaskss($this);
			 */
		}
		return $this->aTasksTypes;
	}

	/**
	 * Declares an association between this object and a TasksLabels object.
	 *
	 * @param      TasksLabels $v
	 * @return     Tasks The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setTasksLabels(TasksLabels $v = null)
	{
		if ($v === null) {
			$this->setTasksLabelId(NULL);
		} else {
			$this->setTasksLabelId($v->getId());
		}

		$this->aTasksLabels = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the TasksLabels object, it will not be re-added.
		if ($v !== null) {
			$v->addTasks($this);
		}

		return $this;
	}


	/**
	 * Get the associated TasksLabels object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     TasksLabels The associated TasksLabels object.
	 * @throws     PropelException
	 */
	public function getTasksLabels(PropelPDO $con = null)
	{
		if ($this->aTasksLabels === null && ($this->tasks_label_id !== null)) {
			$c = new Criteria(TasksLabelsPeer::DATABASE_NAME);
			$c->add(TasksLabelsPeer::ID, $this->tasks_label_id);
			$this->aTasksLabels = TasksLabelsPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aTasksLabels->addTaskss($this);
			 */
		}
		return $this->aTasksLabels;
	}

	/**
	 * Declares an association between this object and a TasksGroups object.
	 *
	 * @param      TasksGroups $v
	 * @return     Tasks The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setTasksGroups(TasksGroups $v = null)
	{
		if ($v === null) {
			$this->setTasksGroupsId(NULL);
		} else {
			$this->setTasksGroupsId($v->getId());
		}

		$this->aTasksGroups = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the TasksGroups object, it will not be re-added.
		if ($v !== null) {
			$v->addTasks($this);
		}

		return $this;
	}


	/**
	 * Get the associated TasksGroups object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     TasksGroups The associated TasksGroups object.
	 * @throws     PropelException
	 */
	public function getTasksGroups(PropelPDO $con = null)
	{
		if ($this->aTasksGroups === null && ($this->tasks_groups_id !== null)) {
			$c = new Criteria(TasksGroupsPeer::DATABASE_NAME);
			$c->add(TasksGroupsPeer::ID, $this->tasks_groups_id);
			$this->aTasksGroups = TasksGroupsPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aTasksGroups->addTaskss($this);
			 */
		}
		return $this->aTasksGroups;
	}

	/**
	 * Declares an association between this object and a ProjectsPhases object.
	 *
	 * @param      ProjectsPhases $v
	 * @return     Tasks The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setProjectsPhases(ProjectsPhases $v = null)
	{
		if ($v === null) {
			$this->setProjectsPhasesId(NULL);
		} else {
			$this->setProjectsPhasesId($v->getId());
		}

		$this->aProjectsPhases = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the ProjectsPhases object, it will not be re-added.
		if ($v !== null) {
			$v->addTasks($this);
		}

		return $this;
	}


	/**
	 * Get the associated ProjectsPhases object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     ProjectsPhases The associated ProjectsPhases object.
	 * @throws     PropelException
	 */
	public function getProjectsPhases(PropelPDO $con = null)
	{
		if ($this->aProjectsPhases === null && ($this->projects_phases_id !== null)) {
			$c = new Criteria(ProjectsPhasesPeer::DATABASE_NAME);
			$c->add(ProjectsPhasesPeer::ID, $this->projects_phases_id);
			$this->aProjectsPhases = ProjectsPhasesPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aProjectsPhases->addTaskss($this);
			 */
		}
		return $this->aProjectsPhases;
	}

	/**
	 * Declares an association between this object and a Versions object.
	 *
	 * @param      Versions $v
	 * @return     Tasks The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setVersions(Versions $v = null)
	{
		if ($v === null) {
			$this->setVersionsId(NULL);
		} else {
			$this->setVersionsId($v->getId());
		}

		$this->aVersions = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the Versions object, it will not be re-added.
		if ($v !== null) {
			$v->addTasks($this);
		}

		return $this;
	}


	/**
	 * Get the associated Versions object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     Versions The associated Versions object.
	 * @throws     PropelException
	 */
	public function getVersions(PropelPDO $con = null)
	{
		if ($this->aVersions === null && ($this->versions_id !== null)) {
			$c = new Criteria(VersionsPeer::DATABASE_NAME);
			$c->add(VersionsPeer::ID, $this->versions_id);
			$this->aVersions = VersionsPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aVersions->addTaskss($this);
			 */
		}
		return $this->aVersions;
	}

	/**
	 * Declares an association between this object and a Users object.
	 *
	 * @param      Users $v
	 * @return     Tasks The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setUsers(Users $v = null)
	{
		if ($v === null) {
			$this->setCreatedBy(NULL);
		} else {
			$this->setCreatedBy($v->getId());
		}

		$this->aUsers = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the Users object, it will not be re-added.
		if ($v !== null) {
			$v->addTasks($this);
		}

		return $this;
	}


	/**
	 * Get the associated Users object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     Users The associated Users object.
	 * @throws     PropelException
	 */
	public function getUsers(PropelPDO $con = null)
	{
		if ($this->aUsers === null && ($this->created_by !== null)) {
			$c = new Criteria(UsersPeer::DATABASE_NAME);
			$c->add(UsersPeer::ID, $this->created_by);
			$this->aUsers = UsersPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aUsers->addTaskss($this);
			 */
		}
		return $this->aUsers;
	}

	/**
	 * Declares an association between this object and a Tickets object.
	 *
	 * @param      Tickets $v
	 * @return     Tasks The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setTickets(Tickets $v = null)
	{
		if ($v === null) {
			$this->setTicketsId(NULL);
		} else {
			$this->setTicketsId($v->getId());
		}

		$this->aTickets = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the Tickets object, it will not be re-added.
		if ($v !== null) {
			$v->addTasks($this);
		}

		return $this;
	}


	/**
	 * Get the associated Tickets object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     Tickets The associated Tickets object.
	 * @throws     PropelException
	 */
	public function getTickets(PropelPDO $con = null)
	{
		if ($this->aTickets === null && ($this->tickets_id !== null)) {
			$c = new Criteria(TicketsPeer::DATABASE_NAME);
			$c->add(TicketsPeer::ID, $this->tickets_id);
			$this->aTickets = TicketsPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aTickets->addTaskss($this);
			 */
		}
		return $this->aTickets;
	}

	/**
	 * Clears out the collTasksCommentss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addTasksCommentss()
	 */
	public function clearTasksCommentss()
	{
		$this->collTasksCommentss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collTasksCommentss collection (array).
	 *
	 * By default this just sets the collTasksCommentss collection to an empty array (like clearcollTasksCommentss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initTasksCommentss()
	{
		$this->collTasksCommentss = array();
	}

	/**
	 * Gets an array of TasksComments objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Tasks has previously been saved, it will retrieve
	 * related TasksCommentss from storage. If this Tasks is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array TasksComments[]
	 * @throws     PropelException
	 */
	public function getTasksCommentss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TasksPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTasksCommentss === null) {
			if ($this->isNew()) {
			   $this->collTasksCommentss = array();
			} else {

				$criteria->add(TasksCommentsPeer::TASKS_ID, $this->id);

				TasksCommentsPeer::addSelectColumns($criteria);
				$this->collTasksCommentss = TasksCommentsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(TasksCommentsPeer::TASKS_ID, $this->id);

				TasksCommentsPeer::addSelectColumns($criteria);
				if (!isset($this->lastTasksCommentsCriteria) || !$this->lastTasksCommentsCriteria->equals($criteria)) {
					$this->collTasksCommentss = TasksCommentsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTasksCommentsCriteria = $criteria;
		return $this->collTasksCommentss;
	}

	/**
	 * Returns the number of related TasksComments objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related TasksComments objects.
	 * @throws     PropelException
	 */
	public function countTasksCommentss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TasksPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collTasksCommentss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(TasksCommentsPeer::TASKS_ID, $this->id);

				$count = TasksCommentsPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(TasksCommentsPeer::TASKS_ID, $this->id);

				if (!isset($this->lastTasksCommentsCriteria) || !$this->lastTasksCommentsCriteria->equals($criteria)) {
					$count = TasksCommentsPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collTasksCommentss);
				}
			} else {
				$count = count($this->collTasksCommentss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a TasksComments object to this object
	 * through the TasksComments foreign key attribute.
	 *
	 * @param      TasksComments $l TasksComments
	 * @return     void
	 * @throws     PropelException
	 */
	public function addTasksComments(TasksComments $l)
	{
		if ($this->collTasksCommentss === null) {
			$this->initTasksCommentss();
		}
		if (!in_array($l, $this->collTasksCommentss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collTasksCommentss, $l);
			$l->setTasks($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tasks is new, it will return
	 * an empty collection; or if this Tasks has previously
	 * been saved, it will retrieve related TasksCommentss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tasks.
	 */
	public function getTasksCommentssJoinUsers($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TasksPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTasksCommentss === null) {
			if ($this->isNew()) {
				$this->collTasksCommentss = array();
			} else {

				$criteria->add(TasksCommentsPeer::TASKS_ID, $this->id);

				$this->collTasksCommentss = TasksCommentsPeer::doSelectJoinUsers($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksCommentsPeer::TASKS_ID, $this->id);

			if (!isset($this->lastTasksCommentsCriteria) || !$this->lastTasksCommentsCriteria->equals($criteria)) {
				$this->collTasksCommentss = TasksCommentsPeer::doSelectJoinUsers($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCommentsCriteria = $criteria;

		return $this->collTasksCommentss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tasks is new, it will return
	 * an empty collection; or if this Tasks has previously
	 * been saved, it will retrieve related TasksCommentss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tasks.
	 */
	public function getTasksCommentssJoinTasksStatus($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TasksPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTasksCommentss === null) {
			if ($this->isNew()) {
				$this->collTasksCommentss = array();
			} else {

				$criteria->add(TasksCommentsPeer::TASKS_ID, $this->id);

				$this->collTasksCommentss = TasksCommentsPeer::doSelectJoinTasksStatus($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksCommentsPeer::TASKS_ID, $this->id);

			if (!isset($this->lastTasksCommentsCriteria) || !$this->lastTasksCommentsCriteria->equals($criteria)) {
				$this->collTasksCommentss = TasksCommentsPeer::doSelectJoinTasksStatus($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCommentsCriteria = $criteria;

		return $this->collTasksCommentss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tasks is new, it will return
	 * an empty collection; or if this Tasks has previously
	 * been saved, it will retrieve related TasksCommentss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tasks.
	 */
	public function getTasksCommentssJoinTasksPriority($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TasksPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTasksCommentss === null) {
			if ($this->isNew()) {
				$this->collTasksCommentss = array();
			} else {

				$criteria->add(TasksCommentsPeer::TASKS_ID, $this->id);

				$this->collTasksCommentss = TasksCommentsPeer::doSelectJoinTasksPriority($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksCommentsPeer::TASKS_ID, $this->id);

			if (!isset($this->lastTasksCommentsCriteria) || !$this->lastTasksCommentsCriteria->equals($criteria)) {
				$this->collTasksCommentss = TasksCommentsPeer::doSelectJoinTasksPriority($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCommentsCriteria = $criteria;

		return $this->collTasksCommentss;
	}

	/**
	 * Resets all collections of referencing foreign keys.
	 *
	 * This method is a user-space workaround for PHP's inability to garbage collect objects
	 * with circular references.  This is currently necessary when using Propel in certain
	 * daemon or large-volumne/high-memory operations.
	 *
	 * @param      boolean $deep Whether to also clear the references on all associated objects.
	 */
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collTasksCommentss) {
				foreach ((array) $this->collTasksCommentss as $o) {
					$o->clearAllReferences($deep);
				}
			}
		} // if ($deep)

		$this->collTasksCommentss = null;
			$this->aProjects = null;
			$this->aTasksStatus = null;
			$this->aTasksPriority = null;
			$this->aTasksTypes = null;
			$this->aTasksLabels = null;
			$this->aTasksGroups = null;
			$this->aProjectsPhases = null;
			$this->aVersions = null;
			$this->aUsers = null;
			$this->aTickets = null;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseTasks:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseTasks::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} // BaseTasks
