<?php

/**
 * Base class that represents a row from the 'tasks_comments' table.
 *
 * 
 *
 * This class was autogenerated by Propel 1.3.0-dev on:
 *
 * 10/01/11 13:54:40
 *
 * @package    lib.model.om
 */
abstract class BaseTasksComments extends BaseObject  implements Persistent {


  const PEER = 'TasksCommentsPeer';

	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var        TasksCommentsPeer
	 */
	protected static $peer;

	/**
	 * The value for the id field.
	 * @var        int
	 */
	protected $id;

	/**
	 * The value for the tasks_id field.
	 * Note: this column has a database default value of: 0
	 * @var        int
	 */
	protected $tasks_id;

	/**
	 * The value for the created_by field.
	 * @var        int
	 */
	protected $created_by;

	/**
	 * The value for the tasks_status_id field.
	 * @var        int
	 */
	protected $tasks_status_id;

	/**
	 * The value for the tasks_priority_id field.
	 * @var        int
	 */
	protected $tasks_priority_id;

	/**
	 * The value for the due_date field.
	 * @var        string
	 */
	protected $due_date;

	/**
	 * The value for the worked_hours field.
	 * @var        double
	 */
	protected $worked_hours;

	/**
	 * The value for the description field.
	 * @var        string
	 */
	protected $description;

	/**
	 * The value for the created_at field.
	 * @var        string
	 */
	protected $created_at;

	/**
	 * The value for the progress field.
	 * @var        int
	 */
	protected $progress;

	/**
	 * @var        Tasks
	 */
	protected $aTasks;

	/**
	 * @var        Users
	 */
	protected $aUsers;

	/**
	 * @var        TasksStatus
	 */
	protected $aTasksStatus;

	/**
	 * @var        TasksPriority
	 */
	protected $aTasksPriority;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInValidation = false;

	/**
	 * Initializes internal state of BaseTasksComments object.
	 * @see        applyDefaults()
	 */
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	/**
	 * Applies default values to this object.
	 * This method should be called from the object's constructor (or
	 * equivalent initialization method).
	 * @see        __construct()
	 */
	public function applyDefaultValues()
	{
		$this->tasks_id = 0;
	}

	/**
	 * Get the [id] column value.
	 * 
	 * @return     int
	 */
	public function getId()
	{
		return $this->id;
	}

	/**
	 * Get the [tasks_id] column value.
	 * 
	 * @return     int
	 */
	public function getTasksId()
	{
		return $this->tasks_id;
	}

	/**
	 * Get the [created_by] column value.
	 * 
	 * @return     int
	 */
	public function getCreatedBy()
	{
		return $this->created_by;
	}

	/**
	 * Get the [tasks_status_id] column value.
	 * 
	 * @return     int
	 */
	public function getTasksStatusId()
	{
		return $this->tasks_status_id;
	}

	/**
	 * Get the [tasks_priority_id] column value.
	 * 
	 * @return     int
	 */
	public function getTasksPriorityId()
	{
		return $this->tasks_priority_id;
	}

	/**
	 * Get the [optionally formatted] temporal [due_date] column value.
	 * 
	 *
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the raw DateTime object will be returned.
	 * @return     mixed Formatted date/time value as string or DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00
	 * @throws     PropelException - if unable to parse/validate the date/time value.
	 */
	public function getDueDate($format = 'Y-m-d')
	{
		if ($this->due_date === null) {
			return null;
		}


		if ($this->due_date === '0000-00-00') {
			// while technically this is not a default value of NULL,
			// this seems to be closest in meaning.
			return null;
		} else {
			try {
				$dt = new DateTime($this->due_date);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->due_date, true), $x);
			}
		}

		if ($format === null) {
			// Because propel.useDateTimeClass is TRUE, we return a DateTime object.
			return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	/**
	 * Get the [worked_hours] column value.
	 * 
	 * @return     double
	 */
	public function getWorkedHours()
	{
		return $this->worked_hours;
	}

	/**
	 * Get the [description] column value.
	 * 
	 * @return     string
	 */
	public function getDescription()
	{
		return $this->description;
	}

	/**
	 * Get the [optionally formatted] temporal [created_at] column value.
	 * 
	 *
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the raw DateTime object will be returned.
	 * @return     mixed Formatted date/time value as string or DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00 00:00:00
	 * @throws     PropelException - if unable to parse/validate the date/time value.
	 */
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->created_at === null) {
			return null;
		}


		if ($this->created_at === '0000-00-00 00:00:00') {
			// while technically this is not a default value of NULL,
			// this seems to be closest in meaning.
			return null;
		} else {
			try {
				$dt = new DateTime($this->created_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->created_at, true), $x);
			}
		}

		if ($format === null) {
			// Because propel.useDateTimeClass is TRUE, we return a DateTime object.
			return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	/**
	 * Get the [progress] column value.
	 * 
	 * @return     int
	 */
	public function getProgress()
	{
		return $this->progress;
	}

	/**
	 * Set the value of [id] column.
	 * 
	 * @param      int $v new value
	 * @return     TasksComments The current object (for fluent API support)
	 */
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = TasksCommentsPeer::ID;
		}

		return $this;
	} // setId()

	/**
	 * Set the value of [tasks_id] column.
	 * 
	 * @param      int $v new value
	 * @return     TasksComments The current object (for fluent API support)
	 */
	public function setTasksId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->tasks_id !== $v || $v === 0) {
			$this->tasks_id = $v;
			$this->modifiedColumns[] = TasksCommentsPeer::TASKS_ID;
		}

		if ($this->aTasks !== null && $this->aTasks->getId() !== $v) {
			$this->aTasks = null;
		}

		return $this;
	} // setTasksId()

	/**
	 * Set the value of [created_by] column.
	 * 
	 * @param      int $v new value
	 * @return     TasksComments The current object (for fluent API support)
	 */
	public function setCreatedBy($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->created_by !== $v) {
			$this->created_by = $v;
			$this->modifiedColumns[] = TasksCommentsPeer::CREATED_BY;
		}

		if ($this->aUsers !== null && $this->aUsers->getId() !== $v) {
			$this->aUsers = null;
		}

		return $this;
	} // setCreatedBy()

	/**
	 * Set the value of [tasks_status_id] column.
	 * 
	 * @param      int $v new value
	 * @return     TasksComments The current object (for fluent API support)
	 */
	public function setTasksStatusId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->tasks_status_id !== $v) {
			$this->tasks_status_id = $v;
			$this->modifiedColumns[] = TasksCommentsPeer::TASKS_STATUS_ID;
		}

		if ($this->aTasksStatus !== null && $this->aTasksStatus->getId() !== $v) {
			$this->aTasksStatus = null;
		}

		return $this;
	} // setTasksStatusId()

	/**
	 * Set the value of [tasks_priority_id] column.
	 * 
	 * @param      int $v new value
	 * @return     TasksComments The current object (for fluent API support)
	 */
	public function setTasksPriorityId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->tasks_priority_id !== $v) {
			$this->tasks_priority_id = $v;
			$this->modifiedColumns[] = TasksCommentsPeer::TASKS_PRIORITY_ID;
		}

		if ($this->aTasksPriority !== null && $this->aTasksPriority->getId() !== $v) {
			$this->aTasksPriority = null;
		}

		return $this;
	} // setTasksPriorityId()

	/**
	 * Sets the value of [due_date] column to a normalized version of the date/time value specified.
	 * 
	 * @param      mixed $v string, integer (timestamp), or DateTime value.  Empty string will
	 *						be treated as NULL for temporal objects.
	 * @return     TasksComments The current object (for fluent API support)
	 */
	public function setDueDate($v)
	{
		// we treat '' as NULL for temporal objects because DateTime('') == DateTime('now')
		// -- which is unexpected, to say the least.
		if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
			// some string/numeric value passed; we normalize that so that we can
			// validate it.
			try {
				if (is_numeric($v)) { // if it's a unix timestamp
					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
					// We have to explicitly specify and then change the time zone because of a
					// DateTime bug: http://bugs.php.net/bug.php?id=43003
					$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->due_date !== null || $dt !== null ) {
			// (nested ifs are a little easier to read in this case)

			$currNorm = ($this->due_date !== null && $tmpDt = new DateTime($this->due_date)) ? $tmpDt->format('Y-m-d') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d') : null;

			if ( ($currNorm !== $newNorm) // normalized values don't match 
					)
			{
				$this->due_date = ($dt ? $dt->format('Y-m-d') : null);
				$this->modifiedColumns[] = TasksCommentsPeer::DUE_DATE;
			}
		} // if either are not null

		return $this;
	} // setDueDate()

	/**
	 * Set the value of [worked_hours] column.
	 * 
	 * @param      double $v new value
	 * @return     TasksComments The current object (for fluent API support)
	 */
	public function setWorkedHours($v)
	{
		if ($v !== null) {
			$v = (double) $v;
		}

		if ($this->worked_hours !== $v) {
			$this->worked_hours = $v;
			$this->modifiedColumns[] = TasksCommentsPeer::WORKED_HOURS;
		}

		return $this;
	} // setWorkedHours()

	/**
	 * Set the value of [description] column.
	 * 
	 * @param      string $v new value
	 * @return     TasksComments The current object (for fluent API support)
	 */
	public function setDescription($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = TasksCommentsPeer::DESCRIPTION;
		}

		return $this;
	} // setDescription()

	/**
	 * Sets the value of [created_at] column to a normalized version of the date/time value specified.
	 * 
	 * @param      mixed $v string, integer (timestamp), or DateTime value.  Empty string will
	 *						be treated as NULL for temporal objects.
	 * @return     TasksComments The current object (for fluent API support)
	 */
	public function setCreatedAt($v)
	{
		// we treat '' as NULL for temporal objects because DateTime('') == DateTime('now')
		// -- which is unexpected, to say the least.
		if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
			// some string/numeric value passed; we normalize that so that we can
			// validate it.
			try {
				if (is_numeric($v)) { // if it's a unix timestamp
					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
					// We have to explicitly specify and then change the time zone because of a
					// DateTime bug: http://bugs.php.net/bug.php?id=43003
					$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->created_at !== null || $dt !== null ) {
			// (nested ifs are a little easier to read in this case)

			$currNorm = ($this->created_at !== null && $tmpDt = new DateTime($this->created_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) // normalized values don't match 
					)
			{
				$this->created_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = TasksCommentsPeer::CREATED_AT;
			}
		} // if either are not null

		return $this;
	} // setCreatedAt()

	/**
	 * Set the value of [progress] column.
	 * 
	 * @param      int $v new value
	 * @return     TasksComments The current object (for fluent API support)
	 */
	public function setProgress($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->progress !== $v) {
			$this->progress = $v;
			$this->modifiedColumns[] = TasksCommentsPeer::PROGRESS;
		}

		return $this;
	} // setProgress()

	/**
	 * Indicates whether the columns in this object are only set to default values.
	 *
	 * This method can be used in conjunction with isModified() to indicate whether an object is both
	 * modified _and_ has some values set which are non-default.
	 *
	 * @return     boolean Whether the columns in this object are only been set with default values.
	 */
	public function hasOnlyDefaultValues()
	{
			// First, ensure that we don't have any columns that have been modified which aren't default columns.
			if (array_diff($this->modifiedColumns, array(TasksCommentsPeer::TASKS_ID))) {
				return false;
			}

			if ($this->tasks_id !== 0) {
				return false;
			}

		// otherwise, everything was equal, so return TRUE
		return true;
	} // hasOnlyDefaultValues()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (0-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param      array $row The row returned by PDOStatement->fetch(PDO::FETCH_NUM)
	 * @param      int $startcol 0-based offset column which indicates which restultset column to start with.
	 * @param      boolean $rehydrate Whether this object is being re-hydrated from the database.
	 * @return     int next starting column
	 * @throws     PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->tasks_id = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
			$this->created_by = ($row[$startcol + 2] !== null) ? (int) $row[$startcol + 2] : null;
			$this->tasks_status_id = ($row[$startcol + 3] !== null) ? (int) $row[$startcol + 3] : null;
			$this->tasks_priority_id = ($row[$startcol + 4] !== null) ? (int) $row[$startcol + 4] : null;
			$this->due_date = ($row[$startcol + 5] !== null) ? (string) $row[$startcol + 5] : null;
			$this->worked_hours = ($row[$startcol + 6] !== null) ? (double) $row[$startcol + 6] : null;
			$this->description = ($row[$startcol + 7] !== null) ? (string) $row[$startcol + 7] : null;
			$this->created_at = ($row[$startcol + 8] !== null) ? (string) $row[$startcol + 8] : null;
			$this->progress = ($row[$startcol + 9] !== null) ? (int) $row[$startcol + 9] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 10; // 10 = TasksCommentsPeer::NUM_COLUMNS - TasksCommentsPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating TasksComments object", $e);
		}
	}

	/**
	 * Checks and repairs the internal consistency of the object.
	 *
	 * This method is executed after an already-instantiated object is re-hydrated
	 * from the database.  It exists to check any foreign keys to make sure that
	 * the objects related to the current object are correct based on foreign key.
	 *
	 * You can override this method in the stub class, but you should always invoke
	 * the base method from the overridden method (i.e. parent::ensureConsistency()),
	 * in case your model changes.
	 *
	 * @throws     PropelException
	 */
	public function ensureConsistency()
	{

		if ($this->aTasks !== null && $this->tasks_id !== $this->aTasks->getId()) {
			$this->aTasks = null;
		}
		if ($this->aUsers !== null && $this->created_by !== $this->aUsers->getId()) {
			$this->aUsers = null;
		}
		if ($this->aTasksStatus !== null && $this->tasks_status_id !== $this->aTasksStatus->getId()) {
			$this->aTasksStatus = null;
		}
		if ($this->aTasksPriority !== null && $this->tasks_priority_id !== $this->aTasksPriority->getId()) {
			$this->aTasksPriority = null;
		}
	} // ensureConsistency

	/**
	 * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
	 *
	 * This will only work if the object has been saved and has a valid primary key set.
	 *
	 * @param      boolean $deep (optional) Whether to also de-associated any related objects.
	 * @param      PropelPDO $con (optional) The PropelPDO connection to use.
	 * @return     void
	 * @throws     PropelException - if this object is deleted, unsaved or doesn't have pk match in db
	 */
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(TasksCommentsPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

		// We don't need to alter the object instance pool; we're just modifying this instance
		// already in the pool.

		$stmt = TasksCommentsPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); // rehydrate

		if ($deep) {  // also de-associate any related objects?

			$this->aTasks = null;
			$this->aUsers = null;
			$this->aTasksStatus = null;
			$this->aTasksPriority = null;
		} // if (deep)
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param      PropelPDO $con
	 * @return     void
	 * @throws     PropelException
	 * @see        BaseObject::setDeleted()
	 * @see        BaseObject::isDeleted()
	 */
	public function delete(PropelPDO $con = null)
	{

    foreach (sfMixer::getCallables('BaseTasksComments:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(TasksCommentsPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			TasksCommentsPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseTasksComments:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	/**
	 * Persists this object to the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All modified related objects will also be persisted in the doSave()
	 * method.  This method wraps all precipitate database operations in a
	 * single transaction.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        doSave()
	 */
	public function save(PropelPDO $con = null)
	{

    foreach (sfMixer::getCallables('BaseTasksComments:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


    if ($this->isNew() && !$this->isColumnModified(TasksCommentsPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(TasksCommentsPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseTasksComments:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			TasksCommentsPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	/**
	 * Performs the work of inserting or updating the row in the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        save()
	 */
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aTasks !== null) {
				if ($this->aTasks->isModified() || $this->aTasks->isNew()) {
					$affectedRows += $this->aTasks->save($con);
				}
				$this->setTasks($this->aTasks);
			}

			if ($this->aUsers !== null) {
				if ($this->aUsers->isModified() || $this->aUsers->isNew()) {
					$affectedRows += $this->aUsers->save($con);
				}
				$this->setUsers($this->aUsers);
			}

			if ($this->aTasksStatus !== null) {
				if ($this->aTasksStatus->isModified() || $this->aTasksStatus->isNew()) {
					$affectedRows += $this->aTasksStatus->save($con);
				}
				$this->setTasksStatus($this->aTasksStatus);
			}

			if ($this->aTasksPriority !== null) {
				if ($this->aTasksPriority->isModified() || $this->aTasksPriority->isNew()) {
					$affectedRows += $this->aTasksPriority->save($con);
				}
				$this->setTasksPriority($this->aTasksPriority);
			}

			if ($this->isNew() ) {
				$this->modifiedColumns[] = TasksCommentsPeer::ID;
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = TasksCommentsPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which
										 // should always be true here (even though technically
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setId($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += TasksCommentsPeer::doUpdate($this, $con);
				}

				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var        array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return     array ValidationFailed[]
	 * @see        validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param      mixed $columns Column name or an array of column names.
	 * @return     boolean Whether all columns pass validation.
	 * @see        doValidate()
	 * @see        getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param      array $columns Array of column names to validate.
	 * @return     mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aTasks !== null) {
				if (!$this->aTasks->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aTasks->getValidationFailures());
				}
			}

			if ($this->aUsers !== null) {
				if (!$this->aUsers->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUsers->getValidationFailures());
				}
			}

			if ($this->aTasksStatus !== null) {
				if (!$this->aTasksStatus->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aTasksStatus->getValidationFailures());
				}
			}

			if ($this->aTasksPriority !== null) {
				if (!$this->aTasksPriority->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aTasksPriority->getValidationFailures());
				}
			}


			if (($retval = TasksCommentsPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param      string $name name
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = TasksCommentsPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @return     mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getTasksId();
				break;
			case 2:
				return $this->getCreatedBy();
				break;
			case 3:
				return $this->getTasksStatusId();
				break;
			case 4:
				return $this->getTasksPriorityId();
				break;
			case 5:
				return $this->getDueDate();
				break;
			case 6:
				return $this->getWorkedHours();
				break;
			case 7:
				return $this->getDescription();
				break;
			case 8:
				return $this->getCreatedAt();
				break;
			case 9:
				return $this->getProgress();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param      string $keyType (optional) One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                        BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM. Defaults to BasePeer::TYPE_PHPNAME.
	 * @param      boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns.  Defaults to TRUE.
	 * @return     an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = TasksCommentsPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getTasksId(),
			$keys[2] => $this->getCreatedBy(),
			$keys[3] => $this->getTasksStatusId(),
			$keys[4] => $this->getTasksPriorityId(),
			$keys[5] => $this->getDueDate(),
			$keys[6] => $this->getWorkedHours(),
			$keys[7] => $this->getDescription(),
			$keys[8] => $this->getCreatedAt(),
			$keys[9] => $this->getProgress(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param      string $name peer name
	 * @param      mixed $value field value
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = TasksCommentsPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @param      mixed $value field value
	 * @return     void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setTasksId($value);
				break;
			case 2:
				$this->setCreatedBy($value);
				break;
			case 3:
				$this->setTasksStatusId($value);
				break;
			case 4:
				$this->setTasksPriorityId($value);
				break;
			case 5:
				$this->setDueDate($value);
				break;
			case 6:
				$this->setWorkedHours($value);
				break;
			case 7:
				$this->setDescription($value);
				break;
			case 8:
				$this->setCreatedAt($value);
				break;
			case 9:
				$this->setProgress($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
	 * BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
	 * The default key type is the column's phpname (e.g. 'AuthorId')
	 *
	 * @param      array  $arr     An array to populate the object from.
	 * @param      string $keyType The type of keys the array uses.
	 * @return     void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = TasksCommentsPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setTasksId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setCreatedBy($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setTasksStatusId($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setTasksPriorityId($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setDueDate($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setWorkedHours($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setDescription($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setCreatedAt($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setProgress($arr[$keys[9]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return     Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(TasksCommentsPeer::DATABASE_NAME);

		if ($this->isColumnModified(TasksCommentsPeer::ID)) $criteria->add(TasksCommentsPeer::ID, $this->id);
		if ($this->isColumnModified(TasksCommentsPeer::TASKS_ID)) $criteria->add(TasksCommentsPeer::TASKS_ID, $this->tasks_id);
		if ($this->isColumnModified(TasksCommentsPeer::CREATED_BY)) $criteria->add(TasksCommentsPeer::CREATED_BY, $this->created_by);
		if ($this->isColumnModified(TasksCommentsPeer::TASKS_STATUS_ID)) $criteria->add(TasksCommentsPeer::TASKS_STATUS_ID, $this->tasks_status_id);
		if ($this->isColumnModified(TasksCommentsPeer::TASKS_PRIORITY_ID)) $criteria->add(TasksCommentsPeer::TASKS_PRIORITY_ID, $this->tasks_priority_id);
		if ($this->isColumnModified(TasksCommentsPeer::DUE_DATE)) $criteria->add(TasksCommentsPeer::DUE_DATE, $this->due_date);
		if ($this->isColumnModified(TasksCommentsPeer::WORKED_HOURS)) $criteria->add(TasksCommentsPeer::WORKED_HOURS, $this->worked_hours);
		if ($this->isColumnModified(TasksCommentsPeer::DESCRIPTION)) $criteria->add(TasksCommentsPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(TasksCommentsPeer::CREATED_AT)) $criteria->add(TasksCommentsPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(TasksCommentsPeer::PROGRESS)) $criteria->add(TasksCommentsPeer::PROGRESS, $this->progress);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return     Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(TasksCommentsPeer::DATABASE_NAME);

		$criteria->add(TasksCommentsPeer::ID, $this->id);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return     int
	 */
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	/**
	 * Generic method to set the primary key (id column).
	 *
	 * @param      int $key Primary key.
	 * @return     void
	 */
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      object $copyObj An object of TasksComments (or compatible) type.
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws     PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setTasksId($this->tasks_id);

		$copyObj->setCreatedBy($this->created_by);

		$copyObj->setTasksStatusId($this->tasks_status_id);

		$copyObj->setTasksPriorityId($this->tasks_priority_id);

		$copyObj->setDueDate($this->due_date);

		$copyObj->setWorkedHours($this->worked_hours);

		$copyObj->setDescription($this->description);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setProgress($this->progress);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); // this is a auto-increment column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return     TasksComments Clone of current object.
	 * @throws     PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return     TasksCommentsPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new TasksCommentsPeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a Tasks object.
	 *
	 * @param      Tasks $v
	 * @return     TasksComments The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setTasks(Tasks $v = null)
	{
		if ($v === null) {
			$this->setTasksId(0);
		} else {
			$this->setTasksId($v->getId());
		}

		$this->aTasks = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the Tasks object, it will not be re-added.
		if ($v !== null) {
			$v->addTasksComments($this);
		}

		return $this;
	}


	/**
	 * Get the associated Tasks object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     Tasks The associated Tasks object.
	 * @throws     PropelException
	 */
	public function getTasks(PropelPDO $con = null)
	{
		if ($this->aTasks === null && ($this->tasks_id !== null)) {
			$c = new Criteria(TasksPeer::DATABASE_NAME);
			$c->add(TasksPeer::ID, $this->tasks_id);
			$this->aTasks = TasksPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aTasks->addTasksCommentss($this);
			 */
		}
		return $this->aTasks;
	}

	/**
	 * Declares an association between this object and a Users object.
	 *
	 * @param      Users $v
	 * @return     TasksComments The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setUsers(Users $v = null)
	{
		if ($v === null) {
			$this->setCreatedBy(NULL);
		} else {
			$this->setCreatedBy($v->getId());
		}

		$this->aUsers = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the Users object, it will not be re-added.
		if ($v !== null) {
			$v->addTasksComments($this);
		}

		return $this;
	}


	/**
	 * Get the associated Users object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     Users The associated Users object.
	 * @throws     PropelException
	 */
	public function getUsers(PropelPDO $con = null)
	{
		if ($this->aUsers === null && ($this->created_by !== null)) {
			$c = new Criteria(UsersPeer::DATABASE_NAME);
			$c->add(UsersPeer::ID, $this->created_by);
			$this->aUsers = UsersPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aUsers->addTasksCommentss($this);
			 */
		}
		return $this->aUsers;
	}

	/**
	 * Declares an association between this object and a TasksStatus object.
	 *
	 * @param      TasksStatus $v
	 * @return     TasksComments The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setTasksStatus(TasksStatus $v = null)
	{
		if ($v === null) {
			$this->setTasksStatusId(NULL);
		} else {
			$this->setTasksStatusId($v->getId());
		}

		$this->aTasksStatus = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the TasksStatus object, it will not be re-added.
		if ($v !== null) {
			$v->addTasksComments($this);
		}

		return $this;
	}


	/**
	 * Get the associated TasksStatus object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     TasksStatus The associated TasksStatus object.
	 * @throws     PropelException
	 */
	public function getTasksStatus(PropelPDO $con = null)
	{
		if ($this->aTasksStatus === null && ($this->tasks_status_id !== null)) {
			$c = new Criteria(TasksStatusPeer::DATABASE_NAME);
			$c->add(TasksStatusPeer::ID, $this->tasks_status_id);
			$this->aTasksStatus = TasksStatusPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aTasksStatus->addTasksCommentss($this);
			 */
		}
		return $this->aTasksStatus;
	}

	/**
	 * Declares an association between this object and a TasksPriority object.
	 *
	 * @param      TasksPriority $v
	 * @return     TasksComments The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setTasksPriority(TasksPriority $v = null)
	{
		if ($v === null) {
			$this->setTasksPriorityId(NULL);
		} else {
			$this->setTasksPriorityId($v->getId());
		}

		$this->aTasksPriority = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the TasksPriority object, it will not be re-added.
		if ($v !== null) {
			$v->addTasksComments($this);
		}

		return $this;
	}


	/**
	 * Get the associated TasksPriority object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     TasksPriority The associated TasksPriority object.
	 * @throws     PropelException
	 */
	public function getTasksPriority(PropelPDO $con = null)
	{
		if ($this->aTasksPriority === null && ($this->tasks_priority_id !== null)) {
			$c = new Criteria(TasksPriorityPeer::DATABASE_NAME);
			$c->add(TasksPriorityPeer::ID, $this->tasks_priority_id);
			$this->aTasksPriority = TasksPriorityPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aTasksPriority->addTasksCommentss($this);
			 */
		}
		return $this->aTasksPriority;
	}

	/**
	 * Resets all collections of referencing foreign keys.
	 *
	 * This method is a user-space workaround for PHP's inability to garbage collect objects
	 * with circular references.  This is currently necessary when using Propel in certain
	 * daemon or large-volumne/high-memory operations.
	 *
	 * @param      boolean $deep Whether to also clear the references on all associated objects.
	 */
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
		} // if ($deep)

			$this->aTasks = null;
			$this->aUsers = null;
			$this->aTasksStatus = null;
			$this->aTasksPriority = null;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseTasksComments:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseTasksComments::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} // BaseTasksComments
