<?php

/**
 * Base class that represents a row from the 'tasks_status' table.
 *
 * 
 *
 * This class was autogenerated by Propel 1.3.0-dev on:
 *
 * 10/01/11 13:54:40
 *
 * @package    lib.model.om
 */
abstract class BaseTasksStatus extends BaseObject  implements Persistent {


  const PEER = 'TasksStatusPeer';

	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var        TasksStatusPeer
	 */
	protected static $peer;

	/**
	 * The value for the id field.
	 * @var        int
	 */
	protected $id;

	/**
	 * The value for the name field.
	 * Note: this column has a database default value of: ''
	 * @var        string
	 */
	protected $name;

	/**
	 * The value for the group field.
	 * Note: this column has a database default value of: ''
	 * @var        string
	 */
	protected $group;

	/**
	 * The value for the sort_order field.
	 * Note: this column has a database default value of: 0
	 * @var        int
	 */
	protected $sort_order;

	/**
	 * The value for the default_value field.
	 * @var        int
	 */
	protected $default_value;

	/**
	 * The value for the active field.
	 * @var        int
	 */
	protected $active;

	/**
	 * @var        array Tasks[] Collection to store aggregation of Tasks objects.
	 */
	protected $collTaskss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collTaskss.
	 */
	private $lastTasksCriteria = null;

	/**
	 * @var        array TasksComments[] Collection to store aggregation of TasksComments objects.
	 */
	protected $collTasksCommentss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collTasksCommentss.
	 */
	private $lastTasksCommentsCriteria = null;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInValidation = false;

	/**
	 * Initializes internal state of BaseTasksStatus object.
	 * @see        applyDefaults()
	 */
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	/**
	 * Applies default values to this object.
	 * This method should be called from the object's constructor (or
	 * equivalent initialization method).
	 * @see        __construct()
	 */
	public function applyDefaultValues()
	{
		$this->name = '';
		$this->group = '';
		$this->sort_order = 0;
	}

	/**
	 * Get the [id] column value.
	 * 
	 * @return     int
	 */
	public function getId()
	{
		return $this->id;
	}

	/**
	 * Get the [name] column value.
	 * 
	 * @return     string
	 */
	public function getName()
	{
		return $this->name;
	}

	/**
	 * Get the [group] column value.
	 * 
	 * @return     string
	 */
	public function getGroup()
	{
		return $this->group;
	}

	/**
	 * Get the [sort_order] column value.
	 * 
	 * @return     int
	 */
	public function getSortOrder()
	{
		return $this->sort_order;
	}

	/**
	 * Get the [default_value] column value.
	 * 
	 * @return     int
	 */
	public function getDefaultValue()
	{
		return $this->default_value;
	}

	/**
	 * Get the [active] column value.
	 * 
	 * @return     int
	 */
	public function getActive()
	{
		return $this->active;
	}

	/**
	 * Set the value of [id] column.
	 * 
	 * @param      int $v new value
	 * @return     TasksStatus The current object (for fluent API support)
	 */
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = TasksStatusPeer::ID;
		}

		return $this;
	} // setId()

	/**
	 * Set the value of [name] column.
	 * 
	 * @param      string $v new value
	 * @return     TasksStatus The current object (for fluent API support)
	 */
	public function setName($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->name !== $v || $v === '') {
			$this->name = $v;
			$this->modifiedColumns[] = TasksStatusPeer::NAME;
		}

		return $this;
	} // setName()

	/**
	 * Set the value of [group] column.
	 * 
	 * @param      string $v new value
	 * @return     TasksStatus The current object (for fluent API support)
	 */
	public function setGroup($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->group !== $v || $v === '') {
			$this->group = $v;
			$this->modifiedColumns[] = TasksStatusPeer::GROUP;
		}

		return $this;
	} // setGroup()

	/**
	 * Set the value of [sort_order] column.
	 * 
	 * @param      int $v new value
	 * @return     TasksStatus The current object (for fluent API support)
	 */
	public function setSortOrder($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->sort_order !== $v || $v === 0) {
			$this->sort_order = $v;
			$this->modifiedColumns[] = TasksStatusPeer::SORT_ORDER;
		}

		return $this;
	} // setSortOrder()

	/**
	 * Set the value of [default_value] column.
	 * 
	 * @param      int $v new value
	 * @return     TasksStatus The current object (for fluent API support)
	 */
	public function setDefaultValue($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->default_value !== $v) {
			$this->default_value = $v;
			$this->modifiedColumns[] = TasksStatusPeer::DEFAULT_VALUE;
		}

		return $this;
	} // setDefaultValue()

	/**
	 * Set the value of [active] column.
	 * 
	 * @param      int $v new value
	 * @return     TasksStatus The current object (for fluent API support)
	 */
	public function setActive($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->active !== $v) {
			$this->active = $v;
			$this->modifiedColumns[] = TasksStatusPeer::ACTIVE;
		}

		return $this;
	} // setActive()

	/**
	 * Indicates whether the columns in this object are only set to default values.
	 *
	 * This method can be used in conjunction with isModified() to indicate whether an object is both
	 * modified _and_ has some values set which are non-default.
	 *
	 * @return     boolean Whether the columns in this object are only been set with default values.
	 */
	public function hasOnlyDefaultValues()
	{
			// First, ensure that we don't have any columns that have been modified which aren't default columns.
			if (array_diff($this->modifiedColumns, array(TasksStatusPeer::NAME,TasksStatusPeer::GROUP,TasksStatusPeer::SORT_ORDER))) {
				return false;
			}

			if ($this->name !== '') {
				return false;
			}

			if ($this->group !== '') {
				return false;
			}

			if ($this->sort_order !== 0) {
				return false;
			}

		// otherwise, everything was equal, so return TRUE
		return true;
	} // hasOnlyDefaultValues()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (0-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param      array $row The row returned by PDOStatement->fetch(PDO::FETCH_NUM)
	 * @param      int $startcol 0-based offset column which indicates which restultset column to start with.
	 * @param      boolean $rehydrate Whether this object is being re-hydrated from the database.
	 * @return     int next starting column
	 * @throws     PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->name = ($row[$startcol + 1] !== null) ? (string) $row[$startcol + 1] : null;
			$this->group = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->sort_order = ($row[$startcol + 3] !== null) ? (int) $row[$startcol + 3] : null;
			$this->default_value = ($row[$startcol + 4] !== null) ? (int) $row[$startcol + 4] : null;
			$this->active = ($row[$startcol + 5] !== null) ? (int) $row[$startcol + 5] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 6; // 6 = TasksStatusPeer::NUM_COLUMNS - TasksStatusPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating TasksStatus object", $e);
		}
	}

	/**
	 * Checks and repairs the internal consistency of the object.
	 *
	 * This method is executed after an already-instantiated object is re-hydrated
	 * from the database.  It exists to check any foreign keys to make sure that
	 * the objects related to the current object are correct based on foreign key.
	 *
	 * You can override this method in the stub class, but you should always invoke
	 * the base method from the overridden method (i.e. parent::ensureConsistency()),
	 * in case your model changes.
	 *
	 * @throws     PropelException
	 */
	public function ensureConsistency()
	{

	} // ensureConsistency

	/**
	 * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
	 *
	 * This will only work if the object has been saved and has a valid primary key set.
	 *
	 * @param      boolean $deep (optional) Whether to also de-associated any related objects.
	 * @param      PropelPDO $con (optional) The PropelPDO connection to use.
	 * @return     void
	 * @throws     PropelException - if this object is deleted, unsaved or doesn't have pk match in db
	 */
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(TasksStatusPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

		// We don't need to alter the object instance pool; we're just modifying this instance
		// already in the pool.

		$stmt = TasksStatusPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); // rehydrate

		if ($deep) {  // also de-associate any related objects?

			$this->collTaskss = null;
			$this->lastTasksCriteria = null;

			$this->collTasksCommentss = null;
			$this->lastTasksCommentsCriteria = null;

		} // if (deep)
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param      PropelPDO $con
	 * @return     void
	 * @throws     PropelException
	 * @see        BaseObject::setDeleted()
	 * @see        BaseObject::isDeleted()
	 */
	public function delete(PropelPDO $con = null)
	{

    foreach (sfMixer::getCallables('BaseTasksStatus:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(TasksStatusPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			TasksStatusPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseTasksStatus:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	/**
	 * Persists this object to the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All modified related objects will also be persisted in the doSave()
	 * method.  This method wraps all precipitate database operations in a
	 * single transaction.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        doSave()
	 */
	public function save(PropelPDO $con = null)
	{

    foreach (sfMixer::getCallables('BaseTasksStatus:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(TasksStatusPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseTasksStatus:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			TasksStatusPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	/**
	 * Performs the work of inserting or updating the row in the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        save()
	 */
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			if ($this->isNew() ) {
				$this->modifiedColumns[] = TasksStatusPeer::ID;
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = TasksStatusPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which
										 // should always be true here (even though technically
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setId($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += TasksStatusPeer::doUpdate($this, $con);
				}

				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			if ($this->collTaskss !== null) {
				foreach ($this->collTaskss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collTasksCommentss !== null) {
				foreach ($this->collTasksCommentss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var        array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return     array ValidationFailed[]
	 * @see        validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param      mixed $columns Column name or an array of column names.
	 * @return     boolean Whether all columns pass validation.
	 * @see        doValidate()
	 * @see        getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param      array $columns Array of column names to validate.
	 * @return     mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = TasksStatusPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collTaskss !== null) {
					foreach ($this->collTaskss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collTasksCommentss !== null) {
					foreach ($this->collTasksCommentss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param      string $name name
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = TasksStatusPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @return     mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getName();
				break;
			case 2:
				return $this->getGroup();
				break;
			case 3:
				return $this->getSortOrder();
				break;
			case 4:
				return $this->getDefaultValue();
				break;
			case 5:
				return $this->getActive();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param      string $keyType (optional) One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                        BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM. Defaults to BasePeer::TYPE_PHPNAME.
	 * @param      boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns.  Defaults to TRUE.
	 * @return     an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = TasksStatusPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getName(),
			$keys[2] => $this->getGroup(),
			$keys[3] => $this->getSortOrder(),
			$keys[4] => $this->getDefaultValue(),
			$keys[5] => $this->getActive(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param      string $name peer name
	 * @param      mixed $value field value
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = TasksStatusPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @param      mixed $value field value
	 * @return     void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setName($value);
				break;
			case 2:
				$this->setGroup($value);
				break;
			case 3:
				$this->setSortOrder($value);
				break;
			case 4:
				$this->setDefaultValue($value);
				break;
			case 5:
				$this->setActive($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
	 * BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
	 * The default key type is the column's phpname (e.g. 'AuthorId')
	 *
	 * @param      array  $arr     An array to populate the object from.
	 * @param      string $keyType The type of keys the array uses.
	 * @return     void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = TasksStatusPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setName($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setGroup($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setSortOrder($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setDefaultValue($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setActive($arr[$keys[5]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return     Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(TasksStatusPeer::DATABASE_NAME);

		if ($this->isColumnModified(TasksStatusPeer::ID)) $criteria->add(TasksStatusPeer::ID, $this->id);
		if ($this->isColumnModified(TasksStatusPeer::NAME)) $criteria->add(TasksStatusPeer::NAME, $this->name);
		if ($this->isColumnModified(TasksStatusPeer::GROUP)) $criteria->add(TasksStatusPeer::GROUP, $this->group);
		if ($this->isColumnModified(TasksStatusPeer::SORT_ORDER)) $criteria->add(TasksStatusPeer::SORT_ORDER, $this->sort_order);
		if ($this->isColumnModified(TasksStatusPeer::DEFAULT_VALUE)) $criteria->add(TasksStatusPeer::DEFAULT_VALUE, $this->default_value);
		if ($this->isColumnModified(TasksStatusPeer::ACTIVE)) $criteria->add(TasksStatusPeer::ACTIVE, $this->active);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return     Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(TasksStatusPeer::DATABASE_NAME);

		$criteria->add(TasksStatusPeer::ID, $this->id);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return     int
	 */
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	/**
	 * Generic method to set the primary key (id column).
	 *
	 * @param      int $key Primary key.
	 * @return     void
	 */
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      object $copyObj An object of TasksStatus (or compatible) type.
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws     PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setName($this->name);

		$copyObj->setGroup($this->group);

		$copyObj->setSortOrder($this->sort_order);

		$copyObj->setDefaultValue($this->default_value);

		$copyObj->setActive($this->active);


		if ($deepCopy) {
			// important: temporarily setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach ($this->getTaskss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addTasks($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getTasksCommentss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addTasksComments($relObj->copy($deepCopy));
				}
			}

		} // if ($deepCopy)


		$copyObj->setNew(true);

		$copyObj->setId(NULL); // this is a auto-increment column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return     TasksStatus Clone of current object.
	 * @throws     PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return     TasksStatusPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new TasksStatusPeer();
		}
		return self::$peer;
	}

	/**
	 * Clears out the collTaskss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addTaskss()
	 */
	public function clearTaskss()
	{
		$this->collTaskss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collTaskss collection (array).
	 *
	 * By default this just sets the collTaskss collection to an empty array (like clearcollTaskss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initTaskss()
	{
		$this->collTaskss = array();
	}

	/**
	 * Gets an array of Tasks objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this TasksStatus has previously been saved, it will retrieve
	 * related Taskss from storage. If this TasksStatus is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Tasks[]
	 * @throws     PropelException
	 */
	public function getTaskss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TasksStatusPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
			   $this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::TASKS_STATUS_ID, $this->id);

				TasksPeer::addSelectColumns($criteria);
				$this->collTaskss = TasksPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(TasksPeer::TASKS_STATUS_ID, $this->id);

				TasksPeer::addSelectColumns($criteria);
				if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
					$this->collTaskss = TasksPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTasksCriteria = $criteria;
		return $this->collTaskss;
	}

	/**
	 * Returns the number of related Tasks objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Tasks objects.
	 * @throws     PropelException
	 */
	public function countTaskss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TasksStatusPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(TasksPeer::TASKS_STATUS_ID, $this->id);

				$count = TasksPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(TasksPeer::TASKS_STATUS_ID, $this->id);

				if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
					$count = TasksPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collTaskss);
				}
			} else {
				$count = count($this->collTaskss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a Tasks object to this object
	 * through the Tasks foreign key attribute.
	 *
	 * @param      Tasks $l Tasks
	 * @return     void
	 * @throws     PropelException
	 */
	public function addTasks(Tasks $l)
	{
		if ($this->collTaskss === null) {
			$this->initTaskss();
		}
		if (!in_array($l, $this->collTaskss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collTaskss, $l);
			$l->setTasksStatus($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TasksStatus is new, it will return
	 * an empty collection; or if this TasksStatus has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TasksStatus.
	 */
	public function getTaskssJoinProjects($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TasksStatusPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::TASKS_STATUS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinProjects($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::TASKS_STATUS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinProjects($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TasksStatus is new, it will return
	 * an empty collection; or if this TasksStatus has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TasksStatus.
	 */
	public function getTaskssJoinTasksPriority($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TasksStatusPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::TASKS_STATUS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinTasksPriority($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::TASKS_STATUS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinTasksPriority($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TasksStatus is new, it will return
	 * an empty collection; or if this TasksStatus has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TasksStatus.
	 */
	public function getTaskssJoinTasksTypes($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TasksStatusPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::TASKS_STATUS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinTasksTypes($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::TASKS_STATUS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinTasksTypes($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TasksStatus is new, it will return
	 * an empty collection; or if this TasksStatus has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TasksStatus.
	 */
	public function getTaskssJoinTasksLabels($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TasksStatusPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::TASKS_STATUS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinTasksLabels($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::TASKS_STATUS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinTasksLabels($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TasksStatus is new, it will return
	 * an empty collection; or if this TasksStatus has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TasksStatus.
	 */
	public function getTaskssJoinTasksGroups($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TasksStatusPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::TASKS_STATUS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinTasksGroups($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::TASKS_STATUS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinTasksGroups($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TasksStatus is new, it will return
	 * an empty collection; or if this TasksStatus has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TasksStatus.
	 */
	public function getTaskssJoinProjectsPhases($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TasksStatusPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::TASKS_STATUS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinProjectsPhases($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::TASKS_STATUS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinProjectsPhases($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TasksStatus is new, it will return
	 * an empty collection; or if this TasksStatus has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TasksStatus.
	 */
	public function getTaskssJoinVersions($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TasksStatusPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::TASKS_STATUS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinVersions($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::TASKS_STATUS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinVersions($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TasksStatus is new, it will return
	 * an empty collection; or if this TasksStatus has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TasksStatus.
	 */
	public function getTaskssJoinUsers($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TasksStatusPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::TASKS_STATUS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinUsers($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::TASKS_STATUS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinUsers($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TasksStatus is new, it will return
	 * an empty collection; or if this TasksStatus has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TasksStatus.
	 */
	public function getTaskssJoinTickets($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TasksStatusPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::TASKS_STATUS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinTickets($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::TASKS_STATUS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinTickets($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}

	/**
	 * Clears out the collTasksCommentss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addTasksCommentss()
	 */
	public function clearTasksCommentss()
	{
		$this->collTasksCommentss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collTasksCommentss collection (array).
	 *
	 * By default this just sets the collTasksCommentss collection to an empty array (like clearcollTasksCommentss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initTasksCommentss()
	{
		$this->collTasksCommentss = array();
	}

	/**
	 * Gets an array of TasksComments objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this TasksStatus has previously been saved, it will retrieve
	 * related TasksCommentss from storage. If this TasksStatus is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array TasksComments[]
	 * @throws     PropelException
	 */
	public function getTasksCommentss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TasksStatusPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTasksCommentss === null) {
			if ($this->isNew()) {
			   $this->collTasksCommentss = array();
			} else {

				$criteria->add(TasksCommentsPeer::TASKS_STATUS_ID, $this->id);

				TasksCommentsPeer::addSelectColumns($criteria);
				$this->collTasksCommentss = TasksCommentsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(TasksCommentsPeer::TASKS_STATUS_ID, $this->id);

				TasksCommentsPeer::addSelectColumns($criteria);
				if (!isset($this->lastTasksCommentsCriteria) || !$this->lastTasksCommentsCriteria->equals($criteria)) {
					$this->collTasksCommentss = TasksCommentsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTasksCommentsCriteria = $criteria;
		return $this->collTasksCommentss;
	}

	/**
	 * Returns the number of related TasksComments objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related TasksComments objects.
	 * @throws     PropelException
	 */
	public function countTasksCommentss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TasksStatusPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collTasksCommentss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(TasksCommentsPeer::TASKS_STATUS_ID, $this->id);

				$count = TasksCommentsPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(TasksCommentsPeer::TASKS_STATUS_ID, $this->id);

				if (!isset($this->lastTasksCommentsCriteria) || !$this->lastTasksCommentsCriteria->equals($criteria)) {
					$count = TasksCommentsPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collTasksCommentss);
				}
			} else {
				$count = count($this->collTasksCommentss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a TasksComments object to this object
	 * through the TasksComments foreign key attribute.
	 *
	 * @param      TasksComments $l TasksComments
	 * @return     void
	 * @throws     PropelException
	 */
	public function addTasksComments(TasksComments $l)
	{
		if ($this->collTasksCommentss === null) {
			$this->initTasksCommentss();
		}
		if (!in_array($l, $this->collTasksCommentss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collTasksCommentss, $l);
			$l->setTasksStatus($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TasksStatus is new, it will return
	 * an empty collection; or if this TasksStatus has previously
	 * been saved, it will retrieve related TasksCommentss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TasksStatus.
	 */
	public function getTasksCommentssJoinTasks($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TasksStatusPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTasksCommentss === null) {
			if ($this->isNew()) {
				$this->collTasksCommentss = array();
			} else {

				$criteria->add(TasksCommentsPeer::TASKS_STATUS_ID, $this->id);

				$this->collTasksCommentss = TasksCommentsPeer::doSelectJoinTasks($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksCommentsPeer::TASKS_STATUS_ID, $this->id);

			if (!isset($this->lastTasksCommentsCriteria) || !$this->lastTasksCommentsCriteria->equals($criteria)) {
				$this->collTasksCommentss = TasksCommentsPeer::doSelectJoinTasks($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCommentsCriteria = $criteria;

		return $this->collTasksCommentss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TasksStatus is new, it will return
	 * an empty collection; or if this TasksStatus has previously
	 * been saved, it will retrieve related TasksCommentss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TasksStatus.
	 */
	public function getTasksCommentssJoinUsers($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TasksStatusPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTasksCommentss === null) {
			if ($this->isNew()) {
				$this->collTasksCommentss = array();
			} else {

				$criteria->add(TasksCommentsPeer::TASKS_STATUS_ID, $this->id);

				$this->collTasksCommentss = TasksCommentsPeer::doSelectJoinUsers($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksCommentsPeer::TASKS_STATUS_ID, $this->id);

			if (!isset($this->lastTasksCommentsCriteria) || !$this->lastTasksCommentsCriteria->equals($criteria)) {
				$this->collTasksCommentss = TasksCommentsPeer::doSelectJoinUsers($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCommentsCriteria = $criteria;

		return $this->collTasksCommentss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TasksStatus is new, it will return
	 * an empty collection; or if this TasksStatus has previously
	 * been saved, it will retrieve related TasksCommentss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TasksStatus.
	 */
	public function getTasksCommentssJoinTasksPriority($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TasksStatusPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTasksCommentss === null) {
			if ($this->isNew()) {
				$this->collTasksCommentss = array();
			} else {

				$criteria->add(TasksCommentsPeer::TASKS_STATUS_ID, $this->id);

				$this->collTasksCommentss = TasksCommentsPeer::doSelectJoinTasksPriority($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksCommentsPeer::TASKS_STATUS_ID, $this->id);

			if (!isset($this->lastTasksCommentsCriteria) || !$this->lastTasksCommentsCriteria->equals($criteria)) {
				$this->collTasksCommentss = TasksCommentsPeer::doSelectJoinTasksPriority($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCommentsCriteria = $criteria;

		return $this->collTasksCommentss;
	}

	/**
	 * Resets all collections of referencing foreign keys.
	 *
	 * This method is a user-space workaround for PHP's inability to garbage collect objects
	 * with circular references.  This is currently necessary when using Propel in certain
	 * daemon or large-volumne/high-memory operations.
	 *
	 * @param      boolean $deep Whether to also clear the references on all associated objects.
	 */
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collTaskss) {
				foreach ((array) $this->collTaskss as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collTasksCommentss) {
				foreach ((array) $this->collTasksCommentss as $o) {
					$o->clearAllReferences($deep);
				}
			}
		} // if ($deep)

		$this->collTaskss = null;
		$this->collTasksCommentss = null;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseTasksStatus:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseTasksStatus::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} // BaseTasksStatus
