<?php

/**
 * Base class that represents a row from the 'tickets' table.
 *
 * 
 *
 * This class was autogenerated by Propel 1.3.0-dev on:
 *
 * 10/01/11 13:54:41
 *
 * @package    lib.model.om
 */
abstract class BaseTickets extends BaseObject  implements Persistent {


  const PEER = 'TicketsPeer';

	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var        TicketsPeer
	 */
	protected static $peer;

	/**
	 * The value for the id field.
	 * @var        int
	 */
	protected $id;

	/**
	 * The value for the departments_id field.
	 * @var        int
	 */
	protected $departments_id;

	/**
	 * The value for the tickets_types_id field.
	 * @var        int
	 */
	protected $tickets_types_id;

	/**
	 * The value for the tickets_status_id field.
	 * @var        int
	 */
	protected $tickets_status_id;

	/**
	 * The value for the name field.
	 * Note: this column has a database default value of: ''
	 * @var        string
	 */
	protected $name;

	/**
	 * The value for the description field.
	 * @var        string
	 */
	protected $description;

	/**
	 * The value for the users_id field.
	 * Note: this column has a database default value of: 0
	 * @var        int
	 */
	protected $users_id;

	/**
	 * The value for the projects_id field.
	 * Note: this column has a database default value of: 0
	 * @var        int
	 */
	protected $projects_id;

	/**
	 * The value for the created_at field.
	 * @var        string
	 */
	protected $created_at;

	/**
	 * @var        Departments
	 */
	protected $aDepartments;

	/**
	 * @var        TicketsTypes
	 */
	protected $aTicketsTypes;

	/**
	 * @var        TicketsStatus
	 */
	protected $aTicketsStatus;

	/**
	 * @var        Users
	 */
	protected $aUsers;

	/**
	 * @var        Projects
	 */
	protected $aProjects;

	/**
	 * @var        array Tasks[] Collection to store aggregation of Tasks objects.
	 */
	protected $collTaskss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collTaskss.
	 */
	private $lastTasksCriteria = null;

	/**
	 * @var        array TicketsComments[] Collection to store aggregation of TicketsComments objects.
	 */
	protected $collTicketsCommentss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collTicketsCommentss.
	 */
	private $lastTicketsCommentsCriteria = null;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInValidation = false;

	/**
	 * Initializes internal state of BaseTickets object.
	 * @see        applyDefaults()
	 */
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	/**
	 * Applies default values to this object.
	 * This method should be called from the object's constructor (or
	 * equivalent initialization method).
	 * @see        __construct()
	 */
	public function applyDefaultValues()
	{
		$this->name = '';
		$this->users_id = 0;
		$this->projects_id = 0;
	}

	/**
	 * Get the [id] column value.
	 * 
	 * @return     int
	 */
	public function getId()
	{
		return $this->id;
	}

	/**
	 * Get the [departments_id] column value.
	 * 
	 * @return     int
	 */
	public function getDepartmentsId()
	{
		return $this->departments_id;
	}

	/**
	 * Get the [tickets_types_id] column value.
	 * 
	 * @return     int
	 */
	public function getTicketsTypesId()
	{
		return $this->tickets_types_id;
	}

	/**
	 * Get the [tickets_status_id] column value.
	 * 
	 * @return     int
	 */
	public function getTicketsStatusId()
	{
		return $this->tickets_status_id;
	}

	/**
	 * Get the [name] column value.
	 * 
	 * @return     string
	 */
	public function getName()
	{
		return $this->name;
	}

	/**
	 * Get the [description] column value.
	 * 
	 * @return     string
	 */
	public function getDescription()
	{
		return $this->description;
	}

	/**
	 * Get the [users_id] column value.
	 * 
	 * @return     int
	 */
	public function getUsersId()
	{
		return $this->users_id;
	}

	/**
	 * Get the [projects_id] column value.
	 * 
	 * @return     int
	 */
	public function getProjectsId()
	{
		return $this->projects_id;
	}

	/**
	 * Get the [optionally formatted] temporal [created_at] column value.
	 * 
	 *
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the raw DateTime object will be returned.
	 * @return     mixed Formatted date/time value as string or DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00 00:00:00
	 * @throws     PropelException - if unable to parse/validate the date/time value.
	 */
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->created_at === null) {
			return null;
		}


		if ($this->created_at === '0000-00-00 00:00:00') {
			// while technically this is not a default value of NULL,
			// this seems to be closest in meaning.
			return null;
		} else {
			try {
				$dt = new DateTime($this->created_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->created_at, true), $x);
			}
		}

		if ($format === null) {
			// Because propel.useDateTimeClass is TRUE, we return a DateTime object.
			return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	/**
	 * Set the value of [id] column.
	 * 
	 * @param      int $v new value
	 * @return     Tickets The current object (for fluent API support)
	 */
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = TicketsPeer::ID;
		}

		return $this;
	} // setId()

	/**
	 * Set the value of [departments_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Tickets The current object (for fluent API support)
	 */
	public function setDepartmentsId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->departments_id !== $v) {
			$this->departments_id = $v;
			$this->modifiedColumns[] = TicketsPeer::DEPARTMENTS_ID;
		}

		if ($this->aDepartments !== null && $this->aDepartments->getId() !== $v) {
			$this->aDepartments = null;
		}

		return $this;
	} // setDepartmentsId()

	/**
	 * Set the value of [tickets_types_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Tickets The current object (for fluent API support)
	 */
	public function setTicketsTypesId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->tickets_types_id !== $v) {
			$this->tickets_types_id = $v;
			$this->modifiedColumns[] = TicketsPeer::TICKETS_TYPES_ID;
		}

		if ($this->aTicketsTypes !== null && $this->aTicketsTypes->getId() !== $v) {
			$this->aTicketsTypes = null;
		}

		return $this;
	} // setTicketsTypesId()

	/**
	 * Set the value of [tickets_status_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Tickets The current object (for fluent API support)
	 */
	public function setTicketsStatusId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->tickets_status_id !== $v) {
			$this->tickets_status_id = $v;
			$this->modifiedColumns[] = TicketsPeer::TICKETS_STATUS_ID;
		}

		if ($this->aTicketsStatus !== null && $this->aTicketsStatus->getId() !== $v) {
			$this->aTicketsStatus = null;
		}

		return $this;
	} // setTicketsStatusId()

	/**
	 * Set the value of [name] column.
	 * 
	 * @param      string $v new value
	 * @return     Tickets The current object (for fluent API support)
	 */
	public function setName($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->name !== $v || $v === '') {
			$this->name = $v;
			$this->modifiedColumns[] = TicketsPeer::NAME;
		}

		return $this;
	} // setName()

	/**
	 * Set the value of [description] column.
	 * 
	 * @param      string $v new value
	 * @return     Tickets The current object (for fluent API support)
	 */
	public function setDescription($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = TicketsPeer::DESCRIPTION;
		}

		return $this;
	} // setDescription()

	/**
	 * Set the value of [users_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Tickets The current object (for fluent API support)
	 */
	public function setUsersId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->users_id !== $v || $v === 0) {
			$this->users_id = $v;
			$this->modifiedColumns[] = TicketsPeer::USERS_ID;
		}

		if ($this->aUsers !== null && $this->aUsers->getId() !== $v) {
			$this->aUsers = null;
		}

		return $this;
	} // setUsersId()

	/**
	 * Set the value of [projects_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Tickets The current object (for fluent API support)
	 */
	public function setProjectsId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->projects_id !== $v || $v === 0) {
			$this->projects_id = $v;
			$this->modifiedColumns[] = TicketsPeer::PROJECTS_ID;
		}

		if ($this->aProjects !== null && $this->aProjects->getId() !== $v) {
			$this->aProjects = null;
		}

		return $this;
	} // setProjectsId()

	/**
	 * Sets the value of [created_at] column to a normalized version of the date/time value specified.
	 * 
	 * @param      mixed $v string, integer (timestamp), or DateTime value.  Empty string will
	 *						be treated as NULL for temporal objects.
	 * @return     Tickets The current object (for fluent API support)
	 */
	public function setCreatedAt($v)
	{
		// we treat '' as NULL for temporal objects because DateTime('') == DateTime('now')
		// -- which is unexpected, to say the least.
		if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
			// some string/numeric value passed; we normalize that so that we can
			// validate it.
			try {
				if (is_numeric($v)) { // if it's a unix timestamp
					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
					// We have to explicitly specify and then change the time zone because of a
					// DateTime bug: http://bugs.php.net/bug.php?id=43003
					$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->created_at !== null || $dt !== null ) {
			// (nested ifs are a little easier to read in this case)

			$currNorm = ($this->created_at !== null && $tmpDt = new DateTime($this->created_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) // normalized values don't match 
					)
			{
				$this->created_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = TicketsPeer::CREATED_AT;
			}
		} // if either are not null

		return $this;
	} // setCreatedAt()

	/**
	 * Indicates whether the columns in this object are only set to default values.
	 *
	 * This method can be used in conjunction with isModified() to indicate whether an object is both
	 * modified _and_ has some values set which are non-default.
	 *
	 * @return     boolean Whether the columns in this object are only been set with default values.
	 */
	public function hasOnlyDefaultValues()
	{
			// First, ensure that we don't have any columns that have been modified which aren't default columns.
			if (array_diff($this->modifiedColumns, array(TicketsPeer::NAME,TicketsPeer::USERS_ID,TicketsPeer::PROJECTS_ID))) {
				return false;
			}

			if ($this->name !== '') {
				return false;
			}

			if ($this->users_id !== 0) {
				return false;
			}

			if ($this->projects_id !== 0) {
				return false;
			}

		// otherwise, everything was equal, so return TRUE
		return true;
	} // hasOnlyDefaultValues()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (0-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param      array $row The row returned by PDOStatement->fetch(PDO::FETCH_NUM)
	 * @param      int $startcol 0-based offset column which indicates which restultset column to start with.
	 * @param      boolean $rehydrate Whether this object is being re-hydrated from the database.
	 * @return     int next starting column
	 * @throws     PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->departments_id = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
			$this->tickets_types_id = ($row[$startcol + 2] !== null) ? (int) $row[$startcol + 2] : null;
			$this->tickets_status_id = ($row[$startcol + 3] !== null) ? (int) $row[$startcol + 3] : null;
			$this->name = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
			$this->description = ($row[$startcol + 5] !== null) ? (string) $row[$startcol + 5] : null;
			$this->users_id = ($row[$startcol + 6] !== null) ? (int) $row[$startcol + 6] : null;
			$this->projects_id = ($row[$startcol + 7] !== null) ? (int) $row[$startcol + 7] : null;
			$this->created_at = ($row[$startcol + 8] !== null) ? (string) $row[$startcol + 8] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 9; // 9 = TicketsPeer::NUM_COLUMNS - TicketsPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating Tickets object", $e);
		}
	}

	/**
	 * Checks and repairs the internal consistency of the object.
	 *
	 * This method is executed after an already-instantiated object is re-hydrated
	 * from the database.  It exists to check any foreign keys to make sure that
	 * the objects related to the current object are correct based on foreign key.
	 *
	 * You can override this method in the stub class, but you should always invoke
	 * the base method from the overridden method (i.e. parent::ensureConsistency()),
	 * in case your model changes.
	 *
	 * @throws     PropelException
	 */
	public function ensureConsistency()
	{

		if ($this->aDepartments !== null && $this->departments_id !== $this->aDepartments->getId()) {
			$this->aDepartments = null;
		}
		if ($this->aTicketsTypes !== null && $this->tickets_types_id !== $this->aTicketsTypes->getId()) {
			$this->aTicketsTypes = null;
		}
		if ($this->aTicketsStatus !== null && $this->tickets_status_id !== $this->aTicketsStatus->getId()) {
			$this->aTicketsStatus = null;
		}
		if ($this->aUsers !== null && $this->users_id !== $this->aUsers->getId()) {
			$this->aUsers = null;
		}
		if ($this->aProjects !== null && $this->projects_id !== $this->aProjects->getId()) {
			$this->aProjects = null;
		}
	} // ensureConsistency

	/**
	 * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
	 *
	 * This will only work if the object has been saved and has a valid primary key set.
	 *
	 * @param      boolean $deep (optional) Whether to also de-associated any related objects.
	 * @param      PropelPDO $con (optional) The PropelPDO connection to use.
	 * @return     void
	 * @throws     PropelException - if this object is deleted, unsaved or doesn't have pk match in db
	 */
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(TicketsPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

		// We don't need to alter the object instance pool; we're just modifying this instance
		// already in the pool.

		$stmt = TicketsPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); // rehydrate

		if ($deep) {  // also de-associate any related objects?

			$this->aDepartments = null;
			$this->aTicketsTypes = null;
			$this->aTicketsStatus = null;
			$this->aUsers = null;
			$this->aProjects = null;
			$this->collTaskss = null;
			$this->lastTasksCriteria = null;

			$this->collTicketsCommentss = null;
			$this->lastTicketsCommentsCriteria = null;

		} // if (deep)
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param      PropelPDO $con
	 * @return     void
	 * @throws     PropelException
	 * @see        BaseObject::setDeleted()
	 * @see        BaseObject::isDeleted()
	 */
	public function delete(PropelPDO $con = null)
	{

    foreach (sfMixer::getCallables('BaseTickets:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(TicketsPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			TicketsPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseTickets:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	/**
	 * Persists this object to the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All modified related objects will also be persisted in the doSave()
	 * method.  This method wraps all precipitate database operations in a
	 * single transaction.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        doSave()
	 */
	public function save(PropelPDO $con = null)
	{

    foreach (sfMixer::getCallables('BaseTickets:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


    if ($this->isNew() && !$this->isColumnModified(TicketsPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(TicketsPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseTickets:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			TicketsPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	/**
	 * Performs the work of inserting or updating the row in the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        save()
	 */
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aDepartments !== null) {
				if ($this->aDepartments->isModified() || $this->aDepartments->isNew()) {
					$affectedRows += $this->aDepartments->save($con);
				}
				$this->setDepartments($this->aDepartments);
			}

			if ($this->aTicketsTypes !== null) {
				if ($this->aTicketsTypes->isModified() || $this->aTicketsTypes->isNew()) {
					$affectedRows += $this->aTicketsTypes->save($con);
				}
				$this->setTicketsTypes($this->aTicketsTypes);
			}

			if ($this->aTicketsStatus !== null) {
				if ($this->aTicketsStatus->isModified() || $this->aTicketsStatus->isNew()) {
					$affectedRows += $this->aTicketsStatus->save($con);
				}
				$this->setTicketsStatus($this->aTicketsStatus);
			}

			if ($this->aUsers !== null) {
				if ($this->aUsers->isModified() || $this->aUsers->isNew()) {
					$affectedRows += $this->aUsers->save($con);
				}
				$this->setUsers($this->aUsers);
			}

			if ($this->aProjects !== null) {
				if ($this->aProjects->isModified() || $this->aProjects->isNew()) {
					$affectedRows += $this->aProjects->save($con);
				}
				$this->setProjects($this->aProjects);
			}

			if ($this->isNew() ) {
				$this->modifiedColumns[] = TicketsPeer::ID;
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = TicketsPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which
										 // should always be true here (even though technically
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setId($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += TicketsPeer::doUpdate($this, $con);
				}

				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			if ($this->collTaskss !== null) {
				foreach ($this->collTaskss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collTicketsCommentss !== null) {
				foreach ($this->collTicketsCommentss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var        array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return     array ValidationFailed[]
	 * @see        validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param      mixed $columns Column name or an array of column names.
	 * @return     boolean Whether all columns pass validation.
	 * @see        doValidate()
	 * @see        getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param      array $columns Array of column names to validate.
	 * @return     mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aDepartments !== null) {
				if (!$this->aDepartments->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aDepartments->getValidationFailures());
				}
			}

			if ($this->aTicketsTypes !== null) {
				if (!$this->aTicketsTypes->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aTicketsTypes->getValidationFailures());
				}
			}

			if ($this->aTicketsStatus !== null) {
				if (!$this->aTicketsStatus->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aTicketsStatus->getValidationFailures());
				}
			}

			if ($this->aUsers !== null) {
				if (!$this->aUsers->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUsers->getValidationFailures());
				}
			}

			if ($this->aProjects !== null) {
				if (!$this->aProjects->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aProjects->getValidationFailures());
				}
			}


			if (($retval = TicketsPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collTaskss !== null) {
					foreach ($this->collTaskss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collTicketsCommentss !== null) {
					foreach ($this->collTicketsCommentss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param      string $name name
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = TicketsPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @return     mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getDepartmentsId();
				break;
			case 2:
				return $this->getTicketsTypesId();
				break;
			case 3:
				return $this->getTicketsStatusId();
				break;
			case 4:
				return $this->getName();
				break;
			case 5:
				return $this->getDescription();
				break;
			case 6:
				return $this->getUsersId();
				break;
			case 7:
				return $this->getProjectsId();
				break;
			case 8:
				return $this->getCreatedAt();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param      string $keyType (optional) One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                        BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM. Defaults to BasePeer::TYPE_PHPNAME.
	 * @param      boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns.  Defaults to TRUE.
	 * @return     an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = TicketsPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getDepartmentsId(),
			$keys[2] => $this->getTicketsTypesId(),
			$keys[3] => $this->getTicketsStatusId(),
			$keys[4] => $this->getName(),
			$keys[5] => $this->getDescription(),
			$keys[6] => $this->getUsersId(),
			$keys[7] => $this->getProjectsId(),
			$keys[8] => $this->getCreatedAt(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param      string $name peer name
	 * @param      mixed $value field value
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = TicketsPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @param      mixed $value field value
	 * @return     void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setDepartmentsId($value);
				break;
			case 2:
				$this->setTicketsTypesId($value);
				break;
			case 3:
				$this->setTicketsStatusId($value);
				break;
			case 4:
				$this->setName($value);
				break;
			case 5:
				$this->setDescription($value);
				break;
			case 6:
				$this->setUsersId($value);
				break;
			case 7:
				$this->setProjectsId($value);
				break;
			case 8:
				$this->setCreatedAt($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
	 * BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
	 * The default key type is the column's phpname (e.g. 'AuthorId')
	 *
	 * @param      array  $arr     An array to populate the object from.
	 * @param      string $keyType The type of keys the array uses.
	 * @return     void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = TicketsPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setDepartmentsId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setTicketsTypesId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setTicketsStatusId($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setName($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setDescription($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setUsersId($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setProjectsId($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setCreatedAt($arr[$keys[8]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return     Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(TicketsPeer::DATABASE_NAME);

		if ($this->isColumnModified(TicketsPeer::ID)) $criteria->add(TicketsPeer::ID, $this->id);
		if ($this->isColumnModified(TicketsPeer::DEPARTMENTS_ID)) $criteria->add(TicketsPeer::DEPARTMENTS_ID, $this->departments_id);
		if ($this->isColumnModified(TicketsPeer::TICKETS_TYPES_ID)) $criteria->add(TicketsPeer::TICKETS_TYPES_ID, $this->tickets_types_id);
		if ($this->isColumnModified(TicketsPeer::TICKETS_STATUS_ID)) $criteria->add(TicketsPeer::TICKETS_STATUS_ID, $this->tickets_status_id);
		if ($this->isColumnModified(TicketsPeer::NAME)) $criteria->add(TicketsPeer::NAME, $this->name);
		if ($this->isColumnModified(TicketsPeer::DESCRIPTION)) $criteria->add(TicketsPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(TicketsPeer::USERS_ID)) $criteria->add(TicketsPeer::USERS_ID, $this->users_id);
		if ($this->isColumnModified(TicketsPeer::PROJECTS_ID)) $criteria->add(TicketsPeer::PROJECTS_ID, $this->projects_id);
		if ($this->isColumnModified(TicketsPeer::CREATED_AT)) $criteria->add(TicketsPeer::CREATED_AT, $this->created_at);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return     Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(TicketsPeer::DATABASE_NAME);

		$criteria->add(TicketsPeer::ID, $this->id);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return     int
	 */
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	/**
	 * Generic method to set the primary key (id column).
	 *
	 * @param      int $key Primary key.
	 * @return     void
	 */
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      object $copyObj An object of Tickets (or compatible) type.
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws     PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setDepartmentsId($this->departments_id);

		$copyObj->setTicketsTypesId($this->tickets_types_id);

		$copyObj->setTicketsStatusId($this->tickets_status_id);

		$copyObj->setName($this->name);

		$copyObj->setDescription($this->description);

		$copyObj->setUsersId($this->users_id);

		$copyObj->setProjectsId($this->projects_id);

		$copyObj->setCreatedAt($this->created_at);


		if ($deepCopy) {
			// important: temporarily setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach ($this->getTaskss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addTasks($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getTicketsCommentss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addTicketsComments($relObj->copy($deepCopy));
				}
			}

		} // if ($deepCopy)


		$copyObj->setNew(true);

		$copyObj->setId(NULL); // this is a auto-increment column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return     Tickets Clone of current object.
	 * @throws     PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return     TicketsPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new TicketsPeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a Departments object.
	 *
	 * @param      Departments $v
	 * @return     Tickets The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setDepartments(Departments $v = null)
	{
		if ($v === null) {
			$this->setDepartmentsId(NULL);
		} else {
			$this->setDepartmentsId($v->getId());
		}

		$this->aDepartments = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the Departments object, it will not be re-added.
		if ($v !== null) {
			$v->addTickets($this);
		}

		return $this;
	}


	/**
	 * Get the associated Departments object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     Departments The associated Departments object.
	 * @throws     PropelException
	 */
	public function getDepartments(PropelPDO $con = null)
	{
		if ($this->aDepartments === null && ($this->departments_id !== null)) {
			$c = new Criteria(DepartmentsPeer::DATABASE_NAME);
			$c->add(DepartmentsPeer::ID, $this->departments_id);
			$this->aDepartments = DepartmentsPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aDepartments->addTicketss($this);
			 */
		}
		return $this->aDepartments;
	}

	/**
	 * Declares an association between this object and a TicketsTypes object.
	 *
	 * @param      TicketsTypes $v
	 * @return     Tickets The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setTicketsTypes(TicketsTypes $v = null)
	{
		if ($v === null) {
			$this->setTicketsTypesId(NULL);
		} else {
			$this->setTicketsTypesId($v->getId());
		}

		$this->aTicketsTypes = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the TicketsTypes object, it will not be re-added.
		if ($v !== null) {
			$v->addTickets($this);
		}

		return $this;
	}


	/**
	 * Get the associated TicketsTypes object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     TicketsTypes The associated TicketsTypes object.
	 * @throws     PropelException
	 */
	public function getTicketsTypes(PropelPDO $con = null)
	{
		if ($this->aTicketsTypes === null && ($this->tickets_types_id !== null)) {
			$c = new Criteria(TicketsTypesPeer::DATABASE_NAME);
			$c->add(TicketsTypesPeer::ID, $this->tickets_types_id);
			$this->aTicketsTypes = TicketsTypesPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aTicketsTypes->addTicketss($this);
			 */
		}
		return $this->aTicketsTypes;
	}

	/**
	 * Declares an association between this object and a TicketsStatus object.
	 *
	 * @param      TicketsStatus $v
	 * @return     Tickets The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setTicketsStatus(TicketsStatus $v = null)
	{
		if ($v === null) {
			$this->setTicketsStatusId(NULL);
		} else {
			$this->setTicketsStatusId($v->getId());
		}

		$this->aTicketsStatus = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the TicketsStatus object, it will not be re-added.
		if ($v !== null) {
			$v->addTickets($this);
		}

		return $this;
	}


	/**
	 * Get the associated TicketsStatus object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     TicketsStatus The associated TicketsStatus object.
	 * @throws     PropelException
	 */
	public function getTicketsStatus(PropelPDO $con = null)
	{
		if ($this->aTicketsStatus === null && ($this->tickets_status_id !== null)) {
			$c = new Criteria(TicketsStatusPeer::DATABASE_NAME);
			$c->add(TicketsStatusPeer::ID, $this->tickets_status_id);
			$this->aTicketsStatus = TicketsStatusPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aTicketsStatus->addTicketss($this);
			 */
		}
		return $this->aTicketsStatus;
	}

	/**
	 * Declares an association between this object and a Users object.
	 *
	 * @param      Users $v
	 * @return     Tickets The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setUsers(Users $v = null)
	{
		if ($v === null) {
			$this->setUsersId(0);
		} else {
			$this->setUsersId($v->getId());
		}

		$this->aUsers = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the Users object, it will not be re-added.
		if ($v !== null) {
			$v->addTickets($this);
		}

		return $this;
	}


	/**
	 * Get the associated Users object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     Users The associated Users object.
	 * @throws     PropelException
	 */
	public function getUsers(PropelPDO $con = null)
	{
		if ($this->aUsers === null && ($this->users_id !== null)) {
			$c = new Criteria(UsersPeer::DATABASE_NAME);
			$c->add(UsersPeer::ID, $this->users_id);
			$this->aUsers = UsersPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aUsers->addTicketss($this);
			 */
		}
		return $this->aUsers;
	}

	/**
	 * Declares an association between this object and a Projects object.
	 *
	 * @param      Projects $v
	 * @return     Tickets The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setProjects(Projects $v = null)
	{
		if ($v === null) {
			$this->setProjectsId(0);
		} else {
			$this->setProjectsId($v->getId());
		}

		$this->aProjects = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the Projects object, it will not be re-added.
		if ($v !== null) {
			$v->addTickets($this);
		}

		return $this;
	}


	/**
	 * Get the associated Projects object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     Projects The associated Projects object.
	 * @throws     PropelException
	 */
	public function getProjects(PropelPDO $con = null)
	{
		if ($this->aProjects === null && ($this->projects_id !== null)) {
			$c = new Criteria(ProjectsPeer::DATABASE_NAME);
			$c->add(ProjectsPeer::ID, $this->projects_id);
			$this->aProjects = ProjectsPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aProjects->addTicketss($this);
			 */
		}
		return $this->aProjects;
	}

	/**
	 * Clears out the collTaskss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addTaskss()
	 */
	public function clearTaskss()
	{
		$this->collTaskss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collTaskss collection (array).
	 *
	 * By default this just sets the collTaskss collection to an empty array (like clearcollTaskss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initTaskss()
	{
		$this->collTaskss = array();
	}

	/**
	 * Gets an array of Tasks objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Tickets has previously been saved, it will retrieve
	 * related Taskss from storage. If this Tickets is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Tasks[]
	 * @throws     PropelException
	 */
	public function getTaskss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TicketsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
			   $this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::TICKETS_ID, $this->id);

				TasksPeer::addSelectColumns($criteria);
				$this->collTaskss = TasksPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(TasksPeer::TICKETS_ID, $this->id);

				TasksPeer::addSelectColumns($criteria);
				if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
					$this->collTaskss = TasksPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTasksCriteria = $criteria;
		return $this->collTaskss;
	}

	/**
	 * Returns the number of related Tasks objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Tasks objects.
	 * @throws     PropelException
	 */
	public function countTaskss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TicketsPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(TasksPeer::TICKETS_ID, $this->id);

				$count = TasksPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(TasksPeer::TICKETS_ID, $this->id);

				if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
					$count = TasksPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collTaskss);
				}
			} else {
				$count = count($this->collTaskss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a Tasks object to this object
	 * through the Tasks foreign key attribute.
	 *
	 * @param      Tasks $l Tasks
	 * @return     void
	 * @throws     PropelException
	 */
	public function addTasks(Tasks $l)
	{
		if ($this->collTaskss === null) {
			$this->initTaskss();
		}
		if (!in_array($l, $this->collTaskss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collTaskss, $l);
			$l->setTickets($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tickets is new, it will return
	 * an empty collection; or if this Tickets has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tickets.
	 */
	public function getTaskssJoinProjects($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TicketsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::TICKETS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinProjects($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::TICKETS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinProjects($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tickets is new, it will return
	 * an empty collection; or if this Tickets has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tickets.
	 */
	public function getTaskssJoinTasksStatus($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TicketsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::TICKETS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinTasksStatus($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::TICKETS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinTasksStatus($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tickets is new, it will return
	 * an empty collection; or if this Tickets has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tickets.
	 */
	public function getTaskssJoinTasksPriority($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TicketsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::TICKETS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinTasksPriority($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::TICKETS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinTasksPriority($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tickets is new, it will return
	 * an empty collection; or if this Tickets has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tickets.
	 */
	public function getTaskssJoinTasksTypes($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TicketsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::TICKETS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinTasksTypes($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::TICKETS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinTasksTypes($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tickets is new, it will return
	 * an empty collection; or if this Tickets has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tickets.
	 */
	public function getTaskssJoinTasksLabels($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TicketsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::TICKETS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinTasksLabels($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::TICKETS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinTasksLabels($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tickets is new, it will return
	 * an empty collection; or if this Tickets has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tickets.
	 */
	public function getTaskssJoinTasksGroups($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TicketsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::TICKETS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinTasksGroups($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::TICKETS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinTasksGroups($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tickets is new, it will return
	 * an empty collection; or if this Tickets has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tickets.
	 */
	public function getTaskssJoinProjectsPhases($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TicketsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::TICKETS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinProjectsPhases($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::TICKETS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinProjectsPhases($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tickets is new, it will return
	 * an empty collection; or if this Tickets has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tickets.
	 */
	public function getTaskssJoinVersions($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TicketsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::TICKETS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinVersions($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::TICKETS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinVersions($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tickets is new, it will return
	 * an empty collection; or if this Tickets has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tickets.
	 */
	public function getTaskssJoinUsers($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TicketsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::TICKETS_ID, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinUsers($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::TICKETS_ID, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinUsers($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}

	/**
	 * Clears out the collTicketsCommentss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addTicketsCommentss()
	 */
	public function clearTicketsCommentss()
	{
		$this->collTicketsCommentss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collTicketsCommentss collection (array).
	 *
	 * By default this just sets the collTicketsCommentss collection to an empty array (like clearcollTicketsCommentss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initTicketsCommentss()
	{
		$this->collTicketsCommentss = array();
	}

	/**
	 * Gets an array of TicketsComments objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Tickets has previously been saved, it will retrieve
	 * related TicketsCommentss from storage. If this Tickets is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array TicketsComments[]
	 * @throws     PropelException
	 */
	public function getTicketsCommentss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TicketsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTicketsCommentss === null) {
			if ($this->isNew()) {
			   $this->collTicketsCommentss = array();
			} else {

				$criteria->add(TicketsCommentsPeer::TICKETS_ID, $this->id);

				TicketsCommentsPeer::addSelectColumns($criteria);
				$this->collTicketsCommentss = TicketsCommentsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(TicketsCommentsPeer::TICKETS_ID, $this->id);

				TicketsCommentsPeer::addSelectColumns($criteria);
				if (!isset($this->lastTicketsCommentsCriteria) || !$this->lastTicketsCommentsCriteria->equals($criteria)) {
					$this->collTicketsCommentss = TicketsCommentsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTicketsCommentsCriteria = $criteria;
		return $this->collTicketsCommentss;
	}

	/**
	 * Returns the number of related TicketsComments objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related TicketsComments objects.
	 * @throws     PropelException
	 */
	public function countTicketsCommentss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TicketsPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collTicketsCommentss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(TicketsCommentsPeer::TICKETS_ID, $this->id);

				$count = TicketsCommentsPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(TicketsCommentsPeer::TICKETS_ID, $this->id);

				if (!isset($this->lastTicketsCommentsCriteria) || !$this->lastTicketsCommentsCriteria->equals($criteria)) {
					$count = TicketsCommentsPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collTicketsCommentss);
				}
			} else {
				$count = count($this->collTicketsCommentss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a TicketsComments object to this object
	 * through the TicketsComments foreign key attribute.
	 *
	 * @param      TicketsComments $l TicketsComments
	 * @return     void
	 * @throws     PropelException
	 */
	public function addTicketsComments(TicketsComments $l)
	{
		if ($this->collTicketsCommentss === null) {
			$this->initTicketsCommentss();
		}
		if (!in_array($l, $this->collTicketsCommentss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collTicketsCommentss, $l);
			$l->setTickets($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tickets is new, it will return
	 * an empty collection; or if this Tickets has previously
	 * been saved, it will retrieve related TicketsCommentss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tickets.
	 */
	public function getTicketsCommentssJoinUsers($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TicketsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTicketsCommentss === null) {
			if ($this->isNew()) {
				$this->collTicketsCommentss = array();
			} else {

				$criteria->add(TicketsCommentsPeer::TICKETS_ID, $this->id);

				$this->collTicketsCommentss = TicketsCommentsPeer::doSelectJoinUsers($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TicketsCommentsPeer::TICKETS_ID, $this->id);

			if (!isset($this->lastTicketsCommentsCriteria) || !$this->lastTicketsCommentsCriteria->equals($criteria)) {
				$this->collTicketsCommentss = TicketsCommentsPeer::doSelectJoinUsers($criteria, $con, $join_behavior);
			}
		}
		$this->lastTicketsCommentsCriteria = $criteria;

		return $this->collTicketsCommentss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tickets is new, it will return
	 * an empty collection; or if this Tickets has previously
	 * been saved, it will retrieve related TicketsCommentss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tickets.
	 */
	public function getTicketsCommentssJoinTicketsStatus($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(TicketsPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTicketsCommentss === null) {
			if ($this->isNew()) {
				$this->collTicketsCommentss = array();
			} else {

				$criteria->add(TicketsCommentsPeer::TICKETS_ID, $this->id);

				$this->collTicketsCommentss = TicketsCommentsPeer::doSelectJoinTicketsStatus($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TicketsCommentsPeer::TICKETS_ID, $this->id);

			if (!isset($this->lastTicketsCommentsCriteria) || !$this->lastTicketsCommentsCriteria->equals($criteria)) {
				$this->collTicketsCommentss = TicketsCommentsPeer::doSelectJoinTicketsStatus($criteria, $con, $join_behavior);
			}
		}
		$this->lastTicketsCommentsCriteria = $criteria;

		return $this->collTicketsCommentss;
	}

	/**
	 * Resets all collections of referencing foreign keys.
	 *
	 * This method is a user-space workaround for PHP's inability to garbage collect objects
	 * with circular references.  This is currently necessary when using Propel in certain
	 * daemon or large-volumne/high-memory operations.
	 *
	 * @param      boolean $deep Whether to also clear the references on all associated objects.
	 */
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collTaskss) {
				foreach ((array) $this->collTaskss as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collTicketsCommentss) {
				foreach ((array) $this->collTicketsCommentss as $o) {
					$o->clearAllReferences($deep);
				}
			}
		} // if ($deep)

		$this->collTaskss = null;
		$this->collTicketsCommentss = null;
			$this->aDepartments = null;
			$this->aTicketsTypes = null;
			$this->aTicketsStatus = null;
			$this->aUsers = null;
			$this->aProjects = null;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseTickets:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseTickets::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} // BaseTickets
