<?php

/**
 * Base class that represents a row from the 'user_reports' table.
 *
 * 
 *
 * This class was autogenerated by Propel 1.3.0-dev on:
 *
 * 10/01/11 13:54:41
 *
 * @package    lib.model.om
 */
abstract class BaseUserReports extends BaseObject  implements Persistent {


  const PEER = 'UserReportsPeer';

	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var        UserReportsPeer
	 */
	protected static $peer;

	/**
	 * The value for the id field.
	 * @var        int
	 */
	protected $id;

	/**
	 * The value for the users_id field.
	 * Note: this column has a database default value of: 0
	 * @var        int
	 */
	protected $users_id;

	/**
	 * The value for the name field.
	 * Note: this column has a database default value of: ''
	 * @var        string
	 */
	protected $name;

	/**
	 * The value for the display_on_home field.
	 * @var        int
	 */
	protected $display_on_home;

	/**
	 * The value for the projects_id field.
	 * @var        string
	 */
	protected $projects_id;

	/**
	 * The value for the projects_type_id field.
	 * @var        string
	 */
	protected $projects_type_id;

	/**
	 * The value for the projects_status_id field.
	 * @var        string
	 */
	protected $projects_status_id;

	/**
	 * The value for the assigned_to field.
	 * @var        string
	 */
	protected $assigned_to;

	/**
	 * The value for the tasks_status_id field.
	 * @var        string
	 */
	protected $tasks_status_id;

	/**
	 * The value for the tasks_type_id field.
	 * @var        string
	 */
	protected $tasks_type_id;

	/**
	 * The value for the tasks_label_id field.
	 * @var        string
	 */
	protected $tasks_label_id;

	/**
	 * The value for the due_date_from field.
	 * @var        string
	 */
	protected $due_date_from;

	/**
	 * The value for the due_date_to field.
	 * @var        string
	 */
	protected $due_date_to;

	/**
	 * The value for the created_from field.
	 * @var        string
	 */
	protected $created_from;

	/**
	 * The value for the created_to field.
	 * @var        string
	 */
	protected $created_to;

	/**
	 * The value for the closed_from field.
	 * @var        string
	 */
	protected $closed_from;

	/**
	 * The value for the closed_to field.
	 * @var        string
	 */
	protected $closed_to;

	/**
	 * The value for the sort_order field.
	 * @var        int
	 */
	protected $sort_order;

	/**
	 * @var        Users
	 */
	protected $aUsers;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInValidation = false;

	/**
	 * Initializes internal state of BaseUserReports object.
	 * @see        applyDefaults()
	 */
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	/**
	 * Applies default values to this object.
	 * This method should be called from the object's constructor (or
	 * equivalent initialization method).
	 * @see        __construct()
	 */
	public function applyDefaultValues()
	{
		$this->users_id = 0;
		$this->name = '';
	}

	/**
	 * Get the [id] column value.
	 * 
	 * @return     int
	 */
	public function getId()
	{
		return $this->id;
	}

	/**
	 * Get the [users_id] column value.
	 * 
	 * @return     int
	 */
	public function getUsersId()
	{
		return $this->users_id;
	}

	/**
	 * Get the [name] column value.
	 * 
	 * @return     string
	 */
	public function getName()
	{
		return $this->name;
	}

	/**
	 * Get the [display_on_home] column value.
	 * 
	 * @return     int
	 */
	public function getDisplayOnHome()
	{
		return $this->display_on_home;
	}

	/**
	 * Get the [projects_id] column value.
	 * 
	 * @return     string
	 */
	public function getProjectsId()
	{
		return $this->projects_id;
	}

	/**
	 * Get the [projects_type_id] column value.
	 * 
	 * @return     string
	 */
	public function getProjectsTypeId()
	{
		return $this->projects_type_id;
	}

	/**
	 * Get the [projects_status_id] column value.
	 * 
	 * @return     string
	 */
	public function getProjectsStatusId()
	{
		return $this->projects_status_id;
	}

	/**
	 * Get the [assigned_to] column value.
	 * 
	 * @return     string
	 */
	public function getAssignedTo()
	{
		return $this->assigned_to;
	}

	/**
	 * Get the [tasks_status_id] column value.
	 * 
	 * @return     string
	 */
	public function getTasksStatusId()
	{
		return $this->tasks_status_id;
	}

	/**
	 * Get the [tasks_type_id] column value.
	 * 
	 * @return     string
	 */
	public function getTasksTypeId()
	{
		return $this->tasks_type_id;
	}

	/**
	 * Get the [tasks_label_id] column value.
	 * 
	 * @return     string
	 */
	public function getTasksLabelId()
	{
		return $this->tasks_label_id;
	}

	/**
	 * Get the [optionally formatted] temporal [due_date_from] column value.
	 * 
	 *
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the raw DateTime object will be returned.
	 * @return     mixed Formatted date/time value as string or DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00
	 * @throws     PropelException - if unable to parse/validate the date/time value.
	 */
	public function getDueDateFrom($format = 'Y-m-d')
	{
		if ($this->due_date_from === null) {
			return null;
		}


		if ($this->due_date_from === '0000-00-00') {
			// while technically this is not a default value of NULL,
			// this seems to be closest in meaning.
			return null;
		} else {
			try {
				$dt = new DateTime($this->due_date_from);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->due_date_from, true), $x);
			}
		}

		if ($format === null) {
			// Because propel.useDateTimeClass is TRUE, we return a DateTime object.
			return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	/**
	 * Get the [optionally formatted] temporal [due_date_to] column value.
	 * 
	 *
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the raw DateTime object will be returned.
	 * @return     mixed Formatted date/time value as string or DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00
	 * @throws     PropelException - if unable to parse/validate the date/time value.
	 */
	public function getDueDateTo($format = 'Y-m-d')
	{
		if ($this->due_date_to === null) {
			return null;
		}


		if ($this->due_date_to === '0000-00-00') {
			// while technically this is not a default value of NULL,
			// this seems to be closest in meaning.
			return null;
		} else {
			try {
				$dt = new DateTime($this->due_date_to);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->due_date_to, true), $x);
			}
		}

		if ($format === null) {
			// Because propel.useDateTimeClass is TRUE, we return a DateTime object.
			return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	/**
	 * Get the [optionally formatted] temporal [created_from] column value.
	 * 
	 *
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the raw DateTime object will be returned.
	 * @return     mixed Formatted date/time value as string or DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00
	 * @throws     PropelException - if unable to parse/validate the date/time value.
	 */
	public function getCreatedFrom($format = 'Y-m-d')
	{
		if ($this->created_from === null) {
			return null;
		}


		if ($this->created_from === '0000-00-00') {
			// while technically this is not a default value of NULL,
			// this seems to be closest in meaning.
			return null;
		} else {
			try {
				$dt = new DateTime($this->created_from);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->created_from, true), $x);
			}
		}

		if ($format === null) {
			// Because propel.useDateTimeClass is TRUE, we return a DateTime object.
			return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	/**
	 * Get the [optionally formatted] temporal [created_to] column value.
	 * 
	 *
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the raw DateTime object will be returned.
	 * @return     mixed Formatted date/time value as string or DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00
	 * @throws     PropelException - if unable to parse/validate the date/time value.
	 */
	public function getCreatedTo($format = 'Y-m-d')
	{
		if ($this->created_to === null) {
			return null;
		}


		if ($this->created_to === '0000-00-00') {
			// while technically this is not a default value of NULL,
			// this seems to be closest in meaning.
			return null;
		} else {
			try {
				$dt = new DateTime($this->created_to);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->created_to, true), $x);
			}
		}

		if ($format === null) {
			// Because propel.useDateTimeClass is TRUE, we return a DateTime object.
			return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	/**
	 * Get the [optionally formatted] temporal [closed_from] column value.
	 * 
	 *
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the raw DateTime object will be returned.
	 * @return     mixed Formatted date/time value as string or DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00
	 * @throws     PropelException - if unable to parse/validate the date/time value.
	 */
	public function getClosedFrom($format = 'Y-m-d')
	{
		if ($this->closed_from === null) {
			return null;
		}


		if ($this->closed_from === '0000-00-00') {
			// while technically this is not a default value of NULL,
			// this seems to be closest in meaning.
			return null;
		} else {
			try {
				$dt = new DateTime($this->closed_from);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->closed_from, true), $x);
			}
		}

		if ($format === null) {
			// Because propel.useDateTimeClass is TRUE, we return a DateTime object.
			return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	/**
	 * Get the [optionally formatted] temporal [closed_to] column value.
	 * 
	 *
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the raw DateTime object will be returned.
	 * @return     mixed Formatted date/time value as string or DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00
	 * @throws     PropelException - if unable to parse/validate the date/time value.
	 */
	public function getClosedTo($format = 'Y-m-d')
	{
		if ($this->closed_to === null) {
			return null;
		}


		if ($this->closed_to === '0000-00-00') {
			// while technically this is not a default value of NULL,
			// this seems to be closest in meaning.
			return null;
		} else {
			try {
				$dt = new DateTime($this->closed_to);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->closed_to, true), $x);
			}
		}

		if ($format === null) {
			// Because propel.useDateTimeClass is TRUE, we return a DateTime object.
			return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	/**
	 * Get the [sort_order] column value.
	 * 
	 * @return     int
	 */
	public function getSortOrder()
	{
		return $this->sort_order;
	}

	/**
	 * Set the value of [id] column.
	 * 
	 * @param      int $v new value
	 * @return     UserReports The current object (for fluent API support)
	 */
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = UserReportsPeer::ID;
		}

		return $this;
	} // setId()

	/**
	 * Set the value of [users_id] column.
	 * 
	 * @param      int $v new value
	 * @return     UserReports The current object (for fluent API support)
	 */
	public function setUsersId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->users_id !== $v || $v === 0) {
			$this->users_id = $v;
			$this->modifiedColumns[] = UserReportsPeer::USERS_ID;
		}

		if ($this->aUsers !== null && $this->aUsers->getId() !== $v) {
			$this->aUsers = null;
		}

		return $this;
	} // setUsersId()

	/**
	 * Set the value of [name] column.
	 * 
	 * @param      string $v new value
	 * @return     UserReports The current object (for fluent API support)
	 */
	public function setName($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->name !== $v || $v === '') {
			$this->name = $v;
			$this->modifiedColumns[] = UserReportsPeer::NAME;
		}

		return $this;
	} // setName()

	/**
	 * Set the value of [display_on_home] column.
	 * 
	 * @param      int $v new value
	 * @return     UserReports The current object (for fluent API support)
	 */
	public function setDisplayOnHome($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->display_on_home !== $v) {
			$this->display_on_home = $v;
			$this->modifiedColumns[] = UserReportsPeer::DISPLAY_ON_HOME;
		}

		return $this;
	} // setDisplayOnHome()

	/**
	 * Set the value of [projects_id] column.
	 * 
	 * @param      string $v new value
	 * @return     UserReports The current object (for fluent API support)
	 */
	public function setProjectsId($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->projects_id !== $v) {
			$this->projects_id = $v;
			$this->modifiedColumns[] = UserReportsPeer::PROJECTS_ID;
		}

		return $this;
	} // setProjectsId()

	/**
	 * Set the value of [projects_type_id] column.
	 * 
	 * @param      string $v new value
	 * @return     UserReports The current object (for fluent API support)
	 */
	public function setProjectsTypeId($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->projects_type_id !== $v) {
			$this->projects_type_id = $v;
			$this->modifiedColumns[] = UserReportsPeer::PROJECTS_TYPE_ID;
		}

		return $this;
	} // setProjectsTypeId()

	/**
	 * Set the value of [projects_status_id] column.
	 * 
	 * @param      string $v new value
	 * @return     UserReports The current object (for fluent API support)
	 */
	public function setProjectsStatusId($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->projects_status_id !== $v) {
			$this->projects_status_id = $v;
			$this->modifiedColumns[] = UserReportsPeer::PROJECTS_STATUS_ID;
		}

		return $this;
	} // setProjectsStatusId()

	/**
	 * Set the value of [assigned_to] column.
	 * 
	 * @param      string $v new value
	 * @return     UserReports The current object (for fluent API support)
	 */
	public function setAssignedTo($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->assigned_to !== $v) {
			$this->assigned_to = $v;
			$this->modifiedColumns[] = UserReportsPeer::ASSIGNED_TO;
		}

		return $this;
	} // setAssignedTo()

	/**
	 * Set the value of [tasks_status_id] column.
	 * 
	 * @param      string $v new value
	 * @return     UserReports The current object (for fluent API support)
	 */
	public function setTasksStatusId($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->tasks_status_id !== $v) {
			$this->tasks_status_id = $v;
			$this->modifiedColumns[] = UserReportsPeer::TASKS_STATUS_ID;
		}

		return $this;
	} // setTasksStatusId()

	/**
	 * Set the value of [tasks_type_id] column.
	 * 
	 * @param      string $v new value
	 * @return     UserReports The current object (for fluent API support)
	 */
	public function setTasksTypeId($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->tasks_type_id !== $v) {
			$this->tasks_type_id = $v;
			$this->modifiedColumns[] = UserReportsPeer::TASKS_TYPE_ID;
		}

		return $this;
	} // setTasksTypeId()

	/**
	 * Set the value of [tasks_label_id] column.
	 * 
	 * @param      string $v new value
	 * @return     UserReports The current object (for fluent API support)
	 */
	public function setTasksLabelId($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->tasks_label_id !== $v) {
			$this->tasks_label_id = $v;
			$this->modifiedColumns[] = UserReportsPeer::TASKS_LABEL_ID;
		}

		return $this;
	} // setTasksLabelId()

	/**
	 * Sets the value of [due_date_from] column to a normalized version of the date/time value specified.
	 * 
	 * @param      mixed $v string, integer (timestamp), or DateTime value.  Empty string will
	 *						be treated as NULL for temporal objects.
	 * @return     UserReports The current object (for fluent API support)
	 */
	public function setDueDateFrom($v)
	{
		// we treat '' as NULL for temporal objects because DateTime('') == DateTime('now')
		// -- which is unexpected, to say the least.
		if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
			// some string/numeric value passed; we normalize that so that we can
			// validate it.
			try {
				if (is_numeric($v)) { // if it's a unix timestamp
					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
					// We have to explicitly specify and then change the time zone because of a
					// DateTime bug: http://bugs.php.net/bug.php?id=43003
					$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->due_date_from !== null || $dt !== null ) {
			// (nested ifs are a little easier to read in this case)

			$currNorm = ($this->due_date_from !== null && $tmpDt = new DateTime($this->due_date_from)) ? $tmpDt->format('Y-m-d') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d') : null;

			if ( ($currNorm !== $newNorm) // normalized values don't match 
					)
			{
				$this->due_date_from = ($dt ? $dt->format('Y-m-d') : null);
				$this->modifiedColumns[] = UserReportsPeer::DUE_DATE_FROM;
			}
		} // if either are not null

		return $this;
	} // setDueDateFrom()

	/**
	 * Sets the value of [due_date_to] column to a normalized version of the date/time value specified.
	 * 
	 * @param      mixed $v string, integer (timestamp), or DateTime value.  Empty string will
	 *						be treated as NULL for temporal objects.
	 * @return     UserReports The current object (for fluent API support)
	 */
	public function setDueDateTo($v)
	{
		// we treat '' as NULL for temporal objects because DateTime('') == DateTime('now')
		// -- which is unexpected, to say the least.
		if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
			// some string/numeric value passed; we normalize that so that we can
			// validate it.
			try {
				if (is_numeric($v)) { // if it's a unix timestamp
					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
					// We have to explicitly specify and then change the time zone because of a
					// DateTime bug: http://bugs.php.net/bug.php?id=43003
					$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->due_date_to !== null || $dt !== null ) {
			// (nested ifs are a little easier to read in this case)

			$currNorm = ($this->due_date_to !== null && $tmpDt = new DateTime($this->due_date_to)) ? $tmpDt->format('Y-m-d') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d') : null;

			if ( ($currNorm !== $newNorm) // normalized values don't match 
					)
			{
				$this->due_date_to = ($dt ? $dt->format('Y-m-d') : null);
				$this->modifiedColumns[] = UserReportsPeer::DUE_DATE_TO;
			}
		} // if either are not null

		return $this;
	} // setDueDateTo()

	/**
	 * Sets the value of [created_from] column to a normalized version of the date/time value specified.
	 * 
	 * @param      mixed $v string, integer (timestamp), or DateTime value.  Empty string will
	 *						be treated as NULL for temporal objects.
	 * @return     UserReports The current object (for fluent API support)
	 */
	public function setCreatedFrom($v)
	{
		// we treat '' as NULL for temporal objects because DateTime('') == DateTime('now')
		// -- which is unexpected, to say the least.
		if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
			// some string/numeric value passed; we normalize that so that we can
			// validate it.
			try {
				if (is_numeric($v)) { // if it's a unix timestamp
					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
					// We have to explicitly specify and then change the time zone because of a
					// DateTime bug: http://bugs.php.net/bug.php?id=43003
					$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->created_from !== null || $dt !== null ) {
			// (nested ifs are a little easier to read in this case)

			$currNorm = ($this->created_from !== null && $tmpDt = new DateTime($this->created_from)) ? $tmpDt->format('Y-m-d') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d') : null;

			if ( ($currNorm !== $newNorm) // normalized values don't match 
					)
			{
				$this->created_from = ($dt ? $dt->format('Y-m-d') : null);
				$this->modifiedColumns[] = UserReportsPeer::CREATED_FROM;
			}
		} // if either are not null

		return $this;
	} // setCreatedFrom()

	/**
	 * Sets the value of [created_to] column to a normalized version of the date/time value specified.
	 * 
	 * @param      mixed $v string, integer (timestamp), or DateTime value.  Empty string will
	 *						be treated as NULL for temporal objects.
	 * @return     UserReports The current object (for fluent API support)
	 */
	public function setCreatedTo($v)
	{
		// we treat '' as NULL for temporal objects because DateTime('') == DateTime('now')
		// -- which is unexpected, to say the least.
		if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
			// some string/numeric value passed; we normalize that so that we can
			// validate it.
			try {
				if (is_numeric($v)) { // if it's a unix timestamp
					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
					// We have to explicitly specify and then change the time zone because of a
					// DateTime bug: http://bugs.php.net/bug.php?id=43003
					$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->created_to !== null || $dt !== null ) {
			// (nested ifs are a little easier to read in this case)

			$currNorm = ($this->created_to !== null && $tmpDt = new DateTime($this->created_to)) ? $tmpDt->format('Y-m-d') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d') : null;

			if ( ($currNorm !== $newNorm) // normalized values don't match 
					)
			{
				$this->created_to = ($dt ? $dt->format('Y-m-d') : null);
				$this->modifiedColumns[] = UserReportsPeer::CREATED_TO;
			}
		} // if either are not null

		return $this;
	} // setCreatedTo()

	/**
	 * Sets the value of [closed_from] column to a normalized version of the date/time value specified.
	 * 
	 * @param      mixed $v string, integer (timestamp), or DateTime value.  Empty string will
	 *						be treated as NULL for temporal objects.
	 * @return     UserReports The current object (for fluent API support)
	 */
	public function setClosedFrom($v)
	{
		// we treat '' as NULL for temporal objects because DateTime('') == DateTime('now')
		// -- which is unexpected, to say the least.
		if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
			// some string/numeric value passed; we normalize that so that we can
			// validate it.
			try {
				if (is_numeric($v)) { // if it's a unix timestamp
					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
					// We have to explicitly specify and then change the time zone because of a
					// DateTime bug: http://bugs.php.net/bug.php?id=43003
					$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->closed_from !== null || $dt !== null ) {
			// (nested ifs are a little easier to read in this case)

			$currNorm = ($this->closed_from !== null && $tmpDt = new DateTime($this->closed_from)) ? $tmpDt->format('Y-m-d') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d') : null;

			if ( ($currNorm !== $newNorm) // normalized values don't match 
					)
			{
				$this->closed_from = ($dt ? $dt->format('Y-m-d') : null);
				$this->modifiedColumns[] = UserReportsPeer::CLOSED_FROM;
			}
		} // if either are not null

		return $this;
	} // setClosedFrom()

	/**
	 * Sets the value of [closed_to] column to a normalized version of the date/time value specified.
	 * 
	 * @param      mixed $v string, integer (timestamp), or DateTime value.  Empty string will
	 *						be treated as NULL for temporal objects.
	 * @return     UserReports The current object (for fluent API support)
	 */
	public function setClosedTo($v)
	{
		// we treat '' as NULL for temporal objects because DateTime('') == DateTime('now')
		// -- which is unexpected, to say the least.
		if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
			// some string/numeric value passed; we normalize that so that we can
			// validate it.
			try {
				if (is_numeric($v)) { // if it's a unix timestamp
					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
					// We have to explicitly specify and then change the time zone because of a
					// DateTime bug: http://bugs.php.net/bug.php?id=43003
					$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->closed_to !== null || $dt !== null ) {
			// (nested ifs are a little easier to read in this case)

			$currNorm = ($this->closed_to !== null && $tmpDt = new DateTime($this->closed_to)) ? $tmpDt->format('Y-m-d') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d') : null;

			if ( ($currNorm !== $newNorm) // normalized values don't match 
					)
			{
				$this->closed_to = ($dt ? $dt->format('Y-m-d') : null);
				$this->modifiedColumns[] = UserReportsPeer::CLOSED_TO;
			}
		} // if either are not null

		return $this;
	} // setClosedTo()

	/**
	 * Set the value of [sort_order] column.
	 * 
	 * @param      int $v new value
	 * @return     UserReports The current object (for fluent API support)
	 */
	public function setSortOrder($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->sort_order !== $v) {
			$this->sort_order = $v;
			$this->modifiedColumns[] = UserReportsPeer::SORT_ORDER;
		}

		return $this;
	} // setSortOrder()

	/**
	 * Indicates whether the columns in this object are only set to default values.
	 *
	 * This method can be used in conjunction with isModified() to indicate whether an object is both
	 * modified _and_ has some values set which are non-default.
	 *
	 * @return     boolean Whether the columns in this object are only been set with default values.
	 */
	public function hasOnlyDefaultValues()
	{
			// First, ensure that we don't have any columns that have been modified which aren't default columns.
			if (array_diff($this->modifiedColumns, array(UserReportsPeer::USERS_ID,UserReportsPeer::NAME))) {
				return false;
			}

			if ($this->users_id !== 0) {
				return false;
			}

			if ($this->name !== '') {
				return false;
			}

		// otherwise, everything was equal, so return TRUE
		return true;
	} // hasOnlyDefaultValues()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (0-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param      array $row The row returned by PDOStatement->fetch(PDO::FETCH_NUM)
	 * @param      int $startcol 0-based offset column which indicates which restultset column to start with.
	 * @param      boolean $rehydrate Whether this object is being re-hydrated from the database.
	 * @return     int next starting column
	 * @throws     PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->users_id = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
			$this->name = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->display_on_home = ($row[$startcol + 3] !== null) ? (int) $row[$startcol + 3] : null;
			$this->projects_id = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
			$this->projects_type_id = ($row[$startcol + 5] !== null) ? (string) $row[$startcol + 5] : null;
			$this->projects_status_id = ($row[$startcol + 6] !== null) ? (string) $row[$startcol + 6] : null;
			$this->assigned_to = ($row[$startcol + 7] !== null) ? (string) $row[$startcol + 7] : null;
			$this->tasks_status_id = ($row[$startcol + 8] !== null) ? (string) $row[$startcol + 8] : null;
			$this->tasks_type_id = ($row[$startcol + 9] !== null) ? (string) $row[$startcol + 9] : null;
			$this->tasks_label_id = ($row[$startcol + 10] !== null) ? (string) $row[$startcol + 10] : null;
			$this->due_date_from = ($row[$startcol + 11] !== null) ? (string) $row[$startcol + 11] : null;
			$this->due_date_to = ($row[$startcol + 12] !== null) ? (string) $row[$startcol + 12] : null;
			$this->created_from = ($row[$startcol + 13] !== null) ? (string) $row[$startcol + 13] : null;
			$this->created_to = ($row[$startcol + 14] !== null) ? (string) $row[$startcol + 14] : null;
			$this->closed_from = ($row[$startcol + 15] !== null) ? (string) $row[$startcol + 15] : null;
			$this->closed_to = ($row[$startcol + 16] !== null) ? (string) $row[$startcol + 16] : null;
			$this->sort_order = ($row[$startcol + 17] !== null) ? (int) $row[$startcol + 17] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 18; // 18 = UserReportsPeer::NUM_COLUMNS - UserReportsPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating UserReports object", $e);
		}
	}

	/**
	 * Checks and repairs the internal consistency of the object.
	 *
	 * This method is executed after an already-instantiated object is re-hydrated
	 * from the database.  It exists to check any foreign keys to make sure that
	 * the objects related to the current object are correct based on foreign key.
	 *
	 * You can override this method in the stub class, but you should always invoke
	 * the base method from the overridden method (i.e. parent::ensureConsistency()),
	 * in case your model changes.
	 *
	 * @throws     PropelException
	 */
	public function ensureConsistency()
	{

		if ($this->aUsers !== null && $this->users_id !== $this->aUsers->getId()) {
			$this->aUsers = null;
		}
	} // ensureConsistency

	/**
	 * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
	 *
	 * This will only work if the object has been saved and has a valid primary key set.
	 *
	 * @param      boolean $deep (optional) Whether to also de-associated any related objects.
	 * @param      PropelPDO $con (optional) The PropelPDO connection to use.
	 * @return     void
	 * @throws     PropelException - if this object is deleted, unsaved or doesn't have pk match in db
	 */
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UserReportsPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

		// We don't need to alter the object instance pool; we're just modifying this instance
		// already in the pool.

		$stmt = UserReportsPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); // rehydrate

		if ($deep) {  // also de-associate any related objects?

			$this->aUsers = null;
		} // if (deep)
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param      PropelPDO $con
	 * @return     void
	 * @throws     PropelException
	 * @see        BaseObject::setDeleted()
	 * @see        BaseObject::isDeleted()
	 */
	public function delete(PropelPDO $con = null)
	{

    foreach (sfMixer::getCallables('BaseUserReports:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UserReportsPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			UserReportsPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseUserReports:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	/**
	 * Persists this object to the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All modified related objects will also be persisted in the doSave()
	 * method.  This method wraps all precipitate database operations in a
	 * single transaction.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        doSave()
	 */
	public function save(PropelPDO $con = null)
	{

    foreach (sfMixer::getCallables('BaseUserReports:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UserReportsPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseUserReports:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			UserReportsPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	/**
	 * Performs the work of inserting or updating the row in the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        save()
	 */
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aUsers !== null) {
				if ($this->aUsers->isModified() || $this->aUsers->isNew()) {
					$affectedRows += $this->aUsers->save($con);
				}
				$this->setUsers($this->aUsers);
			}

			if ($this->isNew() ) {
				$this->modifiedColumns[] = UserReportsPeer::ID;
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = UserReportsPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which
										 // should always be true here (even though technically
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setId($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += UserReportsPeer::doUpdate($this, $con);
				}

				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var        array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return     array ValidationFailed[]
	 * @see        validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param      mixed $columns Column name or an array of column names.
	 * @return     boolean Whether all columns pass validation.
	 * @see        doValidate()
	 * @see        getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param      array $columns Array of column names to validate.
	 * @return     mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aUsers !== null) {
				if (!$this->aUsers->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUsers->getValidationFailures());
				}
			}


			if (($retval = UserReportsPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param      string $name name
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = UserReportsPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @return     mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getUsersId();
				break;
			case 2:
				return $this->getName();
				break;
			case 3:
				return $this->getDisplayOnHome();
				break;
			case 4:
				return $this->getProjectsId();
				break;
			case 5:
				return $this->getProjectsTypeId();
				break;
			case 6:
				return $this->getProjectsStatusId();
				break;
			case 7:
				return $this->getAssignedTo();
				break;
			case 8:
				return $this->getTasksStatusId();
				break;
			case 9:
				return $this->getTasksTypeId();
				break;
			case 10:
				return $this->getTasksLabelId();
				break;
			case 11:
				return $this->getDueDateFrom();
				break;
			case 12:
				return $this->getDueDateTo();
				break;
			case 13:
				return $this->getCreatedFrom();
				break;
			case 14:
				return $this->getCreatedTo();
				break;
			case 15:
				return $this->getClosedFrom();
				break;
			case 16:
				return $this->getClosedTo();
				break;
			case 17:
				return $this->getSortOrder();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param      string $keyType (optional) One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                        BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM. Defaults to BasePeer::TYPE_PHPNAME.
	 * @param      boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns.  Defaults to TRUE.
	 * @return     an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = UserReportsPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getUsersId(),
			$keys[2] => $this->getName(),
			$keys[3] => $this->getDisplayOnHome(),
			$keys[4] => $this->getProjectsId(),
			$keys[5] => $this->getProjectsTypeId(),
			$keys[6] => $this->getProjectsStatusId(),
			$keys[7] => $this->getAssignedTo(),
			$keys[8] => $this->getTasksStatusId(),
			$keys[9] => $this->getTasksTypeId(),
			$keys[10] => $this->getTasksLabelId(),
			$keys[11] => $this->getDueDateFrom(),
			$keys[12] => $this->getDueDateTo(),
			$keys[13] => $this->getCreatedFrom(),
			$keys[14] => $this->getCreatedTo(),
			$keys[15] => $this->getClosedFrom(),
			$keys[16] => $this->getClosedTo(),
			$keys[17] => $this->getSortOrder(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param      string $name peer name
	 * @param      mixed $value field value
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = UserReportsPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @param      mixed $value field value
	 * @return     void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setUsersId($value);
				break;
			case 2:
				$this->setName($value);
				break;
			case 3:
				$this->setDisplayOnHome($value);
				break;
			case 4:
				$this->setProjectsId($value);
				break;
			case 5:
				$this->setProjectsTypeId($value);
				break;
			case 6:
				$this->setProjectsStatusId($value);
				break;
			case 7:
				$this->setAssignedTo($value);
				break;
			case 8:
				$this->setTasksStatusId($value);
				break;
			case 9:
				$this->setTasksTypeId($value);
				break;
			case 10:
				$this->setTasksLabelId($value);
				break;
			case 11:
				$this->setDueDateFrom($value);
				break;
			case 12:
				$this->setDueDateTo($value);
				break;
			case 13:
				$this->setCreatedFrom($value);
				break;
			case 14:
				$this->setCreatedTo($value);
				break;
			case 15:
				$this->setClosedFrom($value);
				break;
			case 16:
				$this->setClosedTo($value);
				break;
			case 17:
				$this->setSortOrder($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
	 * BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
	 * The default key type is the column's phpname (e.g. 'AuthorId')
	 *
	 * @param      array  $arr     An array to populate the object from.
	 * @param      string $keyType The type of keys the array uses.
	 * @return     void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = UserReportsPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setUsersId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setName($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setDisplayOnHome($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setProjectsId($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setProjectsTypeId($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setProjectsStatusId($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setAssignedTo($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setTasksStatusId($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setTasksTypeId($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setTasksLabelId($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setDueDateFrom($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setDueDateTo($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setCreatedFrom($arr[$keys[13]]);
		if (array_key_exists($keys[14], $arr)) $this->setCreatedTo($arr[$keys[14]]);
		if (array_key_exists($keys[15], $arr)) $this->setClosedFrom($arr[$keys[15]]);
		if (array_key_exists($keys[16], $arr)) $this->setClosedTo($arr[$keys[16]]);
		if (array_key_exists($keys[17], $arr)) $this->setSortOrder($arr[$keys[17]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return     Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(UserReportsPeer::DATABASE_NAME);

		if ($this->isColumnModified(UserReportsPeer::ID)) $criteria->add(UserReportsPeer::ID, $this->id);
		if ($this->isColumnModified(UserReportsPeer::USERS_ID)) $criteria->add(UserReportsPeer::USERS_ID, $this->users_id);
		if ($this->isColumnModified(UserReportsPeer::NAME)) $criteria->add(UserReportsPeer::NAME, $this->name);
		if ($this->isColumnModified(UserReportsPeer::DISPLAY_ON_HOME)) $criteria->add(UserReportsPeer::DISPLAY_ON_HOME, $this->display_on_home);
		if ($this->isColumnModified(UserReportsPeer::PROJECTS_ID)) $criteria->add(UserReportsPeer::PROJECTS_ID, $this->projects_id);
		if ($this->isColumnModified(UserReportsPeer::PROJECTS_TYPE_ID)) $criteria->add(UserReportsPeer::PROJECTS_TYPE_ID, $this->projects_type_id);
		if ($this->isColumnModified(UserReportsPeer::PROJECTS_STATUS_ID)) $criteria->add(UserReportsPeer::PROJECTS_STATUS_ID, $this->projects_status_id);
		if ($this->isColumnModified(UserReportsPeer::ASSIGNED_TO)) $criteria->add(UserReportsPeer::ASSIGNED_TO, $this->assigned_to);
		if ($this->isColumnModified(UserReportsPeer::TASKS_STATUS_ID)) $criteria->add(UserReportsPeer::TASKS_STATUS_ID, $this->tasks_status_id);
		if ($this->isColumnModified(UserReportsPeer::TASKS_TYPE_ID)) $criteria->add(UserReportsPeer::TASKS_TYPE_ID, $this->tasks_type_id);
		if ($this->isColumnModified(UserReportsPeer::TASKS_LABEL_ID)) $criteria->add(UserReportsPeer::TASKS_LABEL_ID, $this->tasks_label_id);
		if ($this->isColumnModified(UserReportsPeer::DUE_DATE_FROM)) $criteria->add(UserReportsPeer::DUE_DATE_FROM, $this->due_date_from);
		if ($this->isColumnModified(UserReportsPeer::DUE_DATE_TO)) $criteria->add(UserReportsPeer::DUE_DATE_TO, $this->due_date_to);
		if ($this->isColumnModified(UserReportsPeer::CREATED_FROM)) $criteria->add(UserReportsPeer::CREATED_FROM, $this->created_from);
		if ($this->isColumnModified(UserReportsPeer::CREATED_TO)) $criteria->add(UserReportsPeer::CREATED_TO, $this->created_to);
		if ($this->isColumnModified(UserReportsPeer::CLOSED_FROM)) $criteria->add(UserReportsPeer::CLOSED_FROM, $this->closed_from);
		if ($this->isColumnModified(UserReportsPeer::CLOSED_TO)) $criteria->add(UserReportsPeer::CLOSED_TO, $this->closed_to);
		if ($this->isColumnModified(UserReportsPeer::SORT_ORDER)) $criteria->add(UserReportsPeer::SORT_ORDER, $this->sort_order);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return     Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(UserReportsPeer::DATABASE_NAME);

		$criteria->add(UserReportsPeer::ID, $this->id);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return     int
	 */
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	/**
	 * Generic method to set the primary key (id column).
	 *
	 * @param      int $key Primary key.
	 * @return     void
	 */
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      object $copyObj An object of UserReports (or compatible) type.
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws     PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setUsersId($this->users_id);

		$copyObj->setName($this->name);

		$copyObj->setDisplayOnHome($this->display_on_home);

		$copyObj->setProjectsId($this->projects_id);

		$copyObj->setProjectsTypeId($this->projects_type_id);

		$copyObj->setProjectsStatusId($this->projects_status_id);

		$copyObj->setAssignedTo($this->assigned_to);

		$copyObj->setTasksStatusId($this->tasks_status_id);

		$copyObj->setTasksTypeId($this->tasks_type_id);

		$copyObj->setTasksLabelId($this->tasks_label_id);

		$copyObj->setDueDateFrom($this->due_date_from);

		$copyObj->setDueDateTo($this->due_date_to);

		$copyObj->setCreatedFrom($this->created_from);

		$copyObj->setCreatedTo($this->created_to);

		$copyObj->setClosedFrom($this->closed_from);

		$copyObj->setClosedTo($this->closed_to);

		$copyObj->setSortOrder($this->sort_order);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); // this is a auto-increment column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return     UserReports Clone of current object.
	 * @throws     PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return     UserReportsPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new UserReportsPeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a Users object.
	 *
	 * @param      Users $v
	 * @return     UserReports The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setUsers(Users $v = null)
	{
		if ($v === null) {
			$this->setUsersId(0);
		} else {
			$this->setUsersId($v->getId());
		}

		$this->aUsers = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the Users object, it will not be re-added.
		if ($v !== null) {
			$v->addUserReports($this);
		}

		return $this;
	}


	/**
	 * Get the associated Users object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     Users The associated Users object.
	 * @throws     PropelException
	 */
	public function getUsers(PropelPDO $con = null)
	{
		if ($this->aUsers === null && ($this->users_id !== null)) {
			$c = new Criteria(UsersPeer::DATABASE_NAME);
			$c->add(UsersPeer::ID, $this->users_id);
			$this->aUsers = UsersPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aUsers->addUserReportss($this);
			 */
		}
		return $this->aUsers;
	}

	/**
	 * Resets all collections of referencing foreign keys.
	 *
	 * This method is a user-space workaround for PHP's inability to garbage collect objects
	 * with circular references.  This is currently necessary when using Propel in certain
	 * daemon or large-volumne/high-memory operations.
	 *
	 * @param      boolean $deep Whether to also clear the references on all associated objects.
	 */
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
		} // if ($deep)

			$this->aUsers = null;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseUserReports:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseUserReports::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} // BaseUserReports
