<?php

/**
 * Base class that represents a row from the 'users' table.
 *
 * 
 *
 * This class was autogenerated by Propel 1.3.0-dev on:
 *
 * 10/01/11 13:54:41
 *
 * @package    lib.model.om
 */
abstract class BaseUsers extends BaseObject  implements Persistent {


  const PEER = 'UsersPeer';

	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var        UsersPeer
	 */
	protected static $peer;

	/**
	 * The value for the id field.
	 * @var        int
	 */
	protected $id;

	/**
	 * The value for the users_group_id field.
	 * @var        int
	 */
	protected $users_group_id;

	/**
	 * The value for the name field.
	 * Note: this column has a database default value of: ''
	 * @var        string
	 */
	protected $name;

	/**
	 * The value for the photo field.
	 * @var        string
	 */
	protected $photo;

	/**
	 * The value for the email field.
	 * Note: this column has a database default value of: ''
	 * @var        string
	 */
	protected $email;

	/**
	 * The value for the culture field.
	 * @var        string
	 */
	protected $culture;

	/**
	 * The value for the password field.
	 * Note: this column has a database default value of: ''
	 * @var        string
	 */
	protected $password;

	/**
	 * The value for the active field.
	 * @var        int
	 */
	protected $active;

	/**
	 * The value for the skin field.
	 * @var        string
	 */
	protected $skin;

	/**
	 * @var        UsersGroups
	 */
	protected $aUsersGroups;

	/**
	 * @var        array Departments[] Collection to store aggregation of Departments objects.
	 */
	protected $collDepartmentss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collDepartmentss.
	 */
	private $lastDepartmentsCriteria = null;

	/**
	 * @var        array Discussions[] Collection to store aggregation of Discussions objects.
	 */
	protected $collDiscussionss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collDiscussionss.
	 */
	private $lastDiscussionsCriteria = null;

	/**
	 * @var        array DiscussionsComments[] Collection to store aggregation of DiscussionsComments objects.
	 */
	protected $collDiscussionsCommentss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collDiscussionsCommentss.
	 */
	private $lastDiscussionsCommentsCriteria = null;

	/**
	 * @var        array DiscussionsReports[] Collection to store aggregation of DiscussionsReports objects.
	 */
	protected $collDiscussionsReportss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collDiscussionsReportss.
	 */
	private $lastDiscussionsReportsCriteria = null;

	/**
	 * @var        array Events[] Collection to store aggregation of Events objects.
	 */
	protected $collEventss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collEventss.
	 */
	private $lastEventsCriteria = null;

	/**
	 * @var        array Projects[] Collection to store aggregation of Projects objects.
	 */
	protected $collProjectss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collProjectss.
	 */
	private $lastProjectsCriteria = null;

	/**
	 * @var        array ProjectsComments[] Collection to store aggregation of ProjectsComments objects.
	 */
	protected $collProjectsCommentss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collProjectsCommentss.
	 */
	private $lastProjectsCommentsCriteria = null;

	/**
	 * @var        array ProjectsReports[] Collection to store aggregation of ProjectsReports objects.
	 */
	protected $collProjectsReportss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collProjectsReportss.
	 */
	private $lastProjectsReportsCriteria = null;

	/**
	 * @var        array Tasks[] Collection to store aggregation of Tasks objects.
	 */
	protected $collTaskss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collTaskss.
	 */
	private $lastTasksCriteria = null;

	/**
	 * @var        array TasksComments[] Collection to store aggregation of TasksComments objects.
	 */
	protected $collTasksCommentss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collTasksCommentss.
	 */
	private $lastTasksCommentsCriteria = null;

	/**
	 * @var        array Tickets[] Collection to store aggregation of Tickets objects.
	 */
	protected $collTicketss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collTicketss.
	 */
	private $lastTicketsCriteria = null;

	/**
	 * @var        array TicketsComments[] Collection to store aggregation of TicketsComments objects.
	 */
	protected $collTicketsCommentss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collTicketsCommentss.
	 */
	private $lastTicketsCommentsCriteria = null;

	/**
	 * @var        array TicketsReports[] Collection to store aggregation of TicketsReports objects.
	 */
	protected $collTicketsReportss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collTicketsReportss.
	 */
	private $lastTicketsReportsCriteria = null;

	/**
	 * @var        array UserReports[] Collection to store aggregation of UserReports objects.
	 */
	protected $collUserReportss;

	/**
	 * @var        Criteria The criteria used to select the current contents of collUserReportss.
	 */
	private $lastUserReportsCriteria = null;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInValidation = false;

	/**
	 * Initializes internal state of BaseUsers object.
	 * @see        applyDefaults()
	 */
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	/**
	 * Applies default values to this object.
	 * This method should be called from the object's constructor (or
	 * equivalent initialization method).
	 * @see        __construct()
	 */
	public function applyDefaultValues()
	{
		$this->name = '';
		$this->email = '';
		$this->password = '';
	}

	/**
	 * Get the [id] column value.
	 * 
	 * @return     int
	 */
	public function getId()
	{
		return $this->id;
	}

	/**
	 * Get the [users_group_id] column value.
	 * 
	 * @return     int
	 */
	public function getUsersGroupId()
	{
		return $this->users_group_id;
	}

	/**
	 * Get the [name] column value.
	 * 
	 * @return     string
	 */
	public function getName()
	{
		return $this->name;
	}

	/**
	 * Get the [photo] column value.
	 * 
	 * @return     string
	 */
	public function getPhoto()
	{
		return $this->photo;
	}

	/**
	 * Get the [email] column value.
	 * 
	 * @return     string
	 */
	public function getEmail()
	{
		return $this->email;
	}

	/**
	 * Get the [culture] column value.
	 * 
	 * @return     string
	 */
	public function getCulture()
	{
		return $this->culture;
	}

	/**
	 * Get the [password] column value.
	 * 
	 * @return     string
	 */
	public function getPassword()
	{
		return $this->password;
	}

	/**
	 * Get the [active] column value.
	 * 
	 * @return     int
	 */
	public function getActive()
	{
		return $this->active;
	}

	/**
	 * Get the [skin] column value.
	 * 
	 * @return     string
	 */
	public function getSkin()
	{
		return $this->skin;
	}

	/**
	 * Set the value of [id] column.
	 * 
	 * @param      int $v new value
	 * @return     Users The current object (for fluent API support)
	 */
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = UsersPeer::ID;
		}

		return $this;
	} // setId()

	/**
	 * Set the value of [users_group_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Users The current object (for fluent API support)
	 */
	public function setUsersGroupId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->users_group_id !== $v) {
			$this->users_group_id = $v;
			$this->modifiedColumns[] = UsersPeer::USERS_GROUP_ID;
		}

		if ($this->aUsersGroups !== null && $this->aUsersGroups->getId() !== $v) {
			$this->aUsersGroups = null;
		}

		return $this;
	} // setUsersGroupId()

	/**
	 * Set the value of [name] column.
	 * 
	 * @param      string $v new value
	 * @return     Users The current object (for fluent API support)
	 */
	public function setName($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->name !== $v || $v === '') {
			$this->name = $v;
			$this->modifiedColumns[] = UsersPeer::NAME;
		}

		return $this;
	} // setName()

	/**
	 * Set the value of [photo] column.
	 * 
	 * @param      string $v new value
	 * @return     Users The current object (for fluent API support)
	 */
	public function setPhoto($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->photo !== $v) {
			$this->photo = $v;
			$this->modifiedColumns[] = UsersPeer::PHOTO;
		}

		return $this;
	} // setPhoto()

	/**
	 * Set the value of [email] column.
	 * 
	 * @param      string $v new value
	 * @return     Users The current object (for fluent API support)
	 */
	public function setEmail($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->email !== $v || $v === '') {
			$this->email = $v;
			$this->modifiedColumns[] = UsersPeer::EMAIL;
		}

		return $this;
	} // setEmail()

	/**
	 * Set the value of [culture] column.
	 * 
	 * @param      string $v new value
	 * @return     Users The current object (for fluent API support)
	 */
	public function setCulture($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->culture !== $v) {
			$this->culture = $v;
			$this->modifiedColumns[] = UsersPeer::CULTURE;
		}

		return $this;
	} // setCulture()

	/**
	 * Set the value of [password] column.
	 * 
	 * @param      string $v new value
	 * @return     Users The current object (for fluent API support)
	 */
	public function setPassword($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->password !== $v || $v === '') {
			$this->password = $v;
			$this->modifiedColumns[] = UsersPeer::PASSWORD;
		}

		return $this;
	} // setPassword()

	/**
	 * Set the value of [active] column.
	 * 
	 * @param      int $v new value
	 * @return     Users The current object (for fluent API support)
	 */
	public function setActive($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->active !== $v) {
			$this->active = $v;
			$this->modifiedColumns[] = UsersPeer::ACTIVE;
		}

		return $this;
	} // setActive()

	/**
	 * Set the value of [skin] column.
	 * 
	 * @param      string $v new value
	 * @return     Users The current object (for fluent API support)
	 */
	public function setSkin($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->skin !== $v) {
			$this->skin = $v;
			$this->modifiedColumns[] = UsersPeer::SKIN;
		}

		return $this;
	} // setSkin()

	/**
	 * Indicates whether the columns in this object are only set to default values.
	 *
	 * This method can be used in conjunction with isModified() to indicate whether an object is both
	 * modified _and_ has some values set which are non-default.
	 *
	 * @return     boolean Whether the columns in this object are only been set with default values.
	 */
	public function hasOnlyDefaultValues()
	{
			// First, ensure that we don't have any columns that have been modified which aren't default columns.
			if (array_diff($this->modifiedColumns, array(UsersPeer::NAME,UsersPeer::EMAIL,UsersPeer::PASSWORD))) {
				return false;
			}

			if ($this->name !== '') {
				return false;
			}

			if ($this->email !== '') {
				return false;
			}

			if ($this->password !== '') {
				return false;
			}

		// otherwise, everything was equal, so return TRUE
		return true;
	} // hasOnlyDefaultValues()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (0-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param      array $row The row returned by PDOStatement->fetch(PDO::FETCH_NUM)
	 * @param      int $startcol 0-based offset column which indicates which restultset column to start with.
	 * @param      boolean $rehydrate Whether this object is being re-hydrated from the database.
	 * @return     int next starting column
	 * @throws     PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->users_group_id = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
			$this->name = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->photo = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
			$this->email = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
			$this->culture = ($row[$startcol + 5] !== null) ? (string) $row[$startcol + 5] : null;
			$this->password = ($row[$startcol + 6] !== null) ? (string) $row[$startcol + 6] : null;
			$this->active = ($row[$startcol + 7] !== null) ? (int) $row[$startcol + 7] : null;
			$this->skin = ($row[$startcol + 8] !== null) ? (string) $row[$startcol + 8] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 9; // 9 = UsersPeer::NUM_COLUMNS - UsersPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating Users object", $e);
		}
	}

	/**
	 * Checks and repairs the internal consistency of the object.
	 *
	 * This method is executed after an already-instantiated object is re-hydrated
	 * from the database.  It exists to check any foreign keys to make sure that
	 * the objects related to the current object are correct based on foreign key.
	 *
	 * You can override this method in the stub class, but you should always invoke
	 * the base method from the overridden method (i.e. parent::ensureConsistency()),
	 * in case your model changes.
	 *
	 * @throws     PropelException
	 */
	public function ensureConsistency()
	{

		if ($this->aUsersGroups !== null && $this->users_group_id !== $this->aUsersGroups->getId()) {
			$this->aUsersGroups = null;
		}
	} // ensureConsistency

	/**
	 * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
	 *
	 * This will only work if the object has been saved and has a valid primary key set.
	 *
	 * @param      boolean $deep (optional) Whether to also de-associated any related objects.
	 * @param      PropelPDO $con (optional) The PropelPDO connection to use.
	 * @return     void
	 * @throws     PropelException - if this object is deleted, unsaved or doesn't have pk match in db
	 */
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UsersPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

		// We don't need to alter the object instance pool; we're just modifying this instance
		// already in the pool.

		$stmt = UsersPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); // rehydrate

		if ($deep) {  // also de-associate any related objects?

			$this->aUsersGroups = null;
			$this->collDepartmentss = null;
			$this->lastDepartmentsCriteria = null;

			$this->collDiscussionss = null;
			$this->lastDiscussionsCriteria = null;

			$this->collDiscussionsCommentss = null;
			$this->lastDiscussionsCommentsCriteria = null;

			$this->collDiscussionsReportss = null;
			$this->lastDiscussionsReportsCriteria = null;

			$this->collEventss = null;
			$this->lastEventsCriteria = null;

			$this->collProjectss = null;
			$this->lastProjectsCriteria = null;

			$this->collProjectsCommentss = null;
			$this->lastProjectsCommentsCriteria = null;

			$this->collProjectsReportss = null;
			$this->lastProjectsReportsCriteria = null;

			$this->collTaskss = null;
			$this->lastTasksCriteria = null;

			$this->collTasksCommentss = null;
			$this->lastTasksCommentsCriteria = null;

			$this->collTicketss = null;
			$this->lastTicketsCriteria = null;

			$this->collTicketsCommentss = null;
			$this->lastTicketsCommentsCriteria = null;

			$this->collTicketsReportss = null;
			$this->lastTicketsReportsCriteria = null;

			$this->collUserReportss = null;
			$this->lastUserReportsCriteria = null;

		} // if (deep)
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param      PropelPDO $con
	 * @return     void
	 * @throws     PropelException
	 * @see        BaseObject::setDeleted()
	 * @see        BaseObject::isDeleted()
	 */
	public function delete(PropelPDO $con = null)
	{

    foreach (sfMixer::getCallables('BaseUsers:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UsersPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			UsersPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseUsers:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	/**
	 * Persists this object to the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All modified related objects will also be persisted in the doSave()
	 * method.  This method wraps all precipitate database operations in a
	 * single transaction.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        doSave()
	 */
	public function save(PropelPDO $con = null)
	{

    foreach (sfMixer::getCallables('BaseUsers:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UsersPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseUsers:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			UsersPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	/**
	 * Performs the work of inserting or updating the row in the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        save()
	 */
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aUsersGroups !== null) {
				if ($this->aUsersGroups->isModified() || $this->aUsersGroups->isNew()) {
					$affectedRows += $this->aUsersGroups->save($con);
				}
				$this->setUsersGroups($this->aUsersGroups);
			}

			if ($this->isNew() ) {
				$this->modifiedColumns[] = UsersPeer::ID;
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = UsersPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which
										 // should always be true here (even though technically
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setId($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += UsersPeer::doUpdate($this, $con);
				}

				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			if ($this->collDepartmentss !== null) {
				foreach ($this->collDepartmentss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collDiscussionss !== null) {
				foreach ($this->collDiscussionss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collDiscussionsCommentss !== null) {
				foreach ($this->collDiscussionsCommentss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collDiscussionsReportss !== null) {
				foreach ($this->collDiscussionsReportss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collEventss !== null) {
				foreach ($this->collEventss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collProjectss !== null) {
				foreach ($this->collProjectss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collProjectsCommentss !== null) {
				foreach ($this->collProjectsCommentss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collProjectsReportss !== null) {
				foreach ($this->collProjectsReportss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collTaskss !== null) {
				foreach ($this->collTaskss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collTasksCommentss !== null) {
				foreach ($this->collTasksCommentss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collTicketss !== null) {
				foreach ($this->collTicketss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collTicketsCommentss !== null) {
				foreach ($this->collTicketsCommentss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collTicketsReportss !== null) {
				foreach ($this->collTicketsReportss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collUserReportss !== null) {
				foreach ($this->collUserReportss as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var        array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return     array ValidationFailed[]
	 * @see        validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param      mixed $columns Column name or an array of column names.
	 * @return     boolean Whether all columns pass validation.
	 * @see        doValidate()
	 * @see        getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param      array $columns Array of column names to validate.
	 * @return     mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aUsersGroups !== null) {
				if (!$this->aUsersGroups->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUsersGroups->getValidationFailures());
				}
			}


			if (($retval = UsersPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collDepartmentss !== null) {
					foreach ($this->collDepartmentss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collDiscussionss !== null) {
					foreach ($this->collDiscussionss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collDiscussionsCommentss !== null) {
					foreach ($this->collDiscussionsCommentss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collDiscussionsReportss !== null) {
					foreach ($this->collDiscussionsReportss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collEventss !== null) {
					foreach ($this->collEventss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collProjectss !== null) {
					foreach ($this->collProjectss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collProjectsCommentss !== null) {
					foreach ($this->collProjectsCommentss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collProjectsReportss !== null) {
					foreach ($this->collProjectsReportss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collTaskss !== null) {
					foreach ($this->collTaskss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collTasksCommentss !== null) {
					foreach ($this->collTasksCommentss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collTicketss !== null) {
					foreach ($this->collTicketss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collTicketsCommentss !== null) {
					foreach ($this->collTicketsCommentss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collTicketsReportss !== null) {
					foreach ($this->collTicketsReportss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collUserReportss !== null) {
					foreach ($this->collUserReportss as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param      string $name name
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = UsersPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @return     mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getUsersGroupId();
				break;
			case 2:
				return $this->getName();
				break;
			case 3:
				return $this->getPhoto();
				break;
			case 4:
				return $this->getEmail();
				break;
			case 5:
				return $this->getCulture();
				break;
			case 6:
				return $this->getPassword();
				break;
			case 7:
				return $this->getActive();
				break;
			case 8:
				return $this->getSkin();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param      string $keyType (optional) One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                        BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM. Defaults to BasePeer::TYPE_PHPNAME.
	 * @param      boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns.  Defaults to TRUE.
	 * @return     an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = UsersPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getUsersGroupId(),
			$keys[2] => $this->getName(),
			$keys[3] => $this->getPhoto(),
			$keys[4] => $this->getEmail(),
			$keys[5] => $this->getCulture(),
			$keys[6] => $this->getPassword(),
			$keys[7] => $this->getActive(),
			$keys[8] => $this->getSkin(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param      string $name peer name
	 * @param      mixed $value field value
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = UsersPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @param      mixed $value field value
	 * @return     void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setUsersGroupId($value);
				break;
			case 2:
				$this->setName($value);
				break;
			case 3:
				$this->setPhoto($value);
				break;
			case 4:
				$this->setEmail($value);
				break;
			case 5:
				$this->setCulture($value);
				break;
			case 6:
				$this->setPassword($value);
				break;
			case 7:
				$this->setActive($value);
				break;
			case 8:
				$this->setSkin($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
	 * BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
	 * The default key type is the column's phpname (e.g. 'AuthorId')
	 *
	 * @param      array  $arr     An array to populate the object from.
	 * @param      string $keyType The type of keys the array uses.
	 * @return     void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = UsersPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setUsersGroupId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setName($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setPhoto($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setEmail($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setCulture($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setPassword($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setActive($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setSkin($arr[$keys[8]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return     Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(UsersPeer::DATABASE_NAME);

		if ($this->isColumnModified(UsersPeer::ID)) $criteria->add(UsersPeer::ID, $this->id);
		if ($this->isColumnModified(UsersPeer::USERS_GROUP_ID)) $criteria->add(UsersPeer::USERS_GROUP_ID, $this->users_group_id);
		if ($this->isColumnModified(UsersPeer::NAME)) $criteria->add(UsersPeer::NAME, $this->name);
		if ($this->isColumnModified(UsersPeer::PHOTO)) $criteria->add(UsersPeer::PHOTO, $this->photo);
		if ($this->isColumnModified(UsersPeer::EMAIL)) $criteria->add(UsersPeer::EMAIL, $this->email);
		if ($this->isColumnModified(UsersPeer::CULTURE)) $criteria->add(UsersPeer::CULTURE, $this->culture);
		if ($this->isColumnModified(UsersPeer::PASSWORD)) $criteria->add(UsersPeer::PASSWORD, $this->password);
		if ($this->isColumnModified(UsersPeer::ACTIVE)) $criteria->add(UsersPeer::ACTIVE, $this->active);
		if ($this->isColumnModified(UsersPeer::SKIN)) $criteria->add(UsersPeer::SKIN, $this->skin);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return     Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(UsersPeer::DATABASE_NAME);

		$criteria->add(UsersPeer::ID, $this->id);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return     int
	 */
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	/**
	 * Generic method to set the primary key (id column).
	 *
	 * @param      int $key Primary key.
	 * @return     void
	 */
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      object $copyObj An object of Users (or compatible) type.
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws     PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setUsersGroupId($this->users_group_id);

		$copyObj->setName($this->name);

		$copyObj->setPhoto($this->photo);

		$copyObj->setEmail($this->email);

		$copyObj->setCulture($this->culture);

		$copyObj->setPassword($this->password);

		$copyObj->setActive($this->active);

		$copyObj->setSkin($this->skin);


		if ($deepCopy) {
			// important: temporarily setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach ($this->getDepartmentss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addDepartments($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getDiscussionss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addDiscussions($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getDiscussionsCommentss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addDiscussionsComments($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getDiscussionsReportss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addDiscussionsReports($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getEventss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addEvents($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getProjectss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addProjects($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getProjectsCommentss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addProjectsComments($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getProjectsReportss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addProjectsReports($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getTaskss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addTasks($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getTasksCommentss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addTasksComments($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getTicketss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addTickets($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getTicketsCommentss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addTicketsComments($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getTicketsReportss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addTicketsReports($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getUserReportss() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addUserReports($relObj->copy($deepCopy));
				}
			}

		} // if ($deepCopy)


		$copyObj->setNew(true);

		$copyObj->setId(NULL); // this is a auto-increment column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return     Users Clone of current object.
	 * @throws     PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return     UsersPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new UsersPeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a UsersGroups object.
	 *
	 * @param      UsersGroups $v
	 * @return     Users The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setUsersGroups(UsersGroups $v = null)
	{
		if ($v === null) {
			$this->setUsersGroupId(NULL);
		} else {
			$this->setUsersGroupId($v->getId());
		}

		$this->aUsersGroups = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the UsersGroups object, it will not be re-added.
		if ($v !== null) {
			$v->addUsers($this);
		}

		return $this;
	}


	/**
	 * Get the associated UsersGroups object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     UsersGroups The associated UsersGroups object.
	 * @throws     PropelException
	 */
	public function getUsersGroups(PropelPDO $con = null)
	{
		if ($this->aUsersGroups === null && ($this->users_group_id !== null)) {
			$c = new Criteria(UsersGroupsPeer::DATABASE_NAME);
			$c->add(UsersGroupsPeer::ID, $this->users_group_id);
			$this->aUsersGroups = UsersGroupsPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aUsersGroups->addUserss($this);
			 */
		}
		return $this->aUsersGroups;
	}

	/**
	 * Clears out the collDepartmentss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addDepartmentss()
	 */
	public function clearDepartmentss()
	{
		$this->collDepartmentss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collDepartmentss collection (array).
	 *
	 * By default this just sets the collDepartmentss collection to an empty array (like clearcollDepartmentss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initDepartmentss()
	{
		$this->collDepartmentss = array();
	}

	/**
	 * Gets an array of Departments objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Users has previously been saved, it will retrieve
	 * related Departmentss from storage. If this Users is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Departments[]
	 * @throws     PropelException
	 */
	public function getDepartmentss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collDepartmentss === null) {
			if ($this->isNew()) {
			   $this->collDepartmentss = array();
			} else {

				$criteria->add(DepartmentsPeer::USERS_ID, $this->id);

				DepartmentsPeer::addSelectColumns($criteria);
				$this->collDepartmentss = DepartmentsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(DepartmentsPeer::USERS_ID, $this->id);

				DepartmentsPeer::addSelectColumns($criteria);
				if (!isset($this->lastDepartmentsCriteria) || !$this->lastDepartmentsCriteria->equals($criteria)) {
					$this->collDepartmentss = DepartmentsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastDepartmentsCriteria = $criteria;
		return $this->collDepartmentss;
	}

	/**
	 * Returns the number of related Departments objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Departments objects.
	 * @throws     PropelException
	 */
	public function countDepartmentss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collDepartmentss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(DepartmentsPeer::USERS_ID, $this->id);

				$count = DepartmentsPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(DepartmentsPeer::USERS_ID, $this->id);

				if (!isset($this->lastDepartmentsCriteria) || !$this->lastDepartmentsCriteria->equals($criteria)) {
					$count = DepartmentsPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collDepartmentss);
				}
			} else {
				$count = count($this->collDepartmentss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a Departments object to this object
	 * through the Departments foreign key attribute.
	 *
	 * @param      Departments $l Departments
	 * @return     void
	 * @throws     PropelException
	 */
	public function addDepartments(Departments $l)
	{
		if ($this->collDepartmentss === null) {
			$this->initDepartmentss();
		}
		if (!in_array($l, $this->collDepartmentss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collDepartmentss, $l);
			$l->setUsers($this);
		}
	}

	/**
	 * Clears out the collDiscussionss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addDiscussionss()
	 */
	public function clearDiscussionss()
	{
		$this->collDiscussionss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collDiscussionss collection (array).
	 *
	 * By default this just sets the collDiscussionss collection to an empty array (like clearcollDiscussionss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initDiscussionss()
	{
		$this->collDiscussionss = array();
	}

	/**
	 * Gets an array of Discussions objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Users has previously been saved, it will retrieve
	 * related Discussionss from storage. If this Users is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Discussions[]
	 * @throws     PropelException
	 */
	public function getDiscussionss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collDiscussionss === null) {
			if ($this->isNew()) {
			   $this->collDiscussionss = array();
			} else {

				$criteria->add(DiscussionsPeer::USERS_ID, $this->id);

				DiscussionsPeer::addSelectColumns($criteria);
				$this->collDiscussionss = DiscussionsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(DiscussionsPeer::USERS_ID, $this->id);

				DiscussionsPeer::addSelectColumns($criteria);
				if (!isset($this->lastDiscussionsCriteria) || !$this->lastDiscussionsCriteria->equals($criteria)) {
					$this->collDiscussionss = DiscussionsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastDiscussionsCriteria = $criteria;
		return $this->collDiscussionss;
	}

	/**
	 * Returns the number of related Discussions objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Discussions objects.
	 * @throws     PropelException
	 */
	public function countDiscussionss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collDiscussionss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(DiscussionsPeer::USERS_ID, $this->id);

				$count = DiscussionsPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(DiscussionsPeer::USERS_ID, $this->id);

				if (!isset($this->lastDiscussionsCriteria) || !$this->lastDiscussionsCriteria->equals($criteria)) {
					$count = DiscussionsPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collDiscussionss);
				}
			} else {
				$count = count($this->collDiscussionss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a Discussions object to this object
	 * through the Discussions foreign key attribute.
	 *
	 * @param      Discussions $l Discussions
	 * @return     void
	 * @throws     PropelException
	 */
	public function addDiscussions(Discussions $l)
	{
		if ($this->collDiscussionss === null) {
			$this->initDiscussionss();
		}
		if (!in_array($l, $this->collDiscussionss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collDiscussionss, $l);
			$l->setUsers($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related Discussionss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getDiscussionssJoinProjects($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collDiscussionss === null) {
			if ($this->isNew()) {
				$this->collDiscussionss = array();
			} else {

				$criteria->add(DiscussionsPeer::USERS_ID, $this->id);

				$this->collDiscussionss = DiscussionsPeer::doSelectJoinProjects($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(DiscussionsPeer::USERS_ID, $this->id);

			if (!isset($this->lastDiscussionsCriteria) || !$this->lastDiscussionsCriteria->equals($criteria)) {
				$this->collDiscussionss = DiscussionsPeer::doSelectJoinProjects($criteria, $con, $join_behavior);
			}
		}
		$this->lastDiscussionsCriteria = $criteria;

		return $this->collDiscussionss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related Discussionss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getDiscussionssJoinDiscussionsStatus($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collDiscussionss === null) {
			if ($this->isNew()) {
				$this->collDiscussionss = array();
			} else {

				$criteria->add(DiscussionsPeer::USERS_ID, $this->id);

				$this->collDiscussionss = DiscussionsPeer::doSelectJoinDiscussionsStatus($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(DiscussionsPeer::USERS_ID, $this->id);

			if (!isset($this->lastDiscussionsCriteria) || !$this->lastDiscussionsCriteria->equals($criteria)) {
				$this->collDiscussionss = DiscussionsPeer::doSelectJoinDiscussionsStatus($criteria, $con, $join_behavior);
			}
		}
		$this->lastDiscussionsCriteria = $criteria;

		return $this->collDiscussionss;
	}

	/**
	 * Clears out the collDiscussionsCommentss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addDiscussionsCommentss()
	 */
	public function clearDiscussionsCommentss()
	{
		$this->collDiscussionsCommentss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collDiscussionsCommentss collection (array).
	 *
	 * By default this just sets the collDiscussionsCommentss collection to an empty array (like clearcollDiscussionsCommentss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initDiscussionsCommentss()
	{
		$this->collDiscussionsCommentss = array();
	}

	/**
	 * Gets an array of DiscussionsComments objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Users has previously been saved, it will retrieve
	 * related DiscussionsCommentss from storage. If this Users is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array DiscussionsComments[]
	 * @throws     PropelException
	 */
	public function getDiscussionsCommentss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collDiscussionsCommentss === null) {
			if ($this->isNew()) {
			   $this->collDiscussionsCommentss = array();
			} else {

				$criteria->add(DiscussionsCommentsPeer::USERS_ID, $this->id);

				DiscussionsCommentsPeer::addSelectColumns($criteria);
				$this->collDiscussionsCommentss = DiscussionsCommentsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(DiscussionsCommentsPeer::USERS_ID, $this->id);

				DiscussionsCommentsPeer::addSelectColumns($criteria);
				if (!isset($this->lastDiscussionsCommentsCriteria) || !$this->lastDiscussionsCommentsCriteria->equals($criteria)) {
					$this->collDiscussionsCommentss = DiscussionsCommentsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastDiscussionsCommentsCriteria = $criteria;
		return $this->collDiscussionsCommentss;
	}

	/**
	 * Returns the number of related DiscussionsComments objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related DiscussionsComments objects.
	 * @throws     PropelException
	 */
	public function countDiscussionsCommentss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collDiscussionsCommentss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(DiscussionsCommentsPeer::USERS_ID, $this->id);

				$count = DiscussionsCommentsPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(DiscussionsCommentsPeer::USERS_ID, $this->id);

				if (!isset($this->lastDiscussionsCommentsCriteria) || !$this->lastDiscussionsCommentsCriteria->equals($criteria)) {
					$count = DiscussionsCommentsPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collDiscussionsCommentss);
				}
			} else {
				$count = count($this->collDiscussionsCommentss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a DiscussionsComments object to this object
	 * through the DiscussionsComments foreign key attribute.
	 *
	 * @param      DiscussionsComments $l DiscussionsComments
	 * @return     void
	 * @throws     PropelException
	 */
	public function addDiscussionsComments(DiscussionsComments $l)
	{
		if ($this->collDiscussionsCommentss === null) {
			$this->initDiscussionsCommentss();
		}
		if (!in_array($l, $this->collDiscussionsCommentss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collDiscussionsCommentss, $l);
			$l->setUsers($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related DiscussionsCommentss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getDiscussionsCommentssJoinDiscussions($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collDiscussionsCommentss === null) {
			if ($this->isNew()) {
				$this->collDiscussionsCommentss = array();
			} else {

				$criteria->add(DiscussionsCommentsPeer::USERS_ID, $this->id);

				$this->collDiscussionsCommentss = DiscussionsCommentsPeer::doSelectJoinDiscussions($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(DiscussionsCommentsPeer::USERS_ID, $this->id);

			if (!isset($this->lastDiscussionsCommentsCriteria) || !$this->lastDiscussionsCommentsCriteria->equals($criteria)) {
				$this->collDiscussionsCommentss = DiscussionsCommentsPeer::doSelectJoinDiscussions($criteria, $con, $join_behavior);
			}
		}
		$this->lastDiscussionsCommentsCriteria = $criteria;

		return $this->collDiscussionsCommentss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related DiscussionsCommentss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getDiscussionsCommentssJoinDiscussionsStatus($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collDiscussionsCommentss === null) {
			if ($this->isNew()) {
				$this->collDiscussionsCommentss = array();
			} else {

				$criteria->add(DiscussionsCommentsPeer::USERS_ID, $this->id);

				$this->collDiscussionsCommentss = DiscussionsCommentsPeer::doSelectJoinDiscussionsStatus($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(DiscussionsCommentsPeer::USERS_ID, $this->id);

			if (!isset($this->lastDiscussionsCommentsCriteria) || !$this->lastDiscussionsCommentsCriteria->equals($criteria)) {
				$this->collDiscussionsCommentss = DiscussionsCommentsPeer::doSelectJoinDiscussionsStatus($criteria, $con, $join_behavior);
			}
		}
		$this->lastDiscussionsCommentsCriteria = $criteria;

		return $this->collDiscussionsCommentss;
	}

	/**
	 * Clears out the collDiscussionsReportss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addDiscussionsReportss()
	 */
	public function clearDiscussionsReportss()
	{
		$this->collDiscussionsReportss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collDiscussionsReportss collection (array).
	 *
	 * By default this just sets the collDiscussionsReportss collection to an empty array (like clearcollDiscussionsReportss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initDiscussionsReportss()
	{
		$this->collDiscussionsReportss = array();
	}

	/**
	 * Gets an array of DiscussionsReports objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Users has previously been saved, it will retrieve
	 * related DiscussionsReportss from storage. If this Users is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array DiscussionsReports[]
	 * @throws     PropelException
	 */
	public function getDiscussionsReportss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collDiscussionsReportss === null) {
			if ($this->isNew()) {
			   $this->collDiscussionsReportss = array();
			} else {

				$criteria->add(DiscussionsReportsPeer::USERS_ID, $this->id);

				DiscussionsReportsPeer::addSelectColumns($criteria);
				$this->collDiscussionsReportss = DiscussionsReportsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(DiscussionsReportsPeer::USERS_ID, $this->id);

				DiscussionsReportsPeer::addSelectColumns($criteria);
				if (!isset($this->lastDiscussionsReportsCriteria) || !$this->lastDiscussionsReportsCriteria->equals($criteria)) {
					$this->collDiscussionsReportss = DiscussionsReportsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastDiscussionsReportsCriteria = $criteria;
		return $this->collDiscussionsReportss;
	}

	/**
	 * Returns the number of related DiscussionsReports objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related DiscussionsReports objects.
	 * @throws     PropelException
	 */
	public function countDiscussionsReportss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collDiscussionsReportss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(DiscussionsReportsPeer::USERS_ID, $this->id);

				$count = DiscussionsReportsPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(DiscussionsReportsPeer::USERS_ID, $this->id);

				if (!isset($this->lastDiscussionsReportsCriteria) || !$this->lastDiscussionsReportsCriteria->equals($criteria)) {
					$count = DiscussionsReportsPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collDiscussionsReportss);
				}
			} else {
				$count = count($this->collDiscussionsReportss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a DiscussionsReports object to this object
	 * through the DiscussionsReports foreign key attribute.
	 *
	 * @param      DiscussionsReports $l DiscussionsReports
	 * @return     void
	 * @throws     PropelException
	 */
	public function addDiscussionsReports(DiscussionsReports $l)
	{
		if ($this->collDiscussionsReportss === null) {
			$this->initDiscussionsReportss();
		}
		if (!in_array($l, $this->collDiscussionsReportss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collDiscussionsReportss, $l);
			$l->setUsers($this);
		}
	}

	/**
	 * Clears out the collEventss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addEventss()
	 */
	public function clearEventss()
	{
		$this->collEventss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collEventss collection (array).
	 *
	 * By default this just sets the collEventss collection to an empty array (like clearcollEventss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initEventss()
	{
		$this->collEventss = array();
	}

	/**
	 * Gets an array of Events objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Users has previously been saved, it will retrieve
	 * related Eventss from storage. If this Users is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Events[]
	 * @throws     PropelException
	 */
	public function getEventss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collEventss === null) {
			if ($this->isNew()) {
			   $this->collEventss = array();
			} else {

				$criteria->add(EventsPeer::USERS_ID, $this->id);

				EventsPeer::addSelectColumns($criteria);
				$this->collEventss = EventsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(EventsPeer::USERS_ID, $this->id);

				EventsPeer::addSelectColumns($criteria);
				if (!isset($this->lastEventsCriteria) || !$this->lastEventsCriteria->equals($criteria)) {
					$this->collEventss = EventsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastEventsCriteria = $criteria;
		return $this->collEventss;
	}

	/**
	 * Returns the number of related Events objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Events objects.
	 * @throws     PropelException
	 */
	public function countEventss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collEventss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(EventsPeer::USERS_ID, $this->id);

				$count = EventsPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(EventsPeer::USERS_ID, $this->id);

				if (!isset($this->lastEventsCriteria) || !$this->lastEventsCriteria->equals($criteria)) {
					$count = EventsPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collEventss);
				}
			} else {
				$count = count($this->collEventss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a Events object to this object
	 * through the Events foreign key attribute.
	 *
	 * @param      Events $l Events
	 * @return     void
	 * @throws     PropelException
	 */
	public function addEvents(Events $l)
	{
		if ($this->collEventss === null) {
			$this->initEventss();
		}
		if (!in_array($l, $this->collEventss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collEventss, $l);
			$l->setUsers($this);
		}
	}

	/**
	 * Clears out the collProjectss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addProjectss()
	 */
	public function clearProjectss()
	{
		$this->collProjectss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collProjectss collection (array).
	 *
	 * By default this just sets the collProjectss collection to an empty array (like clearcollProjectss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initProjectss()
	{
		$this->collProjectss = array();
	}

	/**
	 * Gets an array of Projects objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Users has previously been saved, it will retrieve
	 * related Projectss from storage. If this Users is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Projects[]
	 * @throws     PropelException
	 */
	public function getProjectss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collProjectss === null) {
			if ($this->isNew()) {
			   $this->collProjectss = array();
			} else {

				$criteria->add(ProjectsPeer::CREATED_BY, $this->id);

				ProjectsPeer::addSelectColumns($criteria);
				$this->collProjectss = ProjectsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(ProjectsPeer::CREATED_BY, $this->id);

				ProjectsPeer::addSelectColumns($criteria);
				if (!isset($this->lastProjectsCriteria) || !$this->lastProjectsCriteria->equals($criteria)) {
					$this->collProjectss = ProjectsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastProjectsCriteria = $criteria;
		return $this->collProjectss;
	}

	/**
	 * Returns the number of related Projects objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Projects objects.
	 * @throws     PropelException
	 */
	public function countProjectss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collProjectss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(ProjectsPeer::CREATED_BY, $this->id);

				$count = ProjectsPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(ProjectsPeer::CREATED_BY, $this->id);

				if (!isset($this->lastProjectsCriteria) || !$this->lastProjectsCriteria->equals($criteria)) {
					$count = ProjectsPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collProjectss);
				}
			} else {
				$count = count($this->collProjectss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a Projects object to this object
	 * through the Projects foreign key attribute.
	 *
	 * @param      Projects $l Projects
	 * @return     void
	 * @throws     PropelException
	 */
	public function addProjects(Projects $l)
	{
		if ($this->collProjectss === null) {
			$this->initProjectss();
		}
		if (!in_array($l, $this->collProjectss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collProjectss, $l);
			$l->setUsers($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related Projectss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getProjectssJoinProjectsStatus($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collProjectss === null) {
			if ($this->isNew()) {
				$this->collProjectss = array();
			} else {

				$criteria->add(ProjectsPeer::CREATED_BY, $this->id);

				$this->collProjectss = ProjectsPeer::doSelectJoinProjectsStatus($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(ProjectsPeer::CREATED_BY, $this->id);

			if (!isset($this->lastProjectsCriteria) || !$this->lastProjectsCriteria->equals($criteria)) {
				$this->collProjectss = ProjectsPeer::doSelectJoinProjectsStatus($criteria, $con, $join_behavior);
			}
		}
		$this->lastProjectsCriteria = $criteria;

		return $this->collProjectss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related Projectss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getProjectssJoinProjectsTypes($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collProjectss === null) {
			if ($this->isNew()) {
				$this->collProjectss = array();
			} else {

				$criteria->add(ProjectsPeer::CREATED_BY, $this->id);

				$this->collProjectss = ProjectsPeer::doSelectJoinProjectsTypes($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(ProjectsPeer::CREATED_BY, $this->id);

			if (!isset($this->lastProjectsCriteria) || !$this->lastProjectsCriteria->equals($criteria)) {
				$this->collProjectss = ProjectsPeer::doSelectJoinProjectsTypes($criteria, $con, $join_behavior);
			}
		}
		$this->lastProjectsCriteria = $criteria;

		return $this->collProjectss;
	}

	/**
	 * Clears out the collProjectsCommentss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addProjectsCommentss()
	 */
	public function clearProjectsCommentss()
	{
		$this->collProjectsCommentss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collProjectsCommentss collection (array).
	 *
	 * By default this just sets the collProjectsCommentss collection to an empty array (like clearcollProjectsCommentss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initProjectsCommentss()
	{
		$this->collProjectsCommentss = array();
	}

	/**
	 * Gets an array of ProjectsComments objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Users has previously been saved, it will retrieve
	 * related ProjectsCommentss from storage. If this Users is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array ProjectsComments[]
	 * @throws     PropelException
	 */
	public function getProjectsCommentss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collProjectsCommentss === null) {
			if ($this->isNew()) {
			   $this->collProjectsCommentss = array();
			} else {

				$criteria->add(ProjectsCommentsPeer::CREATED_BY, $this->id);

				ProjectsCommentsPeer::addSelectColumns($criteria);
				$this->collProjectsCommentss = ProjectsCommentsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(ProjectsCommentsPeer::CREATED_BY, $this->id);

				ProjectsCommentsPeer::addSelectColumns($criteria);
				if (!isset($this->lastProjectsCommentsCriteria) || !$this->lastProjectsCommentsCriteria->equals($criteria)) {
					$this->collProjectsCommentss = ProjectsCommentsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastProjectsCommentsCriteria = $criteria;
		return $this->collProjectsCommentss;
	}

	/**
	 * Returns the number of related ProjectsComments objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related ProjectsComments objects.
	 * @throws     PropelException
	 */
	public function countProjectsCommentss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collProjectsCommentss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(ProjectsCommentsPeer::CREATED_BY, $this->id);

				$count = ProjectsCommentsPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(ProjectsCommentsPeer::CREATED_BY, $this->id);

				if (!isset($this->lastProjectsCommentsCriteria) || !$this->lastProjectsCommentsCriteria->equals($criteria)) {
					$count = ProjectsCommentsPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collProjectsCommentss);
				}
			} else {
				$count = count($this->collProjectsCommentss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a ProjectsComments object to this object
	 * through the ProjectsComments foreign key attribute.
	 *
	 * @param      ProjectsComments $l ProjectsComments
	 * @return     void
	 * @throws     PropelException
	 */
	public function addProjectsComments(ProjectsComments $l)
	{
		if ($this->collProjectsCommentss === null) {
			$this->initProjectsCommentss();
		}
		if (!in_array($l, $this->collProjectsCommentss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collProjectsCommentss, $l);
			$l->setUsers($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related ProjectsCommentss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getProjectsCommentssJoinProjects($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collProjectsCommentss === null) {
			if ($this->isNew()) {
				$this->collProjectsCommentss = array();
			} else {

				$criteria->add(ProjectsCommentsPeer::CREATED_BY, $this->id);

				$this->collProjectsCommentss = ProjectsCommentsPeer::doSelectJoinProjects($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(ProjectsCommentsPeer::CREATED_BY, $this->id);

			if (!isset($this->lastProjectsCommentsCriteria) || !$this->lastProjectsCommentsCriteria->equals($criteria)) {
				$this->collProjectsCommentss = ProjectsCommentsPeer::doSelectJoinProjects($criteria, $con, $join_behavior);
			}
		}
		$this->lastProjectsCommentsCriteria = $criteria;

		return $this->collProjectsCommentss;
	}

	/**
	 * Clears out the collProjectsReportss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addProjectsReportss()
	 */
	public function clearProjectsReportss()
	{
		$this->collProjectsReportss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collProjectsReportss collection (array).
	 *
	 * By default this just sets the collProjectsReportss collection to an empty array (like clearcollProjectsReportss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initProjectsReportss()
	{
		$this->collProjectsReportss = array();
	}

	/**
	 * Gets an array of ProjectsReports objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Users has previously been saved, it will retrieve
	 * related ProjectsReportss from storage. If this Users is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array ProjectsReports[]
	 * @throws     PropelException
	 */
	public function getProjectsReportss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collProjectsReportss === null) {
			if ($this->isNew()) {
			   $this->collProjectsReportss = array();
			} else {

				$criteria->add(ProjectsReportsPeer::USERS_ID, $this->id);

				ProjectsReportsPeer::addSelectColumns($criteria);
				$this->collProjectsReportss = ProjectsReportsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(ProjectsReportsPeer::USERS_ID, $this->id);

				ProjectsReportsPeer::addSelectColumns($criteria);
				if (!isset($this->lastProjectsReportsCriteria) || !$this->lastProjectsReportsCriteria->equals($criteria)) {
					$this->collProjectsReportss = ProjectsReportsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastProjectsReportsCriteria = $criteria;
		return $this->collProjectsReportss;
	}

	/**
	 * Returns the number of related ProjectsReports objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related ProjectsReports objects.
	 * @throws     PropelException
	 */
	public function countProjectsReportss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collProjectsReportss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(ProjectsReportsPeer::USERS_ID, $this->id);

				$count = ProjectsReportsPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(ProjectsReportsPeer::USERS_ID, $this->id);

				if (!isset($this->lastProjectsReportsCriteria) || !$this->lastProjectsReportsCriteria->equals($criteria)) {
					$count = ProjectsReportsPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collProjectsReportss);
				}
			} else {
				$count = count($this->collProjectsReportss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a ProjectsReports object to this object
	 * through the ProjectsReports foreign key attribute.
	 *
	 * @param      ProjectsReports $l ProjectsReports
	 * @return     void
	 * @throws     PropelException
	 */
	public function addProjectsReports(ProjectsReports $l)
	{
		if ($this->collProjectsReportss === null) {
			$this->initProjectsReportss();
		}
		if (!in_array($l, $this->collProjectsReportss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collProjectsReportss, $l);
			$l->setUsers($this);
		}
	}

	/**
	 * Clears out the collTaskss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addTaskss()
	 */
	public function clearTaskss()
	{
		$this->collTaskss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collTaskss collection (array).
	 *
	 * By default this just sets the collTaskss collection to an empty array (like clearcollTaskss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initTaskss()
	{
		$this->collTaskss = array();
	}

	/**
	 * Gets an array of Tasks objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Users has previously been saved, it will retrieve
	 * related Taskss from storage. If this Users is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Tasks[]
	 * @throws     PropelException
	 */
	public function getTaskss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
			   $this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::CREATED_BY, $this->id);

				TasksPeer::addSelectColumns($criteria);
				$this->collTaskss = TasksPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(TasksPeer::CREATED_BY, $this->id);

				TasksPeer::addSelectColumns($criteria);
				if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
					$this->collTaskss = TasksPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTasksCriteria = $criteria;
		return $this->collTaskss;
	}

	/**
	 * Returns the number of related Tasks objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Tasks objects.
	 * @throws     PropelException
	 */
	public function countTaskss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(TasksPeer::CREATED_BY, $this->id);

				$count = TasksPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(TasksPeer::CREATED_BY, $this->id);

				if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
					$count = TasksPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collTaskss);
				}
			} else {
				$count = count($this->collTaskss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a Tasks object to this object
	 * through the Tasks foreign key attribute.
	 *
	 * @param      Tasks $l Tasks
	 * @return     void
	 * @throws     PropelException
	 */
	public function addTasks(Tasks $l)
	{
		if ($this->collTaskss === null) {
			$this->initTaskss();
		}
		if (!in_array($l, $this->collTaskss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collTaskss, $l);
			$l->setUsers($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getTaskssJoinProjects($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::CREATED_BY, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinProjects($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::CREATED_BY, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinProjects($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getTaskssJoinTasksStatus($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::CREATED_BY, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinTasksStatus($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::CREATED_BY, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinTasksStatus($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getTaskssJoinTasksPriority($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::CREATED_BY, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinTasksPriority($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::CREATED_BY, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinTasksPriority($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getTaskssJoinTasksTypes($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::CREATED_BY, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinTasksTypes($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::CREATED_BY, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinTasksTypes($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getTaskssJoinTasksLabels($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::CREATED_BY, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinTasksLabels($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::CREATED_BY, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinTasksLabels($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getTaskssJoinTasksGroups($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::CREATED_BY, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinTasksGroups($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::CREATED_BY, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinTasksGroups($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getTaskssJoinProjectsPhases($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::CREATED_BY, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinProjectsPhases($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::CREATED_BY, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinProjectsPhases($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getTaskssJoinVersions($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::CREATED_BY, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinVersions($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::CREATED_BY, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinVersions($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related Taskss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getTaskssJoinTickets($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTaskss === null) {
			if ($this->isNew()) {
				$this->collTaskss = array();
			} else {

				$criteria->add(TasksPeer::CREATED_BY, $this->id);

				$this->collTaskss = TasksPeer::doSelectJoinTickets($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksPeer::CREATED_BY, $this->id);

			if (!isset($this->lastTasksCriteria) || !$this->lastTasksCriteria->equals($criteria)) {
				$this->collTaskss = TasksPeer::doSelectJoinTickets($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCriteria = $criteria;

		return $this->collTaskss;
	}

	/**
	 * Clears out the collTasksCommentss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addTasksCommentss()
	 */
	public function clearTasksCommentss()
	{
		$this->collTasksCommentss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collTasksCommentss collection (array).
	 *
	 * By default this just sets the collTasksCommentss collection to an empty array (like clearcollTasksCommentss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initTasksCommentss()
	{
		$this->collTasksCommentss = array();
	}

	/**
	 * Gets an array of TasksComments objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Users has previously been saved, it will retrieve
	 * related TasksCommentss from storage. If this Users is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array TasksComments[]
	 * @throws     PropelException
	 */
	public function getTasksCommentss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTasksCommentss === null) {
			if ($this->isNew()) {
			   $this->collTasksCommentss = array();
			} else {

				$criteria->add(TasksCommentsPeer::CREATED_BY, $this->id);

				TasksCommentsPeer::addSelectColumns($criteria);
				$this->collTasksCommentss = TasksCommentsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(TasksCommentsPeer::CREATED_BY, $this->id);

				TasksCommentsPeer::addSelectColumns($criteria);
				if (!isset($this->lastTasksCommentsCriteria) || !$this->lastTasksCommentsCriteria->equals($criteria)) {
					$this->collTasksCommentss = TasksCommentsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTasksCommentsCriteria = $criteria;
		return $this->collTasksCommentss;
	}

	/**
	 * Returns the number of related TasksComments objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related TasksComments objects.
	 * @throws     PropelException
	 */
	public function countTasksCommentss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collTasksCommentss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(TasksCommentsPeer::CREATED_BY, $this->id);

				$count = TasksCommentsPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(TasksCommentsPeer::CREATED_BY, $this->id);

				if (!isset($this->lastTasksCommentsCriteria) || !$this->lastTasksCommentsCriteria->equals($criteria)) {
					$count = TasksCommentsPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collTasksCommentss);
				}
			} else {
				$count = count($this->collTasksCommentss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a TasksComments object to this object
	 * through the TasksComments foreign key attribute.
	 *
	 * @param      TasksComments $l TasksComments
	 * @return     void
	 * @throws     PropelException
	 */
	public function addTasksComments(TasksComments $l)
	{
		if ($this->collTasksCommentss === null) {
			$this->initTasksCommentss();
		}
		if (!in_array($l, $this->collTasksCommentss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collTasksCommentss, $l);
			$l->setUsers($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related TasksCommentss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getTasksCommentssJoinTasks($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTasksCommentss === null) {
			if ($this->isNew()) {
				$this->collTasksCommentss = array();
			} else {

				$criteria->add(TasksCommentsPeer::CREATED_BY, $this->id);

				$this->collTasksCommentss = TasksCommentsPeer::doSelectJoinTasks($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksCommentsPeer::CREATED_BY, $this->id);

			if (!isset($this->lastTasksCommentsCriteria) || !$this->lastTasksCommentsCriteria->equals($criteria)) {
				$this->collTasksCommentss = TasksCommentsPeer::doSelectJoinTasks($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCommentsCriteria = $criteria;

		return $this->collTasksCommentss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related TasksCommentss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getTasksCommentssJoinTasksStatus($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTasksCommentss === null) {
			if ($this->isNew()) {
				$this->collTasksCommentss = array();
			} else {

				$criteria->add(TasksCommentsPeer::CREATED_BY, $this->id);

				$this->collTasksCommentss = TasksCommentsPeer::doSelectJoinTasksStatus($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksCommentsPeer::CREATED_BY, $this->id);

			if (!isset($this->lastTasksCommentsCriteria) || !$this->lastTasksCommentsCriteria->equals($criteria)) {
				$this->collTasksCommentss = TasksCommentsPeer::doSelectJoinTasksStatus($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCommentsCriteria = $criteria;

		return $this->collTasksCommentss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related TasksCommentss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getTasksCommentssJoinTasksPriority($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTasksCommentss === null) {
			if ($this->isNew()) {
				$this->collTasksCommentss = array();
			} else {

				$criteria->add(TasksCommentsPeer::CREATED_BY, $this->id);

				$this->collTasksCommentss = TasksCommentsPeer::doSelectJoinTasksPriority($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TasksCommentsPeer::CREATED_BY, $this->id);

			if (!isset($this->lastTasksCommentsCriteria) || !$this->lastTasksCommentsCriteria->equals($criteria)) {
				$this->collTasksCommentss = TasksCommentsPeer::doSelectJoinTasksPriority($criteria, $con, $join_behavior);
			}
		}
		$this->lastTasksCommentsCriteria = $criteria;

		return $this->collTasksCommentss;
	}

	/**
	 * Clears out the collTicketss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addTicketss()
	 */
	public function clearTicketss()
	{
		$this->collTicketss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collTicketss collection (array).
	 *
	 * By default this just sets the collTicketss collection to an empty array (like clearcollTicketss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initTicketss()
	{
		$this->collTicketss = array();
	}

	/**
	 * Gets an array of Tickets objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Users has previously been saved, it will retrieve
	 * related Ticketss from storage. If this Users is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Tickets[]
	 * @throws     PropelException
	 */
	public function getTicketss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTicketss === null) {
			if ($this->isNew()) {
			   $this->collTicketss = array();
			} else {

				$criteria->add(TicketsPeer::USERS_ID, $this->id);

				TicketsPeer::addSelectColumns($criteria);
				$this->collTicketss = TicketsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(TicketsPeer::USERS_ID, $this->id);

				TicketsPeer::addSelectColumns($criteria);
				if (!isset($this->lastTicketsCriteria) || !$this->lastTicketsCriteria->equals($criteria)) {
					$this->collTicketss = TicketsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTicketsCriteria = $criteria;
		return $this->collTicketss;
	}

	/**
	 * Returns the number of related Tickets objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Tickets objects.
	 * @throws     PropelException
	 */
	public function countTicketss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collTicketss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(TicketsPeer::USERS_ID, $this->id);

				$count = TicketsPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(TicketsPeer::USERS_ID, $this->id);

				if (!isset($this->lastTicketsCriteria) || !$this->lastTicketsCriteria->equals($criteria)) {
					$count = TicketsPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collTicketss);
				}
			} else {
				$count = count($this->collTicketss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a Tickets object to this object
	 * through the Tickets foreign key attribute.
	 *
	 * @param      Tickets $l Tickets
	 * @return     void
	 * @throws     PropelException
	 */
	public function addTickets(Tickets $l)
	{
		if ($this->collTicketss === null) {
			$this->initTicketss();
		}
		if (!in_array($l, $this->collTicketss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collTicketss, $l);
			$l->setUsers($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related Ticketss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getTicketssJoinDepartments($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTicketss === null) {
			if ($this->isNew()) {
				$this->collTicketss = array();
			} else {

				$criteria->add(TicketsPeer::USERS_ID, $this->id);

				$this->collTicketss = TicketsPeer::doSelectJoinDepartments($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TicketsPeer::USERS_ID, $this->id);

			if (!isset($this->lastTicketsCriteria) || !$this->lastTicketsCriteria->equals($criteria)) {
				$this->collTicketss = TicketsPeer::doSelectJoinDepartments($criteria, $con, $join_behavior);
			}
		}
		$this->lastTicketsCriteria = $criteria;

		return $this->collTicketss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related Ticketss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getTicketssJoinTicketsTypes($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTicketss === null) {
			if ($this->isNew()) {
				$this->collTicketss = array();
			} else {

				$criteria->add(TicketsPeer::USERS_ID, $this->id);

				$this->collTicketss = TicketsPeer::doSelectJoinTicketsTypes($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TicketsPeer::USERS_ID, $this->id);

			if (!isset($this->lastTicketsCriteria) || !$this->lastTicketsCriteria->equals($criteria)) {
				$this->collTicketss = TicketsPeer::doSelectJoinTicketsTypes($criteria, $con, $join_behavior);
			}
		}
		$this->lastTicketsCriteria = $criteria;

		return $this->collTicketss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related Ticketss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getTicketssJoinTicketsStatus($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTicketss === null) {
			if ($this->isNew()) {
				$this->collTicketss = array();
			} else {

				$criteria->add(TicketsPeer::USERS_ID, $this->id);

				$this->collTicketss = TicketsPeer::doSelectJoinTicketsStatus($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TicketsPeer::USERS_ID, $this->id);

			if (!isset($this->lastTicketsCriteria) || !$this->lastTicketsCriteria->equals($criteria)) {
				$this->collTicketss = TicketsPeer::doSelectJoinTicketsStatus($criteria, $con, $join_behavior);
			}
		}
		$this->lastTicketsCriteria = $criteria;

		return $this->collTicketss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related Ticketss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getTicketssJoinProjects($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTicketss === null) {
			if ($this->isNew()) {
				$this->collTicketss = array();
			} else {

				$criteria->add(TicketsPeer::USERS_ID, $this->id);

				$this->collTicketss = TicketsPeer::doSelectJoinProjects($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TicketsPeer::USERS_ID, $this->id);

			if (!isset($this->lastTicketsCriteria) || !$this->lastTicketsCriteria->equals($criteria)) {
				$this->collTicketss = TicketsPeer::doSelectJoinProjects($criteria, $con, $join_behavior);
			}
		}
		$this->lastTicketsCriteria = $criteria;

		return $this->collTicketss;
	}

	/**
	 * Clears out the collTicketsCommentss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addTicketsCommentss()
	 */
	public function clearTicketsCommentss()
	{
		$this->collTicketsCommentss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collTicketsCommentss collection (array).
	 *
	 * By default this just sets the collTicketsCommentss collection to an empty array (like clearcollTicketsCommentss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initTicketsCommentss()
	{
		$this->collTicketsCommentss = array();
	}

	/**
	 * Gets an array of TicketsComments objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Users has previously been saved, it will retrieve
	 * related TicketsCommentss from storage. If this Users is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array TicketsComments[]
	 * @throws     PropelException
	 */
	public function getTicketsCommentss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTicketsCommentss === null) {
			if ($this->isNew()) {
			   $this->collTicketsCommentss = array();
			} else {

				$criteria->add(TicketsCommentsPeer::USERS_ID, $this->id);

				TicketsCommentsPeer::addSelectColumns($criteria);
				$this->collTicketsCommentss = TicketsCommentsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(TicketsCommentsPeer::USERS_ID, $this->id);

				TicketsCommentsPeer::addSelectColumns($criteria);
				if (!isset($this->lastTicketsCommentsCriteria) || !$this->lastTicketsCommentsCriteria->equals($criteria)) {
					$this->collTicketsCommentss = TicketsCommentsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTicketsCommentsCriteria = $criteria;
		return $this->collTicketsCommentss;
	}

	/**
	 * Returns the number of related TicketsComments objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related TicketsComments objects.
	 * @throws     PropelException
	 */
	public function countTicketsCommentss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collTicketsCommentss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(TicketsCommentsPeer::USERS_ID, $this->id);

				$count = TicketsCommentsPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(TicketsCommentsPeer::USERS_ID, $this->id);

				if (!isset($this->lastTicketsCommentsCriteria) || !$this->lastTicketsCommentsCriteria->equals($criteria)) {
					$count = TicketsCommentsPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collTicketsCommentss);
				}
			} else {
				$count = count($this->collTicketsCommentss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a TicketsComments object to this object
	 * through the TicketsComments foreign key attribute.
	 *
	 * @param      TicketsComments $l TicketsComments
	 * @return     void
	 * @throws     PropelException
	 */
	public function addTicketsComments(TicketsComments $l)
	{
		if ($this->collTicketsCommentss === null) {
			$this->initTicketsCommentss();
		}
		if (!in_array($l, $this->collTicketsCommentss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collTicketsCommentss, $l);
			$l->setUsers($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related TicketsCommentss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getTicketsCommentssJoinTickets($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTicketsCommentss === null) {
			if ($this->isNew()) {
				$this->collTicketsCommentss = array();
			} else {

				$criteria->add(TicketsCommentsPeer::USERS_ID, $this->id);

				$this->collTicketsCommentss = TicketsCommentsPeer::doSelectJoinTickets($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TicketsCommentsPeer::USERS_ID, $this->id);

			if (!isset($this->lastTicketsCommentsCriteria) || !$this->lastTicketsCommentsCriteria->equals($criteria)) {
				$this->collTicketsCommentss = TicketsCommentsPeer::doSelectJoinTickets($criteria, $con, $join_behavior);
			}
		}
		$this->lastTicketsCommentsCriteria = $criteria;

		return $this->collTicketsCommentss;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Users is new, it will return
	 * an empty collection; or if this Users has previously
	 * been saved, it will retrieve related TicketsCommentss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Users.
	 */
	public function getTicketsCommentssJoinTicketsStatus($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTicketsCommentss === null) {
			if ($this->isNew()) {
				$this->collTicketsCommentss = array();
			} else {

				$criteria->add(TicketsCommentsPeer::USERS_ID, $this->id);

				$this->collTicketsCommentss = TicketsCommentsPeer::doSelectJoinTicketsStatus($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TicketsCommentsPeer::USERS_ID, $this->id);

			if (!isset($this->lastTicketsCommentsCriteria) || !$this->lastTicketsCommentsCriteria->equals($criteria)) {
				$this->collTicketsCommentss = TicketsCommentsPeer::doSelectJoinTicketsStatus($criteria, $con, $join_behavior);
			}
		}
		$this->lastTicketsCommentsCriteria = $criteria;

		return $this->collTicketsCommentss;
	}

	/**
	 * Clears out the collTicketsReportss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addTicketsReportss()
	 */
	public function clearTicketsReportss()
	{
		$this->collTicketsReportss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collTicketsReportss collection (array).
	 *
	 * By default this just sets the collTicketsReportss collection to an empty array (like clearcollTicketsReportss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initTicketsReportss()
	{
		$this->collTicketsReportss = array();
	}

	/**
	 * Gets an array of TicketsReports objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Users has previously been saved, it will retrieve
	 * related TicketsReportss from storage. If this Users is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array TicketsReports[]
	 * @throws     PropelException
	 */
	public function getTicketsReportss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collTicketsReportss === null) {
			if ($this->isNew()) {
			   $this->collTicketsReportss = array();
			} else {

				$criteria->add(TicketsReportsPeer::USERS_ID, $this->id);

				TicketsReportsPeer::addSelectColumns($criteria);
				$this->collTicketsReportss = TicketsReportsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(TicketsReportsPeer::USERS_ID, $this->id);

				TicketsReportsPeer::addSelectColumns($criteria);
				if (!isset($this->lastTicketsReportsCriteria) || !$this->lastTicketsReportsCriteria->equals($criteria)) {
					$this->collTicketsReportss = TicketsReportsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTicketsReportsCriteria = $criteria;
		return $this->collTicketsReportss;
	}

	/**
	 * Returns the number of related TicketsReports objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related TicketsReports objects.
	 * @throws     PropelException
	 */
	public function countTicketsReportss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collTicketsReportss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(TicketsReportsPeer::USERS_ID, $this->id);

				$count = TicketsReportsPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(TicketsReportsPeer::USERS_ID, $this->id);

				if (!isset($this->lastTicketsReportsCriteria) || !$this->lastTicketsReportsCriteria->equals($criteria)) {
					$count = TicketsReportsPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collTicketsReportss);
				}
			} else {
				$count = count($this->collTicketsReportss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a TicketsReports object to this object
	 * through the TicketsReports foreign key attribute.
	 *
	 * @param      TicketsReports $l TicketsReports
	 * @return     void
	 * @throws     PropelException
	 */
	public function addTicketsReports(TicketsReports $l)
	{
		if ($this->collTicketsReportss === null) {
			$this->initTicketsReportss();
		}
		if (!in_array($l, $this->collTicketsReportss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collTicketsReportss, $l);
			$l->setUsers($this);
		}
	}

	/**
	 * Clears out the collUserReportss collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addUserReportss()
	 */
	public function clearUserReportss()
	{
		$this->collUserReportss = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collUserReportss collection (array).
	 *
	 * By default this just sets the collUserReportss collection to an empty array (like clearcollUserReportss());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initUserReportss()
	{
		$this->collUserReportss = array();
	}

	/**
	 * Gets an array of UserReports objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Users has previously been saved, it will retrieve
	 * related UserReportss from storage. If this Users is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array UserReports[]
	 * @throws     PropelException
	 */
	public function getUserReportss($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collUserReportss === null) {
			if ($this->isNew()) {
			   $this->collUserReportss = array();
			} else {

				$criteria->add(UserReportsPeer::USERS_ID, $this->id);

				UserReportsPeer::addSelectColumns($criteria);
				$this->collUserReportss = UserReportsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(UserReportsPeer::USERS_ID, $this->id);

				UserReportsPeer::addSelectColumns($criteria);
				if (!isset($this->lastUserReportsCriteria) || !$this->lastUserReportsCriteria->equals($criteria)) {
					$this->collUserReportss = UserReportsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUserReportsCriteria = $criteria;
		return $this->collUserReportss;
	}

	/**
	 * Returns the number of related UserReports objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related UserReports objects.
	 * @throws     PropelException
	 */
	public function countUserReportss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(UsersPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collUserReportss === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(UserReportsPeer::USERS_ID, $this->id);

				$count = UserReportsPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(UserReportsPeer::USERS_ID, $this->id);

				if (!isset($this->lastUserReportsCriteria) || !$this->lastUserReportsCriteria->equals($criteria)) {
					$count = UserReportsPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collUserReportss);
				}
			} else {
				$count = count($this->collUserReportss);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a UserReports object to this object
	 * through the UserReports foreign key attribute.
	 *
	 * @param      UserReports $l UserReports
	 * @return     void
	 * @throws     PropelException
	 */
	public function addUserReports(UserReports $l)
	{
		if ($this->collUserReportss === null) {
			$this->initUserReportss();
		}
		if (!in_array($l, $this->collUserReportss, true)) { // only add it if the **same** object is not already associated
			array_push($this->collUserReportss, $l);
			$l->setUsers($this);
		}
	}

	/**
	 * Resets all collections of referencing foreign keys.
	 *
	 * This method is a user-space workaround for PHP's inability to garbage collect objects
	 * with circular references.  This is currently necessary when using Propel in certain
	 * daemon or large-volumne/high-memory operations.
	 *
	 * @param      boolean $deep Whether to also clear the references on all associated objects.
	 */
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collDepartmentss) {
				foreach ((array) $this->collDepartmentss as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collDiscussionss) {
				foreach ((array) $this->collDiscussionss as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collDiscussionsCommentss) {
				foreach ((array) $this->collDiscussionsCommentss as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collDiscussionsReportss) {
				foreach ((array) $this->collDiscussionsReportss as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collEventss) {
				foreach ((array) $this->collEventss as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collProjectss) {
				foreach ((array) $this->collProjectss as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collProjectsCommentss) {
				foreach ((array) $this->collProjectsCommentss as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collProjectsReportss) {
				foreach ((array) $this->collProjectsReportss as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collTaskss) {
				foreach ((array) $this->collTaskss as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collTasksCommentss) {
				foreach ((array) $this->collTasksCommentss as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collTicketss) {
				foreach ((array) $this->collTicketss as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collTicketsCommentss) {
				foreach ((array) $this->collTicketsCommentss as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collTicketsReportss) {
				foreach ((array) $this->collTicketsReportss as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collUserReportss) {
				foreach ((array) $this->collUserReportss as $o) {
					$o->clearAllReferences($deep);
				}
			}
		} // if ($deep)

		$this->collDepartmentss = null;
		$this->collDiscussionss = null;
		$this->collDiscussionsCommentss = null;
		$this->collDiscussionsReportss = null;
		$this->collEventss = null;
		$this->collProjectss = null;
		$this->collProjectsCommentss = null;
		$this->collProjectsReportss = null;
		$this->collTaskss = null;
		$this->collTasksCommentss = null;
		$this->collTicketss = null;
		$this->collTicketsCommentss = null;
		$this->collTicketsReportss = null;
		$this->collUserReportss = null;
			$this->aUsersGroups = null;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseUsers:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseUsers::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} // BaseUsers
